package jp.oarts.pirka.iop.tool.core.business;

import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;

/**
 * ڂ̃VvȎ
 *
 * @author ito
 *
 */
public class AttributeSimpleItem implements AttributeItem {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * O
	 */
	private String name;

	/**
	 * {ꖼ
	 */
	private String nameJp;

	/**
	 * bZ[W
	 */
	private String message;

	/**
	 * ^Cv
	 */
	private AttributeType type;

	/**
	 * 
	 */
	private int length;

	/**
	 * ftHgl
	 */
	private AttributeData DefaultValue;

	/**
	 * `FbJ[
	 */
	private AttributeChecker checker;

	/**
	 * ĨZN^
	 */
	private Selecter[] selecter;

	/**
	 * RXgN^
	 *
	 * @param name
	 *            O
	 * @param nameJp
	 *            {ꖼ
	 * @param message
	 *            bZ[W
	 * @param type
	 *            ^Cv
	 * @param length
	 *            
	 * @param DefaultValue
	 *            ftHgl
	 * @param checker
	 *            `FbJ[i`FbNsȂƂnullj
	 * @param selecter
	 *            Ipf[^iIڂłȂƂnullj
	 */
	public AttributeSimpleItem(String name, String nameJp, String message, AttributeType type, int length,
			AttributeData DefaultValue, AttributeChecker checker, Selecter... selecter) {
		this.name = name;
		this.nameJp = nameJp;
		this.message = message;
		this.type = type;
		this.DefaultValue = DefaultValue;
		this.length = length;
		this.checker = checker;
		this.selecter = selecter;
	}

	/**
	 * RXgN^
	 *
	 * @param name
	 *            O
	 * @param nameJp
	 *            {ꖼ
	 * @param message
	 *            bZ[W
	 * @param type
	 *            ^Cv
	 * @param DefaultValue
	 *            ftHgl
	 * @param checker
	 *            `FbJ[i`FbNsȂƂnullj
	 * @param selecter
	 *            Ipf[^iIڂłȂƂnullj
	 */
	public AttributeSimpleItem(String name, String nameJp, String message, AttributeType type, AttributeData DefaultValue,
			AttributeChecker checker, Selecter... selecter) {
		this(name, nameJp, message, type, 0, DefaultValue, checker, selecter);
	}

	@Override
	public void check(String value, InterfaceDataItem item) throws InterfaceException {
		if (checker != null) {
			checker.check(value, item);
		}
	}

	@Override
	public Selecter[] getSelecter() {
		return selecter;
	}

	@Override
	public AttributeType getAttributeType() {
		return type;
	}

	@Override
	public AttributeData getDefaultValue() {
		return DefaultValue;
	}

	@Override
	public String getMessage() {
		return message;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public String getNameJp() {
		return nameJp;
	}

	@Override
	public int getLength() {
		return length;
	}

	@Override
	public boolean isAlwaysDefaultValue(){
		return false;
	}

}
