package jp.oarts.pirka.iop.tool.core.business;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.List;
import java.util.TreeMap;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.tools.text.TextCreator;

/**
 * t@CNG[^[ATvf[vOC̃eLXgt@CC[W쐬NXhVvȒۓI
 *
 * @author ito
 *
 */

@SuppressWarnings("serial")
public abstract class FileCreatorSampleModelerTextCreatorSimplePlugin extends TextCreator implements
		FileCreatorSampleModelerPlugin {

	/**
	 * o͂镶R[h
	 */
	private static final String FILE_CHAR_SET = "MS932";

	/**
	 * o͂sR[h
	 */
	private static final byte[] CRLF = new byte[] { 0x0d, 0x0a };

	/**
	 * O
	 */
	protected String name;

	/**
	 * {ꖼ
	 */
	protected String nameJp;

	/**
	 * vOC^Cv
	 */
	protected PluginType pluginType;

	/**
	 * Ab^`\tO
	 */
	protected boolean canAttachFlag;

	/**
	 * ̎s\tO
	 */
	protected boolean canExecuteFlag;

	/**
	 * p[^ۑ\tO
	 */
	protected boolean useSaveAndLoadParameter;

	/**
	 * ݒʂŃCN[h̖ڂ͎gpȂ̊mFtO
	 */
	boolean useDisableItemsAttribute;

	/**
	 * ڂ̃}bv
	 */
	protected HashMap<String, AttributeItem> attributeItemMap;

	/**
	 * RXgN^
	 *
	 * @param name
	 * @param nameJp
	 * @param pluginType
	 * @param canAttachFlag
	 * @param canExecuteFlag
	 * @param useSaveAndLoadParameter
	 */
	public FileCreatorSampleModelerTextCreatorSimplePlugin(String name, String nameJp, PluginType pluginType,
			boolean canAttachFlag, boolean canExecuteFlag, boolean useSaveAndLoadParameter) throws InterfaceException {

		this(name, nameJp, pluginType, canAttachFlag, canExecuteFlag, useSaveAndLoadParameter, false);

	}

	/**
	 * RXgN^
	 *
	 * @param name
	 * @param nameJp
	 * @param pluginType
	 * @param canAttachFlag
	 * @param canExecuteFlag
	 * @param useSaveAndLoadParameter
	 * @param useDisableItemsAttribute
	 */
	public FileCreatorSampleModelerTextCreatorSimplePlugin(String name, String nameJp, PluginType pluginType,
			boolean canAttachFlag, boolean canExecuteFlag, boolean useSaveAndLoadParameter, boolean useDisableItemsAttribute)
			throws InterfaceException {
		this.name = name;
		this.nameJp = nameJp;
		this.pluginType = pluginType;
		this.canAttachFlag = canAttachFlag;
		this.canExecuteFlag = canExecuteFlag;
		this.useSaveAndLoadParameter = useSaveAndLoadParameter;
		this.useDisableItemsAttribute = useDisableItemsAttribute;

		attributeItemMap = new HashMap<String, AttributeItem>();
		if (getAttributeItems() != null) {
			for (AttributeItem aItem : getAttributeItems()) {
				attributeItemMap.put(aItem.getName(), aItem);
			}
		}
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public String getNameJp() {
		return nameJp;
	}

	@Override
	public PluginType getPluginType() {
		return pluginType;
	}

	@Override
	public boolean canAttach() {
		return canAttachFlag;
	}

	@Override
	public boolean canExecute() {
		return canExecuteFlag;
	}

	@Override
	public boolean useSaveAndLoadParameter() {
		return useSaveAndLoadParameter;
	}

	@Override
	public AttributeItem getAttributeItem(String name) {
		return attributeItemMap.get(name);
	}

	@Override
	public void preCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

	}

	@Override
	public void afterCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

	}

	@Override
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

	}

	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

	}

	/**
	 * w肳ꂽXg[ɃXg̕{sR[hoCi[ŏo͂
	 *
	 * @param baos
	 * @param lineList
	 * @throws UnsupportedEncodingException
	 * @throws IOException
	 */
	protected void out(ByteArrayOutputStream baos, List<String> lineList) throws UnsupportedEncodingException, IOException {
		out(baos, lineList, FILE_CHAR_SET);
	}

	/**
	 * w肳ꂽXg[ɃXg̕{sR[hoCi[ŏo͂
	 *
	 * @param baos
	 * @param lineList
	 * @throws UnsupportedEncodingException
	 * @throws IOException
	 */
	protected void out(ByteArrayOutputStream baos, List<String> lineList, String charSet) throws UnsupportedEncodingException,
			IOException {
		for (String line : lineList) {
			baos.write(line.getBytes(charSet));
			baos.write(CRLF);
		}
	}

	/**
	 * ȈZipt@C쐬
	 *
	 * @param fileMap
	 *            t@C}bviL[Ft@CAlFt@CC[Wj
	 * @return zipt@CC[W
	 * @throws IOException
	 */
	public byte[] createZipImage(HashMap<String, byte[]> fileMap) throws IOException {

		ByteArrayOutputStream baos = null;
		ZipOutputStream zipOutStream = null;

		try {
			baos = new ByteArrayOutputStream();
			zipOutStream = new ZipOutputStream(baos);

			for (String fileName : fileMap.keySet()) {
				ZipEntry entry = null;
				try {
					entry = new ZipEntry(fileName);
					zipOutStream.putNextEntry(entry);
					zipOutStream.write(fileMap.get(fileName));
				} finally {
					zipOutStream.closeEntry();
				}
			}
			zipOutStream.finish();
		} finally {
			if (zipOutStream != null) {
				zipOutStream.close();
			}
		}
		return baos.toByteArray();
	}

	@Override
	public boolean useDisableItemsAttribute() {
		return useDisableItemsAttribute;
	}

	public byte[] getResourceFile(String resourceName) throws IOException {

		byte[] buff = new byte[2048];
		InputStream is = null;
		ByteArrayOutputStream baos = null;

		try {
			baos = new ByteArrayOutputStream();
			try {
				is = getClass().getResourceAsStream(resourceName);
				if (is == null) {
					throw new IOException("\[Xt@C݂܂" + resourceName);
				}

				while (true) {
					int len = is.read(buff);
					if (len <= 0) {
						break;
					}
					baos.write(buff, 0, len);
				}
				baos.flush();
				return baos.toByteArray();
			} finally {
				if (is != null) {
					is.close();
				}
			}
		} finally {
			if (baos != null) {
				baos.close();
			}
		}

	}


	public byte[] getResourceFile(String resourceName, String inCharSetName, String outCharSetName) throws IOException {

		char[] buff = new char[2048];
		InputStreamReader isr = null;
		ByteArrayOutputStream baos = null;
		OutputStreamWriter osw = null;

		try {
			baos = new ByteArrayOutputStream();
			osw = new OutputStreamWriter(baos, outCharSetName);
			try {
				InputStream is = getClass().getResourceAsStream(resourceName);
				if (is == null) {
					throw new IOException("\[Xt@C݂܂" + resourceName);
				}
				isr = new InputStreamReader(is, inCharSetName);

				while (true) {
					int len = isr.read(buff);
					if (len <= 0) {
						break;
					}
					osw.write(buff, 0, len);
				}
				osw.flush();
				return baos.toByteArray();
			} finally {
				if (isr != null) {
					isr.close();
				}
			}
		} finally {
			if (osw != null) {
				osw.close();
			}
		}

	}
}
