package jp.oarts.pirka.iop.tool.core.business;

import java.io.Serializable;

import jp.oarts.pirka.iop.tool.core.tools.xml.XmlCreator;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlCreatorNode;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlParser;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlParserData;

/**
 * C^[tF[XvWFNg
 *
 * @author ito
 *
 */
public class InterfaceProject implements Cloneable, Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 175960083072625865L;

	/**
	 * vWFNgivWFNgt@Cj
	 */
	private String name;

	/**
	 * vWFNg{ꖼ
	 */
	private String nameJp;

	/**
	 * vWFNg̃Rg
	 */
	private String comment;

	/**
	 * ύXmFtO
	 */
	private boolean changed;

	/**
	 * C^[tF[X}l[W[
	 */
	InterfaceDataManager interfaceDataManager;

	/**
	 * p[^f[^}l[W[
	 */
	ParameterDataManager parameterDataManager;

	/**
	 * RXgN^<BR>
	 */
	private InterfaceProject() {
		// sȂ
	}

	/**
	 * RXgN^
	 *
	 * @param name
	 *            vWFNgivWFNgt@Cj
	 * @param nameJp
	 *            vWFNg{ꖼ
	 * @param comment
	 *            vWFNg̃Rg
	 */
	public InterfaceProject(String name, String nameJp, String comment) {
		this.name = name;
		this.nameJp = nameJp;
		this.comment = comment;
		interfaceDataManager = new InterfaceDataManager();
		parameterDataManager = new ParameterDataManager();
	}

	@Override
	public String toString() {

		StringBuilder sb = new StringBuilder();

		sb.append("name=");
		sb.append(name);
		sb.append(", ");

		sb.append("nameJp=");
		sb.append(nameJp);
		sb.append(", ");

		sb.append("comment=");
		sb.append(comment);
		sb.append(", ");

		sb.append("interfaceDataManager=y");
		sb.append(interfaceDataManager.toString());
		sb.append("z");

		return sb.toString();
	}

	/**
	 * fobOpo
	 */
	public void sysout() {

		System.out.print("name=");
		System.out.println(name);

		System.out.print("nameJp=");
		System.out.println(nameJp);

		System.out.print("comment=");
		System.out.println(comment);

		System.out.println("--------------------------------------------------");

		System.out.println("interfaceDataManager=");
		interfaceDataManager.sysout();
	}

	/**
	 * ̃IuWFNgXML֊i[
	 *
	 * @return XML
	 * @throws InterfaceException
	 */
	public byte[] toXmlByteArray() throws InterfaceException {

		try {
			return toXml().getBytes("UTF-8");
		} catch (Exception e) {
			throw new InterfaceException("vWFNgt@C쐬ł܂", e);
		}
	}

	/**
	 * ̃IuWFNgXML֊i[
	 *
	 * @return XML
	 */
	public String toXml() {

		XmlCreator xml = new XmlCreator();
		toXml(xml);

		return xml.toString();
	}

	/**
	 * ̃IuWFNgXML֊i[
	 *
	 * @param baseNode	VvXMLm[h
	 */
	public void toXml(XmlCreatorNode baseNode) {

		XmlCreatorNode interfaceProjectNode = new XmlCreatorNode("InterfaceProject");
		baseNode.appendChild(interfaceProjectNode);

		interfaceProjectNode.appendChild(new XmlCreatorNode("name", name));
		interfaceProjectNode.appendChild(new XmlCreatorNode("nameJp", nameJp));
		interfaceProjectNode.appendChild(new XmlCreatorNode("comment", comment));

		interfaceDataManager.toXml(interfaceProjectNode);
		parameterDataManager.toXml(interfaceProjectNode);
	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param buf
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 */
	public static InterfaceProject fromXml(byte[] buf) throws InterfaceException {

		try {
			String xmlString;
			xmlString = new String(buf, "UTF-8");
			XmlParser xmlParser = new XmlParser();

			return fromXml(xmlParser.parse(xmlString));
		} catch (Exception e) {
			throw new InterfaceException("XMLt@C͂ł܂", e);
		}

	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param xml
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 */
	public static InterfaceProject fromXml(XmlParserData xml) throws InterfaceException {

		xml = xml.getXmlParserData("InterfaceProject");
		InterfaceProject obj = new InterfaceProject(xml.getString("name"), xml.getString("nameJp"), xml.getString("comment"));

		obj.interfaceDataManager = InterfaceDataManager.fromXml(xml);
		obj.parameterDataManager = ParameterDataManager.fromXml(xml);

		return obj;
	}

	@Override
	public Object clone() {
		InterfaceProject cloneObj = new InterfaceProject();

		cloneObj.name = name;
		cloneObj.nameJp = nameJp;
		cloneObj.comment = comment;
		cloneObj.interfaceDataManager = (InterfaceDataManager) interfaceDataManager.clone();
		cloneObj.parameterDataManager = (ParameterDataManager) parameterDataManager.clone();

		return cloneObj;

	}

	/**
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return nameJp
	 */
	public String getNameJp() {
		return nameJp;
	}

	/**
	 * @return comment
	 */
	public String getComment() {
		return comment;
	}

	/**
	 * @return changed
	 */
	public boolean isChanged() {
		return changed;
	}

	/**
	 * @param name
	 *            Zbg name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @param nameJp
	 *            Zbg nameJp
	 */
	public void setNameJp(String nameJp) {
		this.nameJp = nameJp;
	}

	/**
	 * @param comment
	 *            Zbg comment
	 */
	public void setComment(String comment) {
		this.comment = comment;
	}

	/**
	 * @param changed
	 *            Zbg changed
	 */
	public void setChanged(boolean changed) {
		this.changed = changed;
	}

	/**
	 * @return interfaceDataManager
	 */
	public InterfaceDataManager getInterfaceDataManager() {
		return interfaceDataManager;
	}

	/**
	 * @return parameterDataManager
	 */
	public ParameterDataManager getParameterDataManager() {
		return parameterDataManager;
	}

}
