package jp.oarts.pirka.iop.tool.core.business;

import java.io.IOException;
import java.io.Serializable;
import java.util.HashMap;
import java.util.LinkedHashMap;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlCreatorNode;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlParser;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlParserData;

/**
 * p[^}l[W[
 *
 * @author ito
 *
 */
public class ParameterDataManager implements Cloneable, Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/** p[^}bv vOCEip[^Aj */
	private HashMap<String, LinkedHashMap<String, HashMap<String, ParameterData>>> parameterMap;

	/**
	 * RXgN^
	 */
	protected ParameterDataManager() {
		parameterMap = new HashMap<String, LinkedHashMap<String, HashMap<String, ParameterData>>>();
	}

	/**
	 * vOCɑΉp[^t@C̈ꗗ擾<br>
	 * o^
	 *
	 * @return p[^t@C
	 */
	public String[] getParameterFileListString(String pluginName) {
		LinkedHashMap<String, HashMap<String, ParameterData>> paramaterNameMap = parameterMap.get(pluginName);

		if (paramaterNameMap == null) {
			return new String[0];
		}

		return paramaterNameMap.keySet().toArray(new String[0]);
	}

	/**
	 * vOCAp[^ɑΉp[^ڃ}bv擾<br>
	 *
	 * @param pluginName
	 *            vOC
	 * @param parameterName
	 *            p[^
	 * @return p[^ڃ}bv
	 */
	public HashMap<String, ParameterData> getParameterDataMap(String pluginName, String parameterName) {

		HashMap<String, ParameterData> returnMap = new HashMap<String, ParameterData>();

		LinkedHashMap<String, HashMap<String, ParameterData>> paramaterNameMap = parameterMap.get(pluginName);

		if (paramaterNameMap != null) {
			HashMap<String, ParameterData> map = paramaterNameMap.get(parameterName);

			if (map != null) {

				for (String key : map.keySet()) {
					returnMap.put(key, map.get(key));
				}
			}
		}

		return returnMap;
	}

	/**
	 * vOCAp[^L[Ƃăp[^}bvi[<br>
	 *
	 * @param pluginName
	 * @param parameterName
	 * @param parameterDataMap
	 */
	public void setParameterDataMap(String pluginName, String parameterName, HashMap<String, ParameterData> parameterDataMap) {

		LinkedHashMap<String, HashMap<String, ParameterData>> paramaterNameMap = parameterMap.get(pluginName);
		if (paramaterNameMap == null) {
			paramaterNameMap = new LinkedHashMap<String, HashMap<String, ParameterData>>();
			parameterMap.put(pluginName, paramaterNameMap);
		}

		HashMap<String, ParameterData> storeMap = new HashMap<String, ParameterData>();

		for (String key : parameterDataMap.keySet()) {
			String value = "";
			ParameterData paramData = parameterDataMap.get(key);
			// if (paramData != null) {
			// value = paramData.getValue();
			// }
			storeMap.put(key, paramData);
		}

		paramaterNameMap.put(parameterName, storeMap);
	}

	/**
	 * vOCAp[^L[Ƃăp[^}bvi[<br>
	 *
	 * @param pluginName
	 * @param parameterName
	 */
	public void removeParameterDataMap(String pluginName, String parameterName) {

		LinkedHashMap<String, HashMap<String, ParameterData>> paramaterNameMap = parameterMap.get(pluginName);
		if (paramaterNameMap == null) {
			return;
		}

		paramaterNameMap.remove(parameterName);
	}

	/**
	 * ̃IuWFNgXML֊i[
	 *
	 * @param baseNode
	 */
	public void toXml(XmlCreatorNode baseNode) {

		XmlCreatorNode parameterDataManagerNode = new XmlCreatorNode("parameterDataManager");
		baseNode.appendChild(parameterDataManagerNode);

		XmlCreatorNode parameterMapNode = new XmlCreatorNode("parameterMap");
		parameterDataManagerNode.appendChild(parameterMapNode);

		for (String key : parameterMap.keySet()) {
			XmlCreatorNode entryNode = new XmlCreatorNode("entry");
			parameterMapNode.appendChild(entryNode);

			entryNode.appendChild(new XmlCreatorNode("key", key));

			LinkedHashMap<String, HashMap<String, ParameterData>> parameterFileMap = parameterMap.get(key);

			XmlCreatorNode valueNode = new XmlCreatorNode("value");
			entryNode.appendChild(valueNode);

			toXml(valueNode, parameterFileMap);
		}

	}

	/**
	 * XML֊i[
	 *
	 * @param baseNode
	 * @param parameterFileMap
	 */
	private void toXml(XmlCreatorNode baseNode, LinkedHashMap<String, HashMap<String, ParameterData>> parameterFileMap) {

		XmlCreatorNode parameterFileMapNode = new XmlCreatorNode("parameterFileMap");
		baseNode.appendChild(parameterFileMapNode);

		for (String key : parameterFileMap.keySet()) {
			XmlCreatorNode entryNode = new XmlCreatorNode("entry");
			parameterFileMapNode.appendChild(entryNode);

			entryNode.appendChild(new XmlCreatorNode("key", key));

			HashMap<String, ParameterData> parameterDataMap = parameterFileMap.get(key);

			XmlCreatorNode valueNode = new XmlCreatorNode("value");
			entryNode.appendChild(valueNode);

			toXml(valueNode, parameterDataMap);
		}

	}

	private void toXml(XmlCreatorNode baseNode, HashMap<String, ParameterData> parameterDataMap) {

		XmlCreatorNode parameterDataMapNode = new XmlCreatorNode("parameterDataMap");
		baseNode.appendChild(parameterDataMapNode);

		for (String key : parameterDataMap.keySet()) {

			XmlCreatorNode entryNode = new XmlCreatorNode("entry");

			parameterDataMapNode.appendChild(entryNode);
			entryNode.appendChild(new XmlCreatorNode("key", key));

			ParameterData parameterData = parameterDataMap.get(key);
			XmlCreatorNode valueNode = new XmlCreatorNode("value", parameterData.getValue());
			entryNode.appendChild(valueNode);

			if (parameterData.getFileImage() != null) {
				BASE64Encoder encoder = new BASE64Encoder();
				XmlCreatorNode imageNode = new XmlCreatorNode("image", encoder.encode(parameterData.getFileImage()));
				entryNode.appendChild(imageNode);
			} else {
				XmlCreatorNode imageNode = new XmlCreatorNode("image", "");
				entryNode.appendChild(imageNode);
			}

		}

	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param xml
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 */
	public static ParameterDataManager fromXml(XmlParserData xml) throws InterfaceException {

		ParameterDataManager obj = new ParameterDataManager();

		xml = xml.getXmlParserData("parameterDataManager");

		int index = 0;
		XmlParserData parameterMapXml = xml.getXmlParserData("parameterMap");
		while (true) {
			String entry = XmlParser.createKey("entry" + XmlParser.INDEX_MARKER, index++);
			if (!parameterMapXml.isExists(entry)) {
				break;
			}
			XmlParserData entryXml = parameterMapXml.getXmlParserData(entry);
			obj.parameterMap.put(entryXml.getString("key"), fromXml2(entryXml.getXmlParserData("value")));
		}

		return obj;
	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param xml
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 */
	private static LinkedHashMap<String, HashMap<String, ParameterData>> fromXml2(XmlParserData xml) throws InterfaceException {

		LinkedHashMap<String, HashMap<String, ParameterData>> obj = new LinkedHashMap<String, HashMap<String, ParameterData>>();

		int index = 0;
		XmlParserData parameterFileMapXml = xml.getXmlParserData("parameterFileMap");
		while (true) {
			String entry = XmlParser.createKey("entry" + XmlParser.INDEX_MARKER, index++);
			if (!parameterFileMapXml.isExists(entry)) {
				break;
			}
			XmlParserData entryXml = parameterFileMapXml.getXmlParserData(entry);
			obj.put(entryXml.getString("key"), fromXml3(entryXml.getXmlParserData("value")));
		}

		return obj;
	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param xml
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 */
	private static HashMap<String, ParameterData> fromXml3(XmlParserData xml) throws InterfaceException {

		HashMap<String, ParameterData> obj = new HashMap<String, ParameterData>();

		int index = 0;
		XmlParserData parameterDataMapXml = xml.getXmlParserData("parameterDataMap");
		while (true) {
			String entry = XmlParser.createKey("entry" + XmlParser.INDEX_MARKER, index++);
			if (!parameterDataMapXml.isExists(entry)) {
				break;
			}
			XmlParserData entryXml = parameterDataMapXml.getXmlParserData(entry);

			ParameterData parameterData = null;
			String value = entryXml.getString("value");

			try {
				String imageStr = entryXml.getString("image");
				if (imageStr.length() <= 0) {
					parameterData = new ParameterData(value);
				} else {
					BASE64Decoder decoder = new BASE64Decoder();
					byte[] fileImage = decoder.decodeBuffer(entryXml.getString("image"));
					parameterData = new ParameterData(value, fileImage);
				}

			} catch (Exception e) {
				parameterData = new ParameterData(value);
			}

			obj.put(entryXml.getString("key"), parameterData);
		}

		return obj;
	}

	@Override
	public Object clone() {
		ParameterDataManager cloneObj = new ParameterDataManager();

		for (String key : parameterMap.keySet()) {
			cloneObj.parameterMap.put(key, clone2(parameterMap.get(key)));
		}

		return cloneObj;

	}

	/**
	 * clone
	 *
	 * @param map
	 *            }bv
	 * @return clone}bv
	 */
	public LinkedHashMap<String, HashMap<String, ParameterData>> clone2(
			LinkedHashMap<String, HashMap<String, ParameterData>> map) {
		LinkedHashMap<String, HashMap<String, ParameterData>> cloneObj = new LinkedHashMap<String, HashMap<String, ParameterData>>();

		for (String key : map.keySet()) {
			cloneObj.put(key, map.get(key));
		}

		return cloneObj;

	}

	// /**
	// * clone
	// *
	// * @param map
	// * }bv
	// * @return clone}bv
	// */
	// public HashMap<String, String> clone3(HashMap<String, String> map) {
	// HashMap<String, String> cloneObj = new HashMap<String, String>();
	//
	// for (String key : map.keySet()) {
	// cloneObj.put(key, map.get(key));
	// }
	//
	// return cloneObj;
	// }

}
