package jp.oarts.pirka.iop.tool.core.business;

import java.util.HashMap;

import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;

/**
 * p[^C^[tF[X̃VvȎ
 *
 * @author ito
 *
 */
public class ParameterSimpleItem implements ParameterItem {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * p[^
	 */
	private String name;

	/**
	 * p[^{ꖼ
	 */
	private String nameJp;

	/**
	 * p[^bZ[W
	 */
	private String message;

	/**
	 * p[^^Cv
	 */
	private ParameterType parameterType;

	/**
	 * p[^
	 */
	private int length;

	/**
	 * p[^ftHgl
	 */
	private ParameterData DefaultValue;

	/**
	 * `FbJ[
	 */
	private ParameterChecker checker;

	/**
	 * ĨZN^
	 */
	private Selecter[] selecter;

	private boolean multiSelectFlag;

	/** {^NbNꂽ̏ */
	private ClickListener clickListener;

	/**
	 * RXgN^
	 *
	 * @param name
	 *            p[^
	 * @param nameJp
	 *            p[^{ꖼ
	 * @param message
	 *            p[^bZ[W
	 * @param parameterType
	 *            p[^^Cv
	 * @param length
	 *            p[^
	 * @param DefaultValue
	 *            p[^ftHgl
	 * @param checker
	 *            `FbJ[i`FbNsȂƂnullj
	 * @param selecter
	 *            ĨZN^iIڂłȂƂnullj
	 */
	public ParameterSimpleItem(String name, String nameJp, String message, ParameterType parameterType, int length,
			ParameterData DefaultValue, ParameterChecker checker, boolean multiSelectFlag, Selecter... selecter) {
		this.name = name;
		this.nameJp = nameJp;
		this.message = message;
		this.parameterType = parameterType;
		this.length = length;
		this.DefaultValue = DefaultValue;
		this.checker = checker;
		this.selecter = selecter;
		this.multiSelectFlag = multiSelectFlag;
		this.clickListener = null;
	}

	/**
	 * RXgN^
	 *
	 * @param name
	 *            p[^
	 * @param nameJp
	 *            p[^{ꖼ
	 * @param message
	 *            p[^bZ[W
	 * @param parameterType
	 *            p[^^Cv
	 * @param length
	 *            p[^
	 * @param DefaultValue
	 *            p[^ftHgl
	 * @param checker
	 *            `FbJ[i`FbNsȂƂnullj
	 * @param selecter
	 *            ĨZN^iIڂłȂƂnullj
	 */
	public ParameterSimpleItem(String name, String nameJp, String message, ParameterType parameterType, int length,
			ParameterData DefaultValue, ParameterChecker checker,  Selecter... selecter) {
		this(name, nameJp, message, parameterType, length, DefaultValue, checker, false, selecter);
	}


	/**
	 * RXgN^
	 *
	 * @param name
	 *            p[^
	 * @param nameJp
	 *            p[^{ꖼ
	 * @param message
	 *            p[^bZ[W
	 * @param parameterType
	 *            p[^^Cv
	 * @param DefaultValue
	 *            p[^ftHgl
	 * @param checker
	 *            `FbJ[i`FbNsȂƂnullj
	 * @param selecter
	 *            ĨZN^iIڂłȂƂnullj
	 */
	public ParameterSimpleItem(String name, String nameJp, String message, ParameterType parameterType,
			ParameterData DefaultValue, ParameterChecker checker, Selecter... selecter) {
		this(name, nameJp, message, parameterType, 0, DefaultValue, checker, false, selecter);
	}

	/**
	 * RXgN^({^p)
	 *
	 * @param name
	 *            p[^
	 * @param nameJp
	 *            p[^{ꖼ
	 * @param message
	 *            p[^bZ[W
	 * @param clickListener
	 *            NbN̏
	 */
	public ParameterSimpleItem(String name, String nameJp, String message, ClickListener clickListener) {
		this.name = name;
		this.nameJp = nameJp;
		this.message = message;
		this.parameterType = ParameterType.BUTTON;
		this.length = 0;
		this.DefaultValue = null;
		this.checker = null;
		this.selecter = null;
		this.clickListener = clickListener;
	}

	@Override
	public void check(String value) throws InterfaceException {
		if (checker != null) {
			checker.check(value);
		}
	}

	/**
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return nameJp
	 */
	public String getNameJp() {
		return nameJp;
	}

	/**
	 * @return message
	 */
	public String getMessage() {
		return message;
	}

	/**
	 * @return defaultValue
	 */
	public ParameterData getDefaultValue() {
		return DefaultValue;
	}

	/**
	 * @return checker
	 */
	public ParameterChecker getChecker() {
		return checker;
	}

	/**
	 * @return selecter
	 */
	public Selecter[] getSelecter() {
		return selecter;
	}

	/**
	 * @return parameterType
	 */
	public ParameterType getParameterType() {
		return parameterType;
	}

	@Override
	public int getLength() {
		return length;
	}

	@Override
	public void clickButton(HashMap<String, ParameterItem> paramMap, HashMap<String, ParameterData> dataMap)
			throws InterfaceException {
		if (clickListener != null) {
			clickListener.run(paramMap, dataMap);
		}
	}

	@Override
	public void setSelecter(Selecter[] selecter) {
		this.selecter = selecter;
	}

	@Override
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			return null;
		}
	}

	@Override
	public boolean isMultiSelect() {
		return multiSelectFlag;

	}

	@Override
	public void setMultiSelect(boolean multiSelectFlag) {
		this.multiSelectFlag = multiSelectFlag;

	}

}
