package jp.oarts.pirka.iop.tool.core.business;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.plugin.file.basichtml.BasicHtmlFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.basichtml.BasicHtmlJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.csv.CsvFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.csv.CsvFileInputJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.csv.CsvFileOutputJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.SearcherDaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.SelectListFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.VirtualDbTableFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.gae.GaeDaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml.MntHtmlFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml.MntHtmlJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.vo.ValueObjectJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.vo.ValueObjectJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.webapp.WebAppFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.in.CopyInterfaceDesigner;
import jp.oarts.pirka.iop.tool.core.plugin.in.CsvFileInterfaceDesigner;
import jp.oarts.pirka.iop.tool.core.plugin.in.PirkaHtmlFileInterfaceDesigner;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner;
import jp.oarts.pirka.iop.tool.core.plugin.sample.csv.CsvFileOutputJavaSample;
import jp.oarts.pirka.iop.tool.core.plugin.sample.mnt.MstMntSample;
import jp.oarts.pirka.iop.tool.core.plugin.sample.mntgae.GaeMstMntSample;
import jp.oarts.pirka.iop.tool.core.plugin.sample.mntmulti.MultiMstMntSample;

import org.apache.log4j.Logger;

/**
 * vOC}l[W[
 *
 * @author ito
 *
 */
public class PluginManager {

	/**
	 * vOCNXLqt@CpX
	 */
	private static final String PLUGIN_FILE_NAME = "/plugin.txt";

	/**
	 * B̎IuWFNg
	 */
	private static PluginManager myObj = new PluginManager();

	/**
	 * K[
	 */
	private Logger logger = Logger.getLogger(getClass());

	/**
	 * C^tF[XvOC}bviL[FvOCAlFC^tF[XvOCIuWFNgj
	 */
	private LinkedHashMap<String, InterfaceDesignerPlugin> interfaceDesignerPluginMap;

	/**
	 * t@CNG[^[vOCATvf[vOC}bv<BR>
	 * iL[FvOCAlFvOCIuWFNgj
	 */
	private LinkedHashMap<String, FileCreatorSampleModelerPlugin> attachPluginMap;

	/**
	 * new֎~̃RXgN^
	 */
	private PluginManager() {
		interfaceDesignerPluginMap = new LinkedHashMap<String, InterfaceDesignerPlugin>();
		attachPluginMap = new LinkedHashMap<String, FileCreatorSampleModelerPlugin>();

		init();
	}

	/**
	 * W̑gς݃vOCǉ<BR>
	 * W̃vOCǉ鎞͂̃\bhC邱<BR>
	 * WȊO͂̃NjarʂA\[Xt@C/plugin.txtɃNXLq邱ƁB
	 *
	 * @param classNameList
	 */
	private void setStandardPlugin(List<String> classNameList) {

		// C^tF[XfUCi[
		classNameList.add(CopyInterfaceDesigner.class.getName());
		classNameList.add(CsvFileInterfaceDesigner.class.getName());
		classNameList.add(PirkaHtmlFileInterfaceDesigner.class.getName());
		classNameList.add(DatabaseInterfaceDesigner.class.getName());

		// t@CNG[^[
		classNameList.add(CsvFileCreator.class.getName());
		classNameList.add(BasicHtmlFileCreator.class.getName());
		classNameList.add(BasicHtmlJavaFileCreator.class.getName());
		classNameList.add(MntHtmlFileCreator.class.getName());
		classNameList.add(MntHtmlJavaFileCreator.class.getName());

		classNameList.add(ValueObjectJavaFileCreator.class.getName());

		classNameList.add(DataBaseFileCreator.class.getName());
		classNameList.add(DaoFileCreator.class.getName());
		classNameList.add(GaeDaoFileCreator.class.getName());
		classNameList.add(SearcherDaoFileCreator.class.getName());

		classNameList.add(VirtualDbTableFileCreator.class.getName());
		classNameList.add(SelectListFileCreator.class.getName());
		classNameList.add(WebAppFileCreator.class.getName());

		classNameList.add(CsvFileInputJavaFileCreator.class.getName());
		classNameList.add(CsvFileOutputJavaFileCreator.class.getName());

		// Tvf[
		classNameList.add(MstMntSample.class.getName());
		classNameList.add(MultiMstMntSample.class.getName());

		classNameList.add(GaeMstMntSample.class.getName());
		classNameList.add(CsvFileOutputJavaSample.class.getName());

	}

	/**
	 * 
	 */
	private void init() {

		logger.info("vOC̎荞݂Jn܂");

		List<String> classNameList = new LinkedList<String>();

		setStandardPlugin(classNameList);// W̃vOCZbg

		InputStream is = null;
		BufferedReader br = null;

		try {
			try {
				try {
					is = getClass().getResourceAsStream(PLUGIN_FILE_NAME);
					if (is != null) {
						br = new BufferedReader(new InputStreamReader(is, "UTF-8"));

						while (true) {
							String line = br.readLine();
							if (line == null) {
								break;
							}

							classNameList.add(line);
						}
					}

				} finally {
					if (br != null) {
						br.close();
					}
				}
			} finally {
				if (is != null) {
					is.close();
				}
			}
		} catch (IOException e) {
			logger.fatal("vOCt@C̓ǂݍݎɗ\ʃG[܂", e);
		}

		for (String className : classNameList) {

			try {
				Class<?> classObj = Class.forName(className);
				if (classObj != null) {

					Object pluginObj = classObj.newInstance();

					if (pluginObj instanceof Plugin) {
						Plugin plugin = (Plugin) pluginObj;

						boolean hit = false;
						if (plugin instanceof InterfaceDesignerPlugin) {
							interfaceDesignerPluginMap.put(plugin.getName(), (InterfaceDesignerPlugin) plugin);
							hit = true;
							logger.info("C^[tF[XfUCEvOC荞݂܂ " + plugin.getNameJp());
						}

						if (plugin instanceof FileCreatorSampleModelerPlugin) {
							attachPluginMap.put(plugin.getName(), (FileCreatorSampleModelerPlugin) plugin);
							hit = true;
							logger.info("A^b`EvOC荞݂܂ " + plugin.getNameJp());
						}

						if (!hit) {
							logger.warn("m̃vOCł " + plugin.getNameJp());
						}
					} else {
						logger.warn("vOCł͂܂ " + className);
					}
				} else {
					logger.warn("vOCNX݂܂ " + className);
				}
			} catch (ClassNotFoundException e) {
				logger.warn("vOCNX݂܂ " + className);
			} catch (Exception e) {
				logger.error("vOC̍쐬ɗ\ʃG[܂ " + className, e);
			}
		}
		logger.info("vOC̎荞͏I܂");
	}

	/**
	 * IuWFNg̎擾
	 *
	 * @return vOC}l[W[
	 */
	public static PluginManager getInstance() {
		return myObj;
	}

	/**
	 * ݊ǗĂC^[tF[XfUCIuWFNg̈ꗗ擾
	 *
	 * @return C^[tF[XfUCIuWFNg̈ꗗ
	 */
	public InterfaceDesignerPlugin[] getInterfaceDesignerPluginList() {
		return interfaceDesignerPluginMap.values().toArray(new InterfaceDesignerPlugin[0]);
	}

	/**
	 * w肳ꂽvOCC^[tF[XfUCIuWFNg擾
	 *
	 * @param name
	 *            C^[tF[XfUCvOC
	 * @return C^[tF[XfUCIuWFNg
	 */
	public InterfaceDesignerPlugin getInterfaceDesignerPlugin(String name) {
		return interfaceDesignerPluginMap.get(name);
	}

	/**
	 * ݊ǗĂt@CNG[^[vOCATvf[vOC̈ꗗ擾
	 *
	 * @return t@CNG[^[vOCATvf[vOC̈ꗗ
	 */
	public FileCreatorSampleModelerPlugin[] getAttachPluginList() {
		return attachPluginMap.values().toArray(new FileCreatorSampleModelerPlugin[0]);
	}

	/**
	 *w肳ꂽvOCt@CNG[^[vOCATvf[vOC擾
	 *
	 * @param name
	 *            t@CNG[^[vOCATvf[vOC
	 *
	 * @return t@CNG[^[vOCATvf[vOC
	 */
	public FileCreatorSampleModelerPlugin getAttachPlugin(String name) {
		return attachPluginMap.get(name);
	}
}
