package jp.oarts.pirka.iop.tool.core.general.vo;

import java.io.Serializable;

import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlCreatorNode;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlParserData;

/**
 * CN[h
 *
 * @author ito
 *
 */
public class IncludeInfo implements Cloneable, Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 4907448763390589276L;

	/** CN[hID */
	private int includeId;

	/** CN[hEC^[tF[XID */
	private int includeDataId;

	/** V[PXԍiC^[tF[XIDj */
	private int seqNo;

	/**
	 * RXgN^ CN[hID
	 *
	 * @param includeId
	 *            CN[hEC^[tF[XID
	 * @param includeDataId
	 *            V[PXԍ
	 * @param seqNo
	 */
	public IncludeInfo(int includeId, int includeDataId, int seqNo) {
		this.includeId = includeId;
		this.includeDataId = includeDataId;
		this.seqNo = seqNo;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();

		sb.append("includeId=");
		sb.append(includeId);
		sb.append(", ");

		sb.append("includeDataId=");
		sb.append(includeDataId);
		sb.append(", ");

		sb.append("seqNo=");
		sb.append(seqNo);

		return sb.toString();
	}

	/**
	 * ̃IuWFNgXML֊i[
	 *
	 * @param baseNode
	 */
	public void toXml(XmlCreatorNode baseNode) {

		baseNode.appendChild(new XmlCreatorNode("includeId", includeId));
		baseNode.appendChild(new XmlCreatorNode("includeDataId", includeDataId));
		baseNode.appendChild(new XmlCreatorNode("seqNo", seqNo));
	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param xml
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 * @throws NumberFormatException
	 */
	public static IncludeInfo fromXml(XmlParserData xml) throws NumberFormatException, InterfaceException {
		return new IncludeInfo(xml.getInt("includeId"), xml.getInt("includeDataId"), xml.getInt("seqNo"));
	}

	@Override
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			return null;
		}
	}

	/**
	 * @return includeId
	 */
	public int getIncludeId() {
		return includeId;
	}

	/**
	 * @return includeDataId
	 */
	public int getIncludeDataId() {
		return includeDataId;
	}

	/**
	 * @return seqNo
	 */
	public int getSeqNo() {
		return seqNo;
	}

}
