package jp.oarts.pirka.iop.tool.core.general.vo;

import java.io.Serializable;

import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlCreatorNode;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlParserData;

/**
 * C^[tF[X
 *
 * @author ito
 *
 */
public class InterfaceDataItem implements Cloneable, Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 6315651249698918623L;

	/** C^[tFXID */
	private int dataId;

	/** C^[tFXID */
	private int itemId;

	/** ꍀڃtO true=Afalse=CN[h */
	private boolean baseItem;

	/** CN[hID 0͋K */
	private int includeId;

	/** CN[h̃C^[tFXID */
	private int includeDataId;

	/** CN[h̃C^[tFXID */
	private int includeItemId;

	/** O */
	private String name;

	/** {ꖼ */
	private String nameJp;

	/** tB[h^Cv */
	private FieldType type;

	/** ڒ */
	private long length;

	/** _ȉ̌ */
	private int subLength;

	/** LtO */
	private boolean enable;

	/** ̃IuWFNgɐݒ肳Ă閼O̎gptO */
	private boolean useName;

	/** ̃IuWFNgɐݒ肳Ă{ꖼ̎gptO */
	private boolean useNameJp;

	/** ̃IuWFNgɐݒ肳ĂtB[h^Cv̎gptO */
	private boolean useType;

	/** ̃IuWFNgɐݒ肳Ă鍀ڒ̎gptO */
	private boolean useLength;

	/** R[h^Cv */
	private boolean multiRecordType;

	/** ̃IuWFNgɐݒ肳Ă镡R[h^Cv̎gptO */
	private boolean useMultiRecordType;

	/** L[͉zL[̃`FbN	*/
	private boolean primaryKey;

	/**
	 *RXgN^
	 *
	 * @param dataId
	 *            C^[tF[XID
	 * @param itemId
	 *            C^[tF[XID
	 */
	public InterfaceDataItem(int dataId, int itemId) {
		this.dataId = dataId;
		this.itemId = itemId;

		this.baseItem = true;

		this.includeId = 0;
		this.includeDataId = 0;
		this.includeItemId = 0;

		this.name = null;
		this.nameJp = null;

		this.type = null;
		this.length = 0;
		this.subLength = 0;

		this.enable = true;

		useName = false;
		useNameJp = false;
		useType = false;
		useLength = false;

		multiRecordType = false;
		useMultiRecordType = false;
		primaryKey = false;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();

		sb.append("dataId=");
		sb.append(dataId);
		sb.append(", ");

		sb.append("itemId=");
		sb.append(itemId);
		sb.append(", ");

		sb.append("baseItem=");
		sb.append(baseItem);
		sb.append(", ");

		sb.append("includeId=");
		sb.append(includeId);
		sb.append(", ");

		sb.append("includeDataId=");
		sb.append(includeDataId);
		sb.append(", ");

		sb.append("includeItemId=");
		sb.append(includeItemId);
		sb.append(", ");

		sb.append("name=");
		sb.append(name);
		sb.append(", ");

		sb.append("nameJp=");
		sb.append(nameJp);
		sb.append(", ");

		sb.append("type=");
		sb.append(type);
		sb.append(", ");

		sb.append("length=");
		sb.append(length);
		sb.append(", ");

		sb.append("subLength=");
		sb.append(subLength);
		sb.append(", ");

		sb.append("enable=");
		sb.append(enable);
		sb.append(", ");

		sb.append("useName=");
		sb.append(useName);
		sb.append(", ");

		sb.append("useNameJp=");
		sb.append(useNameJp);
		sb.append(", ");

		sb.append("useType=");
		sb.append(useType);
		sb.append(", ");

		sb.append("useLength=");
		sb.append(useLength);
		sb.append(", ");

		sb.append("multiRecordType=");
		sb.append(multiRecordType);
		sb.append(", ");

		sb.append("useMultiRecordType=");
		sb.append(useMultiRecordType);
		sb.append(", ");

		sb.append("primaryKey=");
		sb.append(primaryKey);

		return sb.toString();
	}

	/**
	 * ̃IuWFNgXML֊i[
	 *
	 * @param baseNode
	 */
	public void toXml(XmlCreatorNode baseNode) {

		baseNode.appendChild(new XmlCreatorNode("dataId", dataId));
		baseNode.appendChild(new XmlCreatorNode("itemId", itemId));
		baseNode.appendChild(new XmlCreatorNode("baseItem", baseItem));
		baseNode.appendChild(new XmlCreatorNode("includeId", includeId));
		baseNode.appendChild(new XmlCreatorNode("includeDataId", includeDataId));
		baseNode.appendChild(new XmlCreatorNode("includeItemId", includeItemId));

		baseNode.appendChild(new XmlCreatorNode("name", name));
		baseNode.appendChild(new XmlCreatorNode("nameJp", nameJp));
		baseNode.appendChild(new XmlCreatorNode("type", "" + type));
		baseNode.appendChild(new XmlCreatorNode("length", "" + length));
		baseNode.appendChild(new XmlCreatorNode("subLength", "" + subLength));
		baseNode.appendChild(new XmlCreatorNode("enable", enable));

		baseNode.appendChild(new XmlCreatorNode("useName", useName));
		baseNode.appendChild(new XmlCreatorNode("useNameJp", useNameJp));
		baseNode.appendChild(new XmlCreatorNode("useType", useType));
		baseNode.appendChild(new XmlCreatorNode("useLength", useLength));

		baseNode.appendChild(new XmlCreatorNode("multiRecordType", multiRecordType));
		baseNode.appendChild(new XmlCreatorNode("useMultiRecordType", useMultiRecordType));

		baseNode.appendChild(new XmlCreatorNode("primaryKey", primaryKey));



	}

	/**
	 * XMLf[^莩IuWFNg쐬
	 *
	 * @param xml
	 *            XMLf[^
	 * @return IuWFNg
	 * @throws InterfaceException
	 * @throws NumberFormatException
	 */
	public static InterfaceDataItem fromXml(XmlParserData xml) throws NumberFormatException, InterfaceException {
		InterfaceDataItem obj = new InterfaceDataItem(xml.getInt("dataId"), xml.getInt("itemId"));

		obj.setBaseItem(xml.getBoolean("baseItem"));
		obj.setIncludeId(xml.getInt("includeId"));

		obj.setIncludeDataId(xml.getInt("includeDataId"));
		obj.setIncludeItemId(xml.getInt("includeItemId"));

		obj.setName(xml.getString("name"));
		obj.setNameJp(xml.getString("nameJp"));
		obj.setType(FieldType.valueOf(xml.getString("type")));
		obj.setLength(xml.getLong("length"));

		try {
			obj.setSubLength(xml.getInt("subLength"));
		} catch (InterfaceException e) {
			obj.setSubLength(0);
		}

		obj.setEnable(xml.getBoolean("enable"));

		obj.setUseName(xml.getBoolean("useName"));
		obj.setUseNameJp(xml.getBoolean("useNameJp"));
		obj.setUseType(xml.getBoolean("useType"));
		obj.setUseLength(xml.getBoolean("useLength"));

		// ȉ͐VݍڂłAߋf[^Ƃ̌݊̂ߖfalsei[
		try {
			obj.setMultiRecordType(xml.getBoolean("multiRecordType"));
		} catch (InterfaceException e) {
			obj.setMultiRecordType(false);
		}

		// ȉ͐VݍڂłAߋf[^Ƃ̌݊̂ߖfalsei[
		try {
			obj.setUseMultiRecordType(xml.getBoolean("useMultiRecordType"));
		} catch (InterfaceException e) {
			obj.setUseMultiRecordType(false);
		}

		// ȉ͐VݍڂłAߋf[^Ƃ̌݊̂ߖfalsei[
		try {
			obj.setPrimaryKey(xml.getBoolean("primaryKey"));
		} catch (InterfaceException e) {
			obj.setPrimaryKey(false);
		}


		return obj;
	}

	/*
	 * ( Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	@Override
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			return null;
		}
	}

	/**
	 * @return includeId
	 */
	public int getIncludeId() {
		return includeId;
	}

	/**
	 * @param includeId
	 *            Zbg includeId
	 */
	public void setIncludeId(int includeId) {
		this.includeId = includeId;
	}

	/**
	 * @return dataId
	 */
	public int getDataId() {
		return dataId;
	}

	/**
	 * @return itemId
	 */
	public int getItemId() {
		return itemId;
	}

	/**
	 * @return baseItem
	 */
	public boolean isBaseItem() {
		return baseItem;
	}

	/**
	 * @return includeDataId
	 */
	public int getIncludeDataId() {
		return includeDataId;
	}

	/**
	 * @return includeItemId
	 */
	public int getIncludeItemId() {
		return includeItemId;
	}

	/**
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return nameJp
	 */
	public String getNameJp() {
		return nameJp;
	}

	/**
	 * @return type
	 */
	public FieldType getType() {
		return type;
	}

	/**
	 * @return length
	 */
	public long getLength() {
		return length;
	}

	/**
	 * @return enable
	 */
	public boolean isEnable() {
		return enable;
	}

	/**
	 * @return useName
	 */
	public boolean isUseName() {
		return useName;
	}

	/**
	 * @return useNameJp
	 */
	public boolean isUseNameJp() {
		return useNameJp;
	}

	/**
	 * @return useType
	 */
	public boolean isUseType() {
		return useType;
	}

	/**
	 * @return useLength
	 */
	public boolean isUseLength() {
		return useLength;
	}

	/**
	 * @param dataId
	 *            Zbg dataId
	 */
	public void setDataId(int dataId) {
		this.dataId = dataId;
	}

	/**
	 * @param itemId
	 *            Zbg itemId
	 */
	public void setItemId(int itemId) {
		this.itemId = itemId;
	}

	/**
	 * @param baseItem
	 *            Zbg baseItem
	 */
	public void setBaseItem(boolean baseItem) {
		this.baseItem = baseItem;
	}

	/**
	 * @param includeDataId
	 *            Zbg includeDataId
	 */
	public void setIncludeDataId(int includeDataId) {
		this.includeDataId = includeDataId;
	}

	/**
	 * @param includeItemId
	 *            Zbg includeItemId
	 */
	public void setIncludeItemId(int includeItemId) {
		this.includeItemId = includeItemId;
	}

	/**
	 * @param name
	 *            Zbg name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @param nameJp
	 *            Zbg nameJp
	 */
	public void setNameJp(String nameJp) {
		this.nameJp = nameJp;
	}

	/**
	 * @param type
	 *            Zbg type
	 */
	public void setType(FieldType type) {
		this.type = type;
	}

	/**
	 * @param length
	 *            Zbg length
	 */
	public void setLength(long length) {
		this.length = length;
	}

	/**
	 * @param enable
	 *            Zbg enable
	 */
	public void setEnable(boolean enable) {
		this.enable = enable;
	}

	/**
	 * @param useName
	 *            Zbg useName
	 */
	public void setUseName(boolean useName) {
		this.useName = useName;
	}

	/**
	 * @param useNameJp
	 *            Zbg useNameJp
	 */
	public void setUseNameJp(boolean useNameJp) {
		this.useNameJp = useNameJp;
	}

	/**
	 * @param useType
	 *            Zbg useType
	 */
	public void setUseType(boolean useType) {
		this.useType = useType;
	}

	/**
	 * @param useLength
	 *            Zbg useLength
	 */
	public void setUseLength(boolean useLength) {
		this.useLength = useLength;
	}

	/**
	 * @return subLength
	 */
	public int getSubLength() {
		return subLength;
	}

	/**
	 * @param subLength
	 *            Zbg subLength
	 */
	public void setSubLength(int subLength) {
		this.subLength = subLength;
	}

	/**
	 * @return the multiRecordType
	 */
	public boolean isMultiRecordType() {
		return multiRecordType;
	}

	/**
	 * @param multiRecordType
	 *            the multiRecordType to set
	 */
	public void setMultiRecordType(boolean multiRecordType) {
		this.multiRecordType = multiRecordType;
	}

	/**
	 * @return the useMultiRecordType
	 */
	public boolean isUseMultiRecordType() {
		return useMultiRecordType;
	}

	/**
	 * @param useMultiRecordType
	 *            the useMultiRecordType to set
	 */
	public void setUseMultiRecordType(boolean useMultiRecordType) {
		this.useMultiRecordType = useMultiRecordType;
	}

	/**
	 * @return the primaryKey
	 */
	public boolean isPrimaryKey() {
		return primaryKey;
	}

	/**
	 * @param primaryKey the primaryKey to set
	 */
	public void setPrimaryKey(boolean primaryKey) {
		this.primaryKey = primaryKey;
	}

}
