package jp.oarts.pirka.iop.tool.core.plugin.file.basichtml;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeChecker;
import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * {IHTMLt@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class BasicHtmlFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = -3818477629989663402L;

	//	vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#BasicHtmlFileCreator";

	//	vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "{IHTMLt@Co";

	// `
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

			//
			new AttributeSimpleItem("controlType", "Rg[^Cv", "WEBʏł̃Rg[̃^CvI܂", AttributeType.SELECT, 0,
					new AttributeData("nonUse"), new AttributeChecker() {

						@Override
						public void check(String value, InterfaceDataItem item) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("Iĉ");
							}
						}
					},
					//
					new Selecter("nonUse", "gpȂ"), new Selecter("fixed", "Œ蕶\"),
					//
					new Selecter("display", "\̂"), new Selecter("password", "pX[h"), new Selecter("text", "eLXg"),
					//
					new Selecter("textarea", "seLXg"),
					//
					new Selecter("file", "t@C"), new Selecter("selectMenu", "Ij["),
					//
					new Selecter("selectList", "IXg"), new Selecter("checkbox", "`FbN"),
					//
					new Selecter("procSubmit", "̂݃{^"), new Selecter("returnSubmit", "߂{^"),
					//
					new Selecter("moveSubmit", "Ɖʈړ{^"), new Selecter("downloadSubmit", "t@C_E[h{^"),
					//
					new Selecter("link", "N")
			//
			),

			//
			new AttributeSimpleItem("required", "K{", "K{`FbNs͂̎Ƀ`FbN܂", AttributeType.CHECK, new AttributeData(false),
					null),
			new AttributeSimpleItem("noCheckButton", "`FbN{^", "`FbN𖳌ɂ{^̎Ƀ`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			new AttributeSimpleItem("underLengthNg", "ڒ̓G[", "w肳ꂽڒZ̓͂ȂɃ`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			//
			new AttributeSimpleItem("stringChaeck", "͎̃`FbN", "͂̎ɍs`FbNw肵Ă", AttributeType.SELECT, 0,
					new AttributeData("noCheck"), null,
					//
					new Selecter("noCheck", "`FbNȂ"), new Selecter("numCheck", "p"),
					//
					new Selecter("ACheck", "pp啶"), new Selecter("aCheck", "pp"), new Selecter("AaCheck", "pp"),
					//
					new Selecter("numACheck", "pp啶"), new Selecter("numaCheck", "pp"), new Selecter("numAaCheck",
							"pp"),
					//
					new Selecter("allHankakuCheck", "SĂ̔p"), new Selecter("allZenkakuCheck", "SĂ̑Sp"),
					//
					new Selecter("hankakuKatakanaCheck", "pJ^Ji"), new Selecter("zenkakuKatakanaCheck", "SpJ^Ji"),
					//
					new Selecter("zenkakuHiraganaCheck", "SpЂ炪"), new Selecter("ninniStringChek", "Cӂ̕i\[XɃTvj")

			//
			),
			//

			new AttributeSimpleItem("dokujiCheck", "Ǝ`FbJ[t", "Ǝ̃`FbJ[𗘗pƂɃ`FbN܂ \[XR[hɓƎ`FbJ[̐`}܂",
					AttributeType.CHECK, new AttributeData(false), null),

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//

			new ParameterSimpleItem("errorMessage", "G[\^Oǉ", "HTMLt@Cprikap̓G[\^u𖄂ߍގ̓`FbN܂",
					ParameterType.CHECK, new ParameterData(true), null),
			new ParameterSimpleItem("useTable", "e[u^Ogp", "o͂HTMLt@Ce[u^OgpĐ`鎞Ƀ`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),

	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public BasicHtmlFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true,
				true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "{IHTMLt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "{IHTMLt@Co͂鎞ɃAb^`܂";
	}

	@Override
	public String getParameterComment() {
		return "{IHTMLt@Co͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + getNameJp() + "x\nAb^`ĂKv܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());
		}

		if (interfaceData == null || !interfaceData.isAttached(getName())) {
			throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + getNameJp() + "xAb^b`Kv܂");
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		boolean useTable = dataMap.get("useTable").getValueBoolean();
		boolean errorMessage = dataMap.get("errorMessage").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		ByteArrayOutputStream baos = null;

		String pattern = "";
		if (useTable) {
			pattern = "pattern02 ";
		} else {
			pattern = "pattern01 ";
		}

		// Rg[^Cvݒ肳ĂȂ͎gpȂID폜
		Integer[] itemIdsWk = interfaceData.getEnableItemIdList();
		List<Integer> itemIdListWk = new ArrayList<Integer>();
		for (Integer id : itemIdsWk) {
			AttributeData controlType = interfaceData.getAttribute(id, getName(), "controlType");
			if (controlType != null && !"nonUse".equals(controlType.getValue())) {
				itemIdListWk.add(id);
			}
		}
		Integer[] itemIds = itemIdListWk.toArray(new Integer[0]);

		try {
			try {
				baos = new ByteArrayOutputStream();

				out(baos, getText("header 1"));

				if (useTable) {
					out(baos, getText("pattern02 css"));
				}

				out(baos, getText("header 2", "title", interfaceData.getNameJp()));
				out(baos, getText(pattern + "header", "title", interfaceData.getNameJp()));

				if (errorMessage) {
					out(baos, getText(pattern + "error"));
				}

				AttributeData controlType = null;

				for (int i = 0; i < itemIds.length; i++) {

					int itemId = itemIds[i];
					InterfaceDataItem item = interfaceData.getItem(itemId);

					controlType = interfaceData.getAttribute(itemId, getName(), "controlType");

					AttributeData preControlType = null;
					if (i > 0) {
						preControlType = interfaceData.getAttribute(itemIds[i - 1], getName(), "controlType");
					}

					AttributeData nextControlType = null;
					if (i < (itemIds.length - 1)) {
						nextControlType = interfaceData.getAttribute(itemIds[i + 1], getName(), "controlType");
					}

					if (!useTable) {
						if (isButtonCtrl(controlType.getValue()) && nextControlType != null
								&& !isButtonCtrl(nextControlType.getValue())) {
							setParameter("br", "<br>");
						} else {
							setParameter("br", "");
						}
					} else {
						if ((preControlType == null && isButtonCtrl(controlType.getValue()))
								|| (preControlType != null && !isButtonCtrl(preControlType.getValue()) && isButtonCtrl(controlType
										.getValue()))) {
							out(baos, getText("pattern02 submit start"));
						}
					}

					setParameter("name", item.getName());
					setParameter("nameJp", item.getNameJp());
					setParameter("option", "");

					if ("fixed".equals(controlType.getValue())) {
						out(baos, getText(pattern + "fixed"));

					} else if ("display".equals(controlType.getValue())) {
						out(baos, getText(pattern + "display"));

					} else if ("password".equals(controlType.getValue())) {
						if (item.getLength() > 0) {
							setParameter("option", "maxlength=\"" + item.getLength() + "\" size=\"" + (item.getLength() * 2)
									+ "\"");
						}
						out(baos, getText(pattern + "password"));

					} else if ("text".equals(controlType.getValue())) {
						switch (item.getType()) {

						case STRING:
							if (item.getLength() > 0) {
								setParameter("option", "maxlength=\"" + item.getLength() + "\" size=\""
										+ (item.getLength() * 2) + "\"");
							}
							break;
						case NUM:
							if (item.getLength() > 0) {
								if (item.getSubLength() > 0) {
									setParameter("option", "maxlength=\"" + (item.getLength() + item.getSubLength() + 2)
											+ "\" size=\"" + (((item.getLength() + item.getSubLength() + 2) * 15) / 10) + "\"");
								} else {
									setParameter("option", "maxlength=\"" + (item.getLength() + 1) + "\", size=\""
											+ (((item.getLength() + 1) * 15) / 10) + "\"");
								}
							}
							break;
						case DATE:
							setParameter("option", "size=\"21\"");
							break;
						case TIME:
							setParameter("option", "size=\"18\"");
							break;
						case DATE_TIME:
							setParameter("option", "size=\"42\"");
							break;

						}
						out(baos, getText(pattern + "text"));

					} else if ("textarea".equals(controlType.getValue())) {
						out(baos, getText(pattern + "textarea"));

					} else if ("file".equals(controlType.getValue())) {
						out(baos, getText(pattern + "file"));

					} else if ("selectMenu".equals(controlType.getValue())) {
						out(baos, getText(pattern + "selectMenu"));

					} else if ("selectList".equals(controlType.getValue())) {
						out(baos, getText(pattern + "selectList"));

					} else if ("checkbox".equals(controlType.getValue())) {
						out(baos, getText(pattern + "checkbox"));

					} else if ("procSubmit".equals(controlType.getValue())) {
						out(baos, getText(pattern + "submit"));

					} else if ("returnSubmit".equals(controlType.getValue())) {
						out(baos, getText(pattern + "submit"));

					} else if ("moveSubmit".equals(controlType.getValue())) {
						out(baos, getText(pattern + "submit"));

					} else if ("downloadSubmit".equals(controlType.getValue())) {
						out(baos, getText(pattern + "submit"));

					} else if ("link".equals(controlType.getValue())) {
						out(baos, getText(pattern + "link"));

					}
					if (useTable) {
						if (isButtonCtrl(controlType.getValue())
								&& (nextControlType != null && !isButtonCtrl(nextControlType.getValue()) || nextControlType == null)) {
							out(baos, getText("pattern02 submit end"));
						}
					}
				}

				out(baos, getText(pattern + "footer"));

				out(baos, getText("footer"));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return new AttributeFileImage(InterfaceTools.changeClassNmae(interfaceData.getName()) + ".html", baos.toByteArray());

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * {^Rg[̊mF
	 *
	 * @param ctrlTypeName
	 * @return	true={^Rg[
	 */
	protected boolean isButtonCtrl(String ctrlTypeName) {

		if ("procSubmit".equals(ctrlTypeName)) {
			return true;
		}
		if ("returnSubmit".equals(ctrlTypeName)) {
			return true;
		}
		if ("moveSubmit".equals(ctrlTypeName)) {
			return true;
		}
		if ("downloadSubmit".equals(ctrlTypeName)) {
			return true;
		}
		return false;

	}

}
