package jp.oarts.pirka.iop.tool.core.plugin.file.basichtml;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.DbType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * {IHTMLRg[Jav\[Xt@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class BasicHtmlJavaFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#BasicHtmlJavaFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "{IHTMLRg[Java\[Xt@Co";

	private static final HashSet<String> canUseDataCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseInputDataCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseSelectListCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseRequiredCheckCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseNoCheckButtonbuttonCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseFreeInputTextCtrlSet = new HashSet<String>();
	private static final HashMap<String, String> stringCheckerMap = new HashMap<String, String>();

	private static final HashSet<String> useActionCtrlSet = new HashSet<String>();

	static {

		canUseDataCtrlSet.add("display");
		canUseDataCtrlSet.add("password");
		canUseDataCtrlSet.add("text");
		canUseDataCtrlSet.add("textarea");
		canUseDataCtrlSet.add("file");
		canUseDataCtrlSet.add("selectMenu");
		canUseDataCtrlSet.add("selectList");
		canUseDataCtrlSet.add("checkbox");

		canUseInputDataCtrlSet.add("password");
		canUseInputDataCtrlSet.add("text");
		canUseInputDataCtrlSet.add("textarea");
		canUseInputDataCtrlSet.add("file");
		canUseInputDataCtrlSet.add("selectMenu");
		canUseInputDataCtrlSet.add("selectList");
		canUseInputDataCtrlSet.add("checkbox");

		canUseRequiredCheckCtrlSet.add("password");
		canUseRequiredCheckCtrlSet.add("text");
		canUseRequiredCheckCtrlSet.add("textarea");
		canUseRequiredCheckCtrlSet.add("file");
		canUseRequiredCheckCtrlSet.add("selectMenu");
		canUseRequiredCheckCtrlSet.add("selectList");

		canUseSelectListCtrlSet.add("selectMenu");
		canUseSelectListCtrlSet.add("selectList");

		canUseNoCheckButtonbuttonCtrlSet.add("procSubmit");
		canUseNoCheckButtonbuttonCtrlSet.add("returnSubmit");
		canUseNoCheckButtonbuttonCtrlSet.add("moveSubmit");
		canUseNoCheckButtonbuttonCtrlSet.add("downloadSubmit");

		canUseFreeInputTextCtrlSet.add("password");
		canUseFreeInputTextCtrlSet.add("text");
		canUseFreeInputTextCtrlSet.add("textarea");

		stringCheckerMap.put("numCheck", "PirkaCheckerStringChars.NUM");
		stringCheckerMap.put("ACheck", "PirkaCheckerStringChars.HIGHT_ALPHABET");
		stringCheckerMap.put("aCheck", "PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("AaCheck", "PirkaCheckerStringChars.HIGHT_ALPHABET, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("numACheck", "PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.HIGHT_ALPHABET");
		stringCheckerMap.put("numaCheck", "PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("numAaCheck",
				"PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.HIGHT_ALPHABET, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("allHankakuCheck", "PirkaCheckerStringChars.HALF");
		stringCheckerMap.put("allZenkakuCheck", "PirkaCheckerStringChars.WIDE");
		stringCheckerMap.put("hankakuKatakanaCheck", "PirkaCheckerStringChars.HARF_KANA");
		stringCheckerMap.put("zenkakuKatakanaCheck", "PirkaCheckerStringChars.WIDE_KATAKANA");
		stringCheckerMap.put("zenkakuHiraganaCheck", "PirkaCheckerStringChars.WIDE_HIRAGANA");
		stringCheckerMap.put("ninniStringChek", "new PirkaCheckerStringChars(\"͓͂镶ɒuĂ\")");

		useActionCtrlSet.add("procSubmit");
		useActionCtrlSet.add("returnSubmit");
		useActionCtrlSet.add("moveSubmit");
		useActionCtrlSet.add("downloadSubmit");
		useActionCtrlSet.add("link");
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//

			new ParameterSimpleItem("dokujiMessage", "ƎG[bZ[Wgp",
					"`FbNprikaW̃G[bZ[Wł͖Ǝ̃bZ[W\ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(false),
					null),
			//

			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
	//
			new ParameterSimpleItem("logout", "Oo̓R[ht",
					"샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(true),
					null),
			//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public BasicHtmlJavaFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "{IHTML𐧌䂷Java\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "{IHTML𐧌䂷Java\[Xt@Co͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + BasicHtmlFileCreator.PLUGIN_NAME_JP + "x\nAb^`ĂKv܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());
		}

		if (interfaceData == null || !interfaceData.isAttached(BasicHtmlFileCreator.PLUGIN_NAME)) {
			throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + BasicHtmlFileCreator.PLUGIN_NAME_JP + "xAb^b`Kv܂");
		}

		IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);

	}
	
	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		boolean logout = dataMap.get("logout").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());
		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		try {

			fileMap.put(className + ".java", createJava(dataMap, interfaceProject));

			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "DaoJava.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	public byte[] createJava(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		boolean dokujiMessage = dataMap.get("dokujiMessage").getValueBoolean();
		boolean logout = dataMap.get("logout").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;

		Integer[] itemIds = interfaceData.getEnableItemIdList();

		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("package", "package", packageName));
				}

				// C|[go&o
				boolean incBigDecimal = false;
				boolean incDate = false;
				boolean incTime = false;
				boolean incTimestamp = false;
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType != null && canUseDataCtrlSet.contains(controlType.getValue())) {
						switch (item.getType()) {
						case NUM:
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								incBigDecimal = true;
							}
							break;
						case DATE:
							incDate = true;
							break;
						case TIME:
							incTime = true;
							break;
						case DATE_TIME:
							incTimestamp = true;
							break;
						}
					}
				}
				if (incBigDecimal) {
					out(baos, getText("import BigDecimal"));
				}
				if (incDate) {
					out(baos, getText("import Date"));
				}
				if (incTime) {
					out(baos, getText("import Time"));
				}
				if (incTimestamp) {
					out(baos, getText("import Timestamp"));
				}
				if (logout) {
					out(baos, getText("import logger"));
				}

				// wb_o
				out(baos, getText("import", "className", className, "nameJp", interfaceData.getNameJp()));
				if(logout){
					out(baos, getText("logger", "className", className, "nameJp", interfaceData.getNameJp()));
				}
				out(baos, getText("class", "className", className, "nameJp", interfaceData.getNameJp()));

				int checkerCount = 0;

				// `FbJ[o
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					AttributeData dokujiItemCheck = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"dokujiCheck");

					// K{`FbN
					if (controlType != null && canUseRequiredCheckCtrlSet.contains(controlType.getValue())) {
						AttributeData required = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
								"required");
						if (required != null && required.getValueBoolean()) {
							if (!dokujiMessage) {
								checkerCount++;
								out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.required"));
							} else {
								checkerCount++;
								out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.required",
										"message", "" + item.getNameJp() + "͎̃G[bZ[WɒuĂ"));
							}
						}
					}

					// ^`FbN
					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {

						if (item.getType() == FieldType.STRING) {
							if (item.getLength() > 0) {
								AttributeData underLengthNg = interfaceData.getAttribute(itemId,
										BasicHtmlFileCreator.PLUGIN_NAME, "underLengthNg");

								if (!dokujiMessage) {
									checkerCount++;
									if (underLengthNg != null && underLengthNg.getValueBoolean()) {
										out(baos, getText("addCheck", "name", item.getName(), "checker",
												"new PirkaCheckerLength(PirkaCheckerLength.JUST, " + item.getLength() + ")"));
									} else {
										out(baos,
												getText("addCheck", "name", item.getName(), "checker",
														"new PirkaCheckerLength(PirkaCheckerLength.RANGE, 0, "
																+ item.getLength() + ")"));
									}
								} else {
									checkerCount++;
									if (underLengthNg != null && underLengthNg.getValueBoolean()) {
										out(baos, getText("addCheck with message", "name", item.getName(), "checker",
												"new PirkaCheckerLength(PirkaCheckerLength.JUST, " + item.getLength() + ")",
												"message", "" + item.getNameJp() + "G[̃G[bZ[WɒuĂ"));
									} else {
										out(baos,
												getText("addCheck with message", "name", item.getName(), "checker",
														"new PirkaCheckerLength(PirkaCheckerLength.RANGE, 0, "
																+ item.getLength() + ")", "message", "" + item.getNameJp()
																+ "I[o[̃G[bZ[WɒuĂ"));
									}
								}
							}

							AttributeData stringChaeck = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
									"stringChaeck");
							if (stringChaeck != null) {
								String checkStr = stringCheckerMap.get(stringChaeck.getValue());
								if (checkStr != null && checkStr.length() > 0) {
									if (!dokujiMessage) {
										checkerCount++;
										out(baos, getText("addCheck", "name", item.getName(), "checker",
												"new PirkaCheckerString(" + checkStr + ")"));
									} else {
										checkerCount++;
										out(baos, getText("addCheck with message", "name", item.getName(), "checker",
												"new PirkaCheckerString(" + checkStr + ")", "message", ""
														+ item.getNameJp() + "̓G[̃G[bZ[WɒuĂ"));
									}
								}
							}

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								if (!dokujiMessage) {
									checkerCount++;
									out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.intValue"));
								} else {
									checkerCount++;
									out(baos, getText("addCheck with message", "name", item.getName(), "checker",
											"PirkaChecker.intValue", "message", "" + item.getNameJp()
													+ "͒lG[̃G[bZ[WɒuĂ"));
								}
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								if (!dokujiMessage) {
									checkerCount++;
									out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.longValue"));
								} else {
									checkerCount++;
									out(baos, getText("addCheck with message", "name", item.getName(), "checker",
											"PirkaChecker.longValue", "message", "" + item.getNameJp()
													+ "͒lG[̃G[bZ[WɒuĂ"));
								}
							} else {
								if (!dokujiMessage) {
									checkerCount++;
									out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.numeric"));
								} else {
									checkerCount++;
									out(baos, getText("addCheck with message", "name", item.getName(), "checker",
											"PirkaChecker.numeric", "message", "" + item.getNameJp()
													+ "͒lG[̃G[bZ[WɒuĂ"));
								}
							}

						} else if (item.getType() == FieldType.DATE) {
							if (!dokujiMessage) {
								checkerCount++;
								out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.date"));
							} else {
								checkerCount++;
								out(baos, getText("addCheck with message", "name", item.getName(), "checker",
										"PirkaChecker.date", "message", "" + item.getNameJp()
												+ "͒lG[̃G[bZ[WɒuĂ"));
							}

						} else if (item.getType() == FieldType.TIME) {
							if (!dokujiMessage) {
								checkerCount++;
								out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.time"));
							} else {
								checkerCount++;
								out(baos, getText("addCheck with message", "name", item.getName(), "checker",
										"PirkaChecker.time", "message", "" + item.getNameJp()
												+ "͒lG[̃G[bZ[WɒuĂ"));
							}

						} else if (item.getType() == FieldType.DATE_TIME) {
							if (!dokujiMessage) {
								checkerCount++;
								out(baos, getText("addCheck", "name", item.getName(), "checker", "PirkaChecker.datetime"));
							} else {
								checkerCount++;
								out(baos, getText("addCheck with message", "name", item.getName(), "checker",
										"PirkaChecker.datetime", "message", "" + item.getNameJp()
												+ "͒lG[̃G[bZ[WɒuĂ"));
							}

						}

						if (dokujiItemCheck != null && dokujiItemCheck.getValueBoolean()) {
							if (!dokujiMessage) {
								checkerCount++;
								out(baos,
										getText("addCheck dokuji", "name", item.getName(), "checker", "PirkaChecker.datetime"));
							} else {
								checkerCount++;
								out(baos, getText("addCheck dokuji with message", "name", item.getName(), "checker",
										"PirkaChecker.datetime", "message", "" + item.getNameJp()
												+ "͒lG[̃G[bZ[WɒuĂ"));
							}

						}

					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("setOfficialFieldName start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseInputDataCtrlSet.contains(controlType.getValue())) {
						out(baos, getText("setOfficialFieldName", "name", item.getName(), "nameJp", item.getNameJp()));
					}
				}

				// Iɓ̓`FbNȂȂ{^̐ݒo
				out(baos, getText("setAutoCheck start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseNoCheckButtonbuttonCtrlSet.contains(controlType.getValue())) {
						AttributeData noCheckButton = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
								"noCheckButton");
						if (noCheckButton != null && noCheckButton.getValueBoolean()) {
							out(baos, getText("setAutoCheck", "name", item.getName()));
						}
					}
				}

				// IXg̍ڒ`ݒo
				out(baos, getText("setSelecter start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseSelectListCtrlSet.contains(controlType.getValue())) {
						out(baos, getText("setSelecter", "name", item.getName(), "nameJp", item.getNameJp()));
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("setFormat start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("setFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));
						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));
						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));
						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("setFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}

				// \f[^i[o
				out(baos, getText("setInitData start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, BasicHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseDataCtrlSet.contains(controlType.getValue())) {
						if (!"file".equals(controlType.getValue())) {
							switch (item.getType()) {
							case STRING:
								setParameter("value", "\"\"");
								break;
							case BOOLEAN:
								setParameter("value", "false");
								break;
							case DATE:
								setParameter("value", "new Date(Calendar.getInstance().getTimeInMillis())");
								break;
							case TIME:
								setParameter("value", "new Time(Calendar.getInstance().getTimeInMillis())");
								break;
							case DATE_TIME:
								setParameter("value", "new Timestamp(Calendar.getInstance().getTimeInMillis())");
								break;
							case NUM:
								if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
									setParameter("value", "BigDecimal.ZERO");
								} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
									setParameter("value", "0L");
								} else {
									setParameter("value", "0");
								}
								break;
							default:
								setParameter("value", "null");
							}

							out(baos, getText("setInitData", "name", item.getName()));
						}
					}
				}

				// Io
				out(baos, getText("init end"));

				boolean fileuploadFlag = false;
				// ANVi[o
				for (Integer actionItemId : itemIds) {
					InterfaceDataItem actionItem = interfaceData.getItem(actionItemId);
					AttributeData actionControlType = interfaceData.getAttribute(actionItemId,
							BasicHtmlFileCreator.PLUGIN_NAME, "controlType");

					if (actionControlType != null && useActionCtrlSet.contains(actionControlType.getValue())) {

						// \bhRgo
						out(baos, getText("actionMethod start 1", "action", actionItem.getName(), "nameJp", actionItem
								.getNameJp()));

						// @returno͏o
						if ("procSubmit".equals(actionControlType.getValue())) {
							// Ȃ
						} else if ("downloadSubmit".equals(actionControlType.getValue())) {
							out(
									baos,
									getText("actionMethod @return", "return",
											"_E[hs킹ƂpirkaFileDownloaderIuWFNg߂܂BʑJڂsƂPirkaWindowIuWFNg߂܂Bnull߂ƌĂяoƂ̉ʂɖ߂܂B"));
						} else {
							out(baos, getText("actionMethod @return", "return",
									"ʑJڂsƂPirkaWindowIuWFNg߂܂Bnull߂ƌĂяoƂ̉ʂɖ߂܂Bthis߂ƉʑJڂ͂܂B"));
						}

						// \bh`擪o
						if ("procSubmit".equals(actionControlType.getValue())) {
							setParameter("type", "void");
						} else if ("downloadSubmit".equals(actionControlType.getValue())) {
							setParameter("type", "PirkaRespons");
						} else {
							setParameter("type", "PirkaWindow");
						}
						out(baos, getText("actionMethod start 2", "methodName", actionItem.getName()));

						if(logout){
							out(baos, getText("actionMethod logger start", "nameJp", interfaceData.getNameJp(), "actionNameJp",  actionItem.getNameJp(), "action", actionItem.getName()));
						}
						
						if (!"link".equals(actionControlType.getValue())) {
							// f[^擾Jno
							out(baos, getText("actionMethod start 3", "methodName", actionItem.getName()));

							for (Integer itemId : itemIds) {
								InterfaceDataItem item = interfaceData.getItem(itemId);
								AttributeData controlType = interfaceData.getAttribute(itemId,
										BasicHtmlFileCreator.PLUGIN_NAME, "controlType");

								String titleName = "actionMethod getData";

								if (controlType != null && canUseInputDataCtrlSet.contains(controlType.getValue())) {
									switch (item.getType()) {
									case STRING:
										setParameter("type", "String");
										setParameter("method", "fm.getValueString");
										setParameter("option", ".trim()");
										break;
									case BOOLEAN:
										setParameter("type", "boolean");
										setParameter("method", "fm.getValueBoolean");
										setParameter("option", "");
										break;
									case DATE:
										setParameter("type", "Date");
										setParameter("method", "fm.getValueDate");
										setParameter("option", "");
										break;
									case TIME:
										setParameter("type", "Time");
										setParameter("method", "fm.getValueTime");
										setParameter("option", "");
										break;
									case DATE_TIME:
										setParameter("type", "Timestamp");
										setParameter("method", "fm.getValueTimestamp");
										setParameter("option", "");
										break;
									case NUM:
										if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
											setParameter("type", "BigDecimal");
											setParameter("method", "fm.getValueBigDecimal");
										} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
											setParameter("type", "Long");
											setParameter("method", "fm.getValueLongObject");
										} else {
											setParameter("type", "Integer");
											setParameter("method", "fm.getValueIntObject");
										}
										setParameter("option", "");
										break;
									case IMAGE:
										setParameter("type", "byte[]");
										if (controlType != null && "file".equals(controlType.getValue())) {
											fileuploadFlag = true;
											setParameter("method", "changeInputStream_to_byteArray(fm.getInputStream");
											setParameter("option", ")");
											titleName = "actionMethod getData file";
										} else {
											setParameter("method", "fm.getValueString");
											setParameter("option", ".getBytes()");
										}
										break;

									default:
										setParameter("type", "String");
										setParameter("method", "fm.getValueString");
										setParameter("option", ".trim()");
									}
									out(baos, getText(titleName, "name", item.getName()));

								}
							}

							out(baos, getText("actionMethod proc"));
						}else{
							out(baos, getText("actionMethod proc link"));
						}
						
						if(logout){
							out(baos, getText("actionMethod logger end", "nameJp", interfaceData.getNameJp(), "actionNameJp",  actionItem.getNameJp(), "action", actionItem.getName()));
						}
						
						// \bh`擪o
						if ("returnSubmit".equals(actionControlType.getValue())) {
							out(baos, getText("actionMethod return null"));

						} else if ("moveSubmit".equals(actionControlType.getValue())
								|| "link".equals(actionControlType.getValue())) {
							out(baos, getText("actionMethod return next"));

						} else if ("downloadSubmit".equals(actionControlType.getValue())) {
							out(baos, getText("actionMethod return download"));
						}

						out(baos, getText("actionMethod footer"));
					}
				}

				// CvbgXg[̓eoCgzɕϊo
				if (fileuploadFlag) {
					out(baos, getText("byteLoad"));
				}

				// tb^o
				out(baos, getText("footer"));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return  baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected String chars(String str, int len) {
		StringBuilder sb = new StringBuilder();

		for (int i = 0; i < len; i++) {
			sb.append(str);
		}

		return sb.toString();
	}

}
