package jp.oarts.pirka.iop.tool.core.plugin.file.csv;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * CSVt@Co͗pJava\[Xt@C쐬Et@CNG[^[vOC
 * 
 * @author ito
 * 
 */
public class CsvFileOutputJavaFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file.csv#CsvFileOutputJavaFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "CSVt@Co͗pJava\[Xt@Co";

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//

			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("mainFlag", "Tvmain\bht", "o͂\[Xt@CɃTvmain\bhtƂ̓`FbN܂",
					ParameterType.CHECK, new ParameterData(false), null),
			new ParameterSimpleItem("logout", "Oo̓R[ht", "샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),

	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public CsvFileOutputJavaFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "CSVt@Co͗pJava\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "CSVt@Co͗pJava\[Xt@Co͂܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {
	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		boolean mainFlag = dataMap.get("mainFlag").getValueBoolean();
		boolean logout = dataMap.get("logout").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		setCommonParameter("loggerComment", logout ? "" : "//");

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		try {
			fileMap.put(className + "CsvFileOut.java", createMain(dataMap, interfaceProject));

			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "CsvFileOut.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	public byte[] createMain(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException, IOException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		boolean mainFlag = dataMap.get("mainFlag").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;

		Integer[] itemIds = interfaceData.getEnableItemIdList();

		try {
			baos = new ByteArrayOutputStream();

			// pbP[Wo
			if (packageName != null && packageName.length() > 0) {
				out(baos, getText("package", "package", packageName));
			}

			out(baos, getText("csv out 1", "nameJp", interfaceData.getNameJp(), "mstName", className));

			// wb_o
			int count = 0;
			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (count++ > 0) {
					out(baos, getText("header write cnm"));
				}
				out(baos, getText("header write", "nameJp", item.getNameJp()));
			}

			out(baos, getText("csv out 2", "mntMast", className));

			// f[^o
			count = 0;
			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (count++ > 0) {
					out(baos, getText("data write cnm"));
				}
				out(baos, getText("data write", "getMethod", InterfaceTools.changeGetterNmae(item.getName(),
						item.getType() == FieldType.BOOLEAN)));
			}

			out(baos, getText("csv out 3"));

			// TvC[`o
			if (mainFlag) {
				out(baos, getText("csv out main", "mstName", className));
			}

			out(baos, getText("csv out 4"));

			baos.flush();
			return baos.toByteArray();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}

	}

}
