package jp.oarts.pirka.iop.tool.core.plugin.file.db;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.DbType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.ReviseType;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

public class DaoFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#DaoFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "DAO Java\[Xt@Co";

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("common", "DAOʃNX\[Xt@Co͂", "DAO\[Xt@Cgp鋤ʃNX̃\[Xt@Cꏏɏo͂ƂɃ`FbN܂",
					ParameterType.CHECK, new ParameterData(true), null),
			//
			new ParameterSimpleItem("db", "f[^x[X", "o͂\[Xt@Cgpf[^x[Xw肵܂", ParameterType.DB, 0, null,
					new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			new ParameterSimpleItem("logout", "Oo̓R[ht",
					"샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(true),
					null),
					
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////
	public DaoFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "DAO Java\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "DAO Java\[Xt@Co͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + DataBaseFileCreator.PLUGIN_NAME_JP
				+ "x\nAb^`ĂKv܂B\n\n"
				+ " f[^[x[Xɑ݂ꕔ̃f[^^ɑΉĂ܂B\n" + "@ 쎞ɃG[Ƃ̓\[XR[h̏CKvłB";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + DataBaseFileCreator.PLUGIN_NAME_JP + "xAb^b`Kv܂");
			}
			Integer[] itemIds = interfaceData.getEnableItemIdList();

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);

			// vC}[L[݃`FbN
			int keyCount = 0;
			for (Integer itemId : itemIds) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME, "primaryKey");
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					keyCount++;
				}
			}
			if (keyCount <= 0) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ͎L[ݒ肳Ă܂");
			}

			// ڃ`FbN
			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if ((item.getType() == FieldType.STRING || item.getType() == FieldType.NUM || item.getType() == FieldType.IMAGE)) {
					if (item.getLength() <= 0) {
						throw new InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
					}
				}
				if ((item.getType() == FieldType.NUM)) {
					if (item.getLength() < item.getSubLength()) {
						throw new InterfaceException("w肳ꂽC^[tF[XɏŜ̌傫lڂ܂");
					}
				}
			}

		}

		String db = dataMap.get("db").getValue();
		if ("".equals(db)) {
			throw new InterfaceException("f[^x[XIĂ܂");
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		DbType db = DbType.valueOf(dataMap.get("db").getValue());
		boolean common = dataMap.get("common").getValueBoolean();
		boolean logout = dataMap.get("logout").getValueBoolean();
		
		setCommonParameter("loggerComment", logout ? "" : "//");

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		Integer[] itemIds = interfaceData.getEnableItemIdList();

		// vC}[L[Xg擾
		List<InterfaceDataItem> primaryKeyItemList = new LinkedList<InterfaceDataItem>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			AttributeData primaryKey = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME, "primaryKey");
			if (primaryKey != null && primaryKey.getValueBoolean()) {
				primaryKeyItemList.add(item);
			}
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());
		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		try {

			// if (target) {
			fileMap.put(className + "Dao.java", createDaoJavaSrcFileImage(interfaceData, itemIds, primaryKeyItemList, db,
					packageName));
			// }

			if (common) {
				fileMap.put("DaoBase.java", createCommonJavaSrcFileImage(packageName));
				fileMap.put("RecordAction.java", createCommonJavaSrcFile2Image(packageName));
				fileMap.put("RecordSearch.java", createCommonJavaSrcFile3Image(packageName));
				fileMap.put("DaoTransaction.java", createCommonJavaSrcFile4Image(packageName));
			}
			
			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "DaoJava.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	/**
	 * DaoJava\[Xt@CC[W쐬
	 *
	 * @param interfaceData
	 * @param itemIds
	 * @param primaryKeyItemList
	 * @param db
	 * @param packageName
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createDaoJavaSrcFileImage(InterfaceData interfaceData, Integer[] itemIds,
			List<InterfaceDataItem> primaryKeyItemList, DbType db, String packageName) throws IOException, InterfaceException {

		HashSet<String> primaryKeyNameSet = new HashSet<String>();
		ReviseType reviseType = DatabaseInterfaceDesigner.getReviseType(db);

		for (InterfaceDataItem item : primaryKeyItemList) {
			primaryKeyNameSet.add(item.getName());
		}

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("dao package", "package", packageName));
				}

				// ===== wb_[ =====
				if (db == DbType.postgreSQL) {
					out(baos, getText("header postgreSQL"));
				}

				if (db == DbType.h2) {
					setParameter("uniqueErrorCode", "23001");
				} else if (db == DbType.oracle) {
					setParameter("uniqueErrorCode", "23000");
				} else if (db == DbType.postgreSQL) {
					setParameter("uniqueErrorCode", "23505");
				}
				out(baos, getText("header", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				out(baos, getText("sql search list", "mstName", mstName));

				if (db == DbType.postgreSQL) {
					out(baos, getText("sql search postgreSQL"));

					for (Integer itemId : itemIds) {
						InterfaceDataItem item = interfaceData.getItem(itemId);

						// Ǝ^Cv̎o
						AttributeData dokujiTypeAttributeData = interfaceData.getAttribute(itemId,
								DataBaseFileCreator.PLUGIN_NAME, "dokujiType");
						String dokujiType = "";
						if (dokujiTypeAttributeData != null) {
							dokujiType = dokujiTypeAttributeData.getValue();
						}
						if (isPostgreSQLBitType(db, dokujiType)) {
							out(baos, getText("sql search postgreSQL field", "fieldNmae", item.getName()));
						}
					}

					out(baos, getText("sql search postgreSQL end"));
				}

				// ===== }pSQL =====
				out(baos, getText("sql insert", "mstName", mstName));
				int count = 0;
				int countAll = 0;
				StringBuilder sb = new StringBuilder();
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (countAll > 0) {
						sb.append(", ");
					}
					sb.append(item.getName());
					count++;
					countAll++;

					if (count >= 10) {
						out(baos, getText("sql insert fields", "fields", sb.toString()));
						sb.setLength(0);
						count = 0;
					}
				}
				if (count > 0) {
					out(baos, getText("sql insert fields", "fields", sb.toString()));
				}

				String values = "";
				if (countAll > 0) {
					values = chars(",?", countAll).substring(1);
				}
				out(baos, getText("sql insert values", "values", values));

				// ===== XVpSQL =====
				out(baos, getText("sql update", "mstName", mstName));
				count = 0;
				countAll = 0;
				sb = new StringBuilder();
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);

					// L[͏
					if (primaryKeyNameSet.contains(item.getName())) {
						continue;
					}

					if (countAll > 0) {
						sb.append(", ");
					}
					sb.append(item.getName());
					sb.append("=?");
					count++;
					countAll++;

					if (count >= 8) {
						out(baos, getText("sql update fields", "fields", sb.toString()));
						sb.setLength(0);
						count = 0;
					}
				}
				if (count > 0) {
					out(baos, getText("sql update fields", "fields", sb.toString()));
				}

				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					if (sb.length() > 0) {
						sb.append(" and ");
					}
					sb.append(item.getName());
					sb.append("=?");
				}
				out(baos, getText("sql update where", "where", sb.toString()));

				// ===== 폜pSQL =====
				out(baos, getText("sql delete", "mstName", mstName));
				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					if (sb.length() > 0) {
						sb.append(" and ");
					}
					sb.append(item.getName());
					sb.append("=?");
				}
				out(baos, getText("sql delete where", "where", sb.toString()));

				// ===== 擾pSQL =====
				out(baos, getText("sql get", "mstName", mstName));
				count = 0;
				countAll = 0;
				sb = new StringBuilder();
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (countAll > 0) {
						sb.append(", ");
					}
					sb.append(item.getName());
					count++;
					countAll++;

					if (count >= 10) {
						out(baos, getText("sql get fields", "fields", sb.toString()));
						sb.setLength(0);
						count = 0;
					}
				}
				if (count > 0) {
					out(baos, getText("sql get fields", "fields", sb.toString()));
				}

				out(baos, getText("sql get from", "mstName", mstName));

				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					if (sb.length() > 0) {
						sb.append(" and ");
					}
					sb.append(item.getName());
					sb.append("=?");
				}
				out(baos, getText("sql get where", "where", sb.toString()));

				// ===== pSQL =====
				out(baos, getText("sql search", "mstName", mstName));
				count = 0;
				countAll = 0;
				sb = new StringBuilder();
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (countAll > 0) {
						sb.append(",");
					}
					sb.append(item.getName());
					count++;
					countAll++;

					if (count >= 10) {
						out(baos, getText("sql search fields", "fields", sb.toString()));
						sb.setLength(0);
						count = 0;
					}
				}
				if (count > 0) {
					out(baos, getText("sql search fields", "fields", sb.toString()));
				}

				out(baos, getText("sql search from", "mstName", mstName));

				// ===== L[pSQL =====
				out(baos, getText("sql search primaryKeys", "mstName", mstName));
				count = 0;
				countAll = 0;
				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					if (countAll > 0) {
						sb.append(",");
					}
					sb.append(item.getName());
					count++;
					countAll++;

					if (count >= 10) {
						out(baos, getText("sql search primaryKeys fields", "fields", sb.toString()));
						sb.setLength(0);
						count = 0;
					}
				}
				if (count > 0) {
					out(baos, getText("sql search primaryKeys fields", "fields", sb.toString()));
				}

				out(baos, getText("sql search primaryKeys from", "mstName", mstName));


				//	
				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					if (sb.length() > 0) {
						sb.append(",");
					}
					sb.append(item.getName());
				}
				out(baos, getText("sql search order", "fields", sb.toString()));

				// ==== RXgN^ ====
				out(baos, getText("constructor", "mstName", mstName));

				// ===== insert\bh =====
				out(baos, getText("insert", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// V[PX
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData autoIncrement = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
							"autoIncrement");

					if (item.getType() == FieldType.NUM && autoIncrement != null && autoIncrement.getValueBoolean()) {

						setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
								item.getType() == FieldType.BOOLEAN));
						setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));

						// Ǝ^Cv̎o
						AttributeData dokujiType = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
								"dokujiType");
						AttributeData sequenceName = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
								"sequenceName");

						if (db == DbType.h2 && dokujiType != null && reviseType.isAutoIncrementFieldType(dokujiType.getValue())) {
							// insertÕV[PX͍sȂ(identitynulli[ƎєԂ̂)
						} else {

							String sequenceNameStr = "";
							if (db == DbType.postgreSQL && reviseType.isAutoIncrementFieldType(dokujiType.getValue())) {
								sequenceNameStr = reviseType.makeAutoSequenceName(mstName, item.getName());
							} else {
								if (sequenceName != null && sequenceName.getValue() != null
										&& sequenceName.getValue().length() > 0) {
									sequenceNameStr = sequenceName.getValue();
								} else {
									sequenceNameStr = reviseType.makeAutoSequenceName(mstName, item.getName());
								}
							}

							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								out(baos, getText("pre seq Integer", "seqName", sequenceNameStr, "oracleSequence",
										db == DbType.oracle ? "true" : "false"));
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								out(baos, getText("pre seq Long", "seqName", sequenceNameStr, "oracleSequence",
										db == DbType.oracle ? "true" : "false"));
							} else {
								out(baos, getText("pre seq BigDecimal", "seqName", sequenceNameStr, "oracleSequence",
										db == DbType.oracle ? "true" : "false"));
							}
						}
					}
				}

				// CT[g又
				out(baos, getText("insert start"));

				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));

					// Ǝ^Cv̎o
					AttributeData dokujiTypeAttributeData = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
							"dokujiType");
					String dokujiType = "";
					if (dokujiTypeAttributeData != null) {
						dokujiType = dokujiTypeAttributeData.getValue();
					}

					switch (item.getType()) {
					case STRING:
						if (isPostgreSQLBitType(db, dokujiType)) {
							out(baos, getText("insert String postgreSQL bit", "modeFlag", !isPostgreSQLVarbitType(db,
									dokujiType) ? "true" : "false", "length", "" + item.getLength()));
						} else {
							out(baos, getText("insert String"));
						}
						break;
					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("insert Integer"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("insert Long"));
						} else {
							out(baos, getText("insert BigDecimal"));
						}
						break;
					case BOOLEAN:
						if (db == DbType.h2 || db == DbType.postgreSQL) {
							out(baos, getText("insert Boolean h2"));
						} else if (db == DbType.oracle) {
							out(baos, getText("insert Boolean oracle"));
						}
						break;
					case DATE:
						out(baos, getText("insert Date"));
						break;
					case TIME:
						out(baos, getText("insert Time"));
						break;
					case DATE_TIME:
						out(baos, getText("insert Timestamp"));
						break;
					case IMAGE:
						out(baos, getText("insert byte[]"));
						break;
					}
				}
				out(baos, getText("insert footer"));

				// V[PX㏈
				if (db == DbType.h2) { // H2identity̎identity()ԐlăZbgBidentityɒli[Ăidentity()֐̓Zbgl߂
					for (Integer itemId : itemIds) {
						InterfaceDataItem item = interfaceData.getItem(itemId);
						AttributeData autoIncrement = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
								"autoIncrement");

						if (item.getType() == FieldType.NUM && autoIncrement != null && autoIncrement.getValueBoolean()) {

							setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));

							// Ǝ^Cv̎o
							AttributeData dokujiType = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
									"dokujiType");

							if (dokujiType != null && reviseType.isAutoIncrementFieldType(dokujiType.getValue())) {
								if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
									out(baos, getText("pre identity Integer"));
								} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
									out(baos, getText("pre identity Long"));
								} else {
									out(baos, getText("pre identity BigDecimal"));
								}
							}
						}
					}
				}

				out(baos, getText("insert footer 2"));

				//
				// ===== update\bh =====
				out(baos, getText("update", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					// Ǝ^Cv̎o
					AttributeData dokujiTypeAttributeData = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
							"dokujiType");
					String dokujiType = "";
					if (dokujiTypeAttributeData != null) {
						dokujiType = dokujiTypeAttributeData.getValue();
					}

					// L[͏
					if (primaryKeyNameSet.contains(item.getName())) {
						continue;
					}

					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));

					switch (item.getType()) {
					case STRING:
						if (isPostgreSQLBitType(db, dokujiType)) {
							out(baos, getText("update String postgreSQL bit", "modeFlag", !isPostgreSQLVarbitType(db,
									dokujiType) ? "true" : "false", "length", "" + item.getLength()));
						} else {
							out(baos, getText("update String"));
						}
						break;
					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("update Integer"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("update Long"));
						} else {
							out(baos, getText("update BigDecimal"));
						}
						break;
					case BOOLEAN:
						if (db == DbType.h2 || db == DbType.postgreSQL) {
							out(baos, getText("update Boolean h2"));
						} else if (db == DbType.oracle) {
							out(baos, getText("update Boolean oracle"));
						}
						break;
					case DATE:
						out(baos, getText("update Date"));
						break;
					case TIME:
						out(baos, getText("update Time"));
						break;
					case DATE_TIME:
						out(baos, getText("update Timestamp"));
						break;
					case IMAGE:
						out(baos, getText("update byte[]"));
						break;
					}
				}

				out(baos, getText("update key"));

				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {

					// Ǝ^Cv̎o
					AttributeData dokujiTypeAttributeData = interfaceData.getAttribute(item.getItemId(),
							DataBaseFileCreator.PLUGIN_NAME, "dokujiType");
					String dokujiType = "";
					if (dokujiTypeAttributeData != null) {
						dokujiType = dokujiTypeAttributeData.getValue();
					}

					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));

					if (isPostgreSQLBitType(db, dokujiType)) {
						out(baos, getText("update key set postgreSQL bit", "modeFlag",
								!isPostgreSQLVarbitType(db, dokujiType) ? "true" : "false", "length", "" + item.getLength()));
					} else {
						out(baos, getText("update key set"));
					}
				}

				out(baos, getText("update footer"));

				//
				// ===== delete\bh =====
				out(baos, getText("delete", "mstName", mstName, "nameJp", interfaceData.getNameJp()));
				out(baos, getText("delete key"));

				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {

					// Ǝ^Cv̎o
					AttributeData dokujiTypeAttributeData = interfaceData.getAttribute(item.getItemId(),
							DataBaseFileCreator.PLUGIN_NAME, "dokujiType");
					String dokujiType = "";
					if (dokujiTypeAttributeData != null) {
						dokujiType = dokujiTypeAttributeData.getValue();
					}

					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));
					if (isPostgreSQLBitType(db, dokujiType)) {
						out(baos, getText("update key set postgreSQL bit", "modeFlag",
								!isPostgreSQLVarbitType(db, dokujiType) ? "true" : "false", "length", "" + item.getLength()));
					} else {
						out(baos, getText("delete key set"));
					}
				}

				out(baos, getText("delete footer"));



				//
				// ===== get\bh =====
				out(baos, getText("get", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				out(baos, getText("get check key"));
				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));
					out(baos, getText("get check key set"));
				}

				out(baos, getText("get key"));
				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {

					// Ǝ^Cv̎o
					AttributeData dokujiTypeAttributeData = interfaceData.getAttribute(item.getItemId(),
							DataBaseFileCreator.PLUGIN_NAME, "dokujiType");
					String dokujiType = "";
					if (dokujiTypeAttributeData != null) {
						dokujiType = dokujiTypeAttributeData.getValue();
					}

					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));

					if (isPostgreSQLBitType(db, dokujiType)) {
						out(baos, getText("get key set postgreSQL bit", "modeFlag",
								!isPostgreSQLVarbitType(db, dokujiType) ? "true" : "false", "length", "" + item.getLength()));
					} else {
						out(baos, getText("get key set"));
					}
				}

				out(baos, getText("get ResultSet", "mstName", mstName));

				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));
					setParameter("name", item.getName());

					switch (item.getType()) {
					case STRING:
						out(baos, getText("get ResultSet String"));
						break;
					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("get ResultSet Int"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("get ResultSet Long"));
						} else {
							out(baos, getText("get ResultSet BigDecimal"));
						}
						break;
					case BOOLEAN:
						if (db == DbType.h2 || db == DbType.postgreSQL) {
							out(baos, getText("get ResultSet Boolean h2"));
						} else if (db == DbType.oracle) {
							out(baos, getText("get ResultSet Boolean oracle"));
						}
						break;
					case DATE:
						out(baos, getText("get ResultSet Date"));
						break;
					case TIME:
						out(baos, getText("get ResultSet Time"));
						break;
					case DATE_TIME:
						out(baos, getText("get ResultSet Timestamp"));
						break;
					case IMAGE:
						out(baos, getText("get ResultSet byte[]"));
						break;
					}
				}

				out(baos, getText("get footer"));

				//
				// ===== getPrimary\bh =====
				out(baos, getText("get primaryKeyList header", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				sb = new StringBuilder();
				for (InterfaceDataItem item : primaryKeyItemList) {
					setParameter("getterName", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));
					out(baos, getText("get primaryKeyList set keys", "name", item.getName()));
				}
				out(baos, getText("get primaryKeyList search start", "mstName", mstName));


				//
				// ===== search\bh =====
				out(baos, getText("search", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));
					setParameter("name", item.getName());

					switch (item.getType()) {
					case STRING:
						out(baos, getText("search ResultSet String"));
						break;
					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("search ResultSet Int"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("search ResultSet Long"));
						} else {
							out(baos, getText("search ResultSet BigDecimal"));
						}
						break;
					case BOOLEAN:
						if (db == DbType.h2 || db == DbType.postgreSQL) {
							out(baos, getText("search ResultSet Boolean h2"));
						} else if (db == DbType.oracle) {
							out(baos, getText("search ResultSet Boolean oracle"));
						}
						break;
					case DATE:
						out(baos, getText("search ResultSet Date"));
						break;
					case TIME:
						out(baos, getText("search ResultSet Time"));
						break;
					case DATE_TIME:
						out(baos, getText("search ResultSet Timestamp"));
						break;
					case IMAGE:
						out(baos, getText("search ResultSet byte[]"));
						break;
					}
				}

				out(baos, getText("search footer"));

				//
				// ===== search primaryKeys\bh =====
				out(baos, getText("search primarykeys", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				for (InterfaceDataItem item : primaryKeyItemList) {

					setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));
					setParameter("name", item.getName());

					switch (item.getType()) {
					case STRING:
						out(baos, getText("search ResultSet String"));
						break;
					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("search ResultSet Int"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("search ResultSet Long"));
						} else {
							out(baos, getText("search ResultSet BigDecimal"));
						}
						break;
					case BOOLEAN:
						if (db == DbType.h2 || db == DbType.postgreSQL) {
							out(baos, getText("search ResultSet Boolean h2"));
						} else if (db == DbType.oracle) {
							out(baos, getText("search ResultSet Boolean oracle"));
						}
						break;
					case DATE:
						out(baos, getText("search ResultSet Date"));
						break;
					case TIME:
						out(baos, getText("search ResultSet Time"));
						break;
					case DATE_TIME:
						out(baos, getText("search ResultSet Timestamp"));
						break;
					case IMAGE:
						out(baos, getText("search ResultSet byte[]"));
						break;
					}
				}

				out(baos, getText("search footer"));


				if (db == DbType.postgreSQL) {
					out(baos, getText("footer postgreSQL"));
				}
				out(baos, getText("footer"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * DAOpJava\[Xt@CC[W쐬iDaoBase.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFileImage(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("daoBase package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("daoBase main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * DAOpJava\[Xt@CC[W쐬iRecordAction.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFile2Image(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("daoSearchAction package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("daoSearchAction main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * DAOpJava\[Xt@CC[W쐬iRecordSearch.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFile3Image(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("recordSearch package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("recordSearch main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * DAOpJava\[Xt@CC[W쐬iDaoTransaction.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFile4Image(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("DaoTransaction package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("DaoTransaction main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected String chars(String str, int len) {
		StringBuilder sb = new StringBuilder();

		for (int i = 0; i < len; i++) {
			sb.append(str);
		}

		return sb.toString();
	}

	/**
	 * w肳ꂽDB^CvyѓƎ^CvpostgreSQLbitvarbit`FbN
	 *
	 * @param db
	 * @param dokujiType
	 * @return bitvarbit̂Ƃtrue
	 */
	public static boolean isPostgreSQLBitType(DbType db, String dokujiType) {
		if (db == DbType.postgreSQL) {
			if (dokujiType != null && (dokujiType instanceof String)) {
				if (subComp("bit", dokujiType)) {
					return true;
				}
				if (subComp("varbit", dokujiType)) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * w肳ꂽDB^CvyѓƎ^CvpostgreSQLvarbit`FbN
	 *
	 * @param db
	 * @param dokujiType
	 * @return true=varbit
	 */
	protected boolean isPostgreSQLVarbitType(DbType db, String dokujiType) {
		if (db == DbType.postgreSQL) {
			if (dokujiType != null && (dokujiType instanceof String)) {
				if (subComp("varbit", dokujiType)) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * compStrbaseStrŊJn镶񂩔r
	 *
	 * @param baseStr
	 *            x[X
	 * @param compStr
	 *            r
	 * @return true=
	 */
	protected static boolean subComp(String baseStr, String compStr) {

		if (baseStr == null && compStr == null) {
			return true;
		}

		if (baseStr.length() <= 0) {
			return true;
		}

		if (compStr.length() < baseStr.length()) {
			return false;
		}

		return baseStr.equalsIgnoreCase(compStr.substring(0, baseStr.length()));
	}

}
