package jp.oarts.pirka.iop.tool.core.plugin.file.db;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.DbType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataMyItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.ReviseType;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * f[^x[X`t@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class DataBaseFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = -4330772947687981187L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#DataBaseFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "f[^x[Xe[u`t@Co";

	public static final String PRIMARY_KEY_ATTACH_NAME = "primaryKey";

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

			//
			new AttributeSimpleItem(PRIMARY_KEY_ATTACH_NAME, "L[", "L[ڂ̂Ƃ`FbN܂", AttributeType.CHECK, new AttributeData(
					false), null),
			//
			new AttributeSimpleItem("notNull", "NULL֎~", "NULL֎~ڂ̂Ƃ`FbN܂", AttributeType.CHECK, new AttributeData(false),
					null),
			//
			new AttributeSimpleItem("default", "ftHg", "ftHglݒ肷Ƃɓ͂܂", AttributeType.TEXT, new AttributeData(""), null),
			//
			new AttributeSimpleItem("varchar", "ϕ", "񂪌Œ蒷łȂƂɃ`FbN܂", AttributeType.CHECK,
					new AttributeData("false"), null),
			//
			new AttributeSimpleItem("dokujiType", "tB[h^(WύXƂ̂ݓ)", "W̌^gpȂƂɓ͂܂", AttributeType.TEXT,
					new AttributeData(""), null),

			new AttributeSimpleItem("autoIncrement", "A", "V[PX̎AԂgpƂɃ`FbN܂", AttributeType.CHECK,
					new AttributeData("false"), null),

			new AttributeSimpleItem("sequenceName", "V[PX", "AԎw莞ŃV[PKvȂƂɓ͂܂", AttributeType.TEXT,
					new AttributeData(""), null),

	//

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("db", "f[^x[X", "o͂e[u`t@Cgpf[^x[Xw肵܂", ParameterType.DB, 0, null,
					new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					})
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public DataBaseFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "f[^x[Xe[u`t@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "f[^x[Xe[uñt@Co͂鎞ɃAb^`܂";
	}

	@Override
	public String getParameterComment() {
		return "f[^x[Xe[u`t@CiCreate tablejo͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + getNameJp() + "x\nAb^`ĂKv܂B";

	}
	@Override
	public void preCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

		// XV
		for (int itemId : myDataMap.keySet()) {
			InterfaceDataMyItem item = interfaceData.getMyItem(itemId);
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);

			AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);
			if (primaryKey != null && primaryKey.getValueBoolean()) {
				item.setPrimaryKey(true);
			}else{
				item.setPrimaryKey(false);
			}
			interfaceData.updateMyItem(item);
		}
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(getName())) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + getNameJp() + "xAb^b`Kv܂");
			}

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);

			Integer[] itemIds = interfaceData.getEnableItemIdList();

			// vC}[L[݃`FbN
			int keyCount = 0;
			for (Integer itemId : itemIds) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, getName(), PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					keyCount++;
				}
			}
			// if (keyCount <= 0) {
			// throw new InterfaceException("w肳ꂽC^[tF[Xɂ͎L[ݒ肳Ă܂");
			// }

			// ڃ`FbN
			for (Integer itemId : itemIds) {

				InterfaceDataItem item = interfaceData.getItem(itemId);
				AttributeData dokujiType = interfaceData.getAttribute(itemId, getName(), "dokujiType");

				if (dokujiType == null || dokujiType.getValue().trim().length() <= 0) {

					if ((item.getType() == FieldType.STRING || item.getType() == FieldType.NUM || item.getType() == FieldType.IMAGE)) {
						if (item.getLength() <= 0) {
							throw new InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
						}
					}

					if ((item.getType() == FieldType.NUM)) {
						if (item.getLength() < item.getSubLength()) {
							throw new InterfaceException("w肳ꂽC^[tF[XɏŜ̌傫lڂ܂");
						}
					}
				}
			}
		}

		String db = dataMap.get("db").getValue();
		if ("".equals(db)) {
			throw new InterfaceException("f[^x[XIĂ܂");
		}

	}

	@Override
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		InterfaceDataItem item = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).getItem(itemId);
		AttributeData autoIncrement = dataMap.get("autoIncrement");

		if (autoIncrement.getValueBoolean()) {
			AttributeData defaultValue = dataMap.get("default");
			if (item.getType() != FieldType.NUM) {
				throw new InterfaceException("lȊO̍ڂɎAԂݒ肳Ă܂");
			}
			if (defaultValue != null && defaultValue.getValue() != null && defaultValue.getValue().length() > 0) {
				throw new InterfaceException("AԂw肳ꂽƂ̓ftHgݒł܂");
			}

		} else {
			AttributeData sequenceName = dataMap.get("sequenceName");
			if (sequenceName != null && sequenceName.getValue() != null && sequenceName.getValue().length() > 0) {
				throw new InterfaceException("AԂw肵ȂƃV[PX͐ݒł܂");
			}
		}
		// }
	}

	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());

		boolean primaryKeyFlag = false;
		for (Integer itemId : myDataMap.keySet()) {
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			if (myAttributeMap != null) {

				// L[`FbN
				AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					primaryKeyFlag = true;
				}
			}
		}

		if (!primaryKeyFlag) {
			throw new InterfaceException("L[Kvł");
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		DbType db = DbType.valueOf(dataMap.get("db").getValue());

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		Integer[] itemIds = interfaceData.getEnableItemIdList();

		// vC}[L[Xg擾
		List<InterfaceDataItem> primaryKeyItemList = new LinkedList<InterfaceDataItem>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			AttributeData primaryKey = interfaceData.getAttribute(itemId, getName(), PRIMARY_KEY_ATTACH_NAME);
			if (primaryKey != null && primaryKey.getValueBoolean()) {
				primaryKeyItemList.add(item);
			}
		}

		try {

			byte[] image = createFileImage(interfaceData, itemIds, primaryKeyItemList, db);

			return new AttributeFileImage(InterfaceTools.changeClassNmae(interfaceData.getName()) + "CreateTable.sql", image);

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	/**
	 * t@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param itemIds
	 *            LȃC^[tF[XIDz
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createFileImage(InterfaceData interfaceData, Integer[] itemIds,
			List<InterfaceDataItem> primaryKeyItemList, DbType db) throws IOException, InterfaceException {

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());
		ReviseType reviseType = DatabaseInterfaceDesigner.getReviseType(db);

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// Create sequence
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (item.getType() == FieldType.NUM) {

						AttributeData autoIncrement = interfaceData.getAttribute(itemId, getName(), "autoIncrement");

						if (autoIncrement != null && autoIncrement.getValueBoolean()) {

							AttributeData sequenceName = interfaceData.getAttribute(itemId, getName(), "sequenceName");
							AttributeData dokujiType = interfaceData.getAttribute(itemId, getName(), "dokujiType");

							if (dokujiType != null && reviseType.isAutoIncrementFieldType(dokujiType.getValue())) {
								// V[PX͏o͂Ȃ
							} else {
								if (sequenceName != null && sequenceName.getValue() != null
										&& sequenceName.getValue().length() > 0) {
									out(baos, getText(db + " sequence", "sequenceName", sequenceName.getValue()));
								} else {
									out(baos, getText(db + " sequence", "sequenceName", reviseType.makeAutoSequenceName(
											mstName, item.getName())));
								}
							}
						}
					}
				}

				// Create table
				out(baos, getText(db + " header", "mstName", mstName));

				int itemNo = 0;
				for (Integer itemId : itemIds) {

					itemNo++;

					InterfaceDataItem item = interfaceData.getItem(itemId);
					setParameter("name", item.getName());

					AttributeData dokujiType = interfaceData.getAttribute(itemId, getName(), "dokujiType");
					if (dokujiType != null && dokujiType.getValue().trim().length() > 0) {
						setParameter("type", dokujiType.getValue().trim());
					} else {
						switch (item.getType()) {
						case STRING:
							AttributeData varchar = interfaceData.getAttribute(itemId, getName(), "varchar");
							if (varchar == null || (!varchar.getValueBoolean())) {
								setParameter("type", "char(" + item.getLength() + ")");
							} else {
								if (db == DbType.oracle) {
									setParameter("type", "varchar2(" + item.getLength() + ")");
								} else {
									setParameter("type", "varchar(" + item.getLength() + ")");
								}
							}
							break;
						case NUM:
							if (item.getSubLength() > 0) {
								setParameter("type", "NUMERIC(" + item.getLength() + ", " + item.getSubLength() + ")");
							} else {
								setParameter("type", "NUMERIC(" + item.getLength() + ")");
							}
							break;
						case BOOLEAN:
							if (db == DbType.h2 || db == DbType.postgreSQL) {
								setParameter("type", "boolean");
							} else if (db == DbType.oracle) {
								setParameter("type", "NUMERIC(1)");
							}
							break;

						case DATE:
							setParameter("type", "date");
							break;

						case TIME:
							if (db == DbType.h2 || db == DbType.postgreSQL) {
								setParameter("type", "time");
							} else if (db == DbType.oracle) {
								setParameter("type", "date");
							}
							break;

						case DATE_TIME:
							setParameter("type", "timestamp");
							break;

						case IMAGE:
							if (db == DbType.h2) {
								setParameter("type", "blob(" + item.getLength() + ")");
							} else if (db == DbType.oracle) {
								setParameter("type", "blob");
							} else if (db == DbType.postgreSQL) {
								setParameter("type", "bytea");
							}
							break;
						}
					}

					// IuVݒ
					StringBuilder optionSb = new StringBuilder();

					AttributeData defaultValue = interfaceData.getAttribute(itemId, getName(), "default");
					AttributeData sequenceName = interfaceData.getAttribute(itemId, getName(), "sequenceName");
					AttributeData autoIncrement = interfaceData.getAttribute(itemId, getName(), "autoIncrement");

					if (defaultValue != null && defaultValue.getValue().trim().length() > 0) {
						optionSb.append(" default ");
						optionSb.append(defaultValue.getValue().trim());
					} else if (db != DbType.oracle && autoIncrement != null && autoIncrement.getValueBoolean()) {
						if (dokujiType != null && reviseType.isAutoIncrementFieldType(dokujiType.getValue())) {
							// o͂Ȃ
						} else {
							optionSb.append(" default nextval('");

							if (sequenceName != null && sequenceName.getValue() != null && sequenceName.getValue().length() > 0) {
								optionSb.append(sequenceName.getValue());
							} else {
								optionSb.append(reviseType.makeAutoSequenceName(mstName, item.getName()));
							}

							optionSb.append("') ");
						}
					}

					AttributeData notNull = interfaceData.getAttribute(itemId, getName(), "notNull");
					if (notNull != null && notNull.getValueBoolean()) {
						optionSb.append(" not null");
					}

					if (itemNo < itemIds.length) {
						optionSb.append(",");
					}

					setParameter("option", optionSb.toString());
					out(baos, getText(db + " item"));
				}

				// L[o̓`FbN
				boolean makeKeyFlag = false;
				for (InterfaceDataItem keyItem : primaryKeyItemList) {

					AttributeData dokujiType = interfaceData.getAttribute(keyItem.getItemId(), getName(), "dokujiType");
					if (db == DbType.h2 && dokujiType != null && reviseType.isAutoIncrementFieldType(dokujiType.getValue())) {
						break;
					}
					makeKeyFlag = true;
				}

				// tb^1o
				out(baos, getText(db + " footer1"));

				// L[쐬
				if (makeKeyFlag) {
					StringBuilder primaryKeySb = new StringBuilder();
					for (InterfaceDataItem keyItem : primaryKeyItemList) {
						if (primaryKeySb.length() > 0) {
							primaryKeySb.append(", ");
						}
						primaryKeySb.append(keyItem.getName());
					}

					// L[o
					if (primaryKeyItemList.size() > 0) {
						out(baos, getText(db + " primaryKey", "mstName", mstName, "primaryKey", primaryKeySb.toString()));
					}
				}

				// tb^2o
				out(baos, getText(db + " footer2"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

}
