package jp.oarts.pirka.iop.tool.core.plugin.file.db;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.DbType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.IncludeInfo;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * T[`[DAOEt@CNG[^[vOC
 *
 * @author ito
 *
 */
public class SearcherDaoFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 5713576716306191853L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.pirka.iop.tool.core.plugin.file.db.SearcherDaoFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "T[`[DAO Java\[Xt@Co";

	public static final String SAFFIX_NAME_DAO = "SearcherDao";

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("db", "f[^x[X", "o͂\[Xt@Cgpf[^x[Xw肵܂", ParameterType.DB, 0, null,
					new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			new ParameterSimpleItem("logout", "Oo̓R[ht",
					"샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(true),
					null),
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public SearcherDaoFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, false, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "T[`[DAOJava\[XR[ho͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "T[`[DAOJava\[XR[ho͂܂B\n" //
				+ "T[`[DAO͎w肳ꂽŃfizf[^x[Xe[ujA\nʂ" //
				+ "C^[tF[X(Value Object)̃XgƂĖ߂܂B\n" //
				+ "AC^[tF[Xɑ݂郊Xgisj͌ΏۂƂ͂Ȃ炸\n" //
				+ "f[^͊i[܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + VirtualDbTableFileCreator.PLUGIN_NAME_JP + "x\nAb^`ĂKv܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + VirtualDbTableFileCreator.PLUGIN_NAME_JP + "xAb^b`Kv܂");
			}

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);
		}
		String db = dataMap.get("db").getValue();
		if ("".equals(db)) {
			throw new InterfaceException("f[^x[XIĂ܂");
		}

	}

	@Override
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {
	}

	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}
		String packageName = dataMap.get("package").getValue();
		DbType db = DbType.valueOf(dataMap.get("db").getValue());
		boolean logout = dataMap.get("logout").getValueBoolean();
		
		setCommonParameter("loggerComment", logout ? "" : "//");

		int rootIncludeId = -1; // ؍\̃[gCN[h
		HashMap<String, Integer> includeIdKey2TableNoMap = new HashMap<String, Integer>(); // L[CN[hL[iKwL[jAe[uԍ
		TreeMap<Integer, ItemInfoEx> itemId2ItemInfoExMap = new TreeMap<Integer, ItemInfoEx>(); // L[ACeIDAlACe
		TreeMap<Integer, Integer> tableNo2InterfaceDataIdMap = new TreeMap<Integer, Integer>(); // L[e[uԍAlC^[tF[XID

		Integer[] itemIds = interfaceData.getAllItemIdList();

		// ؍\̃[gCN[hID擾
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem()) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					rootIncludeId = item.getIncludeId();
				}
			}
		}

		// CN[hIDL[Ee[uԍ}bv쐬
		TableInfo tableInfo = new TableInfo();
		createTableNoMap(interfaceProject, interfaceData, "", includeIdKey2TableNoMap, tableInfo);

		// ACeIDEACe}bv쐬
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem()) {
				createItemIdMap(interfaceProject, itemId, makeIncludeIdKey(item.getIncludeId()), item.getIncludeDataId(), item
						.getIncludeItemId(), itemId2ItemInfoExMap, includeIdKey2TableNoMap);
			}
		}

		// ACeIDEACe}bve[uԍEC^[tF[Xf[^ID}bv쐬
		for (ItemInfoEx itemInfoEx : itemId2ItemInfoExMap.values()) {
			tableNo2InterfaceDataIdMap.put(itemInfoEx.getTableNo(), itemInfoEx.getBaseDataId());
		}

		// N񃊃Xg쐬
		List<NodeLinkInfo> nodeLinkInfoList = new LinkedList<NodeLinkInfo>();
		createLinkKey(interfaceProject, targetInterfaceId, "", nodeLinkInfoList, includeIdKey2TableNoMap);

		// ftHg̕я쐬
		List<TableNoItemId> primaryKeyTableNoItemIdList = new LinkedList<TableNoItemId>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem()) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					TableNoItemId tableNoItenId = getBaseItemId(interfaceProject, "", includeIdKey2TableNoMap,
							targetInterfaceId, itemId);
					primaryKeyTableNoItemIdList.add(tableNoItenId);
				}
			}
		}

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();
		try {
			byte[] image = createFileImage(interfaceProject, db, targetInterfaceId, packageName, rootIncludeId,
					nodeLinkInfoList, tableNo2InterfaceDataIdMap, itemId2ItemInfoExMap, primaryKeyTableNoItemIdList);

			fileMap.put(InterfaceTools.changeClassNmae(interfaceData.getName()) + SAFFIX_NAME_DAO + ".java",image);
			
			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(InterfaceTools.changeClassNmae(interfaceData.getName()) + SAFFIX_NAME_DAO + "Java.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	protected String makeIncludeIdKey(int IncludeId) {
		return makeIncludeIdKey("", IncludeId);
	}

	protected String makeIncludeIdKey(String baseKey, int IncludeId) {
		return baseKey + "#" + IncludeId;
	}

	/**
	 * CN[hIDL[(#IncludeId#IncludeIdEEE)ƃe[uԍ̃}bv쐬B <BR>
	 * AqCN[hR[h̃NL̂͑ΏۊOƂB
	 *
	 * @param interfaceProject
	 * @param interfaceData
	 * @param includeIdKey
	 * @param includeIdKey2TableNoMap
	 * @param tableInfo
	 * @throws InterfaceException
	 */
	protected void createTableNoMap(InterfaceProject interfaceProject, InterfaceData interfaceData, String includeIdKey,
			HashMap<String, Integer> includeIdKey2TableNoMap, TableInfo tableInfo) throws InterfaceException {

		HashMap<Integer, Integer> includeId2InterfaceIdMap = new HashMap<Integer, Integer>();
		Integer[] itemIds = interfaceData.getAllItemIdList();

		int rootIncludeId = -1;
		// w肳ꂽC^[tF[Xf[^̎qC^[tF[XŕR[hݒ肳ĂCN[hID̃Zbg쐻
		HashSet<Integer> tempRightMultiIncludeIdSet = new HashSet<Integer>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isBaseItem()) {
				AttributeData linkOption = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.LINK_OPTION_TYPE_ATTACH_NAME);
				if (linkOption != null && VirtualDbTableFileCreator.LINK_TYPE_MULTI_SET.contains(linkOption.getValue())) {
					if (!tempRightMultiIncludeIdSet.contains(item.getIncludeId())) {
						tempRightMultiIncludeIdSet.add(item.getIncludeId());
					}
				}

				if (item.isPrimaryKey()) {
					rootIncludeId = item.getIncludeId();
				}

				includeId2InterfaceIdMap.put(item.getIncludeId(), item.getIncludeDataId());
			}
		}

		HashMap<Integer, HashSet<Integer>> treeMap = new HashMap<Integer, HashSet<Integer>>(); // ؍\}bv@L[=ẽCN[hIDAl=q̃CN[hIDXg
		// ؍\̃CN[hID}bv쐬
		HashSet<Integer> usedIncludeIdSet = new HashSet<Integer>();
		usedIncludeIdSet.add(rootIncludeId);
		makeTree(rootIncludeId, treeMap, usedIncludeIdSet, interfaceData.getDataId(), interfaceProject);

		// ؍\ǂCN[hIDXg쐬
		List<Integer> includeIdList = new LinkedList<Integer>();
		makeIncludeIdList(includeIdList, rootIncludeId, treeMap);

		for (Integer incId : includeIdList) {
			if (!tempRightMultiIncludeIdSet.contains(incId)) {
				InterfaceData includeData = interfaceProject.getInterfaceDataManager().getInterfaceData(
						includeId2InterfaceIdMap.get(incId));

				String newIncludeIdKey = makeIncludeIdKey(includeIdKey, incId);
				if (includeData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
					createTableNoMap(interfaceProject, includeData, newIncludeIdKey, includeIdKey2TableNoMap, tableInfo);
				} else if (includeData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
					if (!includeIdKey2TableNoMap.containsKey(newIncludeIdKey)) {
						includeIdKey2TableNoMap.put(newIncludeIdKey, tableInfo.getNextTableNo());
					}
				}
			}
		}
	}

	/**
	 * ؍\ǂCN[hIDXg쐬
	 *
	 * @param includeIdList
	 * @param parentIncludeId
	 * @param treeMap
	 */
	protected void makeIncludeIdList(List<Integer> includeIdList, int parentIncludeId,
			HashMap<Integer, HashSet<Integer>> treeMap) {
		includeIdList.add(parentIncludeId);

		for (Integer chaildIncludeId : treeMap.get(parentIncludeId)) {
			makeIncludeIdList(includeIdList, chaildIncludeId, treeMap);
		}
	}

	/**
	 * ACeIDƃACẽ}bv쐬B <BR>
	 * AqCN[hR[h̃NL̂͑ΏۊOƂB
	 *
	 * @param interfaceProject
	 * @param interfaceData
	 * @param includeIdKey
	 * @param includeIdKey2TableNoMap
	 * @param tableInfo
	 * @throws InterfaceException
	 */
	protected void createItemIdMap(InterfaceProject interfaceProject, int orgItemId, String includeIdKey, int dataId,
			int itemId, Map<Integer, ItemInfoEx> itemId2ItemInfoExMap, HashMap<String, Integer> includeIdKey2TableNoMap)
			throws InterfaceException {

		InterfaceData includeData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
		InterfaceDataItem item = includeData.getItem(itemId);
		if (includeData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			if (!item.isBaseItem()) {
				createItemIdMap(interfaceProject, orgItemId, makeIncludeIdKey(includeIdKey, item.getIncludeId()), item
						.getIncludeDataId(), item.getIncludeItemId(), itemId2ItemInfoExMap, includeIdKey2TableNoMap);
			}
		} else if (includeData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
			if (includeIdKey2TableNoMap.containsKey(includeIdKey)) {
				itemId2ItemInfoExMap.put(orgItemId, new ItemInfoEx(orgItemId, includeIdKey2TableNoMap.get(includeIdKey),
						dataId, itemId));
			}
		}
	}

	/**
	 * NL[Xg쐬B <BR>
	 *
	 * @param interfaceProject
	 * @param interfaceData
	 * @param includeIdKey
	 * @param includeIdKey2TableNoMap
	 * @param tableInfo
	 * @throws InterfaceException
	 */
	protected void createLinkKey(InterfaceProject interfaceProject, int targetInterfaceId, String includeIdKey,
			List<NodeLinkInfo> nodeLinkInfoList, HashMap<String, Integer> includeIdKey2TableNoMap) throws InterfaceException {

		int rootIncludeId = -1;
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		Integer[] itemIds = interfaceData.getAllItemIdList();

		// ؍\̃[gCN[hID擾
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem()) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					rootIncludeId = item.getIncludeId();
					break;
				}
			}
		}
		// [g݂ȂƂ͈ȉsȂ
		if (rootIncludeId < 0) {
			return;
		}

		// ؍\̃CN[hID}bv쐬
		HashMap<Integer, HashSet<Integer>> treeMap = new HashMap<Integer, HashSet<Integer>>(); // ؍\}bv@L[=ẽCN[hIDAl=q̃CN[hIDXg
		HashSet<Integer> usedIncludeIdSet = new HashSet<Integer>();
		usedIncludeIdSet.add(rootIncludeId);
		makeTree(rootIncludeId, treeMap, usedIncludeIdSet, targetInterfaceId, interfaceProject);

		// m[hN񃊃Xg֒ǉ
		makeChaildLinkMap(includeIdKey, rootIncludeId, nodeLinkInfoList, treeMap, targetInterfaceId, interfaceProject,
				includeIdKey2TableNoMap);

		// CN[hꂽC^[tF[XfȂ炻̃NN񃊃Xg֒ǉ
		for (IncludeInfo includeInfo : interfaceData.getIncludeIfoList()) {
			InterfaceData includeData = interfaceProject.getInterfaceDataManager().getInterfaceData(
					includeInfo.getIncludeDataId());

			if (includeData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
				createLinkKey(interfaceProject, includeInfo.getIncludeDataId(), makeIncludeIdKey(includeIdKey, includeInfo
						.getIncludeId()), nodeLinkInfoList, includeIdKey2TableNoMap);
			}
		}

	}

	/**
	 * ؍\̃CN[hID}bv쐬
	 *
	 * @param parentIncludeId
	 * @param treeMap
	 * @param usedIncludeIdSet
	 * @param targetInterfaceId
	 * @param interfaceProject
	 * @throws InterfaceException
	 */
	protected void makeTree(int parentIncludeId, HashMap<Integer, HashSet<Integer>> treeMap, HashSet<Integer> usedIncludeIdSet,
			int targetInterfaceId, InterfaceProject interfaceProject) throws InterfaceException {

		HashSet<Integer> chaildIncludeIdSet = new HashSet<Integer>();
		treeMap.put(parentIncludeId, chaildIncludeIdSet);

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		// Integer[] itemIds = interfaceData.getEnableItemIdList();
		Integer[] itemIds = interfaceData.getAllItemIdList();

		// em[hɑ݂郊Nԍ̃Zbg߂
		HashSet<String> linkNoSet = new HashSet<String>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem() && item.getIncludeId() == parentIncludeId) {
				AttributeData linkNo = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.LINK_NO_ATTACH_NAME);
				if (linkNo != null && !"00".equals(linkNo.getValue())) {
					linkNoSet.add(linkNo.getValue());
				}
			}
		}

		// Nԍ̃Zbg݂gpĂȂCN[hID̃Zbg߂
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (item.isBaseItem() || usedIncludeIdSet.contains(item.getIncludeId())) {
				continue;
			}

			AttributeData linkNo = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
					VirtualDbTableFileCreator.LINK_NO_ATTACH_NAME);
			if (linkNo != null && !"00".equals(linkNo.getValue())) {
				if (linkNoSet.contains(linkNo.getValue()) && !chaildIncludeIdSet.contains(item.getIncludeId())) {
					chaildIncludeIdSet.add(item.getIncludeId());
					usedIncludeIdSet.add(item.getIncludeId());
				}
			}
		}

		// q̃CN[hIDɃNĂ鑷̃CN[hID擾
		for (Integer chaildIncludeId : chaildIncludeIdSet) {
			makeTree(chaildIncludeId, treeMap, usedIncludeIdSet, targetInterfaceId, interfaceProject);
		}

	}

	/**
	 * qCN[hID̃N}bv쐬
	 *
	 * @param parentIncludeId
	 * @param chaildLinkMap
	 * @param targetInterfaceId
	 * @param interfaceProject
	 * @throws InterfaceException
	 */
	protected void makeChaildLinkMap(String includeIdKey, int parentIncludeId, List<NodeLinkInfo> nodeLinkInfoList,
			HashMap<Integer, HashSet<Integer>> treeMap, int targetInterfaceId, InterfaceProject interfaceProject,
			HashMap<String, Integer> includeIdKey2TableNoMap) throws InterfaceException {

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		Integer[] itemIds = interfaceData.getAllItemIdList();

		HashMap<Integer, Integer> includeId2InterfaceId = new HashMap<Integer, Integer>();

		// em[hɑ݂郊NԍEitemId̃}bv߂
		HashMap<String, Integer> linkNo2ItemIdMap = new HashMap<String, Integer>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem() && item.getIncludeId() == parentIncludeId) {
				AttributeData linkNo = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.LINK_NO_ATTACH_NAME);
				if (linkNo != null && !"00".equals(linkNo.getValue())) {
					linkNo2ItemIdMap.put(linkNo.getValue(), itemId);
				}
			}

			if (!item.isBaseItem()) {
				includeId2InterfaceId.put(item.getIncludeId(), item.getIncludeDataId());
			}
		}

		// NԍŌ΂ꂽem[hItemIdAqm[hItemID擾̃Xg쐬qCN[hID̃N}bv쐬
		HashSet<Integer> chaildIncludeIdSet = treeMap.get(parentIncludeId);
		for (Integer chaidIncludeId : chaildIncludeIdSet) {
			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (!item.isBaseItem() && item.getIncludeId() == (int) chaidIncludeId) {
					AttributeData linkNo = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
							VirtualDbTableFileCreator.LINK_NO_ATTACH_NAME);
					if (linkNo != null && !"00".equals(linkNo.getValue())) {
						if (linkNo2ItemIdMap.containsKey(linkNo.getValue())) {

							InterfaceDataItem parentItem = interfaceData.getItem(linkNo2ItemIdMap.get(linkNo.getValue()));
							TableNoItemId parentTableNoItemId = getBaseItemId(interfaceProject, makeIncludeIdKey(includeIdKey,
									parentIncludeId), includeIdKey2TableNoMap, parentItem.getIncludeDataId(), parentItem
									.getIncludeItemId());

							InterfaceDataItem chaildItem = interfaceData.getItem(itemId);
							TableNoItemId chaildTableNoItemId = getBaseItemId(interfaceProject, makeIncludeIdKey(includeIdKey,
									chaidIncludeId), includeIdKey2TableNoMap, chaildItem.getIncludeDataId(), chaildItem
									.getIncludeItemId());

							if (parentTableNoItemId != null && chaildTableNoItemId != null) {
								nodeLinkInfoList.add(new NodeLinkInfo(parentTableNoItemId, chaildTableNoItemId));
							}
						}
					}
				}
			}

			// m[h̎qCN[hID̃N}bv쐬
			makeChaildLinkMap(includeIdKey, chaidIncludeId, nodeLinkInfoList, treeMap, targetInterfaceId, interfaceProject,
					includeIdKey2TableNoMap);
		}
	}

	protected TableNoItemId getBaseItemId(InterfaceProject interfaceProject, String IncludeIdKey,
			HashMap<String, Integer> includeIdKey2TableNoMap, int interfaceId, int itemId) throws InterfaceException {
		TableNoItemId rtn = null;

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(interfaceId);
		InterfaceDataItem item = interfaceData.getItem(itemId);

		// if (item.isBaseItem()) {
		if (interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			rtn = getBaseItemId(interfaceProject, makeIncludeIdKey(IncludeIdKey, item.getIncludeId()), includeIdKey2TableNoMap,
					item.getIncludeDataId(), item.getIncludeItemId());
		} else if (interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
			if (includeIdKey2TableNoMap.containsKey(IncludeIdKey)) {
				rtn = new TableNoItemId(includeIdKey2TableNoMap.get(IncludeIdKey), itemId);
			}
		}
		// }
		return rtn;
	}

	protected byte[] createFileImage(InterfaceProject interfaceProject, DbType db, int targetInterfaceId, String packageName,
			int rootIncludeId, List<NodeLinkInfo> nodeLinkInfoLis, TreeMap<Integer, Integer> tableNo2InterfaceDataIdMap,
			TreeMap<Integer, ItemInfoEx> itemId2ItemInfoExMap, List<TableNoItemId> primaryKeyTableNoItemIdList)
			throws IOException, InterfaceException {

		// TreeMap<String, TreeSet<String>> changeFieldTypeMethodMap = new
		// TreeMap<String, TreeSet<String>>();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		String voName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String className = voName + SAFFIX_NAME_DAO;

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("dao package", "package", packageName));
				}

				// ===== wb_[ =====
				if (db == DbType.postgreSQL) {
					out(baos, getText("header postgreSQL"));
				}

				out(baos, getText("header", "nameJp", interfaceData.getNameJp(), "className", className));

				for (Integer itemId : itemId2ItemInfoExMap.keySet()) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.isEnable() && !item.isBaseItem()) {
						ItemInfoEx itemInfoEx = itemId2ItemInfoExMap.get(itemId);

						InterfaceData dbInterfaceDate = interfaceProject.getInterfaceDataManager().getInterfaceData(
								itemInfoEx.getBaseDataId());
						InterfaceDataItem dbItem = dbInterfaceDate.getItem(itemInfoEx.getBaseItemId());
						String type = InterfaceTools.getVoType(dbItem.getType(), dbItem.getLength(), dbItem.getSubLength());

						out(baos, getText("header put key", "keyNmae", item.getName().toLowerCase(), "tableFieldName",
								makeFieldName(itemInfoEx.getTableNo(), dbItem.getName()), "classObject", type));
					}
				}

				out(baos, getText("header 2"));

				int maxEnableFieldLoopCount = 0;
				for (Integer itemId : itemId2ItemInfoExMap.keySet()) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.isEnable() && !item.isBaseItem()) {
						maxEnableFieldLoopCount++;
					}
				}

				StringBuilder sb = new StringBuilder();
				int loopCount = 0;
				for (Integer itemId : itemId2ItemInfoExMap.keySet()) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.isEnable() && !item.isBaseItem()) {
						ItemInfoEx itemInfoEx = itemId2ItemInfoExMap.get(itemId);

						InterfaceData dbInterfaceDate = interfaceProject.getInterfaceDataManager().getInterfaceData(
								itemInfoEx.getBaseDataId());
						InterfaceDataItem dbItem = dbInterfaceDate.getItem(itemInfoEx.getBaseItemId());

						sb.append(makeFieldName(itemInfoEx.getTableNo(), dbItem.getName()) + " as "
								+ item.getName().toLowerCase());
						loopCount++;

						if (loopCount < maxEnableFieldLoopCount) {
							sb.append(", ");
						} else {
							sb.append(" ");
						}

						if ((loopCount % 5) == 0) {
							out(baos, getText("sql search fields", "fields", sb.toString()));
							sb.setLength(0);
						}
					}
				}

				if (sb.length() > 0) {
					out(baos, getText("sql search fields", "fields", sb.toString()));
				}

				InterfaceData rootTableInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
						tableNo2InterfaceDataIdMap.get(1));
				out(baos, getText("sql search from", "tableName", rootTableInterfaceData.getName() + " "
						+ makeAliaseTableName(1)));

				loopCount = 0;
				for (Integer tableNo : tableNo2InterfaceDataIdMap.keySet()) {
					loopCount++;
					if (tableNo != 1) { // [g͏
						InterfaceData tableInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								tableNo2InterfaceDataIdMap.get(tableNo));
						sb.setLength(0);
						for (NodeLinkInfo nodeLinkInfo : nodeLinkInfoLis) {
							if (nodeLinkInfo.getChaild().getTableNo() == tableNo) {
								if (sb.length() > 0) {
									sb.append(" and ");
								}
								sb.append(makeFieldName(tableNo, tableInterfaceData.getItem(
										nodeLinkInfo.getChaild().getItemId()).getName()));
								sb.append("=");
								int parentDataId = tableNo2InterfaceDataIdMap.get(nodeLinkInfo.getParent().getTableNo());
								InterfaceData parentInterfaceData = interfaceProject.getInterfaceDataManager()
										.getInterfaceData(parentDataId);
								sb.append(makeFieldName(nodeLinkInfo.getParent().getTableNo(), parentInterfaceData.getItem(
										nodeLinkInfo.getParent().getItemId()).getName()));
							}
						}
//						if (loopCount >= tableNo2InterfaceDataIdMap.keySet().size()) {
//							out(baos, getText("sql search join;", "tableName", tableInterfaceData.getName() + " "
//									+ makeAliaseTableName(tableNo), "on", sb.toString()));
//						} else {
							out(baos, getText("sql search join", "tableName", tableInterfaceData.getName() + " "
									+ makeAliaseTableName(tableNo), "on", sb.toString()));
//						}
					}
				}

				StringBuilder orderBy = new StringBuilder();
				for (TableNoItemId tableNoItemId : primaryKeyTableNoItemIdList) {
					if (orderBy.length() <= 0) {
						orderBy.append("order by ");
					} else {
						orderBy.append(", ");
					}
					InterfaceDataItem item = interfaceProject.getInterfaceDataManager().getInterfaceData(
							tableNo2InterfaceDataIdMap.get(tableNoItemId.getTableNo())).getItem(tableNoItemId.getItemId());
					orderBy.append(makeFieldName(tableNoItemId.getTableNo(), item.getName()));
				}
				out(baos, getText("sql search list", "voName", voName, "orderBy", orderBy.toString()));

				if (db == DbType.postgreSQL) {
					out(baos, getText("sql search postgreSQL"));

					for (Integer wkItemId : itemId2ItemInfoExMap.keySet()) {
						InterfaceDataItem wkItem = interfaceData.getItem(wkItemId);
						if (wkItem.isEnable() && !wkItem.isBaseItem()) {
							ItemInfoEx itemInfoEx = itemId2ItemInfoExMap.get(wkItemId);

							InterfaceData dbInterfaceDate = interfaceProject.getInterfaceDataManager().getInterfaceData(
									itemInfoEx.getBaseDataId());
							int itemId = itemInfoEx.getBaseItemId();
							InterfaceDataItem item = dbInterfaceDate.getItem(itemId);

							// Ǝ^Cv̎o
							AttributeData dokujiTypeAttributeData = dbInterfaceDate.getAttribute(itemId,
									DataBaseFileCreator.PLUGIN_NAME, "dokujiType");
							String dokujiType = "";
							if (dokujiTypeAttributeData != null) {
								dokujiType = dokujiTypeAttributeData.getValue();
							}
							if (DaoFileCreator.isPostgreSQLBitType(db, dokujiType)) {
								out(baos, getText("sql search postgreSQL field", "fieldNmae", item.getName()));
							}
						}
					}

					out(baos, getText("sql search postgreSQL end"));
				}

				out(baos, getText("constructor", "className", className, "voName", voName, "nameJp", interfaceData.getNameJp()));

				for (Integer itemId : itemId2ItemInfoExMap.keySet()) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.isEnable() && !item.isBaseItem()) {
						ItemInfoEx itemInfoEx = itemId2ItemInfoExMap.get(itemId);

						InterfaceData dbInterfaceDate = interfaceProject.getInterfaceDataManager().getInterfaceData(
								itemInfoEx.getBaseDataId());
						InterfaceDataItem dbItem = dbInterfaceDate.getItem(itemInfoEx.getBaseItemId());

						String change = InterfaceTools.getFieldChangeMethodName(item.getType(), item.getLength(), item
								.getSubLength());

						setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));
						setParameter("name", item.getName().toLowerCase());
						setParameter("change", change);

						switch (dbItem.getType()) {
						case STRING:

							out(baos, getText("search ResultSet String"));
							break;
						case NUM:
							if (InterfaceTools.isIntType(dbItem.getLength(), dbItem.getSubLength())) {
								out(baos, getText("search ResultSet Int"));
							} else if (InterfaceTools.isLongType(dbItem.getLength(), dbItem.getSubLength())) {
								out(baos, getText("search ResultSet Long"));
							} else {
								out(baos, getText("search ResultSet BigDecimal"));
							}
							break;
						case BOOLEAN:
							if (db == DbType.h2 || db == DbType.postgreSQL) {
								out(baos, getText("search ResultSet Boolean h2"));
							} else if (db == DbType.oracle) {
								out(baos, getText("search ResultSet Boolean oracle"));
							}
							break;
						case DATE:
							out(baos, getText("search ResultSet Date"));
							break;
						case TIME:
							out(baos, getText("search ResultSet Time"));
							break;
						case DATE_TIME:
							out(baos, getText("search ResultSet Timestamp"));
							break;
						case IMAGE:
							out(baos, getText("search ResultSet byte[]"));
							break;
						}

						// ^ϊ
						// String type =
						// InterfaceTools.getVoType(item.getType(),
						// item.getLength(), item.getSubLength());
						// String dbType =
						// InterfaceTools.getVoType(dbItem.getType(),
						// dbItem.getLength(), dbItem.getSubLength());
						//
						// TreeSet<String> wkSet = null;
						// if (changeFieldTypeMethodMap.containsKey(type)) {
						// wkSet = changeFieldTypeMethodMap.get(type);
						// } else {
						// wkSet = new TreeSet<String>();
						// changeFieldTypeMethodMap.put(type, wkSet);
						// }
						// wkSet.add(dbType);
						//
						// if (changeFieldTypeMethodMap.containsKey(dbType)) {
						// wkSet = changeFieldTypeMethodMap.get(dbType);
						// } else {
						// wkSet = new TreeSet<String>();
						// changeFieldTypeMethodMap.put(dbType, wkSet);
						// }
						// wkSet.add(type);
					}
				}

				out(baos, getText("search footer"));

				if (db == DbType.postgreSQL) {
					out(baos, getText("footer postgreSQL"));
				}

				// // tB[hϊ\bho
				// for (String type : changeFieldTypeMethodMap.keySet()) {
				// for (String baseType : changeFieldTypeMethodMap.get(type)) {
				// out(baos, getText("change field type " + type + "-" +
				// baseType));
				// }
				// }
				//
				// tb^o
				out(baos, getText("footer"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected String makeAliaseTableName(int tableNo) {
		return "t" + tableNo;
	}

	protected String makeFieldName(int tableNo, String fieldName) {
		return makeAliaseTableName(tableNo) + "." + fieldName.toLowerCase();
	}

	class NodeLinkInfo {
		private TableNoItemId parent;
		private TableNoItemId chaild;

		public NodeLinkInfo(TableNoItemId parent, TableNoItemId chaild) {
			this.parent = parent;
			this.chaild = chaild;
		}

		public String toString() {
			StringBuilder sb = new StringBuilder();

			sb.append("parent");
			sb.append("={");
			sb.append(parent.toString());
			sb.append("}, ");

			sb.append("chaild");
			sb.append("={");
			sb.append(chaild.toString());
			sb.append("} ");

			return sb.toString();
		}

		/**
		 * @return the parent
		 */
		public TableNoItemId getParent() {
			return parent;
		}

		/**
		 * @return the chaild
		 */
		public TableNoItemId getChaild() {
			return chaild;
		}

		/**
		 * @param parent
		 *            the parent to set
		 */
		public void setParent(TableNoItemId parent) {
			this.parent = parent;
		}

		/**
		 * @param chaild
		 *            the chaild to set
		 */
		public void setChaild(TableNoItemId chaild) {
			this.chaild = chaild;
		}

	}

	class TableNoItemId {
		private Integer tableNo;
		private Integer itemId;

		public TableNoItemId(Integer tableNo, Integer itemId) {
			this.tableNo = tableNo;
			this.itemId = itemId;
		}

		public String toString() {
			StringBuilder sb = new StringBuilder();

			sb.append("tableNo");
			sb.append("=");
			sb.append(tableNo);
			sb.append(", ");

			sb.append("itemId");
			sb.append("=");
			sb.append(itemId);

			return sb.toString();
		}

		/**
		 * @return the tableNo
		 */
		public Integer getTableNo() {
			return tableNo;
		}

		/**
		 * @return the itemId
		 */
		public Integer getItemId() {
			return itemId;
		}

		/**
		 * @param tableNo
		 *            the tableNo to set
		 */
		public void setTableNo(Integer tableNo) {
			this.tableNo = tableNo;
		}

		/**
		 * @param itemId
		 *            the itemId to set
		 */
		public void setItemId(Integer itemId) {
			this.itemId = itemId;
		}

	}

	// //////////////////////////////////////////////////////////////////////////////////////////
	class TableInfo {
		private int tableNo = 0;

		public int getNextTableNo() {
			return ++tableNo;
		}

		public int getMaxTableNo() {
			return tableNo;
		}
	}

	class ItemInfoEx {
		private Integer itemId;
		private Integer tableNo;
		private Integer baseDataId;
		private Integer baseItemId;

		public ItemInfoEx(Integer itemId, Integer tableNo, Integer baseDataId, Integer baseItemId) {
			this.itemId = itemId;
			this.tableNo = tableNo;
			this.baseDataId = baseDataId;
			this.baseItemId = baseItemId;
		}

		public String toString() {
			StringBuilder sb = new StringBuilder();

			sb.append("itemId");
			sb.append("=");
			sb.append(itemId);
			sb.append(", ");

			sb.append("tableNo");
			sb.append("=");
			sb.append(tableNo);
			sb.append(", ");

			sb.append("baseDataId");
			sb.append("=");
			sb.append(baseDataId);
			sb.append(", ");

			sb.append("baseItemId");
			sb.append("=");
			sb.append(baseItemId);

			return sb.toString();
		}

		/**
		 * @return the itemId
		 */
		public Integer getItemId() {
			return itemId;
		}

		/**
		 * @return the tableNo
		 */
		public Integer getTableNo() {
			return tableNo;
		}

		/**
		 * @return the baseDataId
		 */
		public Integer getBaseDataId() {
			return baseDataId;
		}

		/**
		 * @return the baseItemId
		 */
		public Integer getBaseItemId() {
			return baseItemId;
		}

		/**
		 * @param itemId
		 *            the itemId to set
		 */
		public void setItemId(Integer itemId) {
			this.itemId = itemId;
		}

		/**
		 * @param tableNo
		 *            the tableNo to set
		 */
		public void setTableNo(Integer tableNo) {
			this.tableNo = tableNo;
		}

		/**
		 * @param baseDataId
		 *            the baseDataId to set
		 */
		public void setBaseDataId(Integer baseDataId) {
			this.baseDataId = baseDataId;
		}

		/**
		 * @param baseItemId
		 *            the baseItemId to set
		 */
		public void setBaseItemId(Integer baseItemId) {
			this.baseItemId = baseItemId;
		}

	}

}
