package jp.oarts.pirka.iop.tool.core.plugin.file.db;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * IXgpJava\[XEt@CNG[^[vOC
 *
 * @author ito
 *
 */
public class SelectListFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 5713576716306191853L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.pirka.iop.tool.core.plugin.file.db.SelectListFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "IXg Java\[Xt@Co";

	public static final String SAFFIX_NAME_DAO = "Dao";
	public static final String SAFFIX_NAME_SEARCHER_DAO = "SearcherDao";
	public static final String SAFFIX_NAME_SELECT_LIST = "SelectList";

	public static final String KEY_ATTACH_NAME = "key";
	public static final String VALUE_ATTACH_NAME = "value";

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //
			new AttributeSimpleItem(KEY_ATTACH_NAME, "ML[", "Iڂ̑ML[ƂĎgpƂɃ`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			new AttributeSimpleItem(VALUE_ATTACH_NAME, "\l", "Iڂ̕\liꗗ\́jƂĎgpƂɃ`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null), };

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("common", "IXgʃNX\[Xt@Co͂", "IXg\[Xt@Cgp鋤ʃNX̃\[Xt@Cꏏɏo͂ƂɃ`FbN܂",
					ParameterType.CHECK, new ParameterData(true), null),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public SelectListFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "IXgJava\[XR[ho͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "IXgJava\[XR[ho͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + VirtualDbTableFileCreator.PLUGIN_NAME_JP + "xA\n" //
				+ "܂́w" + DataBaseFileCreator.PLUGIN_NAME_JP + "x\n" //
				+ "ǂ炩Ɓw" + PLUGIN_NAME_JP + "x\nAb^`ĂKv܂B\n" //
				+ "o͂\[Xt@C͎w肳ꂽC^[tF[X쐬DAO܂MODEL̃NXgp܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + PLUGIN_NAME_JP + "xAb^b`Kv܂");
			}

			if (!interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)
					&& !interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + VirtualDbTableFileCreator.PLUGIN_NAME_JP + "x܂́A" //
						+ "w" + DataBaseFileCreator.PLUGIN_NAME_JP + "xAb^b`Kv܂");
			}

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);
		}

	}

	@Override
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
		InterfaceDataItem item = interfaceData.getItem(itemId);

		if (!item.isEnable()) {

			AttributeData key = dataMap.get(KEY_ATTACH_NAME);
			if ((key != null && key.getValueBoolean())) {
				throw new InterfaceException("tB[hɂ͑ML[͎wł܂");
			}

			AttributeData value = dataMap.get(VALUE_ATTACH_NAME);
			if ((value != null && value.getValueBoolean())) {
				throw new InterfaceException("tB[hɂ͕\nl͎wł܂");
			}

		}
	}

	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

		int keyCount = 0;
		int valueCount = 0;

		// `FbN
		for (Integer itemId : myDataMap.keySet()) {
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			if (myAttributeMap != null) {

				InterfaceDataItem item = interfaceData.getItem(itemId);

				// M擾
				AttributeData key = myAttributeMap.get(KEY_ATTACH_NAME);
				if (key != null && key.getValueBoolean()) {
					keyCount++;
				}

				// \l擾
				AttributeData value = myAttributeMap.get(VALUE_ATTACH_NAME);
				if (value != null && value.getValueBoolean()) {
					valueCount++;
				}
			}
		}

		if (keyCount < 1) {
			throw new InterfaceException("ML[w肳Ă܂");
		}
		if (keyCount > 1) {
			throw new InterfaceException("ML[w肳Ă܂");
		}
		if (valueCount < 1) {
			throw new InterfaceException("\lw肳Ă܂");
		}
		if (valueCount > 1) {
			throw new InterfaceException("\lw肳Ă܂");
		}
	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}
		boolean common = dataMap.get("common").getValueBoolean();
		String packageName = dataMap.get("package").getValue();

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		int keyItemId = -1;
		int valueItemId = -1;

		for (Integer itemId : interfaceData.getEnableItemIdList()) {
			AttributeData key = interfaceData.getAttribute(itemId, PLUGIN_NAME, KEY_ATTACH_NAME);

			// M擾
			if (key != null && key.getValueBoolean()) {
				keyItemId = itemId;
			}

			// \l擾
			AttributeData value = interfaceData.getAttribute(itemId, PLUGIN_NAME, VALUE_ATTACH_NAME);
			if (value != null && value.getValueBoolean()) {
				valueItemId = itemId;
			}
		}

		try {
			byte[] image = createFileImage(interfaceProject, targetInterfaceId, packageName, keyItemId, valueItemId);
			fileMap.put(InterfaceTools.changeClassNmae(interfaceData.getName()) + SAFFIX_NAME_SELECT_LIST + ".java", image);

			if (common) {
				image = createCommonFileImage(packageName);
				fileMap.put("SelectListIF.java", image);
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(InterfaceTools.changeClassNmae(interfaceData.getName()) + SAFFIX_NAME_SELECT_LIST
					+ ".zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	protected byte[] createFileImage(InterfaceProject interfaceProject, int targetInterfaceId, String packageName,
			int keyItemId, int valueItemId) throws IOException, InterfaceException {

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		String voClassName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String className = voClassName + SAFFIX_NAME_SELECT_LIST;
		String daoClassName = voClassName;
		if (interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			daoClassName = voClassName + SAFFIX_NAME_SEARCHER_DAO;
		} else {
			daoClassName = voClassName + SAFFIX_NAME_DAO;
		}

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("package", "package", packageName));
				}

				setParameter("nameJp", interfaceData.getNameJp());
				setParameter("className", className);
				setParameter("daoClassName", daoClassName);
				setParameter("voClassName", voClassName);
				setParameter("getterValue", InterfaceTools.changeGetterNmae(interfaceData.getItem(valueItemId).getName(),
						interfaceData.getItem(valueItemId).getType() == FieldType.BOOLEAN));
				setParameter("getterKey", InterfaceTools.changeGetterNmae(interfaceData.getItem(keyItemId).getName(),
						interfaceData.getItem(keyItemId).getType() == FieldType.BOOLEAN));

				out(baos, getText("start"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected byte[] createCommonFileImage(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("common package", "package", packageName));
				}

				out(baos, getText("common start"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

}
