package jp.oarts.pirka.iop.tool.core.plugin.file.db;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.IncludeInfo;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataMyItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * fEzf[^x[Xe[uEt@CNG[^[vOC
 *
 * @author ito
 *
 */
public class VirtualDbTableFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 5713576716306191853L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.pirka.iop.tool.core.plugin.file.db.VirtualDbTableFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "fEzf[^x[Xe[u Java\[Xt@Co";

	public static final String PRIMARY_KEY_ATTACH_NAME = "primaryKey";
	public static final String LINK_OPTION_TYPE_ATTACH_NAME = "linkOptionType";
	public static final String LINK_NO_ATTACH_NAME = "linkNo";
	public static final String USE_FIELD_ATTACH_NAME = "useField";
	public static final String FIELD_NAME_ATTACH_NAME = "fieldName";
	public static final String FIELD_NAME_JP_ATTACH_NAME = "fieldNameJp";
	public static final String FIELD_TYPE_JP_ATTACH_NAME = "fieldType";
	public static final String FIELD_LENGTH_JP_ATTACH_NAME = "fieldLength";
	public static final String FIELD_SUB_LENGTH_JP_ATTACH_NAME = "fieldSubLength";

	public static final String SAFFIX_NAME_DAO = "Dao";
	public static final String SAFFIX_NAME_MODEL = "Model";

	public static final String LINK_TYPE_ONE_ONE = "1:1";
	public static final String LINK_TYPE_ONE_ONE_REF = "1:1R";
	public static final String LINK_TYPE_ONE_N = "1:n";
	public static final String LINK_TYPE_ONE_N_REF = "1:nR";
	public static final String LINK_TYPE_N_ONE = "n:1";
	public static final String LINK_TYPE_N_ONE_RER = "n:1R";
	public static final String LINK_TYPE_N_N = "n:n";
	public static final String LINK_TYPE_N_N_REF = "n:nR";

	public static final HashSet<String> LINK_TYPE_ONE_SET = new HashSet<String>();
	public static final HashSet<String> LINK_TYPE_MULTI_SET = new HashSet<String>();
	public static final HashSet<String> LINK_TYPE_L_ONE_SET = new HashSet<String>();
	public static final HashSet<String> LINK_TYPE_L_MULTI_SET = new HashSet<String>();
	public static final HashSet<String> LINK_TYPE_REF_SET = new HashSet<String>();

	static {
		LINK_TYPE_L_ONE_SET.add(LINK_TYPE_ONE_ONE);
		LINK_TYPE_L_ONE_SET.add(LINK_TYPE_ONE_ONE_REF);
		LINK_TYPE_L_ONE_SET.add(LINK_TYPE_ONE_N);
		LINK_TYPE_L_ONE_SET.add(LINK_TYPE_ONE_N_REF);

		LINK_TYPE_L_MULTI_SET.add(LINK_TYPE_N_ONE);
		LINK_TYPE_L_MULTI_SET.add(LINK_TYPE_N_ONE_RER);
		LINK_TYPE_L_MULTI_SET.add(LINK_TYPE_N_N);
		LINK_TYPE_L_MULTI_SET.add(LINK_TYPE_N_N_REF);

		LINK_TYPE_ONE_SET.add(LINK_TYPE_ONE_ONE);
		LINK_TYPE_ONE_SET.add(LINK_TYPE_ONE_ONE_REF);
		LINK_TYPE_ONE_SET.add(LINK_TYPE_N_ONE);
		LINK_TYPE_ONE_SET.add(LINK_TYPE_N_ONE_RER);

		LINK_TYPE_MULTI_SET.add(LINK_TYPE_ONE_N);
		LINK_TYPE_MULTI_SET.add(LINK_TYPE_ONE_N_REF);
		LINK_TYPE_MULTI_SET.add(LINK_TYPE_N_N);
		LINK_TYPE_MULTI_SET.add(LINK_TYPE_N_N_REF);

		LINK_TYPE_REF_SET.add(LINK_TYPE_ONE_ONE_REF);
		LINK_TYPE_REF_SET.add(LINK_TYPE_ONE_N_REF);
		LINK_TYPE_REF_SET.add(LINK_TYPE_N_ONE_RER);
		LINK_TYPE_REF_SET.add(LINK_TYPE_N_N_REF);
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //
	//
			new AttributeSimpleItem(PRIMARY_KEY_ATTACH_NAME, "L[", "ze[u̎L[ڂ̂Ƃ`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			//
			new AttributeSimpleItem(LINK_NO_ATTACH_NAME, "Nԍ", "e[um̌ɕKvȍڂɓNԍ^Ă", AttributeType.SELECT,
					new AttributeData("00"), null,
					new Selecter("00", ""), //
					new Selecter("01", "01"), new Selecter("02", "02"), new Selecter("03", "03"), new Selecter("04", "04"),
					new Selecter("05", "05"), //
					new Selecter("06", "06"), //
					new Selecter("07", "07"), new Selecter("08", "08"), new Selecter("09", "09"), new Selecter("10", "10"), //
					new Selecter("11", "11"), //
					new Selecter("12", "12"), //
					new Selecter("13", "13"), new Selecter("14", "14"), new Selecter("15", "15"), //
					new Selecter("16", "16"), //
					new Selecter("17", "17"), //
					new Selecter("18", "18"), //
					new Selecter("19", "19"), new Selecter("20", "20") //
			),
			//

			new AttributeSimpleItem(
					LINK_OPTION_TYPE_ATTACH_NAME,
					"N^CvieFqj",
					"NԍŌꂽe[ũN^Cvqe[ũNԍɐݒ肵ĂB1̃NɃNԍ݂Ƃ͂Pӏɐݒ肷ΗLɂȂ܂B܂w莞1:1ݒ肳ꂽƂ݂Ȃ܂B",
					AttributeType.SELECT, new AttributeData(""), null, new Selecter("", " "), //
					new Selecter(LINK_TYPE_ONE_ONE, "1:1"), new Selecter(LINK_TYPE_ONE_ONE_REF, "1:1(QƂ̂)"),//
					new Selecter(LINK_TYPE_ONE_N, "1:n"), new Selecter(LINK_TYPE_ONE_N_REF, "1:n(QƂ̂)"),//
					new Selecter(LINK_TYPE_N_ONE, "n:1"), new Selecter(LINK_TYPE_N_ONE_RER, "n:1(QƂ̂)"),//
					new Selecter(LINK_TYPE_N_N, "n:n"), new Selecter(LINK_TYPE_N_N_REF, "n:n(QƂ̂)") //
			),

	/****************
	 * new AttributeSimpleItemAlwaysDefaultValue(USE_FIELD_ATTACH_NAME,
	 * "L̕ύX", "ڂ̗LύXƂɑIĂBo^ɍڂ̗Lݒ肳܂B",
	 * AttributeType.SELECT, new AttributeData(""), null, new Selecter("", " "),
	 * // new Selecter("true", "LɕύX"), new Selecter("false", "ɕύX") // ,
	 * ), // new AttributeSimpleItemAlwaysDefaultValue(FIELD_NAME_ATTACH_NAME,
	 * "ږ̕ύX", "ږ̕ύXsƂɐVږ͂ĂBo^ɍږݒ肳܂B",
	 * AttributeType.TEXT, new AttributeData(""), null), //
	 *
	 * // new AttributeSimpleItemAlwaysDefaultValue(FIELD_NAME_JP_ATTACH_NAME,
	 * "ږi{j̕ύX", "ږi{j̕ύXsƂɐVږ͂ĂBo^ɍږi{jݒ肳܂B",
	 * AttributeType.TEXT, new AttributeData(""), null), // new
	 * AttributeSimpleItemAlwaysDefaultValue(FIELD_TYPE_JP_ATTACH_NAME,
	 * "tB[h^Cv̕ύX",
	 * "tB[h^Cv̕ύXsƂɐVtB[h^CvIĂBo^ɃtB[h^Cvݒ肳܂B",
	 * AttributeType.SELECT, new AttributeData(""), null, new Selecter("", " "),
	 * // new Selecter(FieldType.STRING.toString(),
	 * FieldType.STRING.toString()), // new Selecter(FieldType.NUM.toString(),
	 * FieldType.NUM.toString()),// new Selecter(FieldType.BOOLEAN.toString(),
	 * FieldType.BOOLEAN.toString()),// new Selecter(FieldType.DATE.toString(),
	 * FieldType.DATE.toString()),// new Selecter(FieldType.TIME.toString(),
	 * FieldType.TIME.toString()),// new
	 * Selecter(FieldType.DATE_TIME.toString(),
	 * FieldType.DATE_TIME.toString()),// new
	 * Selecter(FieldType.IMAGE.toString(), FieldType.IMAGE.toString())// ), //
	 * new AttributeSimpleItemAlwaysDefaultValue(FIELD_LENGTH_JP_ATTACH_NAME,
	 * "ڒ̕ύX", "ڒ̕ύXsƂɐVڒ͂ĂBo^ɍڒݒ肳܂B",
	 * AttributeType.TEXT, new AttributeData(""), null), // // new
	 * AttributeSimpleItemAlwaysDefaultValue(FIELD_SUB_LENGTH_JP_ATTACH_NAME,
	 * "̕ύX", "̕ύXsƂɐV͂ĂBo^ɏݒ肳܂B",
	 * AttributeType.TEXT, new AttributeData(""), null), //
	 ***********/
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("logout", "Oo̓R[ht",
					"샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(true),
					null),
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public VirtualDbTableFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "fEzf[^x[Xe[upJava\[XR[ho͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "fEzf[^x[Xe[u`鎞ɃAb^`܂B" ;

	}

	@Override
	public String getParameterComment() {
		return "fEzf[^x[Xe[upJava\[XR[ho͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + getNameJp() + "x\nAb^`ĂKv܂B";

	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(getName())) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + getNameJp() + "xAb^b`Kv܂");
			}

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);
		}

	}

	@Override
	public void preCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

		// XV
		for (int itemId : myDataMap.keySet()) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);

			boolean change = false;
			AttributeData use = myAttributeMap.get(USE_FIELD_ATTACH_NAME);
			if (use != null && use.getValue().length() > 0) {
				if ("true".equalsIgnoreCase(use.getValue())) {
					item.setEnable(true);
				} else if ("false".equalsIgnoreCase(use.getValue())) {
					item.setEnable(false);
				} else if ("org".equalsIgnoreCase(use.getValue())) {
					item.setUseName(false);
					item.setUseNameJp(false);
					item.setUseLength(false);
					item.setUseType(false);
				}
				change = true;
			}

			AttributeData fieldName = myAttributeMap.get(FIELD_NAME_ATTACH_NAME);
			if (fieldName != null && fieldName.getValue().length() > 0) {
				String safeFieldName = InterfaceTools.changeSafeInterfaceDataItemNmae(fieldName.getValue(), "");
				if (safeFieldName.length() > 0) {
					item.setName(safeFieldName);
					item.setUseName(true);
					change = true;
				}
			}

			AttributeData fieldNameJp = myAttributeMap.get(FIELD_NAME_JP_ATTACH_NAME);
			if (fieldNameJp != null && fieldNameJp.getValue().length() > 0) {
				item.setNameJp(fieldNameJp.getValue());
				item.setUseNameJp(true);
				change = true;
			}

			AttributeData fieldType = myAttributeMap.get(FIELD_TYPE_JP_ATTACH_NAME);
			if (fieldType != null && fieldType.getValue().length() > 0) {
				item.setType(FieldType.valueOf(fieldType.getValue()));
				item.setUseType(true);
				change = true;
			}

			AttributeData fieldLength = myAttributeMap.get(FIELD_LENGTH_JP_ATTACH_NAME);
			AttributeData fieldSubLength = myAttributeMap.get(FIELD_SUB_LENGTH_JP_ATTACH_NAME);
			if (fieldLength != null && fieldLength.getValue().length() > 0) {
				int length = 0;
				try {
					length = Integer.parseInt(fieldLength.getValue());
				} catch (NumberFormatException e) {
					// Ȃ
				}
				item.setLength(length);
				item.setUseLength(true);
				change = true;
			}

			if (fieldSubLength != null && fieldSubLength.getValue().length() > 0) {
				int length = 0;
				try {
					length = Integer.parseInt(fieldSubLength.getValue());
				} catch (NumberFormatException e) {
					// Ȃ
				}
				item.setSubLength(length);
				item.setUseLength(true);
				change = true;
			}

			AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);
			if (item.isBaseItem()) {
				InterfaceDataMyItem myItem = interfaceData.getMyItem(itemId);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					myItem.setPrimaryKey(true);
				} else {
					myItem.setPrimaryKey(false);
				}
				interfaceData.updateMyItem(myItem);

			} else {
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					item.setPrimaryKey(true);
				} else {
					item.setPrimaryKey(false);
				}
				change = true;
			}
			if (change) {
				interfaceData.updateItem(item);
			}

		}
		HashSet<Integer> multiRecordsIncludeIdSet = new HashSet<Integer>(); // R[h̃CN[hID̃Zbg

		// R[hXV
		for (int itemId : myDataMap.keySet()) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem()) {
				item.setUseMultiRecordType(false);
				item.setMultiRecordType(false);
				interfaceData.updateItem(item);
			}

			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			AttributeData linkType = myAttributeMap.get(LINK_OPTION_TYPE_ATTACH_NAME);
			if (linkType != null && LINK_TYPE_MULTI_SET.contains(linkType.getValue())) {
				multiRecordsIncludeIdSet.add(item.getIncludeId());
			}
		}

		for (Integer multiRecordsIncludeDataId : multiRecordsIncludeIdSet) {
			boolean flag = false;
			for (int itemId : myDataMap.keySet()) {
				HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
				if (myAttributeMap != null) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.getIncludeId() == multiRecordsIncludeDataId) {

						item.setUseMultiRecordType(true);
						item.setMultiRecordType(false);
						if (flag) {
							item.setEnable(false);
						} else {
							// Nԍ`FbN
							AttributeData linkNo = myAttributeMap.get(LINK_NO_ATTACH_NAME);
							if (linkNo != null && !"00".equals(linkNo.getValue())) {
								item.setEnable(true);
								item.setMultiRecordType(true);
								item.setUseMultiRecordType(true);
								flag = true;
							} else {
								item.setEnable(false);
							}
						}
						interfaceData.updateItem(item);
					}
				}
			}
		}


	}

	@Override
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		AttributeData linkType = dataMap.get(LINK_OPTION_TYPE_ATTACH_NAME);
		AttributeData linkNo = dataMap.get(LINK_NO_ATTACH_NAME);

		if ((linkType != null && linkType.getValue().length() > 0)) {
			if (linkNo == null || linkNo.getValue().length() <= 0 || "00".equals(linkNo.getValue())) {
				throw new InterfaceException("N^Cvw肳Ă̂ɃNԍw肳Ă܂");
			}
		}
	}

	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

		TreeMap<Integer, Integer> includeId2InterfaceDataIdMap = new TreeMap<Integer, Integer>();
		HashSet<Integer> primaryKeyIncludeIdSet = new HashSet<Integer>(); // L[̃CN[hID̃Zbg
		HashSet<Integer> multiRecordsIncludeIdSet = new HashSet<Integer>(); // R[h̃CN[hID̃Zbg

		HashMap<String, HashSet<Integer>> linkNoMap = new HashMap<String, HashSet<Integer>>(); // L[=NԍAl=CN[hԍ̃Zbg

		HashSet<Integer> includeIdOrgSet = new HashSet<Integer>();
		HashSet<Integer> includeIdLinkNoSet = new HashSet<Integer>();
		HashSet<String> nameSet = new HashSet<String>();

		HashMap<Integer, String> checkIncludeId2LinkTypeMap = new HashMap<Integer, String>(); // L[CN[hIDAlN^Cv
		HashMap<Integer, Integer> checkIncludeId2LinkTypeCountMap = new HashMap<Integer, Integer>(); // L[CN[hIDAlqN
		HashMap<Integer, String> checkItemId2LinkTypeMap = new HashMap<Integer, String>(); // L[ItemIDAlN^Cv

		HashMap<String, HashSet<String>> parentLinkNoMap = new HashMap<String, HashSet<String>>(); // L[NԍAlN^CvZbg

		// `FbN
		for (Integer itemId : myDataMap.keySet()) {
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			if (myAttributeMap != null) {

				InterfaceDataItem item = interfaceData.getItem(itemId);

				// L[`FbN
				AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					if (!item.isEnable()) {
						throw new InterfaceException("ڂɂ͎L[͐ݒł܂");
					}
					primaryKeyIncludeIdSet.add(item.getIncludeId());
				}

				// Nԍ`FbN
				AttributeData linkNo = myAttributeMap.get(LINK_NO_ATTACH_NAME);
				AttributeData linkType = myAttributeMap.get(LINK_OPTION_TYPE_ATTACH_NAME);
				int includeId = item.getIncludeId();
				if (linkNo != null && !"00".equals(linkNo.getValue())) {
					if (includeId != 0) {
						HashSet<Integer> includeIdSet = null;
						if (!linkNoMap.containsKey(linkNo.getValue())) {
							includeIdSet = new HashSet<Integer>();
							linkNoMap.put(linkNo.getValue(), includeIdSet);
						} else {
							includeIdSet = linkNoMap.get(linkNo.getValue());
						}
						if (includeIdSet.contains(includeId)) {
							throw new InterfaceException("Nԍ" + linkNo.getValue() + "CN[hie[uj" + includeId
									+ "Ɏw肳Ă܂");
						} else {
							includeIdSet.add(includeId);
						}

						includeIdLinkNoSet.add(includeId);
					}

					HashSet<String> kinkTypeWkSet = null;
					if (parentLinkNoMap.containsKey(linkNo.getValue())) {
						kinkTypeWkSet = parentLinkNoMap.get(linkNo.getValue());
					} else {
						kinkTypeWkSet = new HashSet<String>();
						parentLinkNoMap.put(linkNo.getValue(), kinkTypeWkSet);
					}

					if (linkType != null && linkType.getValue().length() <= 0) {
						if (kinkTypeWkSet.contains(linkType.getValue())) {
							throw new InterfaceException("N^CvݒȃN݂܂BNԍ=" + linkNo.getValue());
						}
					}

					kinkTypeWkSet.add(linkType.getValue());
				}

				if (!item.isBaseItem()) {
					includeIdOrgSet.add(includeId);
				}

				if (linkType != null && linkType.getValue().length() > 0) {
					checkItemId2LinkTypeMap.put(item.getItemId(), linkType.getValue());
					if (checkIncludeId2LinkTypeMap.containsKey(item.getIncludeId())) {
						if (!linkType.getValue().equals(checkIncludeId2LinkTypeMap.get(item.getIncludeId()))) {
							throw new InterfaceException("1̃CN[hie[ujɕ̃N^Cv͐ݒł܂");
						}
					} else {
						checkIncludeId2LinkTypeMap.put(item.getIncludeId(), linkType.getValue());
					}

					// CN[hIDƂ̎qN^Cv擾
					if (!checkIncludeId2LinkTypeCountMap.containsKey(item.getIncludeId())) {
						checkIncludeId2LinkTypeCountMap.put(item.getIncludeId(), 1);
					} else {
						checkIncludeId2LinkTypeCountMap.put(item.getIncludeId(), checkIncludeId2LinkTypeCountMap.get(item
								.getIncludeId()) + 1);
					}

					if (LINK_TYPE_MULTI_SET.contains(linkType.getValue())) {
						multiRecordsIncludeIdSet.add(item.getIncludeId());
					}
				}

				if (item.isBaseItem()) {
					if (linkNo != null && !"00".equals(linkNo.getValue())) {
						throw new InterfaceException("CN[hie[ujł͖ڂɂ̓Nԍݒ肷邱Ƃ͂ł܂");
					}
				}
			}
		}

		for (String linkNo : parentLinkNoMap.keySet()) {
			HashSet<String> linkTypeWkSet = parentLinkNoMap.get(linkNo);
			if (!linkTypeWkSet.contains("")) {
				throw new InterfaceException("ee[u̎ʂł܂BNԍ=" + linkNo);
			}
		}

		for (Integer itemId : myDataMap.keySet()) {
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			if (myAttributeMap != null) {

				InterfaceDataItem item = interfaceData.getItem(itemId);

				// tB[h`FbN
				if (item.isEnable()) {
					if (nameSet.contains(item.getName().toLowerCase())) {
						throw new InterfaceException("tB[h" + item.getName() + "dĂ܂");
					} else {
						nameSet.add(item.getName().toLowerCase());
					}
					// }
				}
			}
		}

		if (primaryKeyIncludeIdSet.size() <= 0) {
			throw new InterfaceException("L[w肳Ă܂");
		} else if (primaryKeyIncludeIdSet.size() > 1) {
			throw new InterfaceException("L[̃CN[hie[ujɐݒ肳Ă܂@L[1̃CN[ĥ݂ɐݒ\ł");
		}

		// [ge[ũCN[hID
		int primaryKeyIncludeId = primaryKeyIncludeIdSet.toArray(new Integer[0])[0];

		if (checkIncludeId2LinkTypeMap.containsKey(primaryKeyIncludeId)) {
			throw new InterfaceException("L[ݒ肳ĂCN[hie[ujɂ̓N^Cv͐ݒł܂");
		}

		for (Integer itemId : myDataMap.keySet()) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isBaseItem() && item.getIncludeId() == primaryKeyIncludeId) {
				InterfaceData includeData = interfaceProject.getInterfaceDataManager()
						.getInterfaceData(item.getIncludeDataId());
				HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
				if (myAttributeMap != null) {
					AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);

					InterfaceDataItem includeDataItem = includeData.getItem(item.getIncludeItemId());
					if (primaryKey != null && primaryKey.getValueBoolean()) {
						if (!includeDataItem.isPrimaryKey()) {
							throw new InterfaceException("CN[hŃL[łȂڂɎL[ݒ肳Ă܂");
						}
					} else {
						if (includeDataItem.isPrimaryKey()) {
							throw new InterfaceException("L[CN[hł̓L[ȊO̍ڂɐݒ肳Ă܂");
						}
					}
				}
			}
		}

		if (multiRecordsIncludeIdSet.size() == 1) {
			if (primaryKeyIncludeIdSet.contains(multiRecordsIncludeIdSet.toArray(new Integer[0])[0])) {
				throw new InterfaceException("L[ݒ肳ĂCN[hie[ujɂ̓NIvV̕R[h͎wł܂B");
			}
		}

		for (String linkNo : linkNoMap.keySet()) {
			if (linkNoMap.get(linkNo).size() <= 1) {
				throw new InterfaceException("CN[hie[uj" + linkNoMap.get(linkNo).toArray(new Integer[0])[0]
						+ "Ɏw肳Ă郊Nԍ" + linkNo + "PƂŎw肳Ă܂");
			}
		}

		// CN[h1̂Ƃ̓`FbNȂ
		if (includeIdOrgSet.size() > 1) {
			for (Integer includeId : includeIdOrgSet) {
				if (!includeIdLinkNoSet.contains(includeId)) {
					throw new InterfaceException("CN[hie[uj" + includeId + "ɃNԍݒ肳Ă܂");
				}
			}
		}

		// R[h̃CN[hdNĂ邩̃`FbN
		for (Integer multiRecordsIncludeDataId : multiRecordsIncludeIdSet) {
			// R[h̃CN[hɐݒ肳Ă郊Nԍ̃Zbg߂
			HashSet<String> multiRecordsLinkNoSet = new HashSet<String>();
			for (Integer itemId : myDataMap.keySet()) {
				HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (item.getIncludeId() == multiRecordsIncludeDataId) {
					AttributeData linkNo = myAttributeMap.get(LINK_NO_ATTACH_NAME);
					if (linkNo != null && !"00".equals(linkNo.getValue())) {
						multiRecordsLinkNoSet.add(linkNo.getValue());
					}
				}
			}

			// R[h̃CN[hɐݒ肳Ă郊Nԍ̃ZbgƓԍZbgĂCN[hID̃Zbg쐬
			// ̃CN[hɃNĂ郊Nԍ͑ΏۊOƂ
			HashSet<Integer> linkIncludeIdSet = new HashSet<Integer>();
			for (String nowLinkNo : multiRecordsLinkNoSet) {
				HashSet<Integer> tempIncludeIdSet = new HashSet<Integer>();
				for (Integer itemId : myDataMap.keySet()) {
					HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
					InterfaceDataItem item = interfaceData.getItem(itemId);
					// R[hCN[h͑ΏۊO
					if (item.getIncludeId() != multiRecordsIncludeDataId) {
						AttributeData linkNo = myAttributeMap.get(LINK_NO_ATTACH_NAME);
						if (linkNo != null && nowLinkNo.equals(linkNo.getValue())) {
							tempIncludeIdSet.add(item.getIncludeId());
						}
					}
				}
				if (tempIncludeIdSet.size() == 1) {
					linkIncludeIdSet.add(tempIncludeIdSet.toArray(new Integer[0])[0]);
				}
			}

			if (linkIncludeIdSet.size() > 1) {
				throw new InterfaceException(
						"R[hݒ肳ĂCN[hie[uj͕̃CN[hie[ujƃNł܂@͉ze[uCN[h邱Ƃɂ\ł");
			}
		}

		HashSet<Integer> useIncludeIdSet = new HashSet<Integer>();
		linkFollow(primaryKeyIncludeId, useIncludeIdSet, myDataMap, interfaceData);
		if (useIncludeIdSet.size() != interfaceData.getIncludeIfoList().length) {
			throw new InterfaceException("L[ݒ肳ĂCN[h炽ǂȂCN[hie[uj݂܂@Nԍ̐ݒmFĂ");
		}

		for (IncludeInfo incInfo : interfaceData.getIncludeIfoList()) {
			includeId2InterfaceDataIdMap.put(incInfo.getIncludeId(), incInfo.getIncludeDataId());
		}

		for (Integer includeId : includeIdOrgSet) {

			if (includeId == primaryKeyIncludeId) {
				continue;
			}

			for (Integer itemId : myDataMap.keySet()) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (!item.isBaseItem() && item.getIncludeId() == includeId) {
					InterfaceDataItem includeItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
							item.getIncludeDataId()).getItem(item.getIncludeItemId());
					if (checkIncludeId2LinkTypeMap.containsKey(includeId)) {
						String linkType = checkIncludeId2LinkTypeMap.get(includeId);

						if (!includeItem.isPrimaryKey() && checkItemId2LinkTypeMap.containsKey(itemId)) {
							throw new InterfaceException("qe[ũNݒ肪CN[he[u̎L[ł͂܂BCN[hԍ=" + includeId);
						}

//						if (!LINK_TYPE_MULTI_SET.contains(linkType)) {
//							if (includeItem.isPrimaryKey() && !checkItemId2LinkTypeMap.containsKey(itemId)) {
//								throw new InterfaceException("1:1n:1Nł̓CN[he[ȗSĂ̎L[ƃNȂ΂Ȃ܂BCN[hԍ="
//										+ includeId);
//							}
//						}
					}
				}
			}
		}
	}

	private void linkFollow(int includeId, HashSet<Integer> useIncludeIdSet,
			TreeMap<Integer, HashMap<String, AttributeData>> myDataMap, InterfaceData interfaceData) throws InterfaceException {
		useIncludeIdSet.add(includeId);

		// p[^Ŏw肳ꂽCN[hIDɐݒ肳Ă郊Nԍ̃Zbg߂
		HashSet<String> linkNoSet = new HashSet<String>();
		for (Integer itemId : myDataMap.keySet()) {
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (item.getIncludeId() == includeId) {
				AttributeData linkNo = myAttributeMap.get(LINK_NO_ATTACH_NAME);
				if (linkNo != null && !"00".equals(linkNo.getValue())) {
					linkNoSet.add(linkNo.getValue());
				}
			}
		}

		HashSet<Integer> linkIncludeIdSet = new HashSet<Integer>();
		for (String nowLinkNo : linkNoSet) {
			for (Integer itemId : myDataMap.keySet()) {
				HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (!useIncludeIdSet.contains(item.getIncludeId())) {
					AttributeData linkNo = myAttributeMap.get(LINK_NO_ATTACH_NAME);
					if (linkNo != null && nowLinkNo.equals(linkNo.getValue())) {
						linkIncludeIdSet.add(item.getIncludeId());
					}
				}
			}
		}

		for (Integer checkIncludeId : linkIncludeIdSet) {
			linkFollow(checkIncludeId, useIncludeIdSet, myDataMap, interfaceData);
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}
		String packageName = dataMap.get("package").getValue();
		boolean logout = dataMap.get("logout").getValueBoolean();
		
		setCommonParameter("loggerComment", logout ? "" : "//");

		int rootIncludeId = -1; // ؍\̃[gCN[hD

		TreeMap<Integer, Integer> includeId2InterfaceDataIdMap = new TreeMap<Integer, Integer>();
		TreeMap<Integer, Integer> includeId2RecNoMap = new TreeMap<Integer, Integer>();
		TreeMap<Integer, String> includeId2ListNameMap = new TreeMap<Integer, String>();
		HashSet<Integer> rightMultiIncludeIdSet = new HashSet<Integer>();
		HashSet<Integer> leftMultiIncludeIdSet = new HashSet<Integer>();

		List<Integer> primaryKeyItemIdList = new LinkedList<Integer>();

		HashMap<Integer, HashSet<Integer>> treeMap = new HashMap<Integer, HashSet<Integer>>(); // ؍\}bv@L[=ẽCN[hIDAl=q̃CN[hIDXg
		HashMap<Integer, NodeLinkInfo> chaildLinkMap = new HashMap<Integer, NodeLinkInfo>(); // qCN[hID̃N}bv@L[=q̃CN[hIDAl=m[hN

		List<Integer> updateUseIncludeIdList = new LinkedList<Integer>(); // XVnŎgpCN[hIDXg
		HashSet<Integer> updateUseDataIdSet = new HashSet<Integer>(); // XVnnŎgpf[^IDZbg

		List<Integer> deleteUseIncludeIdList = new LinkedList<Integer>(); // 폜nŎgpCN[hIDXg
		HashSet<Integer> deleteUseDataIdSet = new HashSet<Integer>(); // 폜nnŎgpf[^IDZbg

		HashSet<Integer> getIncludeIdSet = new HashSet<Integer>(); // QƑ̃CN[hIDZbg
		List<Integer> getUseIncludeIdList = new LinkedList<Integer>(); // QƌnnŎgpCN[hIDXg
		HashSet<Integer> getUseDataIdSet = new HashSet<Integer>(); // QƌnnŎgpf[^IDZbg

		HashSet<Integer> leftOneNonRefIncludeIdSet = new HashSet<Integer>(); // 1:11:nŔQƂ̃CN[hID̃Zbg

		HashMap<Integer, String> saffixMap = new HashMap<Integer, String>(); // fEDAÕTtBbNX}bv
		// L[=C^[tF[Xf[^IDAl=TtBbNX

		// Integer[] itemIds = interfaceData.getEnableItemIdList();
		Integer[] itemIds = interfaceData.getAllItemIdList();

		// ؍\̃[gCN[hID^R[h̃CN[hID擾
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isBaseItem()) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, getName(), PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					rootIncludeId = item.getIncludeId();
					primaryKeyItemIdList.add(itemId);

				}

				AttributeData linkOption = interfaceData.getAttribute(itemId, getName(), LINK_OPTION_TYPE_ATTACH_NAME);
				if (linkOption != null && LINK_TYPE_MULTI_SET.contains(linkOption.getValue())) {
					if (!rightMultiIncludeIdSet.contains(item.getIncludeId())) {
						rightMultiIncludeIdSet.add(item.getIncludeId());
					}
				}
				if (linkOption != null && LINK_TYPE_L_MULTI_SET.contains(linkOption.getValue())) {
					if (!leftMultiIncludeIdSet.contains(item.getIncludeId())) {
						leftMultiIncludeIdSet.add(item.getIncludeId());
					}
				}

				if (linkOption != null && LINK_TYPE_REF_SET.contains(linkOption.getValue())) {
					getIncludeIdSet.add(item.getIncludeId());
				}

				if (linkOption != null && LINK_TYPE_L_ONE_SET.contains(linkOption.getValue())
						&& !LINK_TYPE_REF_SET.contains(linkOption.getValue())) {
					leftOneNonRefIncludeIdSet.add(item.getIncludeId());
				}

			}
		}

		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isBaseItem()) {
				if (rightMultiIncludeIdSet.contains(item.getIncludeId())) {

					AttributeData linkOption = interfaceData.getAttribute(itemId, getName(), LINK_NO_ATTACH_NAME);
					if (linkOption != null && linkOption.getValue().length() > 0 && !"00".equals(linkOption.getValue())) {
						if (!includeId2ListNameMap.containsKey(item.getIncludeId())) {
							includeId2ListNameMap.put(item.getIncludeId(), item.getName());
						}
					}
				}
			}
		}

		for (IncludeInfo incInfo : interfaceData.getIncludeIfoList()) {
			includeId2InterfaceDataIdMap.put(incInfo.getIncludeId(), incInfo.getIncludeDataId());
		}

		int recNo = 0;
		for (Integer incId : includeId2InterfaceDataIdMap.keySet()) {
			if (!includeId2ListNameMap.containsKey(incId)) {
				includeId2RecNoMap.put(incId, ++recNo);
			}
		}

		// ؍\̃CN[hID}bv쐬
		HashSet<Integer> usedIncludeIdSet = new HashSet<Integer>();
		usedIncludeIdSet.add(rootIncludeId);
		makeTree(rootIncludeId, treeMap, usedIncludeIdSet, targetInterfaceId, interfaceProject);

		// qCN[hID̃N}bv쐬
		makeChaildLinkMap(rootIncludeId, chaildLinkMap, treeMap, targetInterfaceId, interfaceProject);

		// QƂŎgpCN[hID̎QƏԂێCN[hIDXg쐬
		makeUpdateIncludeIdList(getUseIncludeIdList, rootIncludeId, treeMap);

		// QƂŎgpf[^ID̃Zbg쐬
		for (Integer includeId : getUseIncludeIdList) {
			getUseDataIdSet.add(includeId2InterfaceDataIdMap.get(includeId));
		}

		// f̃f[^IDZbg
		for (Integer dataId : getUseDataIdSet) {
			InterfaceData chaidData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
			if (chaidData.isAttached(getName())) {
				saffixMap.put(dataId, SAFFIX_NAME_MODEL);
			} else {
				saffixMap.put(dataId, SAFFIX_NAME_DAO);
			}
		}

		// XVŎgpCN[hID̍XVԂێCN[hIDXg쐬<BR>
		// yэXVŎgpf[^ID̃Zbg쐬
		for (Integer includeId : getUseIncludeIdList) {

			if (!getIncludeIdSet.contains(includeId)) {
				updateUseIncludeIdList.add(includeId);
				updateUseDataIdSet.add(includeId2InterfaceDataIdMap.get(includeId));

				if (!leftMultiIncludeIdSet.contains(includeId)) {
					deleteUseIncludeIdList.add(includeId);
					deleteUseDataIdSet.add(includeId2InterfaceDataIdMap.get(includeId));
				}
			}
		}

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();
		try {

			byte[] image = createFileImage(interfaceProject, targetInterfaceId, packageName, rootIncludeId,
					includeId2ListNameMap, includeId2InterfaceDataIdMap, includeId2RecNoMap, primaryKeyItemIdList, treeMap,
					chaildLinkMap, updateUseIncludeIdList, deleteUseIncludeIdList, getUseIncludeIdList, updateUseDataIdSet,
					deleteUseDataIdSet, getUseDataIdSet, saffixMap, leftOneNonRefIncludeIdSet);
			
			fileMap.put(InterfaceTools.changeClassNmae(interfaceData.getName()) + "Model.java",image);
			
			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(InterfaceTools.changeClassNmae(interfaceData.getName()) + "ModelJava.zip", createZipImage(fileMap));
			
			
			
			
		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	/**
	 * ؍\ǂCN[hIDXg쐬
	 *
	 * @param includeIdList
	 * @param parentIncludeId
	 * @param treeMap
	 */
	protected void makeUpdateIncludeIdList(List<Integer> includeIdList, int parentIncludeId,
			HashMap<Integer, HashSet<Integer>> treeMap) {
		includeIdList.add(parentIncludeId);

		for (Integer chaildIncludeId : treeMap.get(parentIncludeId)) {
			makeUpdateIncludeIdList(includeIdList, chaildIncludeId, treeMap);
		}
	}

	/**
	 * ؍\̃CN[hID}bv쐬
	 *
	 * @param parentIncludeId
	 * @param treeMap
	 * @param usedIncludeIdSet
	 * @param targetInterfaceId
	 * @param interfaceProject
	 * @throws InterfaceException
	 */
	protected void makeTree(int parentIncludeId, HashMap<Integer, HashSet<Integer>> treeMap, HashSet<Integer> usedIncludeIdSet,
			int targetInterfaceId, InterfaceProject interfaceProject) throws InterfaceException {

		HashSet<Integer> chaildIncludeIdSet = new HashSet<Integer>();
		treeMap.put(parentIncludeId, chaildIncludeIdSet);

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		// Integer[] itemIds = interfaceData.getEnableItemIdList();
		Integer[] itemIds = interfaceData.getAllItemIdList();

		// em[hɑ݂郊Nԍ̃Zbg߂
		HashSet<String> linkNoSet = new HashSet<String>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem() && item.getIncludeId() == parentIncludeId) {
				AttributeData linkNo = interfaceData.getAttribute(itemId, getName(), LINK_NO_ATTACH_NAME);
				if (linkNo != null && !"00".equals(linkNo.getValue())) {
					linkNoSet.add(linkNo.getValue());
				}
			}
		}

		// Nԍ̃Zbg݂gpĂȂCN[hID̃Zbg߂
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (item.isBaseItem() || usedIncludeIdSet.contains(item.getIncludeId())) {
				continue;
			}

			AttributeData linkNo = interfaceData.getAttribute(itemId, getName(), LINK_NO_ATTACH_NAME);
			if (linkNo != null && !"00".equals(linkNo.getValue())) {
				if (linkNoSet.contains(linkNo.getValue()) && !chaildIncludeIdSet.contains(item.getIncludeId())) {
					chaildIncludeIdSet.add(item.getIncludeId());
					usedIncludeIdSet.add(item.getIncludeId());
				}
			}
		}

		// q̃CN[hIDɃNĂ鑷̃CN[hID擾
		for (Integer chaildIncludeId : chaildIncludeIdSet) {
			makeTree(chaildIncludeId, treeMap, usedIncludeIdSet, targetInterfaceId, interfaceProject);
		}

	}

	/**
	 * qCN[hID̃N}bv쐬
	 *
	 * @param parentIncludeId
	 * @param chaildLinkMap
	 * @param targetInterfaceId
	 * @param interfaceProject
	 * @throws InterfaceException
	 */
	protected void makeChaildLinkMap(int parentIncludeId, HashMap<Integer, NodeLinkInfo> chaildLinkMap,
			HashMap<Integer, HashSet<Integer>> treeMap, int targetInterfaceId, InterfaceProject interfaceProject)
			throws InterfaceException {

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		Integer[] itemIds = interfaceData.getAllItemIdList();

		// em[hɑ݂郊NԍEitemId̃}bv߂
		HashMap<String, Integer> linkNo2ItemIdMap = new HashMap<String, Integer>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			if (!item.isBaseItem() && item.getIncludeId() == parentIncludeId) {
				AttributeData linkNo = interfaceData.getAttribute(itemId, getName(), LINK_NO_ATTACH_NAME);
				if (linkNo != null && !"00".equals(linkNo.getValue())) {
					linkNo2ItemIdMap.put(linkNo.getValue(), item.getIncludeItemId());
				}
			}
		}

		// NԍŌ΂ꂽem[hItemIdAqm[hItemID擾̃Xg쐬qCN[hID̃N}bv쐬
		HashSet<Integer> chaildIncludeIdSet = treeMap.get(parentIncludeId);
		for (Integer chaidIncludeId : chaildIncludeIdSet) {

			NodeLinkInfo nodeLinkInfo = new NodeLinkInfo(parentIncludeId, chaidIncludeId);
			chaildLinkMap.put(chaidIncludeId, nodeLinkInfo);

			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (!item.isBaseItem() && item.getIncludeId() == (int) chaidIncludeId) {
					AttributeData linkNo = interfaceData.getAttribute(itemId, getName(), LINK_NO_ATTACH_NAME);
					if (linkNo != null && !"00".equals(linkNo.getValue())) {
						if (linkNo2ItemIdMap.containsKey(linkNo.getValue())) {
							nodeLinkInfo.addItemId(new PairItemId(linkNo2ItemIdMap.get(linkNo.getValue()), item
									.getIncludeItemId()));
						}
					}
				}
			}

			// m[h̎qCN[hID̃N}bv쐬
			makeChaildLinkMap(chaidIncludeId, chaildLinkMap, treeMap, targetInterfaceId, interfaceProject);
		}
	}

	/**
	 * t@CC[W쐬
	 *
	 * @param interfaceProject
	 * @param targetInterfaceId
	 * @param packageName
	 * @param rootIncludeId
	 * @param includeId2ListNameMap
	 * @param includeId2InterfaceDataIdMap
	 * @param includeId2RecNoMap
	 * @param primaryKeyItemIdList
	 * @param treeMap
	 * @param chaildLinkMap
	 * @param updateIncludeIdList
	 * @param deleteIncludeIdList
	 * @param getIncludeIdList
	 * @param updateUseDataIdSet
	 * @param deleteUseDataIdSet
	 * @param getUseDataIdSet
	 * @param saffixMap
	 * @return
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createFileImage(InterfaceProject interfaceProject, int targetInterfaceId, String packageName,
			int rootIncludeId, TreeMap<Integer, String> includeId2ListNameMap,
			TreeMap<Integer, Integer> includeId2InterfaceDataIdMap, TreeMap<Integer, Integer> includeId2RecNoMap,
			List<Integer> primaryKeyItemIdList, HashMap<Integer, HashSet<Integer>> treeMap,
			HashMap<Integer, NodeLinkInfo> chaildLinkMap, List<Integer> updateIncludeIdList, List<Integer> deleteIncludeIdList,
			List<Integer> getIncludeIdList, HashSet<Integer> updateUseDataIdSet, HashSet<Integer> deleteUseDataIdSet,
			HashSet<Integer> getUseDataIdSet, HashMap<Integer, String> saffixMap, HashSet<Integer> rightOneNonRefIncludeIdSet)
			throws IOException, InterfaceException {

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		String voName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String className = voName + "Model";

		InterfaceData ifPrimaryKeyData = interfaceProject.getInterfaceDataManager().getInterfaceData(
				includeId2InterfaceDataIdMap.get(rootIncludeId));
		String primaryKeyDaoName = ifPrimaryKeyData.getName() + saffixMap.get(includeId2InterfaceDataIdMap.get(rootIncludeId));

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("package", "package", packageName));
				}
				out(baos, getText("header", "nameJp", interfaceData.getNameJp(), "className", className));

				// }Jn
				out(baos, getText("insert start", "nameJp", interfaceData.getNameJp(), "voName", voName));

				for (Integer dataId : updateUseDataIdSet) {
					InterfaceData ifData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
					String saffix = saffixMap.get(dataId);
					String daoName = ifData.getName() + saffix;
					out(baos, getText("insert dao model " + saffix, "nameJp", interfaceData.getNameJp(), "daoClassName",
							InterfaceTools.changeClassNmae(daoName), "daoName", InterfaceTools.changeMemberNmae(daoName)));
				}

				// L[݂e[u}
				out(baos, getText("insert main root", //
						"nameJp", ifPrimaryKeyData.getNameJp(), //
						"daoName", InterfaceTools.changeMemberNmae(primaryKeyDaoName), //
						"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
								.get(rootIncludeId)), false)));

				// qe[u}
				for (Integer includeId : updateIncludeIdList) {

					// L[݂e[uƕR[he[u̓XLbv
					if (includeId.intValue() == rootIncludeId || includeId2ListNameMap.containsKey(includeId)) {
						continue;
					}

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(includeId));
					String recordName = InterfaceTools.createRecName(includeId2RecNoMap.get(includeId));

					out(baos, getText("insert main 1", //
							"nameJp", includInterfaceData.getNameJp(), //
							"recordGetter", InterfaceTools.changeGetterNmae(recordName, false)));

					NodeLinkInfo nodeLinkInfo = chaildLinkMap.get(includeId);
					List<PairItemId> pairItemIdList = nodeLinkInfo.getPairItemIdList();

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						out(baos, getText("insert key check", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					out(baos, getText("insert main 1.5"));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("insert key set", //
								"recordSetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getChaildIncludeId())), false), //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(includeId)));

					out(baos, getText("insert main 2", //
							"nameJp", includInterfaceData.getNameJp(), //
							"daoName", daoName, //
							"recordGetter", InterfaceTools.changeGetterNmae(recordName, false)));
				}

				// e[u}
				for (Integer multiIncludeId : includeId2ListNameMap.keySet()) {

					if (!updateIncludeIdList.contains(multiIncludeId)) {
						continue;
					}

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(multiIncludeId));

					NodeLinkInfo nodeLinkInfo = chaildLinkMap.get(multiIncludeId);
					List<PairItemId> pairItemIdList = nodeLinkInfo.getPairItemIdList();

					out(baos, getText("insert main multi 1", //
							"name", includeId2ListNameMap.get(multiIncludeId), //
							"nameJp", includInterfaceData.getNameJp(), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
									.get(nodeLinkInfo.getParentIncludeId())), false)));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						out(baos, getText("insert main multi 2", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					out(baos, getText("insert main multi 3", //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName())));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("insert main multi 4", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}
					out(baos, getText("insert main multi 5", //
							"name", includeId2ListNameMap.get(multiIncludeId), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName())));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("insert main multi 5.2", //
								"name", includeId2ListNameMap.get(multiIncludeId), //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}
					out(baos, getText("insert main multi 5.4", //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false)));

					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(multiIncludeId)));

					out(baos, getText("insert main multi 6", //
							"name", includeId2ListNameMap.get(multiIncludeId), //
							"nameJp", includInterfaceData.getNameJp(), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"daoName", daoName, //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false) //
							));

				}

				// }I
				out(baos, getText("insert end"));

				// /////////////////////////////////////////////////////////////////////////////////

				// XVJn
				out(baos, getText("update start", "nameJp", interfaceData.getNameJp(), "voName", voName));

				for (Integer dataId : updateUseDataIdSet) {
					InterfaceData ifData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
					String saffix = saffixMap.get(dataId);
					String daoName = ifData.getName() + saffix;
					out(baos, getText("update dao model " + saffix, "nameJp", interfaceData.getNameJp(), "daoClassName",
							InterfaceTools.changeClassNmae(daoName), "daoName", InterfaceTools.changeMemberNmae(daoName)));
				}

				// f[^̓ǂݍ
				if (rightOneNonRefIncludeIdSet.size() > 0) {
					out(baos, getText("update main root", "voName", voName, "className", className));
				}

				// L[݂e[uXV
				out(baos, getText("update main root 1", //
						"nameJp", ifPrimaryKeyData.getNameJp(), //
						"daoName", InterfaceTools.changeMemberNmae(primaryKeyDaoName), //
						"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
								.get(rootIncludeId)), false)));

				// qe[uXV
				for (Integer includeId : updateIncludeIdList) {
					// L[݂e[uƕR[he[u̓XLbv
					if (includeId.intValue() == rootIncludeId || includeId2ListNameMap.containsKey(includeId)) {
						continue;
					}

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(includeId));
					String recordName = InterfaceTools.createRecName(includeId2RecNoMap.get(includeId));

					out(baos, getText("update main 1", //
							"nameJp", includInterfaceData.getNameJp(), //
							"recordGetter", InterfaceTools.changeGetterNmae(recordName, false)));

					NodeLinkInfo nodeLinkInfo = chaildLinkMap.get(includeId);
					List<PairItemId> pairItemIdList = nodeLinkInfo.getPairItemIdList();

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						out(baos, getText("update main key check", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					out(baos, getText("update main 2"));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("update key set", //
								"recordSetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getChaildIncludeId())), false), //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}
					out(baos, getText("update main 3", //
							"recordSetter", InterfaceTools.changeSetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
									.get(nodeLinkInfo.getChaildIncludeId())))));

					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(includeId)));

					if (rightOneNonRefIncludeIdSet.contains(includeId)) {
						out(baos, getText("update main del", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getChaildIncludeId())), false), //
								"daoName", daoName));

					}

					out(baos, getText("update main 4", //
							"nameJp", includInterfaceData.getNameJp(), //
							"daoName", daoName, "recordGetter", InterfaceTools.changeGetterNmae(recordName, false)));

				}

				// e[uXV
				for (Integer multiIncludeId : includeId2ListNameMap.keySet()) {

					if (!updateIncludeIdList.contains(multiIncludeId)) {
						continue;
					}

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(multiIncludeId));

					NodeLinkInfo nodeLinkInfo = chaildLinkMap.get(multiIncludeId);
					List<PairItemId> pairItemIdList = nodeLinkInfo.getPairItemIdList();

					out(baos, getText("update main multi 1", //
							"name", includeId2ListNameMap.get(multiIncludeId), //
							"nameJp", includInterfaceData.getNameJp(), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
									.get(nodeLinkInfo.getParentIncludeId())), false)));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						out(baos, getText("update main multi 2", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					out(baos, getText("update main multi 3", //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName())));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("update main multi 4", //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}
					out(baos, getText("update main multi 5", //
							"name", includeId2ListNameMap.get(multiIncludeId), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName())));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("update main multi 5.2", //
								"name", includeId2ListNameMap.get(multiIncludeId), //
								"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
										.get(nodeLinkInfo.getParentIncludeId())), false), //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}
					out(baos, getText("update main multi 5.4", //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false)));

					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(multiIncludeId)));

					if (rightOneNonRefIncludeIdSet.contains(multiIncludeId)) {
						out(baos, getText("update main multi del", //
								"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
								"daoName", daoName, //
								"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId),
										false) //
								));
					}

					out(baos, getText("update main multi 6", //
							"name", includeId2ListNameMap.get(multiIncludeId), //
							"nameJp", includInterfaceData.getNameJp(), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"daoName", daoName, //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false) //
							));

				}

				// XVI
				out(baos, getText("update end"));

				// /////////////////////////////////////////////////////////////////////////////////

				// 폜Jn
				out(baos, getText("delete start", "nameJp", interfaceData.getNameJp(), "voName", voName));

				for (Integer dataId : deleteUseDataIdSet) {
					InterfaceData ifData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
					String saffix = saffixMap.get(dataId);
					String daoName = ifData.getName() + saffix;
					out(baos, getText("delete dao model " + saffix, "nameJp", interfaceData.getNameJp(), "daoClassName",
							InterfaceTools.changeClassNmae(daoName), "daoName", InterfaceTools.changeMemberNmae(daoName)));
				}

				// L[݂e[u폜
				out(baos,
						getText("delete main root", "nameJp", ifPrimaryKeyData.getNameJp(), "daoName", InterfaceTools
								.changeMemberNmae(primaryKeyDaoName), "recordGetter", InterfaceTools.changeGetterNmae(
								InterfaceTools.createRecName(includeId2RecNoMap.get(rootIncludeId)), false), "voName", voName,
								"className", className));

				// qe[u폜
				for (Integer includeId : deleteIncludeIdList) {
					// L[݂e[uƕR[he[u̓XLbv
					if (includeId.intValue() == rootIncludeId || includeId2ListNameMap.containsKey(includeId)) {
						continue;
					}

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(includeId));
					String recordName = InterfaceTools.createRecName(includeId2RecNoMap.get(includeId));
					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(includeId)));

					out(baos, getText("delete main", //
							"nameJp", includInterfaceData.getNameJp(), //
							"daoName", daoName, //
							"recordGetter", InterfaceTools.changeGetterNmae(recordName, false)));
				}

				// e[u폜
				for (Integer multiIncludeId : includeId2ListNameMap.keySet()) {

					if (!deleteIncludeIdList.contains(multiIncludeId)) {
						continue;
					}

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(multiIncludeId));
					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(multiIncludeId)));

					out(baos, getText("delete main multi", //
							"nameJp", includInterfaceData.getNameJp(), //
							"recordGetter", InterfaceTools.changeGetterNmae(includeId2ListNameMap.get(multiIncludeId), false), //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"daoName", daoName));

					//
					// String recordName =
					// includeId2ListNameMap.get(multiIncludeId);
					//
					// List<PairItemId> pairItemIdList =
					// nodeLinkInfo.getPairItemIdList();
					//
					// out(baos, getText("delete main multi 1", //
					// "recordGetter",
					// InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
					// .get(nodeLinkInfo.getParentIncludeId())), false)));
					//
					// for (PairItemId pairItemId : pairItemIdList) {
					// InterfaceDataItem parentItem =
					// interfaceProject.getInterfaceDataManager().getInterfaceData(
					// includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
					// pairItemId.getParentItemId());
					// out(baos, getText("delete multi key check", //
					// "recordGetter",
					// InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
					// .get(nodeLinkInfo.getParentIncludeId())), false), //
					// "getter",
					// InterfaceTools.changeGetterNmae(parentItem.getName(),
					// parentItem.getType() == FieldType.BOOLEAN)));
					// }
					//
					// out(baos, getText("delete main multi 1.5", //
					// "recordName", recordName, //
					// "multiName",
					// InterfaceTools.changeClassNmae(includInterfaceData.getName())));
					//
					// for (PairItemId pairItemId : pairItemIdList) {
					// InterfaceDataItem parentItem =
					// interfaceProject.getInterfaceDataManager().getInterfaceData(
					// includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
					// pairItemId.getParentItemId());
					// InterfaceDataItem chaildItem =
					// interfaceProject.getInterfaceDataManager().getInterfaceData(
					// includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
					// pairItemId.getChaildItemId());
					//
					// out(baos, getText("delete main multi key set", //
					// "recordGetter",
					// InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
					// .get(nodeLinkInfo.getParentIncludeId())), false), //
					// "setter",
					// InterfaceTools.changeSetterNmae(chaildItem.getName()), //
					// "getter",
					// InterfaceTools.changeGetterNmae(parentItem.getName(),
					// parentItem.getType() == FieldType.BOOLEAN), //
					// "recordName", recordName));
					// }
					//
					// String daoName =
					// InterfaceTools.changeMemberNmae(includInterfaceData.getName()
					// +
					// saffixMap.get(includeId2InterfaceDataIdMap.get(multiIncludeId)));
					//
					// out(baos, getText("delete main multi 2", //
					// "multiName",
					// InterfaceTools.changeClassNmae(includInterfaceData.getName()),
					// //
					// "nameJp", includInterfaceData.getNameJp(), //
					// "daoName", daoName, //
					// "recordName", recordName));
				}

				// 폜I
				out(baos, getText("delete end"));

				// /////////////////////////////////////////////////////////////////////////////////

				// 擾Jn
				out(baos, getText("get start", //
						"nameJp", interfaceData.getNameJp(), //
						"voName", voName));

				// L[`FbN
				for (Integer itemId : primaryKeyItemIdList) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					out(baos, getText("get check key set", //
							"getMethod", InterfaceTools.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN)));
				}

				out(baos, getText("get dao model start"));

				for (Integer dataId : getUseDataIdSet) {
					InterfaceData ifData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
					String saffix = saffixMap.get(dataId);
					String daoName = ifData.getName() + saffix;
					out(baos, getText("get dao model " + saffix, //
							"nameJp", interfaceData.getNameJp(), //
							"daoClassName", InterfaceTools.changeClassNmae(daoName), //
							"daoName", InterfaceTools.changeMemberNmae(daoName)));
				}

				// L[݂e[u擾
				InterfaceData primaryKeyData = interfaceProject.getInterfaceDataManager().getInterfaceData(
						includeId2InterfaceDataIdMap.get(rootIncludeId));
				out(baos, getText("get main root", //
						"nameJp", ifPrimaryKeyData.getNameJp(), //
						"daoName", InterfaceTools.changeMemberNmae(primaryKeyDaoName), //
						"recordGetter", InterfaceTools.changeGetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
								.get(rootIncludeId)), false), //
						"recordSetter", InterfaceTools.changeSetterNmae(InterfaceTools.createRecName(includeId2RecNoMap
								.get(rootIncludeId))), //
						"voName", voName,//
						"getClassName", InterfaceTools.changeClassNmae(primaryKeyDaoName), //
						"getClassName", InterfaceTools.changeClassNmae(primaryKeyData.getName()),//
						"recordName", InterfaceTools.createRecName(includeId2RecNoMap.get(rootIncludeId))));

				// qe[u擾
				for (Integer includeId : getIncludeIdList) {

					// L[݂e[uƕR[he[u̓XLbv
					if (includeId.intValue() == rootIncludeId || includeId2ListNameMap.containsKey(includeId)) {
						continue;
					}

					NodeLinkInfo nodeLinkInfo = chaildLinkMap.get(includeId);
					List<PairItemId> pairItemIdList = nodeLinkInfo.getPairItemIdList();

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(includeId));
					String parentRecordName = InterfaceTools.createRecName(includeId2RecNoMap.get(nodeLinkInfo
							.getParentIncludeId()));
					String recordName = InterfaceTools.createRecName(includeId2RecNoMap.get(includeId));

					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(includeId)));
					out(baos, getText("get main 1", //
							"nameJp", includInterfaceData.getNameJp(), //
							"recordGetter", InterfaceTools.changeGetterNmae(parentRecordName, false)));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());

						out(baos, getText("get key check", //
								"recordGetter", InterfaceTools.changeGetterNmae(parentRecordName, false),//
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					out(baos, getText("get main 1.5", //
							"className", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"recordName", recordName));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("get main key", //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()),//
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN), //
								"recordGetter", InterfaceTools.changeGetterNmae(parentRecordName, false), //
								"recordName", recordName));
					}

					out(baos, getText("get main 2", //
							"daoName", daoName, //
							"recordName", recordName, //
							"recordSetter", InterfaceTools.changeSetterNmae(recordName)));
				}

				// e[u擾
				for (Integer multiIncludeId : includeId2ListNameMap.keySet()) {

					NodeLinkInfo nodeLinkInfo = chaildLinkMap.get(multiIncludeId);
					List<PairItemId> pairItemIdList = nodeLinkInfo.getPairItemIdList();

					InterfaceData includInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(multiIncludeId));

					String parentRecordName = InterfaceTools.createRecName(includeId2RecNoMap.get(nodeLinkInfo
							.getParentIncludeId()));
					String recordName = includeId2ListNameMap.get(multiIncludeId);

					out(baos, getText("get main multi 1",//
							"multiRecordGetter", InterfaceTools.changeGetterNmae(recordName, false), //
							"recordGetter", InterfaceTools.changeGetterNmae(parentRecordName, false)));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						out(baos, getText("get multi key check", //
								"recordGetter", InterfaceTools.changeGetterNmae(parentRecordName, false), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN)));
					}

					out(baos, getText("get main multi 2", //
							"recordName", recordName, //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()) //
							));

					for (PairItemId pairItemId : pairItemIdList) {
						InterfaceDataItem parentItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getParentIncludeId())).getItem(
								pairItemId.getParentItemId());
						InterfaceDataItem chaildItem = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(nodeLinkInfo.getChaildIncludeId())).getItem(
								pairItemId.getChaildItemId());

						out(baos, getText("get main multi key set", //
								"setter", InterfaceTools.changeSetterNmae(chaildItem.getName()),//
								"recordGetter", InterfaceTools.changeGetterNmae(parentRecordName, false), //
								"getter", InterfaceTools.changeGetterNmae(parentItem.getName(),
										parentItem.getType() == FieldType.BOOLEAN), //
								"recordName", recordName));
					}

					String daoName = InterfaceTools.changeMemberNmae(includInterfaceData.getName()
							+ saffixMap.get(includeId2InterfaceDataIdMap.get(multiIncludeId)));

					out(baos, getText("get main multi 3", //
							"multiName", InterfaceTools.changeClassNmae(includInterfaceData.getName()), //
							"nameJp", includInterfaceData.getNameJp(), //
							"daoName", daoName,//
							"recordName", recordName, //
							"multiRecordGetter", InterfaceTools.changeGetterNmae(recordName, false), //
							"recordSetter", InterfaceTools.changeSetterNmae(recordName)));
				}

				// 擾I
				out(baos, getText("get end"));

				// /////////////////////////////////////////////////////////////////////////////////

				// L[XǧJn
				InterfaceData primaryData = interfaceProject.getInterfaceDataManager().getInterfaceData(
						includeId2InterfaceDataIdMap.get(rootIncludeId));

				String saffix = saffixMap.get(includeId2InterfaceDataIdMap.get(rootIncludeId));
				String daoName = primaryData.getName() + saffix;
				String recordName = InterfaceTools.createRecName(includeId2RecNoMap.get(rootIncludeId));
				out(baos, getText("get PrimaryKeys start", //
						"nameJp", interfaceData.getNameJp(), //
						"daoClassName", InterfaceTools.changeClassNmae(daoName), //
						"daoName", InterfaceTools.changeMemberNmae(daoName),//
						"recordGetter", InterfaceTools.changeGetterNmae(recordName, false), //
						"recordSetter", InterfaceTools.changeSetterNmae(recordName), //
						"voPrimaryName", InterfaceTools.changeClassNmae(primaryData.getName()), "voName", voName));

				out(baos, getText("get PrimaryKeys dao model " + saffix, //
						"nameJp", interfaceData.getNameJp(), //
						"daoClassName", InterfaceTools.changeClassNmae(daoName), //
						"daoName", InterfaceTools.changeMemberNmae(daoName)));

				out(baos, getText("get PrimaryKeys start 2", //
						"nameJp", interfaceData.getNameJp(), //
						"daoClassName", InterfaceTools.changeClassNmae(daoName), //
						"daoName", InterfaceTools.changeMemberNmae(daoName),//
						"recordGetter", InterfaceTools.changeGetterNmae(recordName, false), //
						"recordSetter", InterfaceTools.changeSetterNmae(recordName), //
						"voPrimaryName", InterfaceTools.changeClassNmae(primaryData.getName()), "voName", voName));
				// /////////////////////////////////////////////////////////////////////////////////

				// tb^o
				out(baos, getText("common", "className", className));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	class NodeLinkInfo {
		private Integer parentIncludeId;
		private Integer chaildIncludeId;
		private List<PairItemId> linkedItemIdList;

		public NodeLinkInfo(Integer parentIncludeId, Integer chaildIncludeId) {
			this.parentIncludeId = parentIncludeId;
			this.chaildIncludeId = chaildIncludeId;
			linkedItemIdList = new LinkedList<PairItemId>();
		}

		/**
		 * @return the parentIncludeId
		 */
		public Integer getParentIncludeId() {
			return parentIncludeId;
		}

		/**
		 * @return the chaildIncludeId
		 */
		public Integer getChaildIncludeId() {
			return chaildIncludeId;
		}

		public void addItemId(PairItemId pairItemId) {
			linkedItemIdList.add(pairItemId);
		}

		public List<PairItemId> getPairItemIdList() {
			return linkedItemIdList;
		}

	}

	class PairItemId {
		private Integer parentItemId;
		private Integer chaildItemId;

		public PairItemId(Integer parentItemId, Integer chaildItemId) {
			this.parentItemId = parentItemId;
			this.chaildItemId = chaildItemId;
		}

		/**
		 * @return the parentItemId
		 */
		public Integer getParentItemId() {
			return parentItemId;
		}

		/**
		 * @return the chaildItemId
		 */
		public Integer getChaildItemId() {
			return chaildItemId;
		}

	}
}
