package jp.oarts.pirka.iop.tool.core.plugin.file.gae;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.DbType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataMyItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * GAEpDAOt@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class GaeDaoFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = -4330772947687981187L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.pirka.iop.tool.core.plugin.file.gae#GaeDaoFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "GAEpDAO Java\[Xt@Co";

	public static final String PRIMARY_KEY_ATTACH_NAME = "primaryKey";

	//	GAEString̍ő咷A̒𒴂TextgpȂ΂ȂȂ
	protected final int MAX_STRING_LENGTH = 500;

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	//
			new AttributeSimpleItem(PRIMARY_KEY_ATTACH_NAME, "L[", "L[ڂ̂Ƃ`FbN܂", AttributeType.CHECK, new AttributeData(
					false), null),
			//
			new AttributeSimpleItem("notNull", "NULL֎~", "NULL֎~ڂ̂Ƃ`FbN܂", AttributeType.CHECK, new AttributeData(false),
					null),
			//
			new AttributeSimpleItem("kind", "eJChiee[uj", "eJChƃNL[̎ɂ̓JChI܂", AttributeType.INTERFACE,
					new AttributeData(""), null),
			//

			new AttributeSimpleItem("autoIncrement", "A", "V[PX̎AԂgpƂɃ`FbN܂", AttributeType.CHECK,
					new AttributeData("false"), null),
	//

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			//
			//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("common", "GAEpDAOʃNX\[Xt@Co͂", "GAEpDAO\[Xt@Cgp鋤ʃNX̃\[Xt@Cꏏɏo͂ƂɃ`FbN܂",
					ParameterType.CHECK, new ParameterData(true), null),
			new ParameterSimpleItem("logout", "Oo̓R[ht",
					"샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(true),
					null),
	//
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public GaeDaoFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "GAEpDAO Java\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "GAEpDAO Java\[Xt@Co͂܂";
	}

	@Override
	public String getParameterComment() {
		return "GAEpDAO Java\[Xt@Co͂܂B\n" //
				+ "o͂sC^[tF[Xɂ́w" + PLUGIN_NAME_JP + "x\nAb^`ĂKv܂B";
	}

	// //////////////////////////

	@Override
	public void preCheckAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

		// XV
		for (int itemId : myDataMap.keySet()) {
			InterfaceDataMyItem item = interfaceData.getMyItem(itemId);
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);

			AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);
			if (primaryKey != null && primaryKey.getValueBoolean()) {
				item.setPrimaryKey(true);
			} else {
				item.setPrimaryKey(false);
			}
			interfaceData.updateMyItem(item);
		}
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(getName())) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + getNameJp() + "xAb^b`Kv܂");
			}

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);

			Integer[] itemIds = interfaceData.getEnableItemIdList();

			// vC}[L[݃`FbN
			int keyCount = 0;
			for (Integer itemId : itemIds) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, getName(), PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					keyCount++;
				}
			}
			if (keyCount <= 0) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ͎L[ݒ肳Ă܂");
			}

			// ڃ`FbN
			for (Integer itemId : itemIds) {

				InterfaceDataItem item = interfaceData.getItem(itemId);
				AttributeData dokujiType = interfaceData.getAttribute(itemId, getName(), "dokujiType");

				if (dokujiType == null || dokujiType.getValue().trim().length() <= 0) {

					// if ((item.getType() == FieldType.STRING || item.getType()
					// == FieldType.NUM || item.getType() == FieldType.IMAGE)) {
					// if (item.getLength() <= 0) {
					// throw new
					// InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
					// }
					// }

					if ((item.getType() == FieldType.NUM)) {
						if (item.getLength() < item.getSubLength()) {
							throw new InterfaceException("w肳ꂽC^[tF[XɏŜ̌傫lڂ܂");
						}
					}
				}
			}
		}

	}

	@Override
	public void checkAttribute(int dataId, int itemId, HashMap<String, AttributeData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		InterfaceDataItem item = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).getItem(itemId);
		AttributeData autoIncrement = dataMap.get("autoIncrement");

		if (autoIncrement.getValueBoolean()) {
			if (item.getType() != FieldType.NUM) {
				throw new InterfaceException("lȊO̍ڂɎAԂݒ肳Ă܂");
			}
		}
	}

	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		TreeMap<Integer, HashMap<String, AttributeData>> myDataMap = dataMap.get(getName());

		boolean primaryKeyFlag = false;
		for (Integer itemId : myDataMap.keySet()) {
			HashMap<String, AttributeData> myAttributeMap = myDataMap.get(itemId);
			if (myAttributeMap != null) {

				// L[`FbN
				AttributeData primaryKey = myAttributeMap.get(PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					primaryKeyFlag = true;
				}
			}
		}

		if (!primaryKeyFlag) {
			throw new InterfaceException("L[Kvł");
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		boolean common = dataMap.get("common").getValueBoolean();
		boolean logout = dataMap.get("logout").getValueBoolean();

		setCommonParameter("loggerComment", logout ? "" : "//");

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		Integer[] itemIds = interfaceData.getEnableItemIdList();

		// vC}[L[Xg擾
		List<InterfaceDataItem> primaryKeyItemList = new LinkedList<InterfaceDataItem>();
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			AttributeData primaryKey = interfaceData.getAttribute(itemId, PLUGIN_NAME, "primaryKey");
			if (primaryKey != null && primaryKey.getValueBoolean()) {
				primaryKeyItemList.add(item);
			}
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());
		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		try {

			// if (target) {
			fileMap.put(className + "Dao.java", createDaoJavaSrcFileImage(interfaceData, itemIds, primaryKeyItemList,
					packageName, interfaceProject));
			// }

			if (common) {
				fileMap.put("GaeDaoBase.java", createCommonJavaSrcFileImage(packageName));
				fileMap.put("RecordAction.java", createCommonJavaSrcFile2Image(packageName));
				fileMap.put("RecordSearch.java", createCommonJavaSrcFile3Image(packageName));
			}
			
			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties.gae"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "GaeDaoJava.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	/**
	 * DaoJava\[Xt@CC[W쐬
	 *
	 * @param interfaceData
	 * @param itemIds
	 * @param primaryKeyItemList
	 * @param db
	 * @param packageName
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createDaoJavaSrcFileImage(InterfaceData interfaceData, Integer[] itemIds,
			List<InterfaceDataItem> primaryKeyItemList, String packageName, InterfaceProject interfaceProject)
			throws IOException, InterfaceException {

		HashSet<String> primaryKeyNameSet = new HashSet<String>();

		for (InterfaceDataItem item : primaryKeyItemList) {
			primaryKeyNameSet.add(item.getName());
		}

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("dao package", "package", packageName));
				}

				// ===== wb_ =====
				out(baos, getText("header", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== tB[hݒ =====
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					out(baos, getText("field length", "fieldName", item.getName(), "length", "" + item.getLength(),
							"subLength", "" + item.getSubLength()));
				}

				// ===== wb_1 =====
				out(baos, getText("header 1"));

				// ===== tB^[gp\tB[hݒ =====
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if((item.getType() == FieldType.STRING  && item.getLength() > MAX_STRING_LENGTH) || item.getType() == FieldType.IMAGE){
						// Ȃ
					}else{
						out(baos, getText("filter field", "fieldName", item.getName()));
					}
				}

				// ===== wb_1.2 =====
				out(baos, getText("header 1.2"));

				// ===== tB^[gp\tB[hݒ =====
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if(item.getType() == FieldType.IMAGE){
						// Ȃ
					}else{
						out(baos, getText("where field", "fieldName", item.getName()));
					}
				}

				// ===== wb_1.4 =====
				out(baos, getText("header 1.4"));

				// ===== tB^[gp\tB[hݒ =====
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if(item.getType() == FieldType.IMAGE){
						// Ȃ
					}else{
						out(baos, getText("sort field", "fieldName", item.getName()));
					}
				}

				// ===== wb_ 2 =====
				out(baos, getText("header 2", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== L[쐬 =====
				for (InterfaceDataItem item : primaryKeyItemList) {

					// kind̎o
					AttributeData kindAttributeData = interfaceData.getAttribute(item.getItemId(), PLUGIN_NAME, "kind");
					String getMethod = InterfaceTools.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN);
					if (kindAttributeData != null && kindAttributeData.getValue().length() > 0) {

						InterfaceData kindInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								kindAttributeData.getValueInt());
						if (kindInterfaceData == null) {
							throw new InterfaceException("eJCh̎擾Ɏs܂");
						}

						out(baos, getText("create key 1", "kindName", kindInterfaceData.getName(), "fieldName", item.getName(),
								"getMethod", getMethod));
					} else {
						out(baos, getText("create key 2", "fieldName", item.getName(), "getMethod", getMethod));
					}
				}

				// ===== wb_ 3 =====
				out(baos, getText("header 3"));

				// ===== L[\[gL[쐬 =====
				for (InterfaceDataItem item : primaryKeyItemList) {
					out(baos, getText("get sort key", "fieldName", item.getName()));
				}

				// ===== wb_ 3.5 =====
				out(baos, getText("header 3.5", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== ̔ =====
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					// autoIncrement̎o
					AttributeData autoIncrementAttributeData = interfaceData.getAttribute(item.getItemId(), PLUGIN_NAME,
							"autoIncrement");
					if (autoIncrementAttributeData != null && autoIncrementAttributeData.getValueBoolean()) {

						setParameter("fieldName", item.getName());
						setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN));
						setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));

						if (item.getType() == FieldType.NUM){
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								out(baos, getText("auto number field int"));
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								out(baos, getText("auto number field long"));
							} else {
								out(baos, getText("auto number field bigdecimal"));
							}
						}
					}
				}

				// ===== wb_ 4 =====
				out(baos, getText("header 4", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== GeBeC쐬 =====
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					setParameter("fieldName", item.getName());
					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));

					switch (item.getType()) {
					case STRING:
						if(item.getLength() > MAX_STRING_LENGTH){
							out(baos, getText("set entity string text"));
						}else{
							out(baos, getText("set entity string"));
						}
						break;

					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("set entity int"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("set entity long"));
						} else {
							out(baos, getText("set entity bigdecimal"));
						}
						break;

					case IMAGE:
						out(baos, getText("set entity byte"));
						break;

					case DATE:
						out(baos, getText("set entity date"));
						break;

					case TIME:
						out(baos, getText("set entity time"));
						break;

					case DATE_TIME:
						out(baos, getText("set entity timestamp"));
						break;

					case BOOLEAN:
						out(baos, getText("set entity boolean"));
						break;
					}
				}

				// ===== wb_ 5 =====
				out(baos, getText("header 5", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== R[h쐬 =====
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					setParameter("fieldName", item.getName());
					setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));

					switch (item.getType()) {
					case STRING:
						out(baos, getText("set rec string"));
						break;

					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("set rec int"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("set rec long"));
						} else {
							out(baos, getText("set rec bigdecimal"));
						}
						break;

					case IMAGE:
						out(baos, getText("set rec byte"));
						break;

					case DATE:
						out(baos, getText("set rec date"));
						break;

					case TIME:
						out(baos, getText("set rec time"));
						break;

					case DATE_TIME:
						out(baos, getText("set rec timestamp"));
						break;

					case BOOLEAN:
						out(baos, getText("set rec boolean"));
						break;
					}
				}

				// ===== wb_ 6 =====
				out(baos, getText("header 6", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== L[݂̂̃R[h쐬 =====
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (!item.isPrimaryKey()) {
						continue;
					}
					setParameter("fieldName", item.getName());
					setParameter("setMethod", InterfaceTools.changeSetterNmae(item.getName()));

					switch (item.getType()) {
					case STRING:
						out(baos, getText("set rec string"));
						break;

					case NUM:
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							out(baos, getText("set rec int"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							out(baos, getText("set rec long"));
						} else {
							out(baos, getText("set rec bigdecimal"));
						}
						break;

					case IMAGE:
						out(baos, getText("set rec byte"));
						break;

					case DATE:
						out(baos, getText("set rec date"));
						break;

					case TIME:
						out(baos, getText("set rec time"));
						break;

					case DATE_TIME:
						out(baos, getText("set rec timestamp"));
						break;

					case BOOLEAN:
						out(baos, getText("set rec boolean"));
						break;
					}
				}

				// ===== {fB =====
				out(baos, getText("body", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== L[݂̂̃R[h쐬 =====
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (!item.isPrimaryKey()) {
						continue;
					}
					setParameter("fieldName", item.getName());
					setParameter("getMethod", InterfaceTools.changeGetterNmae(item.getName(),
							item.getType() == FieldType.BOOLEAN));
					out(baos, getText("body set primary key"));
				}

				// ===== {fB 2 =====
				out(baos, getText("body 2", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				// ===== tb^ =====
				out(baos, getText("footer", "mstName", mstName, "nameJp", interfaceData.getNameJp()));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * GAEEDAOpJava\[Xt@CC[W쐬iGaeDaoBase.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFileImage(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("GaeDaoBase package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("GaeDaoBase main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * GAEEDAOpJava\[Xt@CC[W쐬iRecordAction.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFile2Image(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("daoSearchAction package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("daoSearchAction main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * GAEEDAOpJava\[Xt@CC[W쐬iRecordSearch.javaj
	 *
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createCommonJavaSrcFile3Image(String packageName) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// ===== pbP[W =====
				if (packageName != null && packageName.trim().length() > 0) {
					out(baos, getText("recordSearch package", "package", packageName));
				}

				// ===== wb_[ =====
				out(baos, getText("recordSearch main"));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected String chars(String str, int len) {
		StringBuilder sb = new StringBuilder();

		for (int i = 0; i < len; i++) {
			sb.append(str);
		}

		return sb.toString();
	}

	/**
	 * w肳ꂽDB^CvyѓƎ^CvpostgreSQLbitvarbit`FbN
	 *
	 * @param db
	 * @param dokujiType
	 * @return bitvarbit̂Ƃtrue
	 */
	public static boolean isPostgreSQLBitType(DbType db, String dokujiType) {
		if (db == DbType.postgreSQL) {
			if (dokujiType != null && (dokujiType instanceof String)) {
				if (subComp("bit", dokujiType)) {
					return true;
				}
				if (subComp("varbit", dokujiType)) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * w肳ꂽDB^CvyѓƎ^CvpostgreSQLvarbit`FbN
	 *
	 * @param db
	 * @param dokujiType
	 * @return true=varbit
	 */
	protected boolean isPostgreSQLVarbitType(DbType db, String dokujiType) {
		if (db == DbType.postgreSQL) {
			if (dokujiType != null && (dokujiType instanceof String)) {
				if (subComp("varbit", dokujiType)) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * compStrbaseStrŊJn镶񂩔r
	 *
	 * @param baseStr
	 *            x[X
	 * @param compStr
	 *            r
	 * @return true=
	 */
	protected static boolean subComp(String baseStr, String compStr) {

		if (baseStr == null && compStr == null) {
			return true;
		}

		if (baseStr.length() <= 0) {
			return true;
		}

		if (compStr.length() < baseStr.length()) {
			return false;
		}

		return baseStr.equalsIgnoreCase(compStr.substring(0, baseStr.length()));
	}

}
