package jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.TreeMap;

import jp.oarts.pirka.iop.tool.core.business.AttributeChecker;
import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * eiXpHTMLt@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class MntHtmlFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#MntHtmlFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "DBeiXHTMLt@Co";

	// `
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

			//
			new AttributeSimpleItem("controlType", "Rg[^Cv", "WEBʏł̃Rg[̃^CvI܂", AttributeType.SELECT, 0,
					new AttributeData("text"), new AttributeChecker() {

						@Override
						public void check(String value, InterfaceDataItem item) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("Iĉ");
							}

							if (!"nonUse".equals(value)) {

								if (item.getType() == FieldType.STRING) {
									if (!"text".equals(value) && !"textarea".equals(value) && !"select".equals(value)) {
										throw new InterfaceException("gpłȂRg[ݒ肳Ă܂");
									}
									if (item.getLength() <= 0) {
										throw new InterfaceException("ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
									}
								}

								if (item.getType() == FieldType.NUM) {
									if (!"text".equals(value)) {
										throw new InterfaceException("gpłȂRg[ݒ肳Ă܂");
									}
									if (item.getLength() <= 0) {
										throw new InterfaceException("ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
									}
									if (item.getLength() < item.getSubLength()) {
										throw new InterfaceException("Ŝ̌傫lڂ܂");
									}
								}

								if (item.getType() == FieldType.DATE) {
									if (!"text".equals(value)) {
										throw new InterfaceException("tڂɎgpłȂRg[ݒ肳Ă܂");
									}
								}

								if (item.getType() == FieldType.TIME) {
									if (!"text".equals(value)) {
										throw new InterfaceException("ԍڂɎgpłȂRg[ݒ肳Ă܂");
									}
								}

								if (item.getType() == FieldType.DATE_TIME) {
									if (!"text".equals(value)) {
										throw new InterfaceException("ڂɎgpłȂRg[ݒ肳Ă܂");
									}
								}

								if (item.getType() == FieldType.BOOLEAN) {
									if (!"checkbox".equals(value)) {
										throw new InterfaceException("^UڂɎgpłȂRg[ݒ肳Ă܂");
									}
								}

								if (item.getType() == FieldType.IMAGE) {
									throw new InterfaceException("C[WڂgpĂ܂");
								}

							}
						}
					},
					//
					new Selecter("nonUse", "ʕ\ΏۊO"),
					//
					new Selecter("text", "eLXg"),
					//
					new Selecter("textarea", "seLXg"),
					//
					new Selecter("select", "Ij["),
					//
					new Selecter("checkbox", "`FbN")
			//
			),

			new AttributeSimpleItem("useSearch", "ƂĎgp", "ꗗ\ʂŌƂĎgpƂ̓`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			new AttributeSimpleItem("searchLike", "͑Ov", "񌟍őOvȂƂ̓`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			//
			new AttributeSimpleItem("useList", "ꗗŎgp", "ꗗ\ʂŎgpƂ̓`FbN܂", AttributeType.CHECK, new AttributeData(true),
					null),
			new AttributeSimpleItem("useRef", "ƉŎgp", "ƉʂŎgpƂ̓`FbN܂", AttributeType.CHECK, new AttributeData(true),
					null),
			new AttributeSimpleItem("useIns", "VKŎgp", "VKʂŎgpƂ̓`FbN܂", AttributeType.CHECK, new AttributeData(true),
					null),
			new AttributeSimpleItem("useUp", "CŎgp", "CʂŎgpƂ̓`FbN܂", AttributeType.CHECK, new AttributeData(true), null),

			new AttributeSimpleItem("noInputUp", "Cʓ͋֎~", "Cʂł͓͂sȂڂƂƂ̓`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			//
			new AttributeSimpleItem("underLengthNg", "ڒ̓G[", "͎ɍڒɖȂ͂G[ƂƂ̓`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			//
			new AttributeSimpleItem("stringChaeck", "͎̃`FbN", "͂̎ɍs`FbNw肵Ă", AttributeType.SELECT, 0,
					new AttributeData("noCheck"), null,
					//
					new Selecter("noCheck", "`FbNȂ"), new Selecter("numCheck", "p"),
					//
					new Selecter("ACheck", "pp啶"), new Selecter("aCheck", "pp"), new Selecter("AaCheck", "pp"),
					//
					new Selecter("numACheck", "pp啶"), new Selecter("numaCheck", "pp"), new Selecter("numAaCheck",
							"pp"),
					//
					new Selecter("allHankakuCheck", "SĂ̔p"), new Selecter("allZenkakuCheck", "SĂ̑Sp"),
					//
					new Selecter("hankakuKatakanaCheck", "pJ^Ji"), new Selecter("zenkakuKatakanaCheck", "SpJ^Ji"),
					//
					new Selecter("zenkakuHiraganaCheck", "SpЂ炪"), new Selecter("ninniStringChek", "Cӂ̕i\[XɃTvj")

			//
			),
			//
			new AttributeSimpleItem("dokujiCheck", "Ǝ`FbJ[t", "Ǝ̃`FbJ[𗘗pƂɃ`FbN܂ \[XR[hɓƎ`FbJ[̐`}܂",
					AttributeType.CHECK, new AttributeData(false), null),

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}

					}),
			//
			new ParameterSimpleItem("list", "ꗗ\HTMLt@Co", "ꗗ\ʂHTMLt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("reference", "ƉpHTMLt@Co", "ƉʂHTMLt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("insert", "VKpHTMLt@Co", "VKʂHTMLt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("update", "CpHTMLt@Co", "CʂHTMLt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("gaeFlag", "GAEŎgp", "Google App Enginep̂HTMLt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(false), null),
	//
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////
	@Override
	public void checkAttribute(int dataId, HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap,
			InterfaceProject interfaceProject) throws InterfaceException {

		// f[^x[Xt@CNG[^[A^b`ĂȂΖ߂
		if (!dataMap.containsKey(DataBaseFileCreator.PLUGIN_NAME)) {
			return;
		}

		boolean primaryKeyFlag = false;

		TreeMap<Integer, HashMap<String, AttributeData>> myMap = dataMap.get(getName());

		for (Integer itemId : myMap.keySet()) {

			TreeMap<Integer, HashMap<String, AttributeData>> databaseFileCreatorMap = dataMap
					.get(DataBaseFileCreator.PLUGIN_NAME);
			if (!databaseFileCreatorMap.containsKey(itemId)) {
				continue;
			}

			HashMap<String, AttributeData> databaseFileCreatorAttrMap = databaseFileCreatorMap.get(itemId);

			AttributeData primaryKey = databaseFileCreatorAttrMap.get("primaryKey");
			if (primaryKey == null || primaryKey.getValueBoolean() == false) {
				continue;
			}
			primaryKeyFlag = true;

			HashMap<String, AttributeData> attrMap = myMap.get(itemId);

			AttributeData controlType = attrMap.get("controlType");
			if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
				continue;
			}

			AttributeData useUp = attrMap.get("useUp");
			if (useUp == null || useUp.getValueBoolean() == false) {
				continue;
			}

			AttributeData noInputUp = attrMap.get("noInputUp");
			if (noInputUp == null || noInputUp.getValueBoolean() == true) {
				continue;
			}

			throw new InterfaceException("L[͏Cʂł͓͋֎~ł");
		}

		if (!primaryKeyFlag) {
			throw new InterfaceException("L[Kvł");
		}
	}

	public MntHtmlFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "DBeiXHTMLt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "DBeiXñt@Co͂鎞ɃAb^`܂";
	}

	@Override
	public String getParameterComment() {
		return "f[^x[Xe[ũeiXpHTMLt@Co͂܂B\n" //
				+ "ΏۂƂȂe[u1e[û݂łB\n" //
				+ "o͂sC^[tF[Xɂ́w" + getNameJp() + "x\nAb^`ĂKv܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());
		}
		if (interfaceData != null) {
			if (!interfaceData.isAttached(getName())) {
				throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + getNameJp() + "xAb^b`Kv܂");
			}

			IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);

			Integer[] itemIds = interfaceData.getEnableItemIdList();

			// ڃ`FbN
			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				AttributeData controlType = interfaceData.getAttribute(itemId, getName(), "controlType");

				if (controlType != null && !"nonUse".equals(controlType.getValue())) {

					if (item.getType() == FieldType.STRING) {
						if (!"text".equals(controlType.getValue()) && !"textarea".equals(controlType.getValue())
								&& !"select".equals(controlType.getValue())) {
							throw new InterfaceException("w肳ꂽC^[tF[Xł͕񍀖ڂɎgpłȂRg[ݒ肳Ă܂");
						}
						if (item.getLength() <= 0) {
							throw new InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
						}
					}

					if (item.getType() == FieldType.NUM) {
						if (!"text".equals(controlType.getValue())) {
							throw new InterfaceException("w肳ꂽC^[tF[Xł͐lڂɎgpłȂRg[ݒ肳Ă܂");
						}
						if (item.getLength() <= 0) {
							throw new InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
						}
						if (item.getLength() < item.getSubLength()) {
							throw new InterfaceException("w肳ꂽC^[tF[XɏŜ̌傫lڂ܂");
						}
					}

					if (item.getType() == FieldType.DATE) {
						if (!"text".equals(controlType.getValue())) {
							throw new InterfaceException("w肳ꂽC^[tF[Xł͓tڂɎgpłȂRg[ݒ肳Ă܂");
						}
					}

					if (item.getType() == FieldType.TIME) {
						if (!"text".equals(controlType.getValue())) {
							throw new InterfaceException("w肳ꂽC^[tF[Xł͎ԍڂɎgpłȂRg[ݒ肳Ă܂");
						}
					}

					if (item.getType() == FieldType.DATE_TIME) {
						if (!"text".equals(controlType.getValue())) {
							throw new InterfaceException("w肳ꂽC^[tF[Xł͓ڂɎgpłȂRg[ݒ肳Ă܂");
						}
					}

					if (item.getType() == FieldType.BOOLEAN) {
						if (!"checkbox".equals(controlType.getValue())) {
							throw new InterfaceException("w肳ꂽC^[tF[Xł͐^UڂɎgpłȂRg[ݒ肳Ă܂");
						}
					}

					if (item.getType() == FieldType.IMAGE) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł̓C[WڂgpĂ܂");
					}
				}
			}
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		boolean listFlag = dataMap.get("list").getValueBoolean();
		boolean referenceFlag = dataMap.get("reference").getValueBoolean();
		boolean insertFlag = dataMap.get("insert").getValueBoolean();
		boolean updateFlag = dataMap.get("update").getValueBoolean();
		boolean gaeFlag = dataMap.get("gaeFlag").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		// Rg[^Cvݒ肳ĂȂ͎gpȂID폜
		Integer[] itemIdsWk = interfaceData.getEnableItemIdList();
		List<Integer> itemIdListWk = new ArrayList<Integer>();
		for (Integer id : itemIdsWk) {
			AttributeData controlType = interfaceData.getAttribute(id, getName(), "controlType");
			if (controlType != null) {
				itemIdListWk.add(id);
			}
		}
		Integer[] itemIds = itemIdListWk.toArray(new Integer[0]);

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		try {
			// try {

			if (listFlag) {
				fileMap.put(className + "List.html", createListHtml(interfaceData, itemIds));
			}

			if (referenceFlag) {
				fileMap.put(className + "Reference.html", createReferenceHtml(interfaceData, itemIds));
			}

			if (insertFlag) {
				fileMap.put(className + "Insert.html", createInsertUpdateHtml(true, interfaceData, itemIds));
			}

			if (updateFlag) {
				fileMap.put(className + "Update.html", createInsertUpdateHtml(false, interfaceData, itemIds));
			}

			fileMap.put("prototype.js", getResourceFile("/jp/oarts/pirka/iop/tool/resource/prototype.js"));
			if (!gaeFlag) {
				fileMap.put("pirka.js", getResourceFile("/jp/oarts/pirka/iop/tool/resource/pirka.js"));
			} else {
				fileMap.put("pirka.js", getResourceFile("/jp/oarts/pirka/iop/tool/resource/pirka.js", "MS932", "UTF-8"));
			}
			fileMap.put("pirkaiop.css", getResourceFile("/jp/oarts/pirka/iop/tool/resource/pirkaiop.css"));
			fileMap.put("readMe.txt",
					getResourceFile("/jp/oarts/pirka/iop/tool/core/plugin/file/mnthtml/MntHtmlFileCreatorReadMe.txt"));

			if (fileMap.size() <= 0) {
				throw new InterfaceException("o̓t@CIĂ܂");
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "Html.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	/**
	 * ꗗ\HTMLt@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param paramItemIds
	 *            LȃC^[tF[XIDz
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createListHtml(InterfaceData interfaceData, Integer[] paramItemIds) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			String title = interfaceData.getNameJp() + " ꗗ\";
			out(baos, getText("common header", "title", title));
			out(baos, getText("list 1", "title", title));

			out(baos, getText("list search start"));

			for (Integer itemId : paramItemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);

				AttributeData controlType = interfaceData.getAttribute(itemId, getName(), "controlType");
				AttributeData useSearch = interfaceData.getAttribute(itemId, getName(), "useSearch");
				AttributeData searchLike = interfaceData.getAttribute(itemId, getName(), "searchLike");

				if (controlType != null && !"nonUse".equals(controlType.getValue()) && useSearch != null
						&& useSearch.getValueBoolean()) {
					if ("select".equals(controlType.getValue())) {
						out(baos, getText("list search select", "name", item.getName(), "nameJp", item.getNameJp()));

					} else if ("checkbox".equals(controlType.getValue())) {
						out(baos, getText("list search check", "name", item.getName(), "nameJp", item.getNameJp()));

					} else {
						if (searchLike != null && searchLike.getValueBoolean()) {
							out(baos,
									getText("list search text", "name", item.getName(), "nameJp", item.getNameJp() + "iOvj"));
						} else {
							out(baos, getText("list search text", "name", item.getName(), "nameJp", item.getNameJp()));
						}
					}
				}
			}
			out(baos, getText("list search end"));

			// ꗗŎgp鍀ڂ݂̂IDXg쐬
			List<Integer> itemIdList = new LinkedList<Integer>();
			for (Integer paramItemId : paramItemIds) {
				AttributeData controlType = interfaceData.getAttribute(paramItemId, getName(), "controlType");
				AttributeData useList = interfaceData.getAttribute(paramItemId, getName(), "useList");
				if (controlType != null && !"nonUse".equals(controlType.getValue())
						&& (useList == null || (useList != null && useList.getValueBoolean()))) {
					itemIdList.add(paramItemId);
				}
			}
			Integer[] itemIds = itemIdList.toArray(new Integer[0]);

			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				out(baos, getText("list title", "itemTitle", item.getNameJp()));
			}

			out(baos, getText("list 2"));

			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				out(baos, getText("list value", "itemName", item.getName()));
			}

			out(baos, getText("list 3"));

			out(baos, getText("common footer"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * ƉpHTMLt@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param paramItemIds
	 *            LȃC^[tF[XIDz
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createReferenceHtml(InterfaceData interfaceData, Integer[] paramItemIds) throws IOException,
			InterfaceException {

		// ƉŎgp鍀ڂ݂̂IDXg쐬
		List<Integer> itemIdList = new LinkedList<Integer>();
		for (Integer paramItemId : paramItemIds) {
			AttributeData controlType = interfaceData.getAttribute(paramItemId, getName(), "controlType");
			AttributeData useRef = interfaceData.getAttribute(paramItemId, getName(), "useRef");
			if (controlType != null && !"nonUse".equals(controlType.getValue())
					&& (useRef == null || (useRef != null && useRef.getValueBoolean()))) {
				itemIdList.add(paramItemId);
			}
		}
		Integer[] itemIds = itemIdList.toArray(new Integer[0]);

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			String title = interfaceData.getNameJp() + " Ɖ";
			out(baos, getText("common header", "title", title));
			out(baos, getText("reference 1", "title", title));

			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				out(baos, getText("reference value", "itemName", item.getName(), "itemTitle", item.getNameJp()));
			}

			out(baos, getText("reference 2"));

			out(baos, getText("common footer"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * VKCpHTMLt@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param paramItemIds
	 *            LȃC^[tF[XIDz
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createInsertUpdateHtml(boolean insertMode, InterfaceData interfaceData, Integer[] paramItemIds)
			throws IOException, InterfaceException {

		String useFlagName = insertMode ? "useIns" : "useUp";

		// VKCŎgp鍀ڂ݂̂IDXg쐬
		List<Integer> itemIdList = new LinkedList<Integer>();
		for (Integer paramItemId : paramItemIds) {
			AttributeData useFlag = interfaceData.getAttribute(paramItemId, getName(), useFlagName);
			if (useFlag == null || (useFlag != null && useFlag.getValueBoolean())) {
				itemIdList.add(paramItemId);
			}
		}
		Integer[] itemIds = itemIdList.toArray(new Integer[0]);

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			String title = interfaceData.getNameJp() + (insertMode ? " VK" : " C");
			out(baos, getText("common header", "title", title));
			setParameter("registButtonName", insertMode ? " o^" : " XV");
			out(baos, getText("update 1", "title", title));
			for (Integer itemId : itemIds) {
				InterfaceDataItem item = interfaceData.getItem(itemId);

				AttributeData controlType = interfaceData.getAttribute(itemId, getName(), "controlType");
				AttributeData noInputMode = interfaceData.getAttribute(itemId, getName(), "noInputUp");
				if (controlType != null) {
					if (!insertMode && (noInputMode == null || (noInputMode != null && noInputMode.getValueBoolean()))) {
						out(baos, getText("update value display only", "name", item.getName(), "nameJp", item.getNameJp()));

					} else if ("text".equals(controlType.getValue())) {
						setParameter("option", "");
						switch (item.getType()) {

						case STRING:
							if (item.getLength() > 0) {
								long size = item.getLength() * 2;
								if (size > 100) {
									size = 100;
								}
								setParameter("option", "maxlength=\"" + item.getLength() + "\" size=\"" + size + "\"");
							}
							break;
						case NUM:
							if (item.getLength() > 0) {
								if (item.getSubLength() > 0) {
									setParameter("option", "maxlength=\"" + (item.getLength() + item.getSubLength() + 2)
											+ "\" size=\"" + (((item.getLength() + item.getSubLength() + 2) * 15) / 10) + "\"");
								} else {
									setParameter("option", "maxlength=\"" + (item.getLength() + 1) + "\", size=\""
											+ (((item.getLength() + 1) * 15) / 10) + "\"");
								}
							}
							break;
						case DATE:
							setParameter("option", "size=\"21\"");
							break;
						case TIME:
							setParameter("option", "size=\"18\"");
							break;
						case DATE_TIME:
							setParameter("option", "size=\"42\"");
							break;
						}
						out(baos, getText("update value text", "name", item.getName(), "nameJp", item.getNameJp()));

					} else if ("textarea".equals(controlType.getValue())) {
						out(baos, getText("update value text area", "name", item.getName(), "nameJp", item.getNameJp()));

					} else if ("select".equals(controlType.getValue())) {
						out(baos, getText("update value select", "name", item.getName(), "nameJp", item.getNameJp()));

					} else if ("checkbox".equals(controlType.getValue())) {
						out(baos, getText("update value check", "name", item.getName(), "nameJp", item.getNameJp()));

					}
				}
			}

			out(baos, getText("update 2"));

			out(baos, getText("common footer"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}
}
