package jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.gae.GaeDaoFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * eiXpHTMLRg[Jav\[Xt@C쐬Et@CNG[^[vOC
 * 
 * @author ito
 * 
 */
public class MntHtmlJavaFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#MntHtmlJavaFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "DBeiXHTMLRg[Java\[Xt@Co";

	private static final HashSet<String> canUseInputDataCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseRequiredCheckCtrlSet = new HashSet<String>();
	private static final HashMap<String, String> stringCheckerMap = new HashMap<String, String>();
	private static final HashSet<String> canUseFreeInputTextCtrlSet = new HashSet<String>();

	static {

		canUseInputDataCtrlSet.add("text");
		canUseInputDataCtrlSet.add("textarea");
		canUseInputDataCtrlSet.add("select");
		canUseInputDataCtrlSet.add("checkbox");
		//
		canUseRequiredCheckCtrlSet.add("text");
		canUseRequiredCheckCtrlSet.add("textarea");
		canUseRequiredCheckCtrlSet.add("select");

		canUseFreeInputTextCtrlSet.add("text");
		canUseFreeInputTextCtrlSet.add("textarea");

		stringCheckerMap.put("numCheck", "PirkaCheckerStringChars.NUM");
		stringCheckerMap.put("ACheck", "PirkaCheckerStringChars.HIGHT_ALPHABET");
		stringCheckerMap.put("aCheck", "PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("AaCheck", "PirkaCheckerStringChars.HIGHT_ALPHABET, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("numACheck", "PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.HIGHT_ALPHABET");
		stringCheckerMap.put("numaCheck", "PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("numAaCheck",
				"PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.HIGHT_ALPHABET, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put("allHankakuCheck", "PirkaCheckerStringChars.HALF");
		stringCheckerMap.put("allZenkakuCheck", "PirkaCheckerStringChars.WIDE");
		stringCheckerMap.put("hankakuKatakanaCheck", "PirkaCheckerStringChars.HARF_KANA");
		stringCheckerMap.put("zenkakuKatakanaCheck", "PirkaCheckerStringChars.WIDE_KATAKANA");
		stringCheckerMap.put("zenkakuHiraganaCheck", "PirkaCheckerStringChars.WIDE_HIRAGANA");
		stringCheckerMap.put("ninniStringChek", "new PirkaCheckerStringChars(\"͓͂镶ɒuĂ\")");
		//
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

			//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//

			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("list", "ꗗ\Java\[Xt@Co", "ꗗ\ʗpjava\[Xt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("reference", "ƉpJava\[Xt@Co", "Ɖʗpjava\[Xt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("insert", "VKpJava\[XLt@Co", "VKʗpjava\[Xt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("update", "CpJava\[Xt@Co", "Cʗpjava\[Xt@Co͂Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			new ParameterSimpleItem("logout", "Oo̓R[ht", "샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public MntHtmlJavaFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "DBeiXHTML𐧌䂷Java\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "f[^x[Xe[ũeiXpHTML𐧌䂷Java\[Xt@Co͂܂B\n" //
				+ "ΏۂƂȂf[^x[X̃e[uGAẼJCh1݂̂łB\n" //
				+ "o͂sC^[tF[Xɂ́w" //
				+ MntHtmlFileCreator.PLUGIN_NAME_JP + "x\n" //
				+ "w" + DataBaseFileCreator.PLUGIN_NAME_JP + "x" //
				+ "܂́w" + GaeDaoFileCreator.PLUGIN_NAME_JP + "x\n̂ǂ炩Œ1" //
				+ "A^b`ĂKv܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;
		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());
		}

		if (interfaceData == null || !interfaceData.isAttached(MntHtmlFileCreator.PLUGIN_NAME)) {
			throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + MntHtmlFileCreator.PLUGIN_NAME_JP + "xAb^b`Kv܂");
		}

		if (!interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)
				&& !interfaceData.isAttached(GaeDaoFileCreator.PLUGIN_NAME)) {
			throw new InterfaceException("w肳ꂽC^[tF[Xɂ́w" + DataBaseFileCreator.PLUGIN_NAME_JP + "x܂́w"
					+ GaeDaoFileCreator.PLUGIN_NAME_JP + "xAb^b`Kv܂");
		}

		IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);

		Integer[] itemIds = interfaceData.getEnableItemIdList();

		// vC}[L[݃`FbN
		int keyCount = 0;
		// for (Integer itemId : itemIds) {
		// AttributeData primaryKey = interfaceData.getAttribute(itemId,
		// DataBaseFileCreator.PLUGIN_NAME, "primaryKey");
		// if (primaryKey != null && primaryKey.getValueBoolean()) {
		// keyCount++;
		// }
		// }
		for (Integer itemId : itemIds) {
			if (interfaceData.getItem(itemId).isPrimaryKey()) {
				keyCount++;
			}
		}
		if (keyCount <= 0) {
			throw new InterfaceException("w肳ꂽC^[tF[Xɂ͎L[ݒ肳Ă܂");
		}

		// ڃ`FbN
		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);
			AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "controlType");

			if (controlType != null && !"nonUse".equals(controlType.getValue())) {

				if (item.getType() == FieldType.STRING) {
					if (!"text".equals(controlType.getValue()) && !"textarea".equals(controlType.getValue())
							&& !"select".equals(controlType.getValue())) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł͕񍀖ڂɎgpłȂRg[ݒ肳Ă܂");
					}
					if (item.getLength() <= 0) {
						throw new InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
					}
				}

				if (item.getType() == FieldType.NUM) {
					if (!"text".equals(controlType.getValue())) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł͐lڂɎgpłȂRg[ݒ肳Ă܂");
					}
					if (item.getLength() <= 0) {
						throw new InterfaceException("w肳ꂽC^[tF[X̍ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
					}
					if (item.getLength() < item.getSubLength()) {
						throw new InterfaceException("w肳ꂽC^[tF[XɏŜ̌傫lڂ܂");
					}
				}

				if (item.getType() == FieldType.DATE) {
					if (!"text".equals(controlType.getValue())) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł͓tڂɎgpłȂRg[ݒ肳Ă܂");
					}
				}

				if (item.getType() == FieldType.TIME) {
					if (!"text".equals(controlType.getValue())) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł͎ԍڂɎgpłȂRg[ݒ肳Ă܂");
					}
				}

				if (item.getType() == FieldType.DATE_TIME) {
					if (!"text".equals(controlType.getValue())) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł͓ڂɎgpłȂRg[ݒ肳Ă܂");
					}
				}

				if (item.getType() == FieldType.BOOLEAN) {
					if (!"checkbox".equals(controlType.getValue())) {
						throw new InterfaceException("w肳ꂽC^[tF[Xł͐^UڂɎgpłȂRg[ݒ肳Ă܂");
					}
				}

				if (item.getType() == FieldType.IMAGE) {
					throw new InterfaceException("w肳ꂽC^[tF[Xł̓C[WڂgpĂ܂");
				}
			}
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		boolean listFlag = dataMap.get("list").getValueBoolean();
		boolean referenceFlag = dataMap.get("reference").getValueBoolean();
		boolean insertFlag = dataMap.get("insert").getValueBoolean();
		boolean updateFlag = dataMap.get("update").getValueBoolean();
		boolean logout = dataMap.get("logout").getValueBoolean();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		// Rg[^Cvݒ肳ĂȂ͎gpȂID폜
		Integer[] itemIdsOrg = interfaceData.getEnableItemIdList();
		List<Integer> itemIdListWk = new ArrayList<Integer>();
		for (Integer id : itemIdsOrg) {
			AttributeData controlType = interfaceData.getAttribute(id, MntHtmlFileCreator.PLUGIN_NAME, "controlType");
			if (controlType != null && !"nonUse".equals(controlType.getValue())) {
				itemIdListWk.add(id);
			}
		}
		Integer[] itemIds = itemIdListWk.toArray(new Integer[0]);

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		// vC}[L[Xg擾
		List<InterfaceDataItem> primaryKeyItemList = new LinkedList<InterfaceDataItem>();
		for (Integer itemId : itemIdsOrg) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			// AttributeData primaryKey = interfaceData.getAttribute(itemId,
			// DataBaseFileCreator.PLUGIN_NAME, "primaryKey");
			// if (primaryKey != null && primaryKey.getValueBoolean()) {
			// primaryKeyItemList.add(item);
			// }

			if (item.isPrimaryKey()) {
				primaryKeyItemList.add(item);
			}

		}

		if (primaryKeyItemList.size() <= 0) {
			throw new InterfaceException("L[Kvł");
		}

		try {

			if (listFlag) {
				fileMap.put(className + "List.java", createListJava(interfaceData, itemIds, packageName, primaryKeyItemList,
						logout));
			}

			if (referenceFlag) {
				fileMap.put(className + "Reference.java", createReferenceJava(interfaceData, itemIds, packageName,
						primaryKeyItemList, logout));
			}

			if (insertFlag) {
				fileMap.put(className + "Insert.java", createInsertJava(interfaceData, itemIds, packageName,
						primaryKeyItemList, logout));
			}

			if (updateFlag) {
				fileMap.put(className + "Update.java", createUpdateJava(interfaceData, itemIdsOrg, packageName,
						primaryKeyItemList, logout));
			}

			if (fileMap.size() <= 0) {
				throw new InterfaceException("o̓t@CIĂ܂");
			}

			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}
			
			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "Java.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	/**
	 * ꗗ\Javat@CC[W쐬
	 * 
	 * @param interfaceData
	 *            C^[tF[X
	 * @param paramItemIds
	 *            LȃC^[tF[XIDz
	 * @param logout
	 *            Oo
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createListJava(InterfaceData interfaceData, Integer[] paramItemIds, String packageName,
			List<InterfaceDataItem> primaryKeyItemList, boolean logout) throws IOException, InterfaceException {

		// ꗗŎgp鍀ڂ݂̂IDXg쐬
		List<Integer> itemIdList = new LinkedList<Integer>();
		for (Integer paramItemId : paramItemIds) {
			AttributeData useList = interfaceData.getAttribute(paramItemId, MntHtmlFileCreator.PLUGIN_NAME, "useList");
			if ((useList == null || useList.getValueBoolean())) {
				itemIdList.add(paramItemId);
			}
		}
		Integer[] itemIdLists = itemIdList.toArray(new Integer[0]);

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String classNameJp = interfaceData.getNameJp() + " ꗗ\";
		String loggerComment = logout ? "" : "//";

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("list package", "package", packageName));
				}

				// L[擾
				StringBuilder sb = new StringBuilder();
				for (InterfaceDataItem keyItem : primaryKeyItemList) {
					if (sb.length() > 0) {
						sb.append(", ");
					}
					sb.append("\"" + keyItem.getName() + "\"");
				}

				out(baos, getText("list 1", "mstName", mstName, "classNameJp", classNameJp,
						"primaryKeys", sb.toString(), "loggerComment", loggerComment));
				
				// Ij[}bvo
				for (Integer itemId : paramItemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType != null && "select".equals(controlType.getValue())) {
						out(baos, getText("list select list map def", "name", item.getName()));
					}
				}

				out(baos, getText("list 2", "mstName", mstName));

				// `FbJ[o
				int checkerCount = 0;
				for (Integer itemId : paramItemIds) {

					AttributeData useSearch = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "useSearch");

					if (useSearch == null || !useSearch.getValueBoolean()) {
						continue;
					}

					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (item.getType() == FieldType.NUM) {
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							checkerCount++;
							out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.intValue"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							checkerCount++;
							out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.longValue"));
						} else {
							checkerCount++;
							out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.numeric"));
						}

					} else if (item.getType() == FieldType.DATE) {
						checkerCount++;
						out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.date"));

					} else if (item.getType() == FieldType.TIME) {
						checkerCount++;
						out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.time"));

					} else if (item.getType() == FieldType.DATE_TIME) {
						checkerCount++;
						out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.datetime"));

					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("list addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("list setOfficialFieldName start"));
				for (Integer itemId : paramItemIds) {

					AttributeData useSearch = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "useSearch");
					if (useSearch == null || !useSearch.getValueBoolean()) {
						continue;
					}
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);
					out(baos, getText("list setOfficialFieldName", "name", item.getName(), "nameJp", item.getNameJp()));
				}

				// Iɓ̓`FbNȂȂ{^̐ݒo
				out(baos, getText("list setAutoCheck start"));

				// IXg̍ڒ`ݒo
				for (Integer itemId : paramItemIds) {

					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType != null && "select".equals(controlType.getValue())) {

						InterfaceDataItem item = interfaceData.getItem(itemId);
						String zero = chars("0", (int) (item.getLength() - 1));
						AttributeData useSearch = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
								"useSearch");
						if (useSearch != null && useSearch.getValueBoolean()) {
							out(baos, getText("list setSelecter", "name", item.getName(), "nameJp", item.getNameJp(), "zero",
									zero));
							out(baos, getText("list setSelecter all", "name", item.getName()));
						} else {
							AttributeData useList = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
									"useList");
							if (useList != null && useList.getValueBoolean()) {
								out(baos, getText("list setSelecter", "name", item.getName(), "nameJp", item.getNameJp(),
										"zero", zero));
								out(baos, getText("list setSelecter map only", "name", item.getName()));
							}
						}
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("list setFormat start"));
				for (Integer itemId : paramItemIds) {

					AttributeData useSearch = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "useSearch");
					if (useSearch == null || !useSearch.getValueBoolean()) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("list setFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));

						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("list setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("list setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("list setFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}

				out(baos, getText("list 3", "classNameJp", classNameJp, "mstName", mstName, "loggerComment", loggerComment));

				// ݒ
				for (Integer itemId : paramItemIds) {

					AttributeData useSearch = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "useSearch");
					if (useSearch == null || !useSearch.getValueBoolean()) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					if ("select".equals(controlType.getValue())) {
						out(baos, getText("list set search parameter select", "name", item.getName(), "mstName", mstName));

					} else if ("checkbox".equals(controlType.getValue())) {
						out(baos, getText("list set search parameter boolean", "name", item.getName(), "mstName", mstName));

					} else {

						if (item.getType() == FieldType.STRING) {
							AttributeData searchLike = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
									"searchLike");
							if (searchLike != null && searchLike.getValueBoolean()) {
								out(baos, getText("list set search parameter text like", "name", item.getName(), "mstName",
										mstName));
							} else {
								out(baos, getText("list set search parameter text equal", "name", item.getName(), "mstName",
										mstName));
							}
						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								out(baos, getText("list set search parameter int", "name", item.getName(), "mstName", mstName));
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								out(baos, getText("list set search parameter long", "name", item.getName(), "mstName", mstName));
							} else {
								out(baos, getText("list set search parameter bigdecimal", "name", item.getName(), "mstName",
										mstName));
							}
						} else if (item.getType() == FieldType.DATE) {
							out(baos, getText("list set search parameter date", "name", item.getName(), "mstName", mstName));
						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("list set search parameter time", "name", item.getName(), "mstName", mstName));
						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos,
									getText("list set search parameter timestamp", "name", item.getName(), "mstName", mstName));
						}
					}
				}

				// L[擾
				sb = new StringBuilder();
				for (InterfaceDataItem keyItem : primaryKeyItemList) {

					if (sb.length() > 0) {
						sb.append(", ");
					}

					sb.append("rec.");
					sb.append(InterfaceTools.changeGetterNmae(keyItem.getName(), keyItem.getType() == FieldType.BOOLEAN));
					sb.append("()");
				}

				out(baos, getText("list 4", "classNameJp", classNameJp, "primaryKeyGetMethods", sb.toString(), "mstName", mstName, "loggerComment", loggerComment));

				// ꗗڐݒ
				for (Integer itemId : itemIdLists) {

					AttributeData useList = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "useList");
					if (useList != null && !useList.getValueBoolean()) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					if ("select".equals(controlType.getValue())) {
						out(baos, getText("list set select data", "name", item.getName(), "getMethod", InterfaceTools
								.changeGetterNmae(item.getName(), false)));
					} else {
						out(baos, getText("list set data", "name", item.getName(), "getMethod", InterfaceTools
								.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN)));
					}
				}

				// tb^o
				out(baos, getText("list 5", "classNameJp", classNameJp, "mstName", mstName, "loggerComment", loggerComment));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * ƉJavat@CC[W쐬
	 * 
	 * @param interfaceData
	 *            C^[tF[X
	 * @param parameterItemIds
	 *            LȃC^[tF[XIDz
	 * @param packageName
	 *            pbP[W
	 * @param primaryKeyItemList
	 *            vC}[L[ڃXg
	 * @param logout
	 *            Oo
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createReferenceJava(InterfaceData interfaceData, Integer[] parameterItemIds, String packageName,
			List<InterfaceDataItem> primaryKeyItemList, boolean logout) throws IOException, InterfaceException {

		// ƉʂŎgp鍀ڂ݂̂IDXg쐬
		List<Integer> itemIdRef = new LinkedList<Integer>();
		for (Integer paramItemId : parameterItemIds) {
			AttributeData useRef = interfaceData.getAttribute(paramItemId, MntHtmlFileCreator.PLUGIN_NAME, "useRef");
			if (useRef == null || useRef.getValueBoolean()) {
				itemIdRef.add(paramItemId);
			}
		}
		Integer[] itemIds = itemIdRef.toArray(new Integer[0]);

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());
		
		String classNameJp = interfaceData.getNameJp() + " Ɖ";
		String loggerComment = logout ? "" : "//";
		
		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("ref package", "package", packageName));
				}

				out(baos, getText("ref 1", "mstName", mstName, "classNameJp", classNameJp, "loggerComment", loggerComment));

				// Ij[}bvo
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType != null && "select".equals(controlType.getValue())) {
						out(baos, getText("ref select list map def", "name", item.getName()));
					}
				}

				out(baos, getText("ref 1.5", "mstName", mstName, "loggerComment", loggerComment));


				// IXg̍ڒ`ݒo
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && "select".equals(controlType.getValue())) {
						String zero = chars("0", (int) (item.getLength() - 1));
						out(baos, getText("ref setSelecter", "name", item.getName(), "nameJp", item.getNameJp(), "zero", zero));
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("ref setFormat start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("ref setFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));

						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("ref setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("ref setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("ref setFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}

				out(baos, getText("ref 2", "mstName", mstName));

				// L[擾
				for (InterfaceDataItem item : primaryKeyItemList) {
					setParameter("type", InterfaceTools.getVoType(item.getType(), item.getLength(), item.getSubLength()));
					out(baos, getText("ref primary key set", "name", item.getName(), "setMethodName", InterfaceTools
							.changeSetterNmae(item.getName())));
				}

				out(baos, getText("ref get record", "mstName", mstName));

				// ꗗڐݒ
				for (Integer itemId : itemIds) {

					AttributeData useList = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "useRef");
					if (useList != null && !useList.getValueBoolean()) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType == null || "nonUse".equalsIgnoreCase(controlType.getValue())) {
						continue;
					}

					if ("select".equals(controlType.getValue())) {
						out(baos, getText("ref set select data", "name", item.getName(), "getMethod", InterfaceTools
								.changeGetterNmae(item.getName(), false)));
					} else {
						out(baos, getText("ref set data", "name", item.getName(), "getMethod", InterfaceTools.changeGetterNmae(
								item.getName(), item.getType() == FieldType.BOOLEAN)));
					}
				}

				// tb^o
				out(baos, getText("ref 3", "classNameJp", classNameJp, "mstName", mstName, "loggerComment", loggerComment));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * VKJavat@CC[W쐬
	 * 
	 * @param interfaceData
	 *            C^[tF[X
	 * @param parameterItemIds
	 *            LȃC^[tF[XIDz
	 * @param packageName
	 *            pbP[W
	 * @param logout
	 *            Oo
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createInsertJava(InterfaceData interfaceData, Integer[] parameterItemIds, String packageName,
			List<InterfaceDataItem> primaryKeyItemList, boolean logout) throws IOException, InterfaceException {

		// VKʂŎgp鍀ڂ݂̂IDXg쐬
		List<Integer> itemIdIns = new LinkedList<Integer>();
		for (Integer paramItemId : parameterItemIds) {
			AttributeData useIns = interfaceData.getAttribute(paramItemId, MntHtmlFileCreator.PLUGIN_NAME, "useIns");
			if (useIns == null || useIns.getValueBoolean()) {
				itemIdIns.add(paramItemId);
			}
		}
		Integer[] itemIds = itemIdIns.toArray(new Integer[0]);

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String classNameJp = interfaceData.getNameJp() + " VK";
		String loggerComment = logout ? "" : "//";
		
		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("ins package", "package", packageName));
				}

				out(baos, getText("ins 1", "mstName", mstName, "classNameJp", classNameJp, "loggerComment", loggerComment));

				// Ij[}bvo
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType != null && "select".equals(controlType.getValue())) {
						out(baos, getText("ins select list map def", "name", item.getName()));
					}
				}


				out(baos, getText("ins 2", "mstName", mstName, "loggerComment", loggerComment));

				int checkerCount = 0;

				// `FbJ[o
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					AttributeData dokujiItemCheck = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"dokujiCheck");

					// K{`FbN
					if (controlType != null && canUseRequiredCheckCtrlSet.contains(controlType.getValue())) {

						// AttributeData required =
						// interfaceData.getAttribute(itemId,
						// DataBaseFileCreator.PLUGIN_NAME, "notNull");
						// if (required != null && required.getValueBoolean()) {

						boolean flag = false;
						if (interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
							AttributeData required = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
									"notNull");
							flag |= required != null && required.getValueBoolean();
						}

						if (interfaceData.isAttached(GaeDaoFileCreator.PLUGIN_NAME)) {
							AttributeData required = interfaceData.getAttribute(itemId, GaeDaoFileCreator.PLUGIN_NAME,
									"notNull");
							flag |= required != null && required.getValueBoolean();
						}
						if (flag) {
							checkerCount++;
							out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.required"));
						}
					}

					// ^`FbN
					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {

						if (item.getType() == FieldType.STRING) {
							if (item.getLength() > 0) {
								AttributeData underLengthNg = interfaceData.getAttribute(itemId,
										MntHtmlFileCreator.PLUGIN_NAME, "underLengthNg");

								checkerCount++;
								if (underLengthNg != null && underLengthNg.getValueBoolean()) {
									out(baos, getText("ins addCheck", "name", item.getName(), "checker",
											"new PirkaCheckerLength(PirkaCheckerLength.JUST, " + item.getLength() + ")"));
								} else {
									out(baos, getText("ins addCheck", "name", item.getName(), "checker",
											"new PirkaCheckerLength(PirkaCheckerLength.RANGE, 0, " + item.getLength() + ")"));
								}
							}

							AttributeData stringChaeck = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
									"stringChaeck");
							if (stringChaeck != null) {
								String checkStr = stringCheckerMap.get(stringChaeck.getValue());
								if (checkStr != null && checkStr.length() > 0) {
									checkerCount++;
									out(baos, getText("ins addCheck", "name", item.getName(), "checker",
											"new PirkaCheckerString(" + checkStr + ")"));
								}
							}

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								checkerCount++;
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.intValue"));
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", makeIntRangeCheck(item
										.getLength())));
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								checkerCount++;
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.longValue"));
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", makeLongRangeCheck(item
										.getLength())));
							} else {
								checkerCount++;
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.numeric"));
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", makeBigDecimalRangeCheck(
										item.getLength(), item.getSubLength())));
							}

						} else if (item.getType() == FieldType.DATE) {
							checkerCount++;
							out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.date"));

						} else if (item.getType() == FieldType.TIME) {
							checkerCount++;
							out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.time"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							checkerCount++;
							out(baos, getText("ins addCheck", "name", item.getName(), "checker", "PirkaChecker.datetime"));

						}

						if (dokujiItemCheck != null && dokujiItemCheck.getValueBoolean()) {
							checkerCount++;
							out(baos,
									getText("ins addCheck dokuji", "name", item.getName(), "checker", "PirkaChecker.datetime"));

						}

					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("ins addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("ins setOfficialFieldName start"));
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseInputDataCtrlSet.contains(controlType.getValue())) {
						out(baos, getText("ins setOfficialFieldName", "name", item.getName(), "nameJp", item.getNameJp()));
					}
				}

				out(baos, getText("ins setSelecter start"));

				// IXg̍ڒ`ݒo
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && "select".equals(controlType.getValue())) {
						String zero = chars("0", (int) (item.getLength() - 1));
						out(baos, getText("ins setSelecter", "name", item.getName(), "nameJp", item.getNameJp(), "zero", zero));
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("ins setFormat start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("ins setFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));

						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("ins setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("ins setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("ins setFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}

				out(baos, getText("ins 3", "classNameJp", classNameJp, "mstName", mstName, "loggerComment", loggerComment));

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * XVJavat@CC[W쐬
	 * 
	 * @param interfaceData
	 *            C^[tF[X
	 * @param parameterItemIds
	 *            LȃC^[tF[XIDz
	 * @param packageName
	 *            pbP[W
	 * @param logout
	 *            Oo
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createUpdateJava(InterfaceData interfaceData, Integer[] parameterItemIds, String packageName,
			List<InterfaceDataItem> primaryKeyItemList, boolean logout) throws IOException, InterfaceException {

		HashSet<Integer> itemIdsSet = new HashSet<Integer>();
		// XVʂŎgp鍀ڂ݂̂IDXg쐬
		List<Integer> itemIdUp = new LinkedList<Integer>();
		for (Integer paramItemId : parameterItemIds) {
			AttributeData controlType = interfaceData.getAttribute(paramItemId, MntHtmlFileCreator.PLUGIN_NAME, "controlType");
			if (controlType != null && !"nonUse".equals(controlType.getValue())) {
				AttributeData useUp = interfaceData.getAttribute(paramItemId, MntHtmlFileCreator.PLUGIN_NAME, "useUp");
				if (useUp == null || useUp.getValueBoolean()) {
					itemIdUp.add(paramItemId);
					itemIdsSet.add(paramItemId);
				}
			}
		}
		Integer[] itemIds = itemIdUp.toArray(new Integer[0]);

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String classNameJp = interfaceData.getNameJp() + " XV";
		String loggerComment = logout ? "" : "//";
		
		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("up package", "package", packageName));
				}

				out(baos, getText("up 1", "mstName", mstName, "classNameJp", classNameJp, "loggerComment", loggerComment));

				// Ij[}bvo
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (controlType != null && "select".equals(controlType.getValue())) {
						out(baos, getText("up select list map def", "name", item.getName()));
					}
				}

				out(baos, getText("up 2", "mstName", mstName, "loggerComment", loggerComment));

				int checkerCount = 0;

				// `FbJ[o
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					AttributeData noInputUp = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "noInputUp");
					if (noInputUp == null || noInputUp.getValueBoolean()) {
						continue;
					}

					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					AttributeData dokujiItemCheck = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"dokujiCheck");

					// K{`FbN
					if (controlType != null && canUseRequiredCheckCtrlSet.contains(controlType.getValue())) {
						// AttributeData required =
						// interfaceData.getAttribute(itemId,
						// DataBaseFileCreator.PLUGIN_NAME, "notNull");
						// if (required != null && required.getValueBoolean()) {

						boolean flag = false;
						if (interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
							AttributeData required = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
									"notNull");
							flag |= required != null && required.getValueBoolean();
						}

						if (interfaceData.isAttached(GaeDaoFileCreator.PLUGIN_NAME)) {
							AttributeData required = interfaceData.getAttribute(itemId, GaeDaoFileCreator.PLUGIN_NAME,
									"notNull");
							flag |= required != null && required.getValueBoolean();
						}
						if (flag) {
							checkerCount++;
							out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.required"));
						}
					}

					// ^`FbN
					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {

						if (item.getType() == FieldType.STRING) {
							if (item.getLength() > 0) {
								AttributeData underLengthNg = interfaceData.getAttribute(itemId,
										MntHtmlFileCreator.PLUGIN_NAME, "underLengthNg");

								checkerCount++;
								if (underLengthNg != null && underLengthNg.getValueBoolean()) {
									out(baos, getText("up addCheck", "name", item.getName(), "checker",
											"new PirkaCheckerLength(PirkaCheckerLength.JUST, " + item.getLength() + ")"));
								} else {
									out(baos, getText("up addCheck", "name", item.getName(), "checker",
											"new PirkaCheckerLength(PirkaCheckerLength.RANGE, 0, " + item.getLength() + ")"));
								}
							}

							AttributeData stringChaeck = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
									"stringChaeck");
							if (stringChaeck != null) {
								String checkStr = stringCheckerMap.get(stringChaeck.getValue());
								if (checkStr != null && checkStr.length() > 0) {
									checkerCount++;
									out(baos, getText("up addCheck", "name", item.getName(), "checker",
											"new PirkaCheckerString(" + checkStr + ")"));
								}
							}

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								checkerCount++;
								out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.intValue"));
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", makeIntRangeCheck(item
										.getLength())));
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								checkerCount++;
								out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.longValue"));
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", makeLongRangeCheck(item
										.getLength())));
							} else {
								checkerCount++;
								out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.numeric"));
								out(baos, getText("ins addCheck", "name", item.getName(), "checker", makeBigDecimalRangeCheck(
										item.getLength(), item.getSubLength())));
							}

						} else if (item.getType() == FieldType.DATE) {
							checkerCount++;
							out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.date"));

						} else if (item.getType() == FieldType.TIME) {
							checkerCount++;
							out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.time"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							checkerCount++;
							out(baos, getText("up addCheck", "name", item.getName(), "checker", "PirkaChecker.datetime"));

						}

						if (dokujiItemCheck != null && dokujiItemCheck.getValueBoolean()) {
							checkerCount++;
							out(baos, getText("up addCheck dokuji", "name", item.getName(), "checker", "PirkaChecker.datetime"));

						}

					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("up addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("up setOfficialFieldName start"));
				for (Integer itemId : itemIds) {

					AttributeData noInputUp = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "noInputUp");
					if (noInputUp == null || noInputUp.getValueBoolean()) {
						continue;
					}

					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseInputDataCtrlSet.contains(controlType.getValue())) {
						out(baos, getText("up setOfficialFieldName", "name", item.getName(), "nameJp", item.getNameJp()));
					}
				}

				out(baos, getText("up setSelecter start"));

				// IXg̍ڒ`ݒo
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && "select".equals(controlType.getValue())) {
						String zero = chars("0", (int) (item.getLength() - 1));
						out(baos, getText("up setSelecter", "name", item.getName(), "nameJp", item.getNameJp(), "zero", zero));
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("up setFormat start"));
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");

					if (controlType != null && canUseFreeInputTextCtrlSet.contains(controlType.getValue())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("up setFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));

						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("up setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("up setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("up setFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}

				out(baos, getText("up 3"));

				// f[^ݒ
				for (Integer itemId : itemIds) {

					AttributeData noInputUp = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "noInputUp");
					InterfaceDataItem item = interfaceData.getItem(itemId);
					AttributeData controlType = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME,
							"controlType");
					if (noInputUp == null || (noInputUp != null && noInputUp.getValueBoolean())) {
						if ("select".equals(controlType.getValue())) {
							out(baos, getText("up init set display only select", "name", item.getName(), "getMethod",
									InterfaceTools.changeGetterNmae(item.getName(), false)));
						} else {
							out(baos, getText("up init set display only", "name", item.getName(), "getMethod", InterfaceTools
									.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN)));
						}
					} else {
						out(baos, getText("up init set input", "name", item.getName(), "getMethod", InterfaceTools
								.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN)));
					}
				}

				out(baos, getText("up 4", "classNameJp", classNameJp, "mstName", mstName, "loggerComment", loggerComment));

				// f[^擾
				for (Integer itemId : parameterItemIds) {

					AttributeData noInputUp = interfaceData.getAttribute(itemId, MntHtmlFileCreator.PLUGIN_NAME, "noInputUp");
					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (!itemIdsSet.contains(itemId) || noInputUp == null || (noInputUp != null && noInputUp.getValueBoolean())) {
						out(baos, getText("up get value non use or display only", "setMethod", InterfaceTools
								.changeSetterNmae(item.getName()), "getMethod", InterfaceTools.changeGetterNmae(item.getName(),
								item.getType() == FieldType.BOOLEAN)));
					} else {
						switch (item.getType()) {
						case STRING:
							out(baos, getText("up get value string", "setMethod", InterfaceTools.changeSetterNmae(item
									.getName()), "name", item.getName()));
							break;
						case NUM:
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								out(baos, getText("up get value int", "setMethod", InterfaceTools.changeSetterNmae(item
										.getName()), "name", item.getName()));

							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								out(baos, getText("up get value long", "setMethod", InterfaceTools.changeSetterNmae(item
										.getName()), "name", item.getName()));
							} else {
								out(baos, getText("up get value bigdecimal", "setMethod", InterfaceTools.changeSetterNmae(item
										.getName()), "name", item.getName()));
							}
							break;
						case BOOLEAN:
							out(baos, getText("up get value boolean", "setMethod", InterfaceTools.changeSetterNmae(item
									.getName()), "name", item.getName()));
							break;
						case DATE:
							out(baos, getText("up get value date", "setMethod",
									InterfaceTools.changeSetterNmae(item.getName()), "name", item.getName()));
							break;
						case TIME:
							out(baos, getText("up get value time", "setMethod",
									InterfaceTools.changeSetterNmae(item.getName()), "name", item.getName()));
							break;
						case DATE_TIME:
							out(baos, getText("up get value timestamp", "setMethod", InterfaceTools.changeSetterNmae(item
									.getName()), "name", item.getName()));
							break;
						}
					}
				}
				out(baos, getText("up 5", "classNameJp", classNameJp, "mstName", mstName, "loggerComment", loggerComment));

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected String chars(String str, int len) {
		StringBuilder sb = new StringBuilder();

		for (int i = 0; i < len; i++) {
			sb.append(str);
		}

		return sb.toString();
	}

	protected String makeIntRangeCheck(long length) {

		String max = chars("9", (int) length);

		StringBuilder sb = new StringBuilder();
		sb.append("new PirkaCheckerNumericRange(-");
		sb.append(max);
		sb.append(", ");
		sb.append(max);
		sb.append(")");

		return sb.toString();
	}

	protected String makeLongRangeCheck(long length) {

		String max = chars("9", (int) length);

		StringBuilder sb = new StringBuilder();
		sb.append("new PirkaCheckerNumericRange(-");
		sb.append(max);
		sb.append("L, ");
		sb.append(max);
		sb.append("L)");

		return sb.toString();
	}

	protected String makeBigDecimalRangeCheck(long length, int subLength) {

		String max = "";
		StringBuilder sb = new StringBuilder();
		if (InterfaceTools.isIntType(length, 0) || InterfaceTools.isLongType(length, 0)) {

			max = chars("9", (int) length);

			sb.append("new PirkaCheckerNumericRange(BigDecimal.valueOf(-");
			sb.append(max);
			sb.append("L, ");
			sb.append(subLength);
			sb.append(")");

			sb.append(", ");
			sb.append("BigDecimal.valueOf(");
			sb.append(max);
			sb.append("L, ");
			sb.append(subLength);
			sb.append(")");
			sb.append(")");
		} else {

			if (subLength > 0) {
				max = chars("9", (int) length) + "." + chars("9", subLength);
			} else {
				max = chars("9", (int) length);
			}

			sb.append("new PirkaCheckerNumericRange(new BigDecimal(\"-");
			sb.append(max);
			sb.append("\")");

			sb.append(", ");
			sb.append("new BigDecimal(\"");
			sb.append(max);
			sb.append("\")");
			sb.append(")");
		}
		return sb.toString();
	}

}
