package jp.oarts.pirka.iop.tool.core.plugin.file.vo;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.TreeMap;
import java.util.TreeSet;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.IncludeInfo;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.VirtualDbTableFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * zf[^[x[Xe[upo[IuWFNgJava\[Xt@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class ValueObjectJavaFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.file#ValueObjectJavaFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "Value Object Java\[Xt@Co";

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//

			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),

	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public ValueObjectJavaFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "Value Object Java\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "";
	}

	@Override
	public String getParameterComment() {
		return "Value Object Java\[Xt@Co͂܂B\n" //
				+ "w"+VirtualDbTableFileCreator.PLUGIN_NAME_JP + "xA^b`ĂƂ\n" //
				+ "fpValue Object Java\[Xt@Co͂܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;

		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			// zf[^x[Xe[uA^b`Ă琮`FbNs
			if (interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
				IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);
			}
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		String packageName = dataMap.get("package").getValue();
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);
		if (interfaceData == null) {
			throw new InterfaceException("C^[tF[X̎擾Ɏs܂");
		}

		boolean virtualFlag = interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME);
		boolean daoFlag = interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME);

		// R[h̃CN[hID߂
		// int multiRecordsIncludeId = -1;
		TreeMap<Integer, Integer> includeId2InterfaceDataIdMap = new TreeMap<Integer, Integer>();
		TreeMap<Integer, Integer> includeId2RecNoMap = new TreeMap<Integer, Integer>();
		TreeMap<Integer, String> includeId2ListNameMap = new TreeMap<Integer, String>();
		TreeMap<Integer, String> includeId2ListNameJpMap = new TreeMap<Integer, String>();
		HashSet<Integer> multiReacordOncludeIdSet = new HashSet<Integer>();
		List<Integer> primaryKeyItemIdList = new LinkedList<Integer>();
		TreeMap<String, TreeSet<String>> changeFieldTypeMethodMap = new TreeMap<String, TreeSet<String>>();

		// zf[^x[Xe[uA^b`Ă牼zVOp̊e쐬
		int recNo = 0;
		// int listNo = 0;
		if (virtualFlag) {
			// for (Integer itemId : interfaceData.getEnableItemIdList()) {
			for (Integer itemId : interfaceData.getAllItemIdList()) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (item.isBaseItem()) {
					continue;
				}

				// zf[^x[Xe[ủzL[Xgɒǉ
				if (item.isEnable()) {
					AttributeData primaryKey = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
							VirtualDbTableFileCreator.PRIMARY_KEY_ATTACH_NAME);
					if (primaryKey != null && primaryKey.getValueBoolean()) {
						primaryKeyItemIdList.add(itemId);
					}
				}

				// NIvV
				AttributeData linkOption = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.LINK_OPTION_TYPE_ATTACH_NAME);
				if (linkOption != null && VirtualDbTableFileCreator.LINK_TYPE_MULTI_SET.contains(linkOption.getValue())) {
					if (!multiReacordOncludeIdSet.contains(item.getIncludeId())) {
						multiReacordOncludeIdSet.add(item.getIncludeId());
					}
				}
			}

			for (Integer itemId : interfaceData.getAllItemIdList()) {
				InterfaceDataItem item = interfaceData.getItem(itemId);
				if (item.isBaseItem()) {
					continue;
				}

				if (multiReacordOncludeIdSet.contains(item.getIncludeId())) {
					// NIvV
					AttributeData linkNo = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
							VirtualDbTableFileCreator.LINK_NO_ATTACH_NAME);
					if (linkNo != null && linkNo.getValue().length() > 0 && !"00".equals(linkNo.getValue())) {
						if (!includeId2ListNameMap.containsKey(item.getIncludeId())) {
							includeId2ListNameMap.put(item.getIncludeId(), item.getName());
							includeId2ListNameJpMap.put(item.getIncludeId(), item.getNameJp());
						}
					}
				}
			}

			for (IncludeInfo incInfo : interfaceData.getIncludeIfoList()) {
				includeId2InterfaceDataIdMap.put(incInfo.getIncludeId(), incInfo.getIncludeDataId());
			}

			for (Integer incId : includeId2InterfaceDataIdMap.keySet()) {
				if (!includeId2ListNameMap.containsKey(incId)) {
					includeId2RecNoMap.put(incId, ++recNo);
				}
			}
		} else if (daoFlag) {

			for (Integer itemId : interfaceData.getEnableItemIdList()) {
				// L[Xgɒǉ
				AttributeData primaryKey = interfaceData.getAttribute(itemId, DataBaseFileCreator.PLUGIN_NAME,
						DataBaseFileCreator.PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					primaryKeyItemIdList.add(itemId);
				}
			}
		}

		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;

		Integer[] itemIds = interfaceData.getAllItemIdList();

		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("package", "package", packageName));
				}

				// C|[go&o
				boolean incBigDecimal = false;
				boolean incDate = false;
				boolean incTime = false;
				boolean incTimestamp = false;
				for (Integer itemId : itemIds) {
					InterfaceDataItem item = interfaceData.getItem(itemId);

					// R[h͑ΏۊOƂ
					if (!item.isEnable() || !item.isBaseItem() && includeId2ListNameMap.containsKey(item.getIncludeId())) {
						continue;
					}

					switch (item.getType()) {
					case NUM:
						if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
							incBigDecimal = true;
						}
						break;
					case DATE:
						incDate = true;
						break;
					case TIME:
						incTime = true;
						break;
					case DATE_TIME:
						incTimestamp = true;
						break;
					}
				}
				if (incBigDecimal) {
					out(baos, getText("header BigDecimal"));
				}
				if (incDate) {
					out(baos, getText("header Date"));
				}
				if (incTime) {
					out(baos, getText("header Time"));
				}
				if (incTimestamp) {
					out(baos, getText("header Timestamp"));
				}
				if (includeId2ListNameMap.size() > 0) {
					out(baos, getText("header multi"));
				}

				// wb_o
				out(baos, getText("header", "className", className, "nameJp", interfaceData.getNameJp()));

				// oϐ`o
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (item.isEnable() || (!item.isBaseItem() && includeId2ListNameMap.containsKey(item.getIncludeId()))) {

						String type = InterfaceTools.getVoType(item.getType(), item.getLength(), item.getSubLength());
						if (item.isBaseItem() || !virtualFlag) {
							out(baos, getText("body define", "type", type, "name", item.getName(), "nameJp", item.getNameJp()));
						} else {
							String comment = "";
							InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
									includeId2InterfaceDataIdMap.get(item.getIncludeId()));
							String memItemName = memIfData.getItem(item.getIncludeItemId()).getName();

							if (!includeId2ListNameMap.containsKey(item.getIncludeId())) {
								recNo = includeId2RecNoMap.get(item.getIncludeId());
								comment = InterfaceTools.createRecName(recNo) + "." + memItemName;
								out(baos, getText("body define comment", "type", type, "name", item.getName(), "nameJp", item
										.getNameJp(), "comment", comment));
							}

						}
					}
				}

				int count = 0;
				if (virtualFlag) {
					// oϐR[h`o R[h
					for (Integer incId : includeId2InterfaceDataIdMap.keySet()) {

						InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(incId));

						if (includeId2ListNameMap.containsKey(incId)) {
							out(baos, getText("body define", //
									"type", "List<" + InterfaceTools.changeClassNmae(memIfData.getName()) + ">", //
									"name", includeId2ListNameMap.get(incId) + " = new LinkedList<"
											+ InterfaceTools.changeClassNmae(memIfData.getName()) + ">()", //
									"nameJp", " Xgi" + memIfData.getNameJp() + "j"));
						}
					}

					// oϐR[h`o
					for (Integer incId : includeId2InterfaceDataIdMap.keySet()) {

						InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(incId));

						if (!includeId2ListNameMap.containsKey(incId)) {

							if (count++ <= 0) {
								out(baos, getText("body define ---"));
							}

							recNo = includeId2RecNoMap.get(incId);
							out(baos, getText("body define record", "type",
									InterfaceTools.changeClassNmae(memIfData.getName()), "name", InterfaceTools
											.createRecName(recNo), "nameJp", memIfData.getNameJp()));
						}
					}
				}

				// RXgN^o
				out(baos, getText("body constructor", "className", className, "nameJp", interfaceData.getNameJp()));

				// toString\bho
				out(baos, getText("body toString 1"));
				if (includeId2ListNameMap.size() > 0) {
					out(baos, getText("body toString 1.2"));
				}
				out(baos, getText("body toString 1.5"));

				count = 0;
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);

					if (item.isEnable()) {
						if (item.isBaseItem()
								|| (!item.isBaseItem() && !includeId2ListNameMap.containsKey(item.getIncludeId()))) {

							if (count++ > 0) {
								out(baos, getText("body toString 3"));
							}

							if (item.isBaseItem() || !virtualFlag) {
								switch (item.getType()) {
								case STRING:
									setParameter("value", item.getName());
									break;
								case BOOLEAN:
									setParameter("value", item.getName());
									break;
								case DATE:
									setParameter("value", item.getName());
									break;
								case TIME:
									setParameter("value", item.getName());
									break;
								case DATE_TIME:
									setParameter("value", item.getName());
									break;
								case IMAGE:
									setParameter("value", item.getName() + " == null ? \"null\" : \"length=\" + "
											+ item.getName() + ".length");
									break;
								case NUM:
									setParameter("value", item.getName());
									break;
								default:
									setParameter("value", "\"-\"");
								}

							} else {

								String getterMethod = InterfaceTools.changeGetterNmae(item.getName(),
										item.getType() == FieldType.BOOLEAN);

								switch (item.getType()) {
								case STRING:
									setParameter("value", getterMethod + "()");
									break;
								case BOOLEAN:
									setParameter("value", getterMethod + "()");
									break;
								case DATE:
									setParameter("value", getterMethod + "()");
									break;
								case TIME:
									setParameter("value", getterMethod + "()");
									break;
								case DATE_TIME:
									setParameter("value", getterMethod + "()");
									break;
								case IMAGE:
									setParameter("value", getterMethod + "() == null ? \"null\" : \"length=\" + "
											+ getterMethod + "()" + ".length");
									break;
								case NUM:
									setParameter("value", getterMethod + "()");
									break;
								default:
									setParameter("value", "\"-\"");
								}
							}
							out(baos, getText("body toString 2", "name", item.getName(), "nameJp", item.getNameJp()));
						}
					}
				}

				for (Integer includeId : includeId2ListNameMap.keySet()) {
					if (count++ > 0) {
						out(baos, getText("body toString 3"));
					}
					InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(includeId));

					out(baos, getText("body toString 2-multi", //
							"nameJp", "" + includeId2ListNameJpMap.get(includeId), //
							"name", includeId2ListNameMap.get(includeId), //
							"listClassName", InterfaceTools.changeClassNmae(memIfData.getName())));
				}

				out(baos, getText("body toString 4"));

				// Qb^[AZb^[\bho tB[h
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.isEnable()) {
						if (item.isBaseItem()
								|| (!item.isBaseItem() && !includeId2ListNameMap.containsKey(item.getIncludeId()))) {

							String type = InterfaceTools.getVoType(item.getType(), item.getLength(), item.getSubLength());

							String getterMethod = InterfaceTools.changeGetterNmae(item.getName(),
									item.getType() == FieldType.BOOLEAN);
							String setterMethod = InterfaceTools.changeSetterNmae(item.getName());

							String name = "";
							String setName = "";
							String returnName = "";
							if (item.isBaseItem() || !virtualFlag) {
								name = item.getName();
								setName = "this." + item.getName() + " = " + item.getName();
								returnName = item.getName();

								out(baos, getText("body setter getter", "name", name, "nameJp", item.getNameJp(), "type", type,
										"getterMethod", getterMethod, "setterMethod", setterMethod, "setName", setName,
										"returnName", returnName));
							} else {

								if (includeId2ListNameMap.containsKey(item.getIncludeId())) {
									continue;
								}

								InterfaceData baseIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
										item.getIncludeDataId());
								InterfaceDataItem baseItem = baseIfData.getItem(item.getIncludeItemId());
								String baseName = baseItem.getName();
								name = item.getName();
								String baseType = InterfaceTools.getVoType(baseItem.getType(), baseItem.getLength(), baseItem
										.getSubLength());
								if (type.equals(baseType)) {
									returnName = InterfaceTools.createRecName(includeId2RecNoMap.get(item.getIncludeId()))
											+ " == null ? null : "
											+ InterfaceTools.createRecName(includeId2RecNoMap.get(item.getIncludeId())) + "."
											+ InterfaceTools.changeGetterNmae(baseName, item.getType() == FieldType.BOOLEAN)
											+ "()";

									setName = InterfaceTools.createRecName(includeId2RecNoMap.get(item.getIncludeId())) + "."
											+ InterfaceTools.changeSetterNmae(baseName) + "(" + item.getName() + ")";

								} else {
									returnName = InterfaceTools.getFieldChangeMethodName(item.getType(), item.getLength(), item
											.getSubLength()) //
											+ "("
											+ InterfaceTools.createRecName(includeId2RecNoMap.get(item.getIncludeId()))
											+ " == null ? null : "
											+ InterfaceTools.createRecName(includeId2RecNoMap.get(item.getIncludeId()))
											+ "."
											+ InterfaceTools
													.changeGetterNmae(baseName, baseItem.getType() == FieldType.BOOLEAN)
											+ "())";

									setName = InterfaceTools.createRecName(includeId2RecNoMap.get(item.getIncludeId())) + "."
											+ InterfaceTools.changeSetterNmae(baseName)
											+ "(" //
											+ InterfaceTools.getFieldChangeMethodName(baseItem.getType(), baseItem.getLength(),
													baseItem.getSubLength()) + "(" + item.getName() + "))";

									TreeSet<String> wkSet = null;
									if (changeFieldTypeMethodMap.containsKey(type)) {
										wkSet = changeFieldTypeMethodMap.get(type);
									} else {
										wkSet = new TreeSet<String>();
										changeFieldTypeMethodMap.put(type, wkSet);
									}
									wkSet.add(baseType);

									if (changeFieldTypeMethodMap.containsKey(baseType)) {
										wkSet = changeFieldTypeMethodMap.get(baseType);
									} else {
										wkSet = new TreeSet<String>();
										changeFieldTypeMethodMap.put(baseType, wkSet);
									}
									wkSet.add(type);
								}

								String recordType = InterfaceTools.changeClassNmae(baseIfData.getName());

								out(baos, getText("body setter getter2", "name", name, "nameJp", item.getNameJp(), "type",
										type, "getterMethod", getterMethod, "setterMethod", setterMethod, "setName", setName,
										"returnName", returnName, "recordName", InterfaceTools.createRecName(includeId2RecNoMap
												.get(item.getIncludeId())), "recordType", recordType));
							}
						}
					}
				}

				// R[h̃Xg擾Eݒp
				for (Integer includeId : includeId2ListNameMap.keySet()) {
					InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							includeId2InterfaceDataIdMap.get(includeId));
					String recordName = includeId2ListNameMap.get(includeId);
					out(baos, getText("MultiMember", //
							"name", recordName, //
							"nameJp", includeId2ListNameJpMap.get(includeId), //
							"listClassName", InterfaceTools.changeClassNmae(memIfData.getName()), //
							"getter", InterfaceTools.changeGetterNmae(recordName, false), //
							"recordName", recordName));
				}

				// Qb^[AZb^[\bho R[h
				// oϐR[h`o
				if (virtualFlag) {
					for (Integer incId : includeId2InterfaceDataIdMap.keySet()) {
						InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(incId));
						if (!includeId2ListNameMap.containsKey(incId)) {
							recNo = includeId2RecNoMap.get(incId);

							String name = InterfaceTools.createRecName(recNo);
							String getterMethod = InterfaceTools.changeGetterNmae(name, false);
							;
							String setterMethod = InterfaceTools.changeSetterNmae(name);
							String setName = "this." + name + " = " + name;
							String returnName = name;
							String type = "";

							type = InterfaceTools.changeClassNmae(memIfData.getName());
							out(baos, getText("body setter getter", "name", name, "nameJp", "R[h" + recNo + ":"
									+ memIfData.getNameJp(), "type", type, "getterMethod", getterMethod, "setterMethod",
									setterMethod, "setName", setName, "returnName", returnName));
						}
					}
				}

				// L[r
				if (primaryKeyItemIdList.size() > 0) {
					out(baos, getText("equalsPrimaryKeys start", "className", className));
					for (Integer itemId : primaryKeyItemIdList) {

						InterfaceDataItem item = interfaceData.getItem(itemId);
						String getterName = InterfaceTools
								.changeGetterNmae(item.getName(), item.getType() == FieldType.BOOLEAN);
						String comp = InterfaceTools.getVoComp(item.getType(), item.getLength(), item.getSubLength(), "target",
								getterName + "()");

						out(baos, getText("equalsPrimaryKeys main", "fieldNameJp", item.getNameJp(), "comp", comp,
								"getterName", getterName));

					}
					out(baos, getText("equalsPrimaryKeys end"));
				}

				// N[
				out(baos, getText("clone", "type", className));
				for (Integer itemId : itemIds) {

					InterfaceDataItem item = interfaceData.getItem(itemId);
					if (item.isEnable()) {
						if (item.isBaseItem() || !virtualFlag) {
							out(baos, getText("clone 1", "name", item.getName(), "cloneName", InterfaceTools.getVoClone(item
									.getType(), item.getLength(), item.getSubLength(), item.getName())));
						}
					}
				}

				if (virtualFlag) {
					for (Integer incId : includeId2InterfaceDataIdMap.keySet()) {
						InterfaceData memIfData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								includeId2InterfaceDataIdMap.get(incId));

						if (includeId2ListNameMap.containsKey(incId)) {
							out(baos, getText("clone 3", //
									"name", includeId2ListNameMap.get(incId), //
									"type", InterfaceTools.changeClassNmae(memIfData.getName())));
						} else {
							recNo = includeId2RecNoMap.get(incId);
							String name = InterfaceTools.createRecName(recNo);
							out(baos, getText("clone 2", "name", name, "type", InterfaceTools.changeClassNmae(memIfData
									.getName())));
						}
					}
				}
				out(baos, getText("clone 4"));

				// tB[hϊ\bho
				for (String type : changeFieldTypeMethodMap.keySet()) {
					for (String baseType : changeFieldTypeMethodMap.get(type)) {
						out(baos, getText("change field type " + type + "-" + baseType));
					}
				}

				// tb^o
				out(baos, getText("footer"));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return new AttributeFileImage(className + ".java", baos.toByteArray());

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}
}
