package jp.oarts.pirka.iop.tool.core.plugin.file.webapp;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeChecker;
import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.AttributeSimpleItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.AttributeType;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.VirtualDbTableFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;
import jp.oarts.pirka.iop.tool.core.tools.text.HtmlTextCreator;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * zf[^[x[Xe[upo[IuWFNgJava\[Xt@C쐬Et@CNG[^[vOC
 *
 * @author ito
 *
 */
public class WebAppFileCreator extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.pirka.iop.tool.core.plugin.file.webapp.WebAppFileCreator";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "WEBAvP[V HTMLt@CEJava\[Xt@Co";

	// public static final String FIELD_TYPE_NONE = "none";

	public static final String FIELD_TYPE_TEXT = "text";

	public static final String FIELD_TYPE_TEXTAREA = "textarea";

	public static final String FIELD_TYPE_SELECT = "select";

	public static final String FIELD_TYPE_RADIOBUTTON = "radiobutton";

	public static final String FIELD_TYPE_CHECKBOX = "checkbox";

	public static final String CHECK_NUM = "numCheck";
	public static final String CHECK_A = "ACheck";
	public static final String CHECK_a = "aCheck";
	public static final String CHECK_Aa = "AaCheck";
	public static final String CHECK_NUM_A = "numACheck";
	public static final String CHECK_NUM_a = "numaCheck";
	public static final String CHECK_NUM_Aa = "numAaCheck";
	public static final String CHECK_ALL_HANKAKU = "allHankakuCheck";
	public static final String CHECK_ALL_ZENKAKU = "allZenkakuCheck";
	public static final String CHECK_HANKAKU_KATAKANA = "hankakuKatakanaCheck";
	public static final String CHECK_ZENKAKU_KATAKANA = "zenkakuKatakanaCheck";
	public static final String CHECK_ZENKAKU_HIRAGANA = "zenkakuHiraganaCheck";
	public static final String CHECKNINNI_STRING = "ninniStringChek";

	private static final String MODE_MARK_STR = "<!-- $! ";
	private static final String MODE_MARK_END_STR = "-->";

	private static final String SELECT_MARK_REFERENCE = "ref";
	private static final String SELECT_MARK_UPDATEE = "upd";
	private static final String SELECT_MARK_INSERT = "ins";

	private enum Crud {
		ref, ins, upd
	}

	private static final HashSet<String> canUseInputDataCtrlSet = new HashSet<String>();
	private static final HashSet<String> canUseRequiredCheckCtrlSet = new HashSet<String>();
	private static final HashMap<String, String> stringCheckerMap = new HashMap<String, String>();
	private static final HashSet<String> canUseFreeInputTextCtrlSet = new HashSet<String>();

	static {

		canUseInputDataCtrlSet.add(FIELD_TYPE_TEXT);
		canUseInputDataCtrlSet.add(FIELD_TYPE_TEXTAREA);
		canUseInputDataCtrlSet.add(FIELD_TYPE_SELECT);
		canUseInputDataCtrlSet.add(FIELD_TYPE_CHECKBOX);
		//
		canUseRequiredCheckCtrlSet.add(FIELD_TYPE_TEXT);
		canUseRequiredCheckCtrlSet.add(FIELD_TYPE_TEXTAREA);
		canUseRequiredCheckCtrlSet.add(FIELD_TYPE_SELECT);

		canUseFreeInputTextCtrlSet.add(FIELD_TYPE_TEXT);
		canUseFreeInputTextCtrlSet.add(FIELD_TYPE_TEXTAREA);

		stringCheckerMap.put(CHECK_NUM, "PirkaCheckerStringChars.NUM");
		stringCheckerMap.put(CHECK_A, "PirkaCheckerStringChars.HIGHT_ALPHABET");
		stringCheckerMap.put(CHECK_a, "PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put(CHECK_Aa, "PirkaCheckerStringChars.HIGHT_ALPHABET, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put(CHECK_NUM_A, "PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.HIGHT_ALPHABET");
		stringCheckerMap.put(CHECK_NUM_a, "PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put(CHECK_NUM_Aa,
				"PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.HIGHT_ALPHABET, PirkaCheckerStringChars.LOW_ALPHABET");
		stringCheckerMap.put(CHECK_ALL_HANKAKU, "PirkaCheckerStringChars.HALF");
		stringCheckerMap.put(CHECK_ZENKAKU_KATAKANA, "PirkaCheckerStringChars.WIDE");
		stringCheckerMap.put(CHECK_HANKAKU_KATAKANA, "PirkaCheckerStringChars.HARF_KANA");
		stringCheckerMap.put(CHECK_ZENKAKU_KATAKANA, "PirkaCheckerStringChars.WIDE_KATAKANA");
		stringCheckerMap.put(CHECK_ZENKAKU_HIRAGANA, "PirkaCheckerStringChars.WIDE_HIRAGANA");
		stringCheckerMap.put(CHECKNINNI_STRING, "new PirkaCheckerStringChars(\"͓͂镶ɒuĂ\")");
		//
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //
			//
			new AttributeSimpleItem("controlType", "Rg[^Cv", "WEBʏł̃Rg[̃^CvI܂", AttributeType.SELECT, 0,
					new AttributeData(FIELD_TYPE_TEXT), new AttributeChecker() {

						@Override
						public void check(String value, InterfaceDataItem item) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("Iĉ");
							}

							if (item.getType() == FieldType.STRING) {
								if (!FIELD_TYPE_TEXT.equals(value) && !FIELD_TYPE_TEXTAREA.equals(value)
										&& !FIELD_TYPE_SELECT.equals(value) && !FIELD_TYPE_RADIOBUTTON.equals(value)) {
									throw new InterfaceException("gpłȂRg[ݒ肳Ă܂");
								}
								if (item.getLength() <= 0) {
									throw new InterfaceException("ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
								}
							}

							if (item.getType() == FieldType.NUM) {
								// if (!FIELD_TYPE_TEXT.equals(value) ) {
								if (!FIELD_TYPE_TEXT.equals(value) && !FIELD_TYPE_TEXTAREA.equals(value)
										&& !FIELD_TYPE_SELECT.equals(value) && !FIELD_TYPE_RADIOBUTTON.equals(value)) {
									throw new InterfaceException("gpłȂRg[ݒ肳Ă܂");
								}
								if (item.getLength() <= 0) {
									throw new InterfaceException("ڒKvȍڂ0ȉ̒lݒ肳Ă܂");
								}
								if (item.getLength() < item.getSubLength()) {
									throw new InterfaceException("Ŝ̌傫lڂ܂");
								}
							}

							if (item.getType() == FieldType.DATE) {
								if (!FIELD_TYPE_TEXT.equals(value)) {
									throw new InterfaceException("tڂɎgpłȂRg[ݒ肳Ă܂");
								}
							}

							if (item.getType() == FieldType.TIME) {
								if (!FIELD_TYPE_TEXT.equals(value)) {
									throw new InterfaceException("ԍڂɎgpłȂRg[ݒ肳Ă܂");
								}
							}

							if (item.getType() == FieldType.DATE_TIME) {
								if (!FIELD_TYPE_TEXT.equals(value)) {
									throw new InterfaceException("ڂɎgpłȂRg[ݒ肳Ă܂");
								}
							}

							if (item.getType() == FieldType.BOOLEAN) {
								if (!FIELD_TYPE_CHECKBOX.equals(value)) {
									throw new InterfaceException("^UڂɎgpłȂRg[ݒ肳Ă܂");
								}
							}

							if (item.getType() == FieldType.IMAGE) {
								throw new InterfaceException("C[WڂgpĂ܂");
							}
						}
					},
					//
					new Selecter(FIELD_TYPE_TEXT, "eLXg"),
					//
					new Selecter(FIELD_TYPE_TEXTAREA, "seLXg"),
					//
					new Selecter(FIELD_TYPE_SELECT, "Ij["),
					//
					new Selecter(FIELD_TYPE_RADIOBUTTON, "W{{^"),
					//
					new Selecter(FIELD_TYPE_CHECKBOX, "`FbN")
			//
			),

			new AttributeSimpleItem("search", "", "ꗗ\ʂł̌w肵Ă", AttributeType.SELECT, 0, new AttributeData(
					"nouse"), null,
			//
					new Selecter("nouse", ""), new Selecter("equals", ""), new Selecter("like", "Ov")
			//
			),
			//
			new AttributeSimpleItem("useList", "ꗗ", "ꗗ\ʂŎgpƂ̓`FbN܂", AttributeType.CHECK, new AttributeData(true), null),
			new AttributeSimpleItem("useRef", "Ɖ", "ƉʂŎgpƂ̓`FbN܂", AttributeType.CHECK, new AttributeData(true), null),
			new AttributeSimpleItem("useIns", "VK", "VKʂŎgpƂ͓͂܂͕\݂̂I܂", AttributeType.SELECT, 0, new AttributeData(
					"input"), null, //
					new Selecter("", ""), new Selecter("input", ""), new Selecter("display", "\")

			),
			new AttributeSimpleItem("useUp", "C", "CʂŎgpƂ͓͂܂͕\݂̂I܂", AttributeType.SELECT, 0, new AttributeData(
					"input"), null, //
					new Selecter("", ""), new Selecter("input", ""), new Selecter("display", "\")),
			//
			new AttributeSimpleItem("autoRowNo", "sԍ", "s̕\ɎIɍsԍi[ƂɃ`FbN܂B`FbNsƕs\ɂ͎Iɓ͋֎~ƂȂ܂B",
					AttributeType.CHECK, new AttributeData(false), null),
			//
			new AttributeSimpleItem("required", "K{͍", "K{͍ڂ̂Ƃ̓`FbN܂", AttributeType.CHECK, new AttributeData(false),
					null),
			//
			new AttributeSimpleItem("underLengthNg", "ڒ̓G[", "͎ɍڒɖȂ͂G[ƂƂ̓`FbN܂", AttributeType.CHECK,
					new AttributeData(false), null),
			//
			new AttributeSimpleItem("stringChaeck", "͎̃`FbN", "͂̎ɍs`FbNw肵Ă", AttributeType.SELECT, 0,
					new AttributeData("noCheck"), null,
					//
					new Selecter("noCheck", "`FbNȂ"), new Selecter(CHECK_NUM, "p"),
					//
					new Selecter(CHECK_A, "pp啶"), new Selecter(CHECK_a, "pp"), new Selecter(CHECK_Aa, "pp"),
					//
					new Selecter(CHECK_NUM_A, "pp啶"), new Selecter(CHECK_NUM_a, "pp"), new Selecter(CHECK_NUM_Aa,
							"pp"),
					//
					new Selecter(CHECK_ALL_HANKAKU, "SĂ̔p"), new Selecter(CHECK_ZENKAKU_KATAKANA, "SĂ̑Sp"),
					//
					new Selecter(CHECK_HANKAKU_KATAKANA, "pJ^Ji"), new Selecter(CHECK_ZENKAKU_KATAKANA, "SpJ^Ji"),
					//
					new Selecter(CHECK_ZENKAKU_HIRAGANA, "SpЂ炪"), new Selecter(CHECKNINNI_STRING, "Cӂ̕i\[XɃTvj")

			//
			),
			//
			new AttributeSimpleItem("dokujiCheck", "Ǝ`FbJ[t", "Ǝ̃`FbJ[𗘗pƂɃ`FbN܂ \[XR[hɓƎ`FbJ[̐`}܂",
					AttributeType.CHECK, new AttributeData(false), null),
			//
			new AttributeSimpleItem("selectListName", "IXgNX",
					"Rg[^CvIj[AWI{^̎ɑIڂ擾IXgpJava\[XEt@CNG[^[vOCō쐬NX͂gNXw肵܂B",
					AttributeType.TEXT, new AttributeData(""), null),

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //
	//
			new ParameterSimpleItem("searcherInterface", "ɎgpDAO̓T[`[DAOC^[tF[X", "ɎgpDAO̓T[`[DAÕC^[tF[Xw肵܂",
					ParameterType.INTERFACE, 0, null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("searcherHtmlFile", "p`HTMLt@C(C)", "p̐`HTMLt@CAbv[h܂Bw莞̓ftHg̐`gp܂B",
					ParameterType.FILE, null, null),
			//
			new ParameterSimpleItem("targetInterface", "VKECEƉE폜sDAO̓fC^[tF[X", "VKECEƉE폜sDAO̓f̃C^[tF[Xw肵܂",
					ParameterType.INTERFACE, 0, null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("targetHtmlFile", "VKECEƉE폜p`HTMLt@C(C)",
					"VKECEƉE폜p̐`HTMLt@CAbv[h܂Bw莞̓ftHg̐`gp܂B", ParameterType.FILE, null, null),
			//
			new ParameterSimpleItem("charSet", "`t@C̕R[h(C)", "`t@C̕R[hw肵܂", ParameterType.SELECT,
					new ParameterData("Shift-JIS"), null, //
					new Selecter("Shift-JIS", "Shift-JIS"), new Selecter("EUC", "EUC"), new Selecter("UTF-8", "UTF-8")), //
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			new ParameterSimpleItem("logout", "Oo̓R[ht",
					"샍OAÕOo̓R[hgݍ݂ƂɃ`FbN܂", ParameterType.CHECK, new ParameterData(true),
					null),
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public WebAppFileCreator() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.FILE_CREATOR, true, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "WEBAvP[V HTMLt@CEJava\[Xt@Co͂܂";
	}

	@Override
	public String getAttributeComment() {
		return "WEBAvP[V HTMLt@CEJava\[Xt@Co͂܂";
	}

	@Override
	public String getParameterComment() {
		return "WEBAvP[Vp HTMLt@CEJava\[Xt@Co͂܂B\n" //
				+ "ɎgpDAO̓T[`[DAOC^[tF[XƐVKECEƉE폜sfC^[tF[X\n" //
				+ "L[͌^yѕڂ\ĂƂ͂̏ԂłȂ΂Ȃ܂B\n" //
				+ "ɎgpDAO̓T[`[DAOC^[tF[XAVKECEƉE폜sfC^[tF[X͋\n" + //
				"w" + VirtualDbTableFileCreator.PLUGIN_NAME_JP + "xA\n" //
				+ "܂́w" + DataBaseFileCreator.PLUGIN_NAME_JP + "x\n" //
				+ "ǂ炩Ɓw" + PLUGIN_NAME_JP + "x\nAb^`ĂKv܂B";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData searcherInterfaceId = dataMap.get("searcherInterface");
		InterfaceData searchInterfaceData = null;

		if (searcherInterfaceId != null) {
			searchInterfaceData = interfaceProject.getInterfaceDataManager()
					.getInterfaceData(searcherInterfaceId.getValueInt());

			if (!searchInterfaceData.isAttached(PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽɎgpDAO̓T[`[DAOC^[tF[Xɂ́w" + PLUGIN_NAME_JP + "xAb^b`Kv܂");
			}

			// zf[^x[Xe[uA^b`Ă琮`FbNs
			if (searchInterfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
				IopUtil.checkAttach(searcherInterfaceId.getValueInt(), interfaceProject);
			} else if (!searchInterfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽɎgpDAO̓T[`[DAOC^[tF[Xɂ́w" //
						+ VirtualDbTableFileCreator.PLUGIN_NAME_JP + "x܂" + "w"
						+ DataBaseFileCreator.PLUGIN_NAME_JP
						+ "xAb^b`Kv܂");
			}
		}

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		InterfaceData interfaceData = null;

		if (targetInterfaceId != null) {
			interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId.getValueInt());

			if (!interfaceData.isAttached(PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽVKECEƉE폜sfC^[tF[Xɂ́w" + PLUGIN_NAME_JP + "xAb^b`Kv܂");
			}

			// zf[^x[Xe[uA^b`Ă琮`FbNs
			if (interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
				IopUtil.checkAttach(targetInterfaceId.getValueInt(), interfaceProject);
			} else if (!interfaceData.isAttached(DataBaseFileCreator.PLUGIN_NAME)) {
				throw new InterfaceException("w肳ꂽVKECEƉE폜sfC^[tF[Xɂ́w" //
						+ VirtualDbTableFileCreator.PLUGIN_NAME_JP + "x܂" + "w"
						+ DataBaseFileCreator.PLUGIN_NAME_JP
						+ "xAb^b`Kv܂");
			}
		}

	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {

		int searcherInterfaceId = dataMap.get("searcherInterface").getValueInt();
		InterfaceData searcherInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(searcherInterfaceId);

		boolean modelFlagSearcher = false;
		if (searcherInterfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			modelFlagSearcher = true;
		}

		int targetInterfaceId = dataMap.get("targetInterface").getValueInt();
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceId);

		boolean modelFlag = false;
		if (interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			modelFlag = true;
		}



		String charSet = dataMap.get("charSet").getValue();
		String packageName = dataMap.get("package").getValue();
		boolean logout = dataMap.get("logout").getValueBoolean();
		setCommonParameter("loggerComment", logout ? "" : "//");

		ParameterData searcherHtmlFileParam = dataMap.get("searcherHtmlFile");
		String searcherHtmlFile = searcherHtmlFileParam.getValue();

		ParameterData targetHtmlFileParam = dataMap.get("targetHtmlFile");
		String targetHtmlFile = targetHtmlFileParam.getValue();

		List<ItemInfo> searcherItemInfoList = new LinkedList<ItemInfo>();
		List<InterfaceDataItem> searcherPrimaryKeyItemList = new LinkedList<InterfaceDataItem>();
		createSearcherItemInfo(dataMap, searcherItemInfoList, searcherPrimaryKeyItemList, interfaceProject);

		List<ItemInfo> itemInfoList = new LinkedList<ItemInfo>();
		List<InterfaceDataItem> primaryKeyItemList = new LinkedList<InterfaceDataItem>();
		createItemInfo(dataMap, itemInfoList, primaryKeyItemList, interfaceProject);

		String searcherClassName = InterfaceTools.changeClassNmae(searcherInterfaceData.getName());
		String className = InterfaceTools.changeClassNmae(interfaceData.getName());

		HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();
		try {

			HtmlTextCreator searchHtmlText;
			if (targetHtmlFile == null || targetHtmlFile.length() <= 0) {
				String fileName = "/" + getClass().getPackage().getName().replace('.', '/')
						+ "/WebAppFileCreatorDefaultSearch.html";
				searchHtmlText = new HtmlTextCreator(fileName, "UTF-8");
			} else {
				searchHtmlText = new HtmlTextCreator(searcherHtmlFileParam.getFileImage(), charSet);
			}

			HtmlTextCreator crudHtmlText;
			if (targetHtmlFile == null || targetHtmlFile.length() <= 0) {
				String fileName = "/" + getClass().getPackage().getName().replace('.', '/')
						+ "/WebAppFileCreatorDefaultCrud.html";
				crudHtmlText = new HtmlTextCreator(fileName, "UTF-8");
			} else {
				crudHtmlText = new HtmlTextCreator(targetHtmlFileParam.getFileImage(), charSet);
			}

			fileMap.put(searcherClassName + "List.html", createListHtml(searchHtmlText, searcherItemInfoList,
					searcherPrimaryKeyItemList, searcherInterfaceData));

			fileMap.put(className + "Reference.html", createCrudHtml(crudHtmlText, itemInfoList, primaryKeyItemList,
					interfaceData, Crud.ref));

			fileMap.put(className + "Insert.html", createCrudHtml(crudHtmlText, itemInfoList, primaryKeyItemList,
					interfaceData, Crud.ins));

			fileMap.put(className + "Update.html", createCrudHtml(crudHtmlText, itemInfoList, primaryKeyItemList,
					interfaceData, Crud.upd));

			fileMap.put(searcherClassName + "List.java", createListJava(searcherItemInfoList, searcherPrimaryKeyItemList,
					searcherInterfaceData, packageName, modelFlagSearcher, className));

			fileMap.put(className + "Reference.java", createReferenceJava(itemInfoList, primaryKeyItemList, interfaceData,
					packageName, modelFlag, searcherClassName));

			fileMap.put(className + "Insert.java", createInsertJava(itemInfoList, primaryKeyItemList, interfaceData,
					packageName, modelFlag, searcherClassName, interfaceProject));

			fileMap.put(className + "Update.java", createUpdateJava(itemInfoList, primaryKeyItemList, interfaceData,
					packageName, modelFlag, searcherClassName, interfaceProject));

			fileMap.put("prototype.js",getResourceFile("/jp/oarts/pirka/iop/tool/resource/prototype.js"));
			fileMap.put("pirka.js",getResourceFile("/jp/oarts/pirka/iop/tool/resource/pirka.js"));
			fileMap.put("readMe.txt",getResourceFile("/jp/oarts/pirka/iop/tool/core/plugin/file/webapp/WebAppFileCreatorReadMe.txt"));

			if (logout) {
				fileMap.put("log4j-1.2.16.jar", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j-1.2.16.jar"));
				fileMap.put("log4j.properties", getResourceFile("/jp/oarts/pirka/iop/tool/resource/log4j.properties"));
				fileMap.put("readMeLog.txt", getResourceFile("/jp/oarts/pirka/iop/tool/resource/ReadMeLog.txt"));
			}

			if (fileMap.size() <= 0) {
				throw new InterfaceException("o̓t@CIĂ܂");
			}

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "Html.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
	}

	protected byte[] createListHtml(HtmlTextCreator text, List<ItemInfo> searcherItemInfoList,
			List<InterfaceDataItem> searcherPrimaryKeyItemList, InterfaceData interfaceData) throws InterfaceException {

		ByteArrayOutputStream baos = null;

		try {
			try {
				baos = new ByteArrayOutputStream();
				SelectOut out = null;
				out = new SelectOut(baos);

				String[] commonParams = makeParams(interfaceData.getNameJp(), "", "", "", null);

				// HTMLo
				out.put(text.getText("html", commonParams));

				// HEADER-o
				out.put(text.getText("header", commonParams));

				// HEADER-ENDo
				out.put(text.getText("header end", commonParams));

				// BODY
				out.put(text.getText("body", commonParams));

				out.put(text.getText("search area", commonParams));

				// ͗̈
				for (ItemInfo itemInfo : searcherItemInfoList) {
					if (!itemInfo.isUseSearch()) {
						continue;
					}

					String fieldTitle = itemInfo.getItem().getNameJp();
					if (itemInfo.isUseLike()) {
						fieldTitle = fieldTitle + "iOvj";
					}
					String[] fieldParams = makeParams(interfaceData.getNameJp(), fieldTitle, "param_field_"
							+ itemInfo.getItem().getName(), "", null);

					out.put(text.getText("search field", fieldParams));

					if (FIELD_TYPE_TEXT.equals(itemInfo.getScreenFieldType())
							|| FIELD_TYPE_TEXTAREA.equals(itemInfo.getScreenFieldType())) {
						out(baos, text.getText("search field text", fieldParams));

					} else if (FIELD_TYPE_SELECT.equals(itemInfo.getScreenFieldType())) {
						out(baos, text.getText("search field select", fieldParams));

					} else if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {
						out(baos, text.getText("search field radio", fieldParams));

					} else if (FIELD_TYPE_CHECKBOX.equals(itemInfo.getScreenFieldType())) {
						out(baos, text.getText("search field checkbox", fieldParams));

					}

					out.put(text.getText("search field end", fieldParams));
				}
				out.put(text.getText("search end", commonParams));

				// ꗗ^Cg
				out.put(text.getText("list area", commonParams));
				for (ItemInfo itemInfo : searcherItemInfoList) {
					if (!itemInfo.isUseList()) {
						continue;
					}

					String[] fieldParams = makeParams(interfaceData.getNameJp(), itemInfo.getItem().getNameJp(), "field_"
							+ itemInfo.getItem().getName(), "", null);

					out.put(text.getText("list area title", fieldParams));
				}
				out.put(text.getText("list area title end", commonParams));

				// ꗗf[^
				out.put(text.getText("list area row", commonParams));
				for (ItemInfo itemInfo : searcherItemInfoList) {
					if (!itemInfo.isUseList()) {
						continue;
					}

					String[] fieldParams = makeParams(interfaceData.getNameJp(), itemInfo.getItem().getNameJp(), "field_"
							+ itemInfo.getItem().getName(), "", null);

					out(baos, text.getText("list area row field", fieldParams));
				}
				out(baos, text.getText("list area row field end", commonParams));

				out.put(text.getText("list area row end", commonParams));
				out.put(text.getText("list area end", commonParams));

				out.put(text.getText("body end", commonParams));
				out.put(text.getText("html end", commonParams));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected byte[] createCrudHtml(HtmlTextCreator text, List<ItemInfo> searcherItemInfoList,
			List<InterfaceDataItem> searcherPrimaryKeyItemList, InterfaceData interfaceData, Crud crud)
			throws InterfaceException {

		ByteArrayOutputStream baos = null;

		try {
			try {
				baos = new ByteArrayOutputStream();
				SelectOut out = null;
				switch (crud) {
				case ins:
					out = new SelectOut(baos, SELECT_MARK_INSERT);
					break;
				case upd:
					out = new SelectOut(baos, SELECT_MARK_UPDATEE);
					break;
				case ref:
					out = new SelectOut(baos, SELECT_MARK_REFERENCE);
					break;
				}

				String[] commonParams = makeParams(interfaceData.getNameJp(), "", "", "", crud);

				// HTMLo
				out.put(text.getText("html", commonParams));

				// HEADER-o
				out.put(text.getText("header", commonParams));

				// HEADER-ENDo
				out.put(text.getText("header end", commonParams));

				// BODY
				out.put(text.getText("body", commonParams));

				int row = 0;
				int col = 0;
				int mode = 0; // 0=non, 1=single, 2=multi
				for (ItemInfo itemInfo : searcherItemInfoList) {
					boolean isUse = false;
					switch (crud) {
					case ins:
						isUse = itemInfo.isUseInsert();
						break;
					case upd:
						isUse = itemInfo.isUseUpdate();
						break;
					case ref:
						isUse = itemInfo.isUseRef();
						break;
					}

					if (!isUse) {
						continue;
					}

					if (!itemInfo.isListFlag()) {
						if (mode == 0) {
							// BODY
							out.put(text.getText("single area", commonParams));
							mode = 1;
							row = 0;
						} else if (mode == 2) {
							out.put(text.getText("multi area row end", commonParams));
							out.put(text.getText("multi area end", commonParams));
							out.put(text.getText("single area", commonParams));
							mode = 1;
							row = 0;
						}

						row++;
						String[] fieldParams = makeParams(interfaceData.getNameJp(), itemInfo.getItem().getNameJp(), "field_"
								+ itemInfo.getItem().getName(), "", crud);
						out.put(text.getText("single area field", fieldParams));

						boolean noneUse = crud == Crud.ref || (crud == Crud.upd && itemInfo.isNoInputUp())
								|| (crud == Crud.ins && itemInfo.isNoInputIns());
						if (!noneUse && FIELD_TYPE_TEXT.equals(itemInfo.getScreenFieldType())) {
							out(baos, text.getText("single area field text", fieldParams));

						} else if (!noneUse && FIELD_TYPE_TEXTAREA.equals(itemInfo.getScreenFieldType())) {
							out(baos, text.getText("single area field textarea", fieldParams));

						} else if (!noneUse && FIELD_TYPE_SELECT.equals(itemInfo.getScreenFieldType())) {
							out(baos, text.getText("single area field select", fieldParams));

						} else if (!noneUse && FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {
							out(baos, text.getText("single area field radiobutton", fieldParams));

						} else if (!noneUse && FIELD_TYPE_CHECKBOX.equals(itemInfo.getScreenFieldType())) {
							out(baos, text.getText("single area field checkbox", fieldParams));

						} else {
							out.put(text.getText("single area field none", fieldParams));
						}
						out.put(text.getText("single area field end", fieldParams));
					} else {
						if (mode == 1) {
							out.put(text.getText("single area end", commonParams));
							mode = 2;
							row = 0;
						}
						String[] multiParams = makeParams(interfaceData.getNameJp(), "", "", itemInfo.getItem().getName(), crud);

						out.put(text.getText("multi area", multiParams));

						col = 0;
						for (ItemInfo multiIteminfo : itemInfo.getListItemList()) {

							boolean isMultiUse = false;
							switch (crud) {
							case ins:
								isMultiUse = multiIteminfo.isUseInsert();
								break;
							case upd:
								isMultiUse = multiIteminfo.isUseUpdate();
								break;
							case ref:
								isMultiUse = multiIteminfo.isUseRef();
								break;
							}

							if (!isMultiUse) {
								continue;
							}

							col++;
							String[] multiFieldParams = makeParams(interfaceData.getNameJp(), multiIteminfo.getItem()
									.getNameJp(), "field_" + itemInfo.getItem().getName() + "_"
									+ multiIteminfo.getItem().getName(), itemInfo.getItem().getName(), crud);
							out.put(text.getText("multi area title", multiFieldParams));
						}
						out.put(text.getText("multi area title end", multiParams));

						out.put(text.getText("multi area row", multiParams));

						col = 0;
						for (ItemInfo multiIteminfo : itemInfo.getListItemList()) {

							boolean isMultiUse = false;
							switch (crud) {
							case ins:
								isMultiUse = multiIteminfo.isUseInsert();
								break;
							case upd:
								isMultiUse = multiIteminfo.isUseUpdate();
								break;
							case ref:
								isMultiUse = multiIteminfo.isUseRef();
								break;
							}

							if (!isMultiUse) {
								continue;
							}

							col++;
							String[] multiFieldParams = makeParams(interfaceData.getNameJp(), multiIteminfo.getItem()
									.getNameJp(), "field_" + itemInfo.getItem().getName() + "_"
									+ multiIteminfo.getItem().getName(), itemInfo.getItem().getName(), crud);
							out.put(text.getText("multi area row field", multiFieldParams));

							boolean noneUse = crud == Crud.ref || (crud == Crud.upd && multiIteminfo.isNoInputUp())
									|| (crud == Crud.ins && multiIteminfo.isNoInputIns());

							if (!noneUse && FIELD_TYPE_TEXT.equals(multiIteminfo.getScreenFieldType())) {
								out(baos, text.getText("multi area row field text", multiFieldParams));

							} else if (!noneUse && FIELD_TYPE_TEXTAREA.equals(multiIteminfo.getScreenFieldType())) {
								out(baos, text.getText("multi area row field textarea", multiFieldParams));

							} else if (!noneUse && FIELD_TYPE_SELECT.equals(multiIteminfo.getScreenFieldType())) {
								out(baos, text.getText("multi area row field select", multiFieldParams));

							} else if (!noneUse && FIELD_TYPE_RADIOBUTTON.equals(multiIteminfo.getScreenFieldType())) {
								out(baos, text.getText("multi area row field radiobutton", multiFieldParams));

							} else if (!noneUse && FIELD_TYPE_CHECKBOX.equals(multiIteminfo.getScreenFieldType())) {
								out(baos, text.getText("multi area row field checkbox", multiFieldParams));

							} else {
								out.put(text.getText("multi area row field none", multiFieldParams));
							}
							out.put(text.getText("multi area row field end", multiFieldParams));
						}
						out.put(text.getText("multi area row end", multiParams));
						out.put(text.getText("multi area end", multiParams));
						mode = 0;
						row = 0;
					}
				}
				if (mode == 1) {
					out.put(text.getText("single area end", commonParams));

				}

				out.put(text.getText("body end", commonParams));
				out.put(text.getText("html end", commonParams));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * ꗗ\Javat@CC[W쐬
	 *
	 * @param searcherItemInfoList
	 * @param searcherPrimaryKeyItemList
	 * @param interfaceData
	 * @param packageName
	 * @param modelFlag
	 * @return
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createListJava(List<ItemInfo> searcherItemInfoList, List<InterfaceDataItem> searcherPrimaryKeyItemList,
			InterfaceData interfaceData, String packageName, boolean modelFlag, String mntCLassName) throws IOException,
			InterfaceException {

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());
		String daoModelName = "";
		if (modelFlag) {
			daoModelName = mstName + "SearcherDao";
		} else {
			daoModelName = mstName + "Dao";
		}

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("list package", "package", packageName));
				}

				// L[擾
				StringBuilder sb = new StringBuilder();
				for (InterfaceDataItem keyItem : searcherPrimaryKeyItemList) {
					if (sb.length() > 0) {
						sb.append(", ");
					}
					sb.append("\"" + keyItem.getName() + "\"");
				}

//				out(baos, getText("list 1", "mstName", mstName, "classNameJp", interfaceData.getNameJp() + " ꗗ\",
//						"primaryKeys", sb.toString(), "daoModelName", daoModelName));
				setCommonParameter("classNameJp", interfaceData.getNameJp() + " ꗗ\");
				out(baos, getText("list 1", "mstName", mstName, "primaryKeys", sb.toString(), "daoModelName", daoModelName));

				// ꗗ\̃Ro[^[̐ݒo
				for (ItemInfo itemInfo : searcherItemInfoList) {
					InterfaceDataItem item = itemInfo.getItem();
					if (itemInfo.isUseList()) {
						out(baos, getText("list converter", "name", item.getName(), "nameJp", item.getNameJp()));
					}
				}

				out(baos, getText("list 1.5"));
				out(baos, getText("list 2", "mstName", mstName));

				// `FbJ[o
				int checkerCount = 0;
				for (ItemInfo itemInfo : searcherItemInfoList) {
					if (!itemInfo.isUseSearch()) {
						continue;
					}

					InterfaceDataItem item = itemInfo.getItem();

					if (item.getType() == FieldType.NUM) {
						if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
							checkerCount++;
							out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.intValue"));
						} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
							checkerCount++;
							out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.longValue"));
						} else {
							checkerCount++;
							out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.numeric"));
						}

					} else if (item.getType() == FieldType.DATE) {
						checkerCount++;
						out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.date"));

					} else if (item.getType() == FieldType.TIME) {
						checkerCount++;
						out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.time"));

					} else if (item.getType() == FieldType.DATE_TIME) {
						checkerCount++;
						out(baos, getText("list addCheck", "name", item.getName(), "checker", "PirkaChecker.datetime"));

					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("list addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("list setOfficialFieldName start"));
				for (ItemInfo itemInfo : searcherItemInfoList) {
					if (!itemInfo.isUseSearch()) {
						continue;
					}

					InterfaceDataItem item = itemInfo.getItem();
					if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {
						out(baos,
								getText("list setOfficialFieldName radio", "name", item.getName(), "nameJp", item.getNameJp()));
					} else {
						out(baos, getText("list setOfficialFieldName", "name", item.getName(), "nameJp", item.getNameJp()));
					}
				}

				// Iɓ̓`FbNsȂ{^̐ݒo
				out(baos, getText("list setAutoCheck start"));

				// IXg̍ڒ`ݒo
				for (ItemInfo itemInfo : searcherItemInfoList) {
					InterfaceDataItem item = itemInfo.getItem();
					if (FIELD_TYPE_SELECT.equals(itemInfo.getScreenFieldType())) {

						if (itemInfo.isUseSearch()) {
							if (itemInfo.getSelectListName() == null || itemInfo.getSelectListName().length() <= 0) {
								out(baos, getText("list setSelecter", "name", item.getName()));
							} else {
								out(baos, getText("list setSelecter 2", "name", item.getName(), "SelectListObjectName",
										itemInfo.getSelectListName()));
							}
							out(baos, getText("list setSelecter end", "name", item.getName(), "nameJp", item.getNameJp()));
						}
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("list setFormat start"));
				for (ItemInfo itemInfo : searcherItemInfoList) {

					InterfaceDataItem item = itemInfo.getItem();
					if (!itemInfo.isUseSearch()) {
						continue;
					}

					if (canUseFreeInputTextCtrlSet.contains(itemInfo.getScreenFieldType())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("list setFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));

						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("list setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("list setFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("list setFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}
				out(baos, getText("list 3"));

				// ꗗ\tH[}b^[̐ݒo
				for (ItemInfo itemInfo : searcherItemInfoList) {

					InterfaceDataItem item = itemInfo.getItem();
					if (!itemInfo.isUseList()) {
						continue;
					}

					if (canUseFreeInputTextCtrlSet.contains(itemInfo.getScreenFieldType())) {
						if (item.getType() == FieldType.DATE) {
							out(baos, getText("list setListFormat", "name", item.getName(), "format",
									"new DateFieldFormat(\"yyyy/MM/dd\")"));

						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("list setListFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"HH:mm:ss\")"));

						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("list setListFormat", "name", item.getName(), "format",
									"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
								long seisuubu = item.getLength() - item.getSubLength();
								if (seisuubu <= 50 && seisuubu > 0) {
									String formatStr = null;
									if (item.getSubLength() <= 0) {
										formatStr = chars("#", (int) seisuubu - 1) + "0";
									} else {
										formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
									}
									out(baos, getText("list setListFormat", "name", item.getName(), "format",
											"new NumericFieldFormat(\"" + formatStr + "\")"));
								}
							}
						}
					}
				}
				out(baos, getText("list 3.5", "mstName", mstName));

				// WI{^Xg̍ڒ`ݒoe
				for (ItemInfo itemInfo : searcherItemInfoList) {
					InterfaceDataItem item = itemInfo.getItem();
					if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {

						if (itemInfo.isUseSearch()) {
							if (itemInfo.getSelectListName() == null || itemInfo.getSelectListName().length() <= 0) {
								out(baos, getText("list initDynamicHtml 1", "name", item.getName()));
							} else {
								out(baos, getText("list initDynamicHtml 2", "name", item.getName(), "SelectListObjectName",
										itemInfo.getSelectListName()));
							}

							String[] raioParams = makeParams(interfaceData.getNameJp(), item.getNameJp(), item.getName(), "",
									null);
							out(baos, getText("list initDynamicHtml 3", raioParams));
						}
					}
				}

				out(baos, getText("list 3.7", "mstName", mstName));

				// ݒ
				for (ItemInfo itemInfo : searcherItemInfoList) {

					InterfaceDataItem item = itemInfo.getItem();
					if (!itemInfo.isUseSearch()) {
						continue;
					}

					if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {
						setParameter("group", "Group");
					} else {
						setParameter("group", "");
					}

					if (FIELD_TYPE_CHECKBOX.equals(itemInfo.getScreenFieldType())) {
						out(baos, getText("list set search parameter boolean", "name", item.getName(), "mstName", mstName,
								"daoModelName", daoModelName));
					} else {

						if (item.getType() == FieldType.STRING) {
							if (itemInfo.isUseLike()) {
								out(baos, getText("list set search parameter text like", "name", item.getName(), "mstName",
										mstName, "daoModelName", daoModelName));
							} else {
								out(baos, getText("list set search parameter text equal", "name", item.getName(), "mstName",
										mstName, "daoModelName", daoModelName));
							}
						} else if (item.getType() == FieldType.NUM) {
							if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
								out(baos, getText("list set search parameter int", "name", item.getName(), "mstName", mstName,
										"daoModelName", daoModelName));
							} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
								out(baos, getText("list set search parameter long", "name", item.getName(), "mstName", mstName,
										"daoModelName", daoModelName));
							} else {
								out(baos, getText("list set search parameter bigdecimal", "name", item.getName(), "mstName",
										mstName, "daoModelName", daoModelName));
							}
						} else if (item.getType() == FieldType.DATE) {
							out(baos, getText("list set search parameter date", "name", item.getName(), "mstName", mstName,
									"daoModelName", daoModelName));
						} else if (item.getType() == FieldType.TIME) {
							out(baos, getText("list set search parameter time", "name", item.getName(), "mstName", mstName,
									"daoModelName", daoModelName));
						} else if (item.getType() == FieldType.DATE_TIME) {
							out(baos, getText("list set search parameter timestamp", "name", item.getName(), "mstName",
									mstName, "daoModelName", daoModelName));
						}
					}
				}

				// L[擾
				sb = new StringBuilder();
				for (InterfaceDataItem keyItem : searcherPrimaryKeyItemList) {

					if (sb.length() > 0) {
						sb.append(", ");
					}

					sb.append("rec.");
					sb.append(InterfaceTools.changeGetterNmae(keyItem.getName(), keyItem.getType() == FieldType.BOOLEAN));
					sb.append("()");
				}

				out(baos, getText("list 4", "primaryKeyGetMethods", sb.toString(), "mstName", mstName, "mstMntName",
						mntCLassName));

				// tb^o
				out(baos, getText("list 5", "mstName", mstName));
				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * ƉJavat@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param parameterItemIds
	 *            LȃC^[tF[XIDz
	 * @param packageName
	 *            pbP[W
	 * @param primaryKeyItemList
	 *            vC}[L[ڃXg
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createReferenceJava(List<ItemInfo> itemInfoList, List<InterfaceDataItem> primaryKeyItemList,
			InterfaceData interfaceData, String packageName, boolean modelFlag, String searcherClassName) throws IOException,
			InterfaceException {

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("ref package", "package", packageName));
				}

//				out(baos, getText("ref 1", "mstName", mstName, "classNameJp", interfaceData.getNameJp() + " Ɖ",
//						"mstListName", searcherClassName));
				setCommonParameter("classNameJp", interfaceData.getNameJp() + " Ɖ");
				out(baos, getText("ref 1", "mstName", mstName, "mstListName", searcherClassName));

				out(baos, getText("ref 1.5", "mstName", mstName));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseRef()) {
						out(baos, getText("ref converter", "name", itemInfo.getItem().getName(), "nameJp", itemInfo.getItem()
								.getNameJp()));
					}
				}
				out(baos, getText("ref converter end"));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseRef() && itemInfo.isListFlag()) {
						out(baos, getText("ref converter multi", "multiName", itemInfo.getItem().getName(), "nameJp", itemInfo
								.getItem().getNameJp()));
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isUseRef() && !multiItemInfo.isListFlag()) {
								out(baos, getText("ref converter multi field", "multiName", itemInfo.getItem().getName(),
										"nameJp", multiItemInfo.getItem().getNameJp(), "name", multiItemInfo.getItem()
												.getName()));
							}
						}
						out(baos, getText("ref converter multi end"));
					}
				}

				out(baos, getText("ref 1.6", "mstName", mstName, "mstListName", searcherClassName));

				// tH[}b^[̐ݒo
				out(baos, getText("ref setFormat start"));
				for (ItemInfo itemInfo : itemInfoList) {

					if (itemInfo.isUseRef() && !itemInfo.isListFlag()) {

						InterfaceDataItem item = itemInfo.getItem();
						if (canUseFreeInputTextCtrlSet.contains(itemInfo.getScreenFieldType())) {
							if (item.getType() == FieldType.DATE) {
								out(baos, getText("ref setFormat", "name", item.getName(), "format",
										"new DateFieldFormat(\"yyyy/MM/dd\")"));

							} else if (item.getType() == FieldType.TIME) {
								out(baos, getText("ref setFormat", "name", item.getName(), "format",
										"new TimeFieldFormat(\"HH:mm:ss\")"));

							} else if (item.getType() == FieldType.DATE_TIME) {
								out(baos, getText("ref setFormat", "name", item.getName(), "format",
										"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

							} else if (item.getType() == FieldType.NUM) {
								if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
									long seisuubu = item.getLength() - item.getSubLength();
									if (seisuubu <= 50 && seisuubu > 0) {
										String formatStr = null;
										if (item.getSubLength() <= 0) {
											formatStr = chars("#", (int) seisuubu - 1) + "0";
										} else {
											formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
										}
										out(baos, getText("ref setFormat", "name", item.getName(), "format",
												"new NumericFieldFormat(\"" + formatStr + "\")"));
									}
								}
							}
						}
					}
				}

				for (ItemInfo itemInfo : itemInfoList) {

					if (itemInfo.isUseRef() && itemInfo.isListFlag()) {
						boolean startFlag = false;
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {

							String formatString = null;
							InterfaceDataItem item = itemInfo.getItem();

							if (multiItemInfo.isUseRef() && !multiItemInfo.isListFlag()) {
								if (canUseFreeInputTextCtrlSet.contains(multiItemInfo.getScreenFieldType())) {
									if (item.getType() == FieldType.DATE) {
										formatString = "new DateFieldFormat(\"yyyy/MM/dd\")";

									} else if (item.getType() == FieldType.TIME) {
										formatString = "new TimeFieldFormat(\"HH:mm:ss\")";

									} else if (item.getType() == FieldType.DATE_TIME) {
										formatString = "new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")";

									} else if (item.getType() == FieldType.NUM) {
										if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
											long seisuubu = item.getLength() - item.getSubLength();
											if (seisuubu <= 50 && seisuubu > 0) {
												String formatStr = null;
												if (item.getSubLength() <= 0) {
													formatStr = chars("#", (int) seisuubu - 1) + "0";
												} else {
													formatStr = chars("#", (int) seisuubu - 1) + "0."
															+ chars("0", item.getSubLength());
												}
												formatString = "new NumericFieldFormat(\"" + formatStr + "\")";
											}
										}
									}
								}
							}

							if (formatString != null) {
								if (!startFlag) {
									startFlag = true;
									out(baos, getText("ref setFormat multi start", "multiName", itemInfo.getItem().getName()));
								}
								out(baos, getText("ref setListFormat multi field", "multiName", itemInfo.getItem().getName(),
										"name", item.getName(), "format", formatString));
							}
						}
					}
				}

				out(baos, getText("ref 2", "mstName", mstName));

				// L[擾
				for (InterfaceDataItem item : primaryKeyItemList) {
					setParameter("type", InterfaceTools.getVoType(item.getType(), item.getLength(), item.getSubLength()));
					out(baos, getText("ref primary key set", "name", item.getName(), "setMethodName", InterfaceTools
							.changeSetterNmae(item.getName())));
				}

				String daoModel = null;
				String mstClassName = null;
				String mstNameCreate = null;
				if (modelFlag) {
					daoModel = "model";
					mstClassName = mstName + "Model";
					mstNameCreate = mstClassName + ".getInstance()";
				} else {
					daoModel = "dao";
					mstClassName = mstName + "Dao";
					mstNameCreate = "new " + mstClassName + "()";
				}
				out(baos, getText("ref get record", "mstName", mstName, "daoModel", daoModel, "mstClassName", mstClassName,
						"mstNameCreate", mstNameCreate));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseRef() && itemInfo.isListFlag()) {
						String listGetter = InterfaceTools.changeGetterNmae(itemInfo.getItem().getName(), false);
						out(baos, getText("ref get record multi", "nameJp", itemInfo.getItem().getNameJp(), "listGetter",
								listGetter, "multiName", itemInfo.getItem().getName()));
					}
				}

				// tb^o
				out(baos, getText("ref 3", "mstName", mstName, "daoModel", daoModel, "mstClassName", mstClassName,
						"mstNameCreate", mstNameCreate));

				baos.flush();

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * VKJavat@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param parameterItemIds
	 *            LȃC^[tF[XIDz
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createInsertJava(List<ItemInfo> itemInfoList, List<InterfaceDataItem> primaryKeyItemList,
			InterfaceData interfaceData, String packageName, boolean modelFlag, String searcherClassName,
			InterfaceProject interfaceProject) throws IOException, InterfaceException {

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("ins package", "package", packageName));
				}

//				out(baos, getText("ins 1", "mstName", mstName, "classNameJp", interfaceData.getNameJp() + " VK"));
				setCommonParameter("classNameJp", interfaceData.getNameJp() + " VK");
				out(baos, getText("ins 1", "mstName", mstName));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert() && !itemInfo.isListFlag()) {
						out(baos, getText("ins converter", "name", itemInfo.getItem().getName(), "nameJp", itemInfo.getItem()
								.getNameJp()));
					}
				}
				out(baos, getText("ins converter end"));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert() && itemInfo.isListFlag()) {
						out(baos, getText("ins converter multi", "multiName", itemInfo.getItem().getName(), "nameJp", itemInfo
								.getItem().getNameJp()));
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isUseInsert()) {
								out(baos, getText("ins converter multi field", "multiName", itemInfo.getItem().getName(),
										"nameJp", multiItemInfo.getItem().getNameJp(), "name", multiItemInfo.getItem()
												.getName()));
							}
						}
						out(baos, getText("ins converter multi end"));
					}
				}

				out(baos, getText("ins 2", "mstName", mstName));

				int checkerCount = 0;

				// `FbJ[o
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();

						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName();
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseInsert() && !multiItemInfo.isListFlag()) {
									outCheck(baos, prefix, multiItemInfo);
									checkerCount++;
								}
							}
						} else {
							outCheck(baos, "field", itemInfo);
							checkerCount++;
						}
					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("ins addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("ins setOfficialFieldName start"));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();
						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName() + "_";
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseInsert() && !multiItemInfo.isListFlag()) {
									if (FIELD_TYPE_RADIOBUTTON.equals(multiItemInfo.getScreenFieldType())) {
										out(baos, getText("ins setOfficialFieldName", "name", prefix
												+ multiItemInfo.getItem().getName(), "nameJp", multiItemInfo.getItem()
												.getNameJp(), "fm", "getDefaultLoopFieldMap(\"radio_loop_" + prefix
												+ multiItemInfo.getItem().getName() + "\")"));
									} else {
										out(baos, getText("ins setOfficialFieldName", "name", prefix
												+ multiItemInfo.getItem().getName(), "nameJp", multiItemInfo.getItem()
												.getNameJp(), "fm", "getDefaultLoopFieldMap(\"" + item.getName() + "_loop\")"));
									}
								}
							}
						} else {
							if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {
								out(baos, getText("ins setOfficialFieldName", "name", "field_" + item.getName(), "nameJp", item
										.getNameJp(), "fm", "getDefaultLoopFieldMap(\"radio_loop_field_" + item.getName()
										+ "\")"));
							} else {
								out(baos, getText("ins setOfficialFieldName", "name", "field_" + item.getName(), "nameJp", item
										.getNameJp(), "fm", "fm"));
							}
						}
					}
				}

				// `FbN֎~ݒ
				out(baos, getText("ins no check button"));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						if (itemInfo.isListFlag()) {
							out(baos, getText("ins no check button multi", "name", itemInfo.getItem().getName()));
						}
					}
				}
				out(baos, getText("ins setSelecter start"));

				// IXg̍ڒ`ݒo
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();
						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName() + "_";
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseInsert() && !multiItemInfo.isListFlag()) {
									if (FIELD_TYPE_SELECT.equals(multiItemInfo.getScreenFieldType())) {
										if (multiItemInfo.getSelectListName() == null
												|| multiItemInfo.getSelectListName().length() <= 0) {
											out(baos, getText("ins setSelecter", "name", prefix
													+ multiItemInfo.getItem().getName()));
										} else {
											out(baos, getText("ins setSelecter 2", "name", prefix
													+ multiItemInfo.getItem().getName(), "SelectListObjectName", multiItemInfo
													.getSelectListName()));
										}
										out(baos, getText("ins setSelecter end multi", "name", prefix
												+ multiItemInfo.getItem().getName(), "nameJp", multiItemInfo.getItem()
												.getNameJp(), "multiName", item.getName()));
									}
								}
							}
						} else {
							if (FIELD_TYPE_SELECT.equals(itemInfo.getScreenFieldType())) {
								String prefix = "field_";
								if (itemInfo.getSelectListName() == null || itemInfo.getSelectListName().length() <= 0) {
									out(baos, getText("ins setSelecter", "name", prefix + item.getName()));
								} else {
									out(baos, getText("ins setSelecter 2", "name", prefix + item.getName(),
											"SelectListObjectName", itemInfo.getSelectListName()));
								}
								out(baos, getText("ins setSelecter end", "name", prefix + item.getName(), "nameJp", item
										.getNameJp()));
							}
						}
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("ins setFormat start"));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();
						String prefix = "";
						if (itemInfo.isListFlag()) {
							prefix = "field_" + item.getName() + "_";
						} else {
							prefix = "field_";
						}

						if (canUseFreeInputTextCtrlSet.contains(itemInfo.getScreenFieldType())) {
							if (item.getType() == FieldType.DATE) {
								out(baos, getText("ins setFormat", "name", prefix + item.getName(), "format",
										"new DateFieldFormat(\"yyyy/MM/dd\")"));

							} else if (item.getType() == FieldType.TIME) {
								out(baos, getText("ins setFormat", "name", prefix + item.getName(), "format",
										"new TimeFieldFormat(\"HH:mm:ss\")"));

							} else if (item.getType() == FieldType.DATE_TIME) {
								out(baos, getText("ins setFormat", "name", prefix + item.getName(), "format",
										"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

							} else if (item.getType() == FieldType.NUM) {
								if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
									long seisuubu = item.getLength() - item.getSubLength();

									if (seisuubu <= 50 && seisuubu > 0) {
										String formatStr = null;
										if (item.getSubLength() <= 0) {
											formatStr = chars("#", (int) seisuubu - 1) + "0";
										} else {
											formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
										}
										out(baos, getText("ins setFormat", "name", prefix + item.getName(), "format",
												"new NumericFieldFormat(\"" + formatStr + "\")"));
									}
								}
							}
						}
					}
				}

				out(baos, getText("ins 3", "mstName", mstName));

				// WI{^Xg̍ڒ`ݒoe
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();
						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName() + "_";
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseInsert() && !multiItemInfo.isListFlag()) {
									if (FIELD_TYPE_RADIOBUTTON.equals(multiItemInfo.getScreenFieldType())) {
										if (multiItemInfo.getSelectListName() == null
												|| multiItemInfo.getSelectListName().length() <= 0) {
											out(baos, getText("ins initDynamicHtml 1", "name", prefix
													+ multiItemInfo.getItem().getName()));
										} else {
											out(baos, getText("ins initDynamicHtml 2", "name", prefix
													+ multiItemInfo.getItem().getName(), "SelectListObjectName", multiItemInfo
													.getSelectListName()));
										}
										String[] raioParams = makeParams(interfaceData.getNameJp(), multiItemInfo.getItem()
												.getNameJp(), prefix + multiItemInfo.getItem().getName(), item.getName(), null);
										out(baos, getText("ins initDynamicHtml 4", raioParams));
									}
								}
							}
						} else {
							if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {

								if (itemInfo.getSelectListName() == null || itemInfo.getSelectListName().length() <= 0) {
									out(baos, getText("ins initDynamicHtml 1", "name", item.getName()));
								} else {
									out(baos, getText("ins initDynamicHtml 2", "name", item.getName(), "SelectListObjectName",
											itemInfo.getSelectListName()));
								}

								String[] raioParams = makeParams(interfaceData.getNameJp(), item.getNameJp(), item.getName(),
										"", null);
								out(baos, getText("ins initDynamicHtml 3", raioParams));
							}
						}
					}
				}

				out(baos, getText("ins 3.5", "mstName", mstName));

				// s̃f[^擾
				for (ItemInfo multiItemInfo : itemInfoList) {
					if (multiItemInfo.isUseInsert() && multiItemInfo.isListFlag()) {
						InterfaceDataItem multiItem = multiItemInfo.getItem();
						InterfaceData multiInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								multiItem.getIncludeDataId());
						String listGetter = InterfaceTools.changeGetterNmae(multiItem.getName(), false);
						out(baos, getText("ins get record multi", //
								"nameJp", multiItemInfo.getItem().getNameJp(), //
								"listGetter", listGetter, //
								"multiName", multiItemInfo.getItem().getName(), //
								"multiClass", InterfaceTools.changeClassNmae(multiInterfaceData.getName())));
					}
				}

				// sԍݒ
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert() && itemInfo.isListFlag()) {
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isAutoRowNo()) {
								out(baos, getText("ins get record multi autoRowNo start", //
										"nameJp", multiItemInfo.getItem().getNameJp(), //
										"getter", InterfaceTools.changeGetterNmae(itemInfo.getItem().getName(), false), //
										"setter", InterfaceTools.changeSetterNmae(multiItemInfo.getItem().getName())));
							}
						}
					}
				}

				String daoModel = null;
				String mstClassName = null;
				String mstNameCreate = null;
				if (modelFlag) {
					daoModel = "model";
					mstClassName = mstName + "Model";
					mstNameCreate = mstClassName + ".getInstance()";
				} else {
					daoModel = "dao";
					mstClassName = mstName + "Dao";
					mstNameCreate = "new " + mstClassName + "()";
				}
				out(baos, getText("ins 4", "mstName", mstName, "daoModel", daoModel, "mstClassName", mstClassName,
						"mstNameCreate", mstNameCreate));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert() && itemInfo.isListFlag()) {
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isUseInsert() && multiItemInfo.isAutoRowNo()) {
								out(baos, getText("ins autoRowNo start", //
										"multiName", itemInfo.getItem().getName(), //
										"name", multiItemInfo.getItem().getName()));
							}
						}
					}
				}
				out(baos, getText("ins 4.5"));

				// s̍sǉE폜
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						if (itemInfo.isListFlag()) {
							out(baos, getText("ins line add del", "name", itemInfo.getItem().getName(), "nameJp", itemInfo
									.getItem().getNameJp()));
						}
					}
				}
				out(baos, getText("ins 5"));

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * CJavat@CC[W쐬
	 *
	 * @param interfaceData
	 *            C^[tF[X
	 * @param parameterItemIds
	 *            LȃC^[tF[XIDz
	 * @param packageName
	 *            pbP[W
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createUpdateJava(List<ItemInfo> itemInfoList, List<InterfaceDataItem> primaryKeyItemList,
			InterfaceData interfaceData, String packageName, boolean modelFlag, String searcherClassName,
			InterfaceProject interfaceProject) throws IOException, InterfaceException {

		String mstName = InterfaceTools.changeClassNmae(interfaceData.getName());

		ByteArrayOutputStream baos = null;
		try {
			try {
				baos = new ByteArrayOutputStream();

				// pbP[Wo
				if (packageName != null && packageName.length() > 0) {
					out(baos, getText("upd package", "package", packageName));
				}

//				out(baos, getText("upd 1", "mstName", mstName, "classNameJp", interfaceData.getNameJp() + " C"));
				setCommonParameter("classNameJp", interfaceData.getNameJp() + " C");
				out(baos, getText("upd 1", "mstName", mstName));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate() && !itemInfo.isListFlag()) {
						out(baos, getText("upd converter", "name", itemInfo.getItem().getName(), "nameJp", itemInfo.getItem()
								.getNameJp()));
					}
				}
				out(baos, getText("upd converter end"));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate() && itemInfo.isListFlag()) {
						out(baos, getText("upd converter multi", "multiName", itemInfo.getItem().getName(), "nameJp", itemInfo
								.getItem().getNameJp()));
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isUseUpdate()) {
								out(baos, getText("upd converter multi field", "multiName", itemInfo.getItem().getName(),
										"nameJp", multiItemInfo.getItem().getNameJp(), "name", multiItemInfo.getItem()
												.getName()));
							}
						}
						out(baos, getText("upd converter multi end"));
					}
				}

				out(baos, getText("upd 2", "mstName", mstName, "searcherClassName", searcherClassName));

				int checkerCount = 0;

				// `FbJ[o
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate()) {
						InterfaceDataItem item = itemInfo.getItem();

						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName();
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseUpdate() && !multiItemInfo.isListFlag()) {
									outCheck(baos, prefix, multiItemInfo);
									checkerCount++;
								}
							}
						} else {
							outCheck(baos, "field", itemInfo);
							checkerCount++;
						}
					}
				}

				// ^[i[o
				if (checkerCount > 0) {
					out(baos, getText("upd addErrorCheckReturner"));
				}

				// C^[tF[Xƃ^Cg̃No
				out(baos, getText("upd setOfficialFieldName start"));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();
						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName() + "_";
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseInsert() && !multiItemInfo.isListFlag()) {
									if (FIELD_TYPE_RADIOBUTTON.equals(multiItemInfo.getScreenFieldType())) {
										out(baos, getText("upd setOfficialFieldName", "name", prefix
												+ multiItemInfo.getItem().getName(), "nameJp", multiItemInfo.getItem()
												.getNameJp(), "fm", "getDefaultLoopFieldMap(\"radio_loop_" + prefix
												+ multiItemInfo.getItem().getName() + "\")"));
									} else {
										out(baos, getText("upd setOfficialFieldName", "name", prefix
												+ multiItemInfo.getItem().getName(), "nameJp", multiItemInfo.getItem()
												.getNameJp(), "fm", "getDefaultLoopFieldMap(\"" + item.getName() + "_loop\")"));
									}
								}
							}
						} else {
							if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {
								out(baos, getText("upd setOfficialFieldName", "name", "field_" + item.getName(), "nameJp", item
										.getNameJp(), "fm", "getDefaultLoopFieldMap(\"radio_loop_field_" + item.getName()
										+ "\")"));
							} else {
								out(baos, getText("upd setOfficialFieldName", "name", "field_" + item.getName(), "nameJp", item
										.getNameJp(), "fm", "fm"));
							}
						}
					}
				}

				// `FbN֎~ݒ
				out(baos, getText("upd no check button"));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate()) {
						if (itemInfo.isListFlag()) {
							out(baos, getText("upd no check button multi", "name", itemInfo.getItem().getName()));
						}
					}
				}
				out(baos, getText("upd setSelecter start"));

				// IXg̍ڒ`ݒo
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate()) {
						InterfaceDataItem item = itemInfo.getItem();
						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName() + "_";
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseUpdate() && !multiItemInfo.isListFlag()) {
									if (FIELD_TYPE_SELECT.equals(multiItemInfo.getScreenFieldType())) {
										if (multiItemInfo.getSelectListName() == null
												|| multiItemInfo.getSelectListName().length() <= 0) {
											out(baos, getText("upd setSelecter", "name", prefix
													+ multiItemInfo.getItem().getName()));
										} else {
											out(baos, getText("upd setSelecter 2", "name", prefix
													+ multiItemInfo.getItem().getName(), "SelectListObjectName", multiItemInfo
													.getSelectListName()));
										}
										out(baos, getText("upd setSelecter end multi", "name", prefix
												+ multiItemInfo.getItem().getName(), "nameJp", multiItemInfo.getItem()
												.getNameJp(), "multiName", item.getName()));
									}
								}
							}
						} else {
							if (FIELD_TYPE_SELECT.equals(itemInfo.getScreenFieldType())) {
								String prefix = "field_";
								if (itemInfo.getSelectListName() == null || itemInfo.getSelectListName().length() <= 0) {
									out(baos, getText("upd setSelecter", "name", prefix + item.getName()));
								} else {
									out(baos, getText("upd setSelecter 2", "name", prefix + item.getName(),
											"SelectListObjectName", itemInfo.getSelectListName()));
								}
								out(baos, getText("upd setSelecter end", "name", prefix + item.getName(), "nameJp", item
										.getNameJp()));
							}
						}
					}
				}

				// tH[}b^[̐ݒo
				out(baos, getText("upd setFormat start"));
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate()) {
						InterfaceDataItem item = itemInfo.getItem();
						String prefix = "";
						if (itemInfo.isListFlag()) {
							prefix = "field_" + item.getName() + "_";
						} else {
							prefix = "field_";
						}

						if (canUseFreeInputTextCtrlSet.contains(itemInfo.getScreenFieldType())) {
							if (item.getType() == FieldType.DATE) {
								out(baos, getText("upd setFormat", "name", prefix + item.getName(), "format",
										"new DateFieldFormat(\"yyyy/MM/dd\")"));

							} else if (item.getType() == FieldType.TIME) {
								out(baos, getText("upd setFormat", "name", prefix + item.getName(), "format",
										"new TimeFieldFormat(\"HH:mm:ss\")"));

							} else if (item.getType() == FieldType.DATE_TIME) {
								out(baos, getText("upd setFormat", "name", prefix + item.getName(), "format",
										"new TimeFieldFormat(\"yyyy/MM/dd HH:mm:ss\")"));

							} else if (item.getType() == FieldType.NUM) {
								if (InterfaceTools.isBigDecimalType(item.getLength(), item.getSubLength())) {
									long seisuubu = item.getLength() - item.getSubLength();

									if (seisuubu <= 50 && seisuubu > 0) {
										String formatStr = null;
										if (item.getSubLength() <= 0) {
											formatStr = chars("#", (int) seisuubu - 1) + "0";
										} else {
											formatStr = chars("#", (int) seisuubu - 1) + "0." + chars("0", item.getSubLength());
										}
										out(baos, getText("upd setFormat", "name", prefix + item.getName(), "format",
												"new NumericFieldFormat(\"" + formatStr + "\")"));
									}
								}
							}
						}
					}
				}

				out(baos, getText("upd 3", "mstName", mstName));

				// WI{^Xg̍ڒ`ݒoe
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert()) {
						InterfaceDataItem item = itemInfo.getItem();
						if (itemInfo.isListFlag()) {
							String prefix = "field_" + itemInfo.getItem().getName() + "_";
							for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
								if (multiItemInfo.isUseInsert() && !multiItemInfo.isListFlag()) {
									if (FIELD_TYPE_RADIOBUTTON.equals(multiItemInfo.getScreenFieldType())) {
										if (multiItemInfo.getSelectListName() == null
												|| multiItemInfo.getSelectListName().length() <= 0) {
											out(baos, getText("upd initDynamicHtml 1", "name", prefix
													+ multiItemInfo.getItem().getName()));
										} else {
											out(baos, getText("upd initDynamicHtml 2", "name", prefix
													+ multiItemInfo.getItem().getName(), "SelectListObjectName", multiItemInfo
													.getSelectListName()));
										}
										String[] raioParams = makeParams(interfaceData.getNameJp(), multiItemInfo.getItem()
												.getNameJp(), prefix + multiItemInfo.getItem().getName(), item.getName(), null);
										out(baos, getText("upd initDynamicHtml 4", raioParams));
									}
								}
							}
						} else {
							if (FIELD_TYPE_RADIOBUTTON.equals(itemInfo.getScreenFieldType())) {

								if (itemInfo.getSelectListName() == null || itemInfo.getSelectListName().length() <= 0) {
									out(baos, getText("upd initDynamicHtml 1", "name", item.getName()));
								} else {
									out(baos, getText("upd initDynamicHtml 2", "name", item.getName(), "SelectListObjectName",
											itemInfo.getSelectListName()));
								}

								String[] raioParams = makeParams(interfaceData.getNameJp(), item.getNameJp(), item.getName(),
										"", null);
								out(baos, getText("upd initDynamicHtml 3", raioParams));
							}
						}
					}
				}

				out(baos, getText("upd 3.2", "mstName", mstName));

				// L[擾
				for (InterfaceDataItem item : primaryKeyItemList) {
					setParameter("type", InterfaceTools.getVoType(item.getType(), item.getLength(), item.getSubLength()));
					out(baos, getText("upd primary key set", "name", item.getName(), "setMethodName", InterfaceTools
							.changeSetterNmae(item.getName())));
				}

				String daoModel = null;
				String mstClassName = null;
				String mstNameCreate = null;
				if (modelFlag) {
					daoModel = "model";
					mstClassName = mstName + "Model";
					mstNameCreate = mstClassName + ".getInstance()";
				} else {
					daoModel = "dao";
					mstClassName = mstName + "Dao";
					mstNameCreate = "new " + mstClassName + "()";
				}
				out(baos, getText("upd get record", "mstName", mstName, "daoModel", daoModel, "mstClassName", mstClassName,
						"mstNameCreate", mstNameCreate));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate() && itemInfo.isListFlag()) {
						String listGetter = InterfaceTools.changeGetterNmae(itemInfo.getItem().getName(), false);
						out(baos, getText("upd set record multi", "nameJp", itemInfo.getItem().getNameJp(), "listGetter",
								listGetter, "multiName", itemInfo.getItem().getName()));
					}
				}
				out(baos, getText("upd 3.5"));

				for (ItemInfo multiItemInfo : itemInfoList) {
					if (multiItemInfo.isUseUpdate() && multiItemInfo.isListFlag()) {
						InterfaceDataItem multiItem = multiItemInfo.getItem();
						InterfaceData multiInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
								multiItem.getIncludeDataId());
						String listGetter = InterfaceTools.changeGetterNmae(multiItem.getName(), false);
						out(baos, getText("upd get record multi", //
								"nameJp", multiItemInfo.getItem().getNameJp(), //
								"listGetter", listGetter, //
								"multiName", multiItemInfo.getItem().getName(), //
								"multiClass", InterfaceTools.changeClassNmae(multiInterfaceData.getName())));
					}
				}

				// sԍݒ
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseInsert() && itemInfo.isListFlag()) {
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isAutoRowNo()) {
								out(baos, getText("upd get record multi autoRowNo start", //
										"nameJp", multiItemInfo.getItem().getNameJp(), //
										"getter", InterfaceTools.changeGetterNmae(itemInfo.getItem().getName(), false), //
										"setter", InterfaceTools.changeSetterNmae(multiItemInfo.getItem().getName())));
							}
						}
					}
				}

				out(baos, getText("upd 4", "mstName", mstName, "daoModel", daoModel, "mstClassName", mstClassName,
						"mstNameCreate", mstNameCreate));

				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate() && itemInfo.isListFlag()) {
						for (ItemInfo multiItemInfo : itemInfo.getListItemList()) {
							if (multiItemInfo.isUseUpdate() && multiItemInfo.isAutoRowNo()) {
								out(baos, getText("upd autoRowNo start", //
										"multiName", itemInfo.getItem().getName(), //
										"name", multiItemInfo.getItem().getName()));
							}
						}
					}
				}
				out(baos, getText("upd 4.5"));

				// s̍sǉE폜
				for (ItemInfo itemInfo : itemInfoList) {
					if (itemInfo.isUseUpdate()) {
						if (itemInfo.isListFlag()) {
							out(baos, getText("upd line add del", "name", itemInfo.getItem().getName(), "nameJp", itemInfo
									.getItem().getNameJp()));
						}
					}
				}
				out(baos, getText("upd 5"));

			} finally {
				if (baos != null) {
					baos.close();
				}
			}
			return baos.toByteArray();

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	protected int outCheck(ByteArrayOutputStream baos, String prefix, ItemInfo itemInfo) throws UnsupportedEncodingException,
			IOException, InterfaceException {

		int checkerCount = 0;

		InterfaceDataItem item = itemInfo.getItem();
		String name = prefix + "_" + item.getName();

		// K{̓`FbN
		if (canUseRequiredCheckCtrlSet.contains(itemInfo.getScreenFieldType())) {
			if (itemInfo.isRequired()) {
				checkerCount++;
				out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.required"));
			}
		}

		// ^`FbN
		if (canUseFreeInputTextCtrlSet.contains(itemInfo.getScreenFieldType())) {

			if (item.getType() == FieldType.STRING) {
				if (item.getLength() > 0) {
					checkerCount++;
					if (itemInfo.isUnderLengthNg()) {
						out(baos, getText("ins addCheck", "name", name, "checker",
								"new PirkaCheckerLength(PirkaCheckerLength.JUST, " + item.getLength() + ")"));
					} else {
						out(baos, getText("ins addCheck", "name", name, "checker",
								"new PirkaCheckerLength(PirkaCheckerLength.RANGE, 0, " + item.getLength() + ")"));
					}
				}
				String checkStr = stringCheckerMap.get(itemInfo.getStringChaeck());
				if (checkStr != null && checkStr.length() > 0) {
					checkerCount++;
					out(baos, getText("ins addCheck", "name", name, "checker", "new PirkaCheckerString(" + checkStr + ")"));
				}

			} else if (item.getType() == FieldType.NUM) {
				if (InterfaceTools.isIntType(item.getLength(), item.getSubLength())) {
					checkerCount++;
					out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.intValue"));
					out(baos, getText("ins addCheck", "name", name, "checker", makeIntRangeCheck(item.getLength())));
				} else if (InterfaceTools.isLongType(item.getLength(), item.getSubLength())) {
					checkerCount++;
					out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.longValue"));
					out(baos, getText("ins addCheck", "name", name, "checker", makeLongRangeCheck(item.getLength())));
				} else {
					checkerCount++;
					out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.numeric"));
					out(baos, getText("ins addCheck", "name", name, "checker", makeBigDecimalRangeCheck(item.getLength(), item
							.getSubLength())));
				}

			} else if (item.getType() == FieldType.DATE) {
				checkerCount++;
				out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.date"));

			} else if (item.getType() == FieldType.TIME) {
				checkerCount++;
				out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.time"));

			} else if (item.getType() == FieldType.DATE_TIME) {
				checkerCount++;
				out(baos, getText("ins addCheck", "name", name, "checker", "PirkaChecker.datetime"));

			}

			if (itemInfo.isDokujiCheck()) {
				checkerCount++;
				out(baos, getText("ins addCheck dokuji", "name", name, "checker", "PirkaChecker.datetime"));

			}

		}

		return checkerCount;
	}

	protected String makeIntRangeCheck(long length) {

		String max = chars("9", (int) length);

		StringBuilder sb = new StringBuilder();
		sb.append("new PirkaCheckerNumericRange(-");
		sb.append(max);
		sb.append(", ");
		sb.append(max);
		sb.append(")");

		return sb.toString();
	}

	protected String makeLongRangeCheck(long length) {

		String max = chars("9", (int) length);

		StringBuilder sb = new StringBuilder();
		sb.append("new PirkaCheckerNumericRange(-");
		sb.append(max);
		sb.append("L, ");
		sb.append(max);
		sb.append("L)");

		return sb.toString();
	}

	protected String makeBigDecimalRangeCheck(long length, int subLength) {

		String max = "";
		StringBuilder sb = new StringBuilder();
		if (InterfaceTools.isIntType(length, 0) || InterfaceTools.isLongType(length, 0)) {

			max = chars("9", (int) length);

			sb.append("new PirkaCheckerNumericRange(BigDecimal.valueOf(-");
			sb.append(max);
			sb.append("L, ");
			sb.append(subLength);
			sb.append(")");

			sb.append(", ");
			sb.append("BigDecimal.valueOf(");
			sb.append(max);
			sb.append("L, ");
			sb.append(subLength);
			sb.append(")");
			sb.append(")");
		} else {

			if (subLength > 0) {
				max = chars("9", (int) length) + "." + chars("9", subLength);
			} else {
				max = chars("9", (int) length);
			}

			sb.append("new PirkaCheckerNumericRange(new BigDecimal(\"-");
			sb.append(max);
			sb.append("\")");

			sb.append(", ");
			sb.append("new BigDecimal(\"");
			sb.append(max);
			sb.append("\")");
			sb.append(")");
		}
		return sb.toString();
	}

	protected String[] makeParams(String title, String fiedTitle, String ctrlName, String listName, Crud crud) {
		List<String> paramList = new LinkedList<String>();

		if (crud != null) {
			paramList.add("function");
			switch (crud) {
			case ins:
				paramList.add("VKo^");
				break;

			case upd:
				paramList.add("C");
				break;

			case ref:
				paramList.add("Ɖ");
				break;

			}
		}

		paramList.add("title");
		paramList.add(title);

		paramList.add("name-errorMessage");
		paramList.add("errorMessage");

		paramList.add("name");
		paramList.add(ctrlName);

		paramList.add("name-loop");
		paramList.add(listName + "_loop");

		paramList.add("field-title");
		paramList.add(fiedTitle);

		paramList.add("name-radio-loop");
		paramList.add("radio_loop_" + ctrlName);

		paramList.add("name-radio-title");
		paramList.add("radio_title_" + ctrlName);

		paramList.add("name-save-button");
		paramList.add("save_button");

		paramList.add("name-cancel-button");
		paramList.add("cancel_button");

		paramList.add("name-delete-button");
		paramList.add("delete_button");

		paramList.add("name-return-button");
		paramList.add("return_button");

		paramList.add("name-line-insert-button");
		paramList.add(listName + "_line_insert_button");

		paramList.add("name-line-delete-button");
		paramList.add(listName + "_line_delete_button");

		paramList.add("name-clear-button");
		paramList.add("clear_button");

		paramList.add("name-search-button");
		paramList.add("search_button");

		paramList.add("name-list-loop");
		paramList.add("list_loop");

		paramList.add("name-goto-reference-button");
		paramList.add("goto_reference_button");

		paramList.add("name-goto-update-button");
		paramList.add("goto_update_button");

		paramList.add("name-goto-insert-button");
		paramList.add("goto_insert_button");

		return paramList.toArray(new String[0]);
	}

	protected void createSearcherItemInfo(HashMap<String, ParameterData> dataMap, List<ItemInfo> itemInfoList,
			List<InterfaceDataItem> primaryKeyItemList, InterfaceProject interfaceProject) throws InterfaceException {

		ParameterData searcherInterface = dataMap.get("searcherInterface");
		int searcherInterfaceDataId = searcherInterface.getValueInt();
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(searcherInterfaceDataId);

		// zf[^x[Xe[uA^b`Ă烂fpĂяo
		if (!interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			createItemInfoFromDao(searcherInterfaceDataId, itemInfoList, primaryKeyItemList, interfaceProject, true, false);
		} else {
			createItemInfoFromModel(searcherInterfaceDataId, itemInfoList, primaryKeyItemList, interfaceProject, true, false,
					false);

		}
	}

	protected void createItemInfo(HashMap<String, ParameterData> dataMap, List<ItemInfo> itemInfoList,
			List<InterfaceDataItem> primaryKeyItemList, InterfaceProject interfaceProject) throws InterfaceException {

		ParameterData targetInterface = dataMap.get("targetInterface");
		int targetInterfaceDataId = targetInterface.getValueInt();
		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(targetInterfaceDataId);

		// zf[^x[Xe[uA^b`Ă烂fpĂяo
		if (!interfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
			createItemInfoFromDao(targetInterfaceDataId, itemInfoList, primaryKeyItemList, interfaceProject, false, false);
		} else {
			createItemInfoFromModel(targetInterfaceDataId, itemInfoList, primaryKeyItemList, interfaceProject, false, true,
					false);
		}
	}

	protected void createItemInfoFromDao(int dataId, List<ItemInfo> itemInfoList, List<InterfaceDataItem> primaryKeyItemList,
			InterfaceProject interfaceProject, boolean readOnly, boolean multi) throws InterfaceException {

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
		Integer[] itemIds = interfaceData.getAllItemIdList();

		for (Integer itemId : itemIds) {

			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isEnable()) {
				continue;
			}
			if (item.isPrimaryKey()) {
				primaryKeyItemList.add(item);
			}

			ItemInfo itemInfo = new ItemInfo();

			itemInfo.setListFlag(false);
			itemInfo.setListItemList(null);
			itemInfo.setItem(item);

			itemInfo.setReadOnly(readOnly);

			AttributeData controlType = interfaceData.getAttribute(itemId, PLUGIN_NAME, "controlType");
			if (controlType != null) {
				itemInfo.setScreenFieldType(controlType.getValue());
			} else {
				itemInfo.setScreenFieldType(FIELD_TYPE_TEXT);
			}

			itemInfo.setUseSearch(false);
			itemInfo.setUseLike(false);
			AttributeData search = interfaceData.getAttribute(itemId, PLUGIN_NAME, "search");
			if (search != null && !"nouse".equals(search.getValue())) {
				itemInfo.setUseSearch(true);
				if ("equals".equals(search.getValue())) {
					// Ȃ
				} else if ("like".equals(search.getValue())) {
					itemInfo.setUseLike(true);
				}
			}

			AttributeData useList = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useList");
			itemInfo.setUseList(useList != null ? useList.getValueBoolean() : false);

			AttributeData useRef = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useRef");
			itemInfo.setUseRef(useRef != null ? useRef.getValueBoolean() : false);

			itemInfo.setUseInsert(false);
			itemInfo.setNoInputIns(false);
			AttributeData useInsert = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useIns");
			itemInfo.setUseInsert(useInsert != null ? useInsert.getValueBoolean() : false);
			if (useInsert != null && !"".equals(useInsert.getValue())) {
				itemInfo.setUseInsert(true);
				if ("input".equals(useInsert.getValue())) {
					// Ȃ
				} else if ("display".equals(useInsert.getValue())) {
					itemInfo.setNoInputIns(true);
				}
			}

			itemInfo.setUseUpdate(false);
			itemInfo.setNoInputUp(false);
			AttributeData useUpdate = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useUp");
			if (useUpdate != null && !"".equals(useUpdate.getValue())) {
				itemInfo.setUseUpdate(true);
				if ("input".equals(useUpdate.getValue())) {
					// Ȃ
				} else if ("display".equals(useUpdate.getValue())) {
					itemInfo.setNoInputUp(true);
				}
			}

			AttributeData autoRowNo = interfaceData.getAttribute(itemId, PLUGIN_NAME, "autoRowNo");
			if (autoRowNo != null && autoRowNo.getValueBoolean() && multi) {
				itemInfo.setNoInputIns(true);
				itemInfo.setNoInputUp(true);
				itemInfo.setAutoRowNo(true);
			}

			AttributeData required = interfaceData.getAttribute(itemId, PLUGIN_NAME, "required");
			itemInfo.setRequired(required != null ? required.getValueBoolean() : false);

			AttributeData underLengthNg = interfaceData.getAttribute(itemId, PLUGIN_NAME, "underLengthNg");
			itemInfo.setUnderLengthNg(underLengthNg != null ? underLengthNg.getValueBoolean() : false);

			AttributeData stringChaeck = interfaceData.getAttribute(itemId, PLUGIN_NAME, "stringChaeck");
			itemInfo.setStringChaeck(stringChaeck != null ? stringChaeck.getValue() : "");

			AttributeData dokujiCheck = interfaceData.getAttribute(itemId, PLUGIN_NAME, "dokujiCheck");
			itemInfo.setDokujiCheck(dokujiCheck != null ? dokujiCheck.getValueBoolean() : false);

			AttributeData selectListName = interfaceData.getAttribute(itemId, PLUGIN_NAME, "selectListName");
			itemInfo.setSelectListName(selectListName != null ? selectListName.getValue() : "");

			itemInfoList.add(itemInfo);
		}
	}

	protected void createItemInfoFromModel(int dataId, List<ItemInfo> itemInfoList, List<InterfaceDataItem> primaryKeyItemList,
			InterfaceProject interfaceProject, boolean readOnly, boolean useListInclude, boolean multi)
			throws InterfaceException {

		HashSet<Integer> rightMultiIncludeIdSet = new HashSet<Integer>();
		HashSet<Integer> getIncludeIdSet = new HashSet<Integer>(); // QƑ̃CN[hIDZbg
		HashSet<Integer> listIncludeIdCheckSet = new HashSet<Integer>();

		InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);
		Integer[] itemIds = interfaceData.getAllItemIdList();

		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isBaseItem()) {
				AttributeData primaryKey = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.PRIMARY_KEY_ATTACH_NAME);
				if (primaryKey != null && primaryKey.getValueBoolean()) {
					primaryKeyItemList.add(item);
				}

				AttributeData linkOption = interfaceData.getAttribute(itemId, VirtualDbTableFileCreator.PLUGIN_NAME,
						VirtualDbTableFileCreator.LINK_OPTION_TYPE_ATTACH_NAME);
				if (linkOption != null && VirtualDbTableFileCreator.LINK_TYPE_MULTI_SET.contains(linkOption.getValue())) {
					rightMultiIncludeIdSet.add(item.getIncludeId());
				}

				if (linkOption != null && VirtualDbTableFileCreator.LINK_TYPE_REF_SET.contains(linkOption.getValue())) {
					getIncludeIdSet.add(item.getIncludeId());
				}
			}
		}

		for (Integer itemId : itemIds) {
			InterfaceDataItem item = interfaceData.getItem(itemId);

			if (!item.isEnable()) {
				continue;
			}

			ItemInfo itemInfo = new ItemInfo();

			if (!item.isBaseItem() && rightMultiIncludeIdSet.contains(item.getIncludeId())) {
				if (!listIncludeIdCheckSet.contains(item.getIncludeDataId()) && useListInclude) {
					itemInfo.setListFlag(true);
					List<ItemInfo> chaildItemList = new LinkedList<ItemInfo>();
					List<InterfaceDataItem> tempPrimaryKeyItemList = new LinkedList<InterfaceDataItem>();
					itemInfo.setListItemList(chaildItemList);

					InterfaceData multiInterfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
							item.getIncludeDataId());
					if (!multiInterfaceData.isAttached(VirtualDbTableFileCreator.PLUGIN_NAME)) {
						createItemInfoFromDao(item.getIncludeDataId(), chaildItemList, tempPrimaryKeyItemList,
								interfaceProject, readOnly, true);
					} else {
						createItemInfoFromModel(item.getIncludeDataId(), chaildItemList, tempPrimaryKeyItemList,
								interfaceProject, getIncludeIdSet.contains(item.getIncludeId()), false, true);
					}
				} else {
					continue;
				}
			} else {
				itemInfo.setListFlag(false);
				itemInfo.setListItemList(null);
			}

			itemInfo.setItem(item);
			itemInfo.setReadOnly(readOnly);

			AttributeData controlType = interfaceData.getAttribute(itemId, PLUGIN_NAME, "controlType");
			if (controlType != null) {
				itemInfo.setScreenFieldType(controlType.getValue());
			} else {
				itemInfo.setScreenFieldType(FIELD_TYPE_TEXT);
			}

			itemInfo.setUseSearch(false);
			itemInfo.setUseLike(false);
			AttributeData search = interfaceData.getAttribute(itemId, PLUGIN_NAME, "search");
			if (search != null && !"nouse".equals(search.getValue())) {
				itemInfo.setUseSearch(true);
				if ("equals".equals(search.getValue())) {
					// Ȃ
				} else if ("like".equals(search.getValue())) {
					itemInfo.setUseLike(true);
				}
			}

			AttributeData useList = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useList");
			itemInfo.setUseList(useList != null ? useList.getValueBoolean() : false);

			AttributeData useRef = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useRef");
			itemInfo.setUseRef(useRef != null ? useRef.getValueBoolean() : false);

			itemInfo.setUseInsert(false);
			itemInfo.setNoInputIns(false);
			AttributeData useInsert = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useIns");
			itemInfo.setUseInsert(useInsert != null ? useInsert.getValueBoolean() : false);
			if (useInsert != null && !"".equals(useInsert.getValue())) {
				itemInfo.setUseInsert(true);
				if ("input".equals(useInsert.getValue())) {
					// Ȃ
				} else if ("display".equals(useInsert.getValue())) {
					itemInfo.setNoInputIns(true);
				}
			}

			itemInfo.setUseUpdate(false);
			itemInfo.setNoInputUp(false);
			AttributeData useUpdate = interfaceData.getAttribute(itemId, PLUGIN_NAME, "useUp");
			if (useUpdate != null && !"".equals(useUpdate.getValue())) {
				itemInfo.setUseUpdate(true);
				if ("input".equals(useUpdate.getValue())) {
					// Ȃ
				} else if ("display".equals(useUpdate.getValue())) {
					itemInfo.setNoInputUp(true);
				}
			}

			AttributeData autoRowNo = interfaceData.getAttribute(itemId, PLUGIN_NAME, "autoRowNo");
			if (autoRowNo != null && autoRowNo.getValueBoolean() && multi) {
				itemInfo.setNoInputIns(true);
				itemInfo.setNoInputUp(true);
				itemInfo.setAutoRowNo(true);
			}

			AttributeData required = interfaceData.getAttribute(itemId, PLUGIN_NAME, "required");
			itemInfo.setRequired(required != null ? required.getValueBoolean() : false);

			AttributeData underLengthNg = interfaceData.getAttribute(itemId, PLUGIN_NAME, "underLengthNg");
			itemInfo.setUnderLengthNg(underLengthNg != null ? underLengthNg.getValueBoolean() : false);

			AttributeData stringChaeck = interfaceData.getAttribute(itemId, PLUGIN_NAME, "stringChaeck");
			itemInfo.setStringChaeck(stringChaeck != null ? stringChaeck.getValue() : "");

			AttributeData dokujiCheck = interfaceData.getAttribute(itemId, PLUGIN_NAME, "dokujiCheck");
			itemInfo.setDokujiCheck(dokujiCheck != null ? dokujiCheck.getValueBoolean() : false);

			AttributeData selectListName = interfaceData.getAttribute(itemId, PLUGIN_NAME, "selectListName");
			itemInfo.setSelectListName(selectListName != null ? selectListName.getValue() : "");

			itemInfoList.add(itemInfo);

		}

	}

	protected String chars(String str, int len) {
		StringBuilder sb = new StringBuilder();

		for (int i = 0; i < len; i++) {
			sb.append(str);
		}

		return sb.toString();
	}

	class SelectOut {
		ByteArrayOutputStream baos;
		String[] outMarks;

		public SelectOut(ByteArrayOutputStream baos, String... outMarks) {
			this.baos = baos;
			this.outMarks = outMarks;
		}

		/**
		 * w肳ꂽXg[ɃXg̕{sR[hoCi[ŏo͂
		 *
		 * @param lineList
		 * @throws UnsupportedEncodingException
		 * @throws IOException
		 */
		protected void put(List<String> lineList) throws UnsupportedEncodingException, IOException {

			List<String> outList = new LinkedList<String>();
			for (String line : lineList) {

				int endIndex = line.indexOf(MODE_MARK_END_STR);
				if (line.indexOf(MODE_MARK_STR) == 0 && endIndex > 0) {
					String mark = line.substring(MODE_MARK_STR.length(), endIndex).trim();
					for (String outMark : outMarks) {
						if (mark.equals(outMark)) {
							outList.add(line.substring(endIndex + MODE_MARK_END_STR.length()));
							break;
						}
					}
				} else {
					outList.add(line);
				}

			}

			if (outList.size() > 0) {
				out(baos, outList);
			}
		}

	}

	class ItemInfo {
		boolean listFlag;
		List<ItemInfo> listItemList;

		InterfaceDataItem item;
		String screenFieldType;

		boolean readOnly;
		boolean useList;
		boolean useInsert;
		boolean useUpdate;
		boolean useRef;

		boolean useSearch;
		boolean useLike;

		boolean noInputIns;
		boolean noInputUp;

		boolean autoRowNo;

		boolean required;
		boolean underLengthNg;
		String stringChaeck;
		boolean dokujiCheck;
		String selectListName;

		/**
		 * @return the listFlag
		 */
		public boolean isListFlag() {
			return listFlag;
		}

		/**
		 * @return the listItemList
		 */
		public List<ItemInfo> getListItemList() {
			return listItemList;
		}

		/**
		 * @return the item
		 */
		public InterfaceDataItem getItem() {
			return item;
		}

		/**
		 * @return the screenFieldType
		 */
		public String getScreenFieldType() {
			return screenFieldType;
		}

		/**
		 * @return the readOnly
		 */
		public boolean isReadOnly() {
			return readOnly;
		}

		/**
		 * @return the useList
		 */
		public boolean isUseList() {
			return useList;
		}

		/**
		 * @return the useInsert
		 */
		public boolean isUseInsert() {
			return useInsert;
		}

		/**
		 * @return the useUpdate
		 */
		public boolean isUseUpdate() {
			return useUpdate;
		}

		/**
		 * @return the useRef
		 */
		public boolean isUseRef() {
			return useRef;
		}

		/**
		 * @return the useSearch
		 */
		public boolean isUseSearch() {
			return useSearch;
		}

		/**
		 * @return the useLike
		 */
		public boolean isUseLike() {
			return useLike;
		}

		/**
		 * @return the noInputUp
		 */
		public boolean isNoInputUp() {
			return noInputUp;
		}

		/**
		 * @return the underLengthNg
		 */
		public boolean isUnderLengthNg() {
			return underLengthNg;
		}

		/**
		 * @return the stringChaeck
		 */
		public String getStringChaeck() {
			return stringChaeck;
		}

		/**
		 * @return the dokujiCheck
		 */
		public boolean isDokujiCheck() {
			return dokujiCheck;
		}

		/**
		 * @return the selectListName
		 */
		public String getSelectListName() {
			return selectListName;
		}

		/**
		 * @param listFlag
		 *            the listFlag to set
		 */
		public void setListFlag(boolean listFlag) {
			this.listFlag = listFlag;
		}

		/**
		 * @param listItemList
		 *            the listItemList to set
		 */
		public void setListItemList(List<ItemInfo> listItemList) {
			this.listItemList = listItemList;
		}

		/**
		 * @param item
		 *            the item to set
		 */
		public void setItem(InterfaceDataItem item) {
			this.item = item;
		}

		/**
		 * @param screenFieldType
		 *            the screenFieldType to set
		 */
		public void setScreenFieldType(String screenFieldType) {
			this.screenFieldType = screenFieldType;
		}

		/**
		 * @param readOnly
		 *            the readOnly to set
		 */
		public void setReadOnly(boolean readOnly) {
			this.readOnly = readOnly;
		}

		/**
		 * @param useList
		 *            the useList to set
		 */
		public void setUseList(boolean useList) {
			this.useList = useList;
		}

		/**
		 * @param useInsert
		 *            the useInsert to set
		 */
		public void setUseInsert(boolean useInsert) {
			this.useInsert = useInsert;
		}

		/**
		 * @param useUpdate
		 *            the useUpdate to set
		 */
		public void setUseUpdate(boolean useUpdate) {
			this.useUpdate = useUpdate;
		}

		/**
		 * @param useRef
		 *            the useRef to set
		 */
		public void setUseRef(boolean useRef) {
			this.useRef = useRef;
		}

		/**
		 * @param useSearch
		 *            the useSearch to set
		 */
		public void setUseSearch(boolean useSearch) {
			this.useSearch = useSearch;
		}

		/**
		 * @param useLike
		 *            the useLike to set
		 */
		public void setUseLike(boolean useLike) {
			this.useLike = useLike;
		}

		/**
		 * @param noInputUp
		 *            the noInputUp to set
		 */
		public void setNoInputUp(boolean noInputUp) {
			this.noInputUp = noInputUp;
		}

		/**
		 * @param underLengthNg
		 *            the underLengthNg to set
		 */
		public void setUnderLengthNg(boolean underLengthNg) {
			this.underLengthNg = underLengthNg;
		}

		/**
		 * @param stringChaeck
		 *            the stringChaeck to set
		 */
		public void setStringChaeck(String stringChaeck) {
			this.stringChaeck = stringChaeck;
		}

		/**
		 * @param dokujiCheck
		 *            the dokujiCheck to set
		 */
		public void setDokujiCheck(boolean dokujiCheck) {
			this.dokujiCheck = dokujiCheck;
		}

		/**
		 * @param selectListName
		 *            the selectListName to set
		 */
		public void setSelectListName(String selectListName) {
			this.selectListName = selectListName;
		}

		/**
		 * @return the required
		 */
		public boolean isRequired() {
			return required;
		}

		/**
		 * @param required
		 *            the required to set
		 */
		public void setRequired(boolean required) {
			this.required = required;
		}

		/**
		 * @return the noInputIns
		 */
		public boolean isNoInputIns() {
			return noInputIns;
		}

		/**
		 * @param noInputIns
		 *            the noInputIns to set
		 */
		public void setNoInputIns(boolean noInputIns) {
			this.noInputIns = noInputIns;
		}

		/**
		 * @return the autoRowNo
		 */
		public boolean isAutoRowNo() {
			return autoRowNo;
		}

		/**
		 * @param autoRowNo
		 *            the autoRowNo to set
		 */
		public void setAutoRowNo(boolean autoRowNo) {
			this.autoRowNo = autoRowNo;
		}

	}

}
