package jp.oarts.pirka.iop.tool.core.plugin.in;

import java.util.HashMap;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDesignerPlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * C^tF[XRs[Et@CfUCi[vOC
 *
 * @author ito
 *
 */
public class CopyInterfaceDesigner implements InterfaceDesignerPlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = -7451726694840163479L;

	// p[^`
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("fromInterface", "Rs[C^[tF[X", "Rs[̃C^[tF[XI܂", ParameterType.INTERFACE, 1, null,
					new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),

			//
			new ParameterSimpleItem("exCopy", "CN[hĂ鍀ڂ̓Rs[Œ`ꂽڂƂăRs[s",
					"CN[hĂ鍀ڂRs[Œ`ꂽڂƂăRs[sƂ`FbN܂", ParameterType.CHECK, new ParameterData(false), null),

			//
			new ParameterSimpleItem("attachCopy", "A^b`̃Rs[s", "A^b`yёRs[Ƃ̓`FbN܂", ParameterType.CHECK,
					new ParameterData(false), null),

			//
			new ParameterSimpleItem("interfaceName", "Rs[̃C^[tF[X", "Rs[ĐV쐬C^[tFX͂܂", ParameterType.TEXT,
					new ParameterData("copyInterface"), new ParameterChecker() {

						@Override
						public void check(String str) throws InterfaceException {
							if (str == null || str.length() <= 0) {
								throw new InterfaceException("͂ł");
							}

							if (!InterfaceTools.isSafeInterfaceDataNmae(str)) {
								throw new InterfaceException("gpłȂ͂܂");
							}
						}
					}),

			//
			new ParameterSimpleItem("interfaceNameJp", "Rs[̃C^[tF[Xi{ꖼj", "Rs[ĐV쐬C^[tFX{ꖼ͂܂",
					ParameterType.TEXT, new ParameterData("Rs[ꂽC^[tF[X"), new ParameterChecker() {

						@Override
						public void check(String str) throws InterfaceException {
							if (str == null || str.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),

			//
			new ParameterSimpleItem("comment", "Rs[̃C^[tF[XRg", "Rs[ĐV쐬C^[tFX̃Rg͂܂", ParameterType.TEXT_AREA, null, null),

	};

	@Override
	public String createInterfaceDesign(HashMap<String, ParameterData> dataMap, InterfaceProject project) throws InterfaceException {

		int fromId = dataMap.get("fromInterface").getValueInt();
		boolean exCopy = dataMap.get("exCopy").getValueBoolean();
		boolean attachCopy = dataMap.get("attachCopy").getValueBoolean();
		String interfaceName = dataMap.get("interfaceName").getValue();
		String interfaceNameJp = dataMap.get("interfaceNameJp").getValue();
		String comment = dataMap.get("comment").getValue();

		InterfaceData fromData = project.getInterfaceDataManager().getInterfaceData(fromId);
		InterfaceData toData;
		if (!exCopy) {
			toData = fromData.clone(attachCopy);
		} else {
			toData = fromData.expandcClone(attachCopy);
		}

		toData.setName(interfaceName);
		toData.setNameJp(interfaceNameJp);
		toData.setComment(comment);
		return null;
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public String getComment() {
		return "`ς݃C^[tF[XC^[tF[X̃Rs[쐬܂";
	}

	@Override
	public String getParameterComment() {
		return "`ς݃C^[tF[XC^[tF[X̃Rs[쐬܂B";
	}

	@Override
	public String getName() {
		return "jp.oarts.ifop.tool.core.plugin.in#CopyInterfaceDesigner";
	}

	@Override
	public String getNameJp() {
		return "C^[tF[X̃Rs[";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

	}

	@Override
	public boolean useSaveAndLoadParameter() {
		return false;
	}

}
