package jp.oarts.pirka.iop.tool.core.plugin.in;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDesignerPlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataMyItem;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * CSVt@CǍEt@CfUCi[C^[tF[X
 *
 * @author ito
 *
 */
public class CsvFileInterfaceDesigner implements InterfaceDesignerPlugin {

	/**
	 *
	 */
	private static final long serialVersionUID = -4181482973945241760L;

	// p[^`
	@SuppressWarnings("serial")
	private static ParameterItem[] parameterItems = new ParameterItem[] { //
	//

			new ParameterSimpleItem("file", "CSVt@C", "ǍsCSVt@Cw肵܂", ParameterType.FILE, null, new ParameterChecker() {

				@Override
				public void check(String value) throws InterfaceException {
					if (value == null || value.length() <= 0) {
						throw new InterfaceException("͂ł");
					}
				}
			}),
			//

			new ParameterSimpleItem("existsHeaderLine", "CSVwb_sL", "ǂݍ܂CSVt@CɃwb_񂪑݂ƂɃ`FbN܂", ParameterType.CHECK,
					new ParameterData(true), null),
			//

			new ParameterSimpleItem("interfaceName", "C^[tF[X", "V쐬C^[tFX͂܂", ParameterType.TEXT,
					new ParameterData("newInterface"), new ParameterChecker() {

						@Override
						public void check(String str) throws InterfaceException {
							if (str == null || str.length() <= 0) {
								throw new InterfaceException("͂ł");
							}

							if (!InterfaceTools.isSafeInterfaceDataNmae(str)) {
								throw new InterfaceException("gpłȂ͂܂");
							}
						}
					}),
			//

			new ParameterSimpleItem("interfaceNameJp", "C^[tF[Xi{ꖼj", "V쐬C^[tFX{ꖼ͂܂", ParameterType.TEXT,
					new ParameterData("VC^[tF[X"), new ParameterChecker() {

						@Override
						public void check(String str) throws InterfaceException {
							if (str == null || str.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//

			new ParameterSimpleItem("comment", "C^[tF[XRg", "V쐬C^[tFX̃Rg͂܂", ParameterType.TEXT_AREA, null, null),

	};

	@Override
	public String createInterfaceDesign(HashMap<String, ParameterData> dataMap, InterfaceProject project) throws InterfaceException {

		byte[] file = dataMap.get("file").getFileImage();
		boolean existsHeaderLine = dataMap.get("existsHeaderLine").getValueBoolean();
		String interfaceName = dataMap.get("interfaceName").getValue();
		String interfaceNameJp = dataMap.get("interfaceNameJp").getValue();
		String comment = dataMap.get("comment").getValue();

		int errorCount = 0;
		BufferedReader br = null;

		DecimalFormat fmt = new DecimalFormat("0000");

		List<InterfaceDataMyItem> fieldList = new LinkedList<InterfaceDataMyItem>();
		int lineCount = 0;
		// wb_s̓ǂݔ΂̂
		if (existsHeaderLine) {
			lineCount--;
		}

		try {
			try {
				br = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(file), "JISAutoDetect"));

				while (true) {
					String line = br.readLine();

					if (line == null) {
						break;
					}

					lineCount++;

					// wb_s̓ǂݔ΂
					if (lineCount < 1) {
						continue;
					}

					// ftHgl
					String name = "item" + fmt.format(lineCount);
					String nameJp = "" + fmt.format(lineCount);
					String typeStr = "String";
					String lengthStr = "10";
					String subLengthStr = "0";

					String[] csvFieldData = InterfaceTools.csvLineSplit(line);

					if (csvFieldData.length >= 1) {
						String nameWk = csvFieldData[0];
						if (nameWk.length() > 0) {
							if (!InterfaceTools.isSafeInterfaceDataItemNmae(nameWk)) {
								errorCount++;
								nameWk = InterfaceTools.changeSafeInterfaceDataItemNmae(nameWk, "");
							}
						} else {
							errorCount++;
						}
						if (nameWk.length() > 0) {
							name = nameWk;
						}

						if (csvFieldData.length >= 2) {
							String nameJpWk = csvFieldData[1];
							if (nameJpWk.length() > 0) {
								nameJp = nameJpWk;
							} else {
								errorCount++;
							}
						}

						if (csvFieldData.length >= 3) {
							typeStr = csvFieldData[2];
						} else {
							errorCount++;
						}
						FieldType type = null;
						try {
							type = FieldType.valueOf(typeStr);
						} catch (Exception e1) {
							// Ȃ
						}
						if (type == null) {
							type = FieldType.STRING;
							errorCount++;
						}

						if (csvFieldData.length >= 4) {
							if (csvFieldData[3].length() > 0) {
								lengthStr = csvFieldData[3];
							}
						}

						long length = 0;
						try {
							length = Long.valueOf(lengthStr);
						} catch (NumberFormatException e) {
							errorCount++;
						}

						if (csvFieldData.length >= 5) {
							if (csvFieldData[4].length() > 0) {
								subLengthStr = csvFieldData[4];
							}
						}
						int subLength = 0;
						try {
							subLength = Integer.valueOf(subLengthStr);
						} catch (NumberFormatException e) {
							errorCount++;
						}

						fieldList.add(new InterfaceDataMyItem(name, nameJp, type, length, subLength, false));
					}
				}

			} finally {
				if (br != null) {
					br.close();
				}
			}
		} catch (IOException e) {
			throw new InterfaceException("CSVt@C͒ɃG[܂", e);
		}

		InterfaceData newInterfaceData = project.getInterfaceDataManager().createInterfaceData();

		newInterfaceData.setName(interfaceName);
		newInterfaceData.setNameJp(interfaceNameJp);
		newInterfaceData.setComment(comment);

		for (InterfaceDataMyItem item : fieldList) {
			newInterfaceData.addMyItem(item);
		}

		if (errorCount > 0) {
			return "G[" + errorCount + "݂܂B\nG[ӏɂ̓ftHglݒ肵܂B\nmFB";
		}

		return null;
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public String getComment() {
		return "CSVt@Cǂݍ݃C^[tF[X쐬܂";
	}

	@Override
	public String getParameterComment() {
		return "CSVt@Cǂݍ݃C^[tF[X쐬܂B\n\n" //
				+ "CSVt@C̍ڂ̕тȉɎ܂B\n" //
				+ "@\"ږ\",\"ږi{j\",\"ڃ^Cv\",ڒ,Tuڒ\n\n" //
				+ "ږ͉pAڃ^Cv\"STRING\":A\"NUM\":lA\n" //
				+ "\"IMAGE\":C[WioCijA\"DATE\":tA\"TIME\":ԁA\n" //
				+ "\"DATE_TIME\":tԁA\"BOOLEAN\":^Uwł܂B";
	}

	@Override
	public String getName() {
		return "jp.oarts.ifop.tool.core.plugin.in#CsvFileInterfaceDesigner";
	}

	@Override
	public String getNameJp() {
		return "CSVt@CC^[tF[X쐬";
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

	}

	@Override
	public boolean useSaveAndLoadParameter() {
		return false;
	}

}
