package jp.oarts.pirka.iop.tool.core.plugin.in.database;

import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner.DatabaseMetaInfo;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

/**
 * postgreSQLp̕␳[`
 * @author ito
 *
 */
public class PostgreSQLReviseType extends ReviseType {

	public PostgreSQLReviseType() {

		preChnageFieldTypeMap.put("bpchar".toLowerCase(), "char");

		setLengthMapItem.put("character varying".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY,
				2147483647L, 0));
		setLengthMapItem.put("varchar".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("character".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("char".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));

		setLengthMapItem.put("numeric".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 131089L, 0));
		setLengthMapItem.put("decimal".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 131089L, 0));

		setLengthMapItem.put("bit".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 1L, 0));
		setLengthMapItem.put("bit varying".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));
		setLengthMapItem.put("varbit".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_ONLY, 2147483647L, 0));

		setLengthMapItem.put("interval".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));

		setLengthMapItem.put("TIME".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		setLengthMapItem
				.put("TIME without time zone".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		setLengthMapItem.put("TIME with time zone".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		setLengthMapItem.put("timetz".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		setLengthMapItem.put("TIMESTAMP".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));
		setLengthMapItem.put("TIMESTAMP without time zone".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY,
				0L, 6));
		setLengthMapItem.put("TIMESTAMP with time zone".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L,
				6));
		setLengthMapItem.put("timestamptz".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_DEC_ONLY, 0L, 6));

//		setLengthMapItem.put("money".toLowerCase(), new ChangeInfo(ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC, 20L, 2));

		autoIncrementFieldTypeSet.add("bigserial".toLowerCase());
		autoIncrementFieldTypeSet.add("serial".toLowerCase());
		autoIncrementFieldTypeSet.add("serial4".toLowerCase());
		autoIncrementFieldTypeSet.add("serial8".toLowerCase());
	}

	/**
	 * ŏIϊs
	 * @param info
	 */
	@Override
	protected void lastChange(DatabaseMetaInfo info){
		//	bigserialserial̃ftHglɂnextvaluei[Ă邪CreateTableɂ͕svȂ̂ō폜
		if("bigserial".equalsIgnoreCase(info.getFieldType()) || "serial".equalsIgnoreCase(info.getFieldType())){
			info.setDefaultValue("");
			info.setAutoIncrement(true);
			info.setNotNull(false);	//	DB쐬Serialŉʑ쎞͖́iftHgŃV[PXj\Ƃ̂ not null͂
		} else {
			if (info.getType() == FieldType.NUM && info.getDefaultValue() != null && info.getDefaultValue().length() > 0) {
				String sequenceName = IopUtil.getSequenceNameFromNextval(info.getDefaultValue());
				if (sequenceName != null) {
					info.setAutoIncrement(true);
					info.setSequenceName(sequenceName);
					info.setDefaultValue("");
				}
			}
		}


//		if("bit".equalsIgnoreCase(info.getFieldType()) ){
//			info.setType(FieldType.IMAGE);
//		}
		if(info.getType() == FieldType.NUM && info.getLength()>100){
			info.setLength(20);
		}
		if (info.getType() == FieldType.NUM && info.getSubLength() > 100) {
			info.setSubLength(2);
		}
	}



}