package jp.oarts.pirka.iop.tool.core.plugin.in.database;

import java.util.HashMap;
import java.util.HashSet;

import jp.oarts.pirka.iop.tool.core.plugin.in.database.DatabaseInterfaceDesigner.DatabaseMetaInfo;

/**
 * f[^x[X^␳ϊp̒ۃNX
 *
 * @author ito
 *
 */
public abstract class ReviseType {

	// ɕϊĂ^Cv
	protected HashMap<String, String> preChnageFieldTypeMap = new HashMap<String, String>();

	// f[^vݒf[^^}bviDBʁj
	protected HashMap<String, ChangeInfo> setLengthMapItem = new HashMap<String, ChangeInfo>();

	// Aԃ^CvtB[h^CvZbg
	protected HashSet<String> autoIncrementFieldTypeSet = new HashSet<String>();

	/**
	 * Ǝ^̕񐶐
	 *
	 * @param lengthMode
	 * @param type
	 * @param length
	 * @param subLength
	 * @return 
	 */
	protected String createDefineFieldType(int lengthMode, String type, long length, int subLength) {

		switch (lengthMode) {
		case ChangeInfo.SET_LENGTH_MODE_LEN_ONLY:
			return type + "(" + length + ")";
		case ChangeInfo.SET_LENGTH_MODE_DEC_ONLY:
			if (subLength == 0) {
				return type;
			}
			return type + "(" + subLength + ")";
		case ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC:
			if (subLength == 0) {
				return type + "(" + length + ")";
			}
			return type + "(" + length + ", " + subLength + ")";
		}

		return type;

	}

	/**
	 * ̘A锼pXy[X1̃Xy[Xɒu
	 *
	 * @param str
	 * @return 
	 */
	protected String cutMultiSpace(String str) {
		StringBuilder sb = new StringBuilder();

		boolean spaceFlag = false;
		str = str.trim();

		for (char c : str.toCharArray()) {
			if (c == ' ') {
				if (!spaceFlag) {
					spaceFlag = true;
					sb.append(c);
				}
			} else {
				spaceFlag = false;
				sb.append(c);
			}
		}

		return sb.toString();
	}

	/**
	 * ␳ϊ
	 *
	 * @param info
	 */
	public void reviseType(DatabaseMetaInfo info) {

		String key = cutMultiSpace(info.getFieldType()).trim().toLowerCase();

		if (preChnageFieldTypeMap.containsKey(key)) {
			key = preChnageFieldTypeMap.get(key);
		}
		ChangeInfo ci = null;
		boolean changeFlag = false;
		if (setLengthMapItem.containsKey(key)) {

			ci = setLengthMapItem.get(key);
			switch (ci.getSetLengthMode()) {
			case ChangeInfo.SET_LENGTH_MODE_LEN_ONLY:
				if (info.getLength() != ci.getDefaultLength()) {
					changeFlag = true;
				}
				break;

			case ChangeInfo.SET_LENGTH_MODE_LEN_AND_DEC:
				if (numberChangeCheck(info, ci)) {
					changeFlag = true;
				}
				break;

			case ChangeInfo.SET_LENGTH_MODE_DEC_ONLY:
				if (info.getSubLength() != ci.getDefaultSubLength()) {
					changeFlag = true;
				}
				break;
			}
		}

		lastChange(info);

		if (changeFlag) {
			info.setFieldType(createDefineFieldType(ci.getSetLengthMode(), info.getFieldType(), info.getLength(), info
					.getSubLength()));
		} else {
			// info.setLength(0);
			// info.setSubLength(0);
		}

		return;

	}

	/**
	 * ŏIϊs
	 *
	 * @param info
	 */
	protected void lastChange(DatabaseMetaInfo info) {

	}

	/**
	 * Œ萔l̎Ɍ^`̕ϊs̃`FbN
	 *
	 * @param info
	 * @param ci
	 * @return true=^`̕ϊKv
	 */
	protected boolean numberChangeCheck(DatabaseMetaInfo info, ChangeInfo ci) {
		return info.getLength() != ci.getDefaultLength() || info.getSubLength() != ci.getDefaultSubLength();
	}

	/**
	 * AԂ̃tB[h^Cv
	 *
	 * @param fialdType
	 * @return
	 */
	public boolean isAutoIncrementFieldType(String fialdType) {
		if (fialdType == null) {
			return false;
		}

		return autoIncrementFieldTypeSet.contains(fialdType.toLowerCase());
	}

	/**
	 * V[PX
	 *
	 * @param tableName
	 *            e[u
	 * @param fieldName
	 *            tB[h
	 * @return
	 */
	public String makeAutoSequenceName(String tableName, String fieldName) {
		return tableName + "_" + fieldName + "_seq";
	}

}
