package jp.oarts.pirka.iop.tool.core.plugin.sample.csv;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerPlugin;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.Define;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.file.csv.CsvFileOutputJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.vo.ValueObjectJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * f[^x[X̃e[ũR[hCSVt@C֏o̓ob`vOTvf[
 *
 * @author ito
 *
 */
@SuppressWarnings("serial")
public class CsvFileOutputJavaSample extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.sample#CsvFileOutputJavaSample";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "CSVt@Co̓ob`vOTvo";

	/**
	 *
	 */

	static final HashSet<String> paramerteNameSet;

	static {
		paramerteNameSet = new HashSet<String>();
		paramerteNameSet.add("targetInterface");
		paramerteNameSet.add("package");
		paramerteNameSet.add("db");
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			//
			new ParameterSimpleItem("db", "f[^x[X", "o͂\[Xt@Cgpf[^x[Xw肵܂", ParameterType.DB, 0, null,
					new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					})
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public CsvFileOutputJavaSample() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.SAMPLE_MODELER, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "f[^x[X̃e[ũR[hCSVt@C֏o͂ob`vOɕKv\n" //
				+ "Tv\[Xt@CAf[^x[Xe[u`t@C\n" //
				+ "et@Co͂܂B\n\n" //
				+ "o͂sC^[tF[Xɂ\n" //
				+ "@w" + DataBaseFileCreator.PLUGIN_NAME_JP + "x\n" //
				+ "A^b`ĂKv܂B\n\n" + " f[^[x[Xɑ݂ꕔ̃f[^^ɑΉĂ܂B\n" + "@ 쎞ɃG[Ƃ̓\[XR[h̏CKvłB";
	}

	@Override
	public String getAttributeComment() {
		return getComment();
	}

	@Override
	public String getParameterComment() {
		return getComment();
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		ParameterData packageName = dataMap.get("package");
		ParameterData db = dataMap.get("db");

		List<String> errrorKeyTempList = new LinkedList<String>();
		HashMap<String, ParameterData> paramMap = new HashMap<String, ParameterData>();

		try {
			FileCreatorSampleModelerPlugin plugin = null;
			// f[^x[X`
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("db", db);
			plugin = new DataBaseFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			// DAO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("db", db);
			paramMap.put("common", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new DaoFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			// VO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			plugin = new ValueObjectJavaFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			// CSV
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("mainFlag", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new CsvFileOutputJavaFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

		} catch (InterfaceException e) {
			HashSet<String> set = new HashSet<String>();

			for (String keyName : errrorKeyTempList) {
				if (paramerteNameSet.contains(keyName) && !set.contains(keyName)) {
					set.add(keyName);
				}
			}
			for (String keyName : set) {
				errrorKeyList.add(keyName);
			}
			throw e;
		}
	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {
		try {
			HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();
			InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
					dataMap.get("targetInterface").getValueInt());
			String className = InterfaceTools.changeClassNmae(interfaceData.getName());
			String nameJp = interfaceData.getNameJp();

			ParameterData targetInterfaceId = dataMap.get("targetInterface");
			ParameterData packageName = dataMap.get("package");
			ParameterData db = dataMap.get("db");

			HashMap<String, ParameterData> paramMap = new HashMap<String, ParameterData>();

			FileCreatorSampleModelerPlugin plugin = null;

			// f[^x[X`
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("db", db);
			plugin = new DataBaseFileCreator();
			AttributeFileImage tempFile = plugin.create(paramMap, interfaceProject);
			fileMap.put(tempFile.getFileNmae(), tempFile.getFileImage());

			// DAO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("db", db);
			paramMap.put("common", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new DaoFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

			// VO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			plugin = new ValueObjectJavaFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			fileMap.put(tempFile.getFileNmae(), tempFile.getFileImage());

			// CSV
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("mainFlag", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new CsvFileOutputJavaFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

			// readMe.txt
			fileMap.put("readMe.txt", createReadMeTxt(packageName.getValue(), className, nameJp));

			// db.xml
			fileMap.put("db.xml", createDbXml(packageName.getValue(), className, nameJp));

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "MstMntSample.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * readMe.txtt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createReadMeTxt(String packageName, String className, String nameJp) throws IOException,
			InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			setParameter("nameJp", nameJp);
			setParameter("ver", Define.PROGRAM_VERSION_NO);
			setParameter("date", (new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")).format(Calendar.getInstance().getTime()));
			out(baos, getText("readMe.txt"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * web.xmlt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createWebXml(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("web.xml"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * db.xmlt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createDbXml(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("db.xml"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * startAppt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createStartApp(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("startApp"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}
}
