package jp.oarts.pirka.iop.tool.core.plugin.sample.mntgae;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerPlugin;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.Define;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.file.gae.GaeDaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml.MntHtmlFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml.MntHtmlJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.vo.ValueObjectJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * GAEp}X^eiXTvf[
 *
 * @author ito
 *
 */
@SuppressWarnings("serial")
public class GaeMstMntSample extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.sample.mntgae#GaeMstMntSample";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "GAEp}X^[eiXTvo";

	static final HashSet<String> paramerteNameSet;

	static {
		paramerteNameSet = new HashSet<String>();
		paramerteNameSet.add("targetInterface");
		paramerteNameSet.add("package");
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 0,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null), };

	// /////////////////////////////////////////////////////////////////////////////////////

	public GaeMstMntSample() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.SAMPLE_MODELER, false, true, true);
	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "GAEE}X^eiXɕKvHTMLt@CATv\[Xt@C\n" //
				+ "et@Co͂܂B\n\n" //
				+ "o͂sC^[tF[Xɂ\n@w" //
				+ MntHtmlFileCreator.PLUGIN_NAME_JP + "xA\n@w" + GaeDaoFileCreator.PLUGIN_NAME_JP + "x\n" //
				+ "A^b`ĂKv܂B";

	}

	@Override
	public String getAttributeComment() {
		return getComment();
	}

	@Override
	public String getParameterComment() {
		return getComment();
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		ParameterData targetInterfaceId = dataMap.get("targetInterface");
		ParameterData packageName = dataMap.get("package");

		List<String> errrorKeyTempList = new LinkedList<String>();
		HashMap<String, ParameterData> paramMap = new HashMap<String, ParameterData>();

		try {
			FileCreatorSampleModelerPlugin plugin = null;

			// DAO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			// paramMap.put("db", db);
			paramMap.put("common", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new GaeDaoFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			// VO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			plugin = new ValueObjectJavaFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			// HTML
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("list", new ParameterData(true));
			paramMap.put("reference", new ParameterData(true));
			paramMap.put("insert", new ParameterData(true));
			paramMap.put("update", new ParameterData(true));
			paramMap.put("gaeFlag", new ParameterData(true));
			plugin = new MntHtmlFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			// HTML java
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("list", new ParameterData(true));
			paramMap.put("reference", new ParameterData(true));
			paramMap.put("insert", new ParameterData(true));
			paramMap.put("update", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new MntHtmlJavaFileCreator();
			plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

		} catch (InterfaceException e) {
			HashSet<String> set = new HashSet<String>();

			for (String keyName : errrorKeyTempList) {
				if (paramerteNameSet.contains(keyName) && !set.contains(keyName)) {
					set.add(keyName);
				}
			}
			for (String keyName : set) {
				errrorKeyList.add(keyName);
			}
			throw e;
		}
	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {
		try {
			HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();
			InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
					dataMap.get("targetInterface").getValueInt());
			String className = InterfaceTools.changeClassNmae(interfaceData.getName());
			String nameJp = interfaceData.getNameJp();

			ParameterData targetInterfaceId = dataMap.get("targetInterface");
			ParameterData packageName = dataMap.get("package");

			HashMap<String, ParameterData> paramMap = new HashMap<String, ParameterData>();

			FileCreatorSampleModelerPlugin plugin = null;

			AttributeFileImage tempFile;

			// VO
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			plugin = new ValueObjectJavaFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			fileMap.put(tempFile.getFileNmae(), tempFile.getFileImage());

			// HTML
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("list", new ParameterData(true));
			paramMap.put("reference", new ParameterData(true));
			paramMap.put("insert", new ParameterData(true));
			paramMap.put("update", new ParameterData(true));
			paramMap.put("gaeFlag", new ParameterData(true));
			plugin = new MntHtmlFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

			// HTML java
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("list", new ParameterData(true));
			paramMap.put("reference", new ParameterData(true));
			paramMap.put("insert", new ParameterData(true));
			paramMap.put("update", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new MntHtmlJavaFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

			
			// DAO	log4j.propertiesGAEp̕o͂邽߁ÃvOC͍ŌłȂĂ͂ȂȂ@ӁII
			paramMap.clear();
			paramMap.put("targetInterface", targetInterfaceId);
			paramMap.put("package", packageName);
			paramMap.put("common", new ParameterData(true));
			paramMap.put("logout", new ParameterData(true));
			plugin = new GaeDaoFileCreator();
			tempFile = plugin.create(paramMap, interfaceProject);
			InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);
			
			// readMe.txt
			fileMap.put("readMe.txt", createReadMeTxt(packageName.getValue(), className, nameJp));

			// web.xml
			fileMap.put("web.xml", createWebXml(packageName.getValue(), className, nameJp));

			// Gg[|Cg
			fileMap.put(className + "StartApp.java", createStartApp(packageName.getValue(), className, nameJp));

			if (fileMap.size() == 1) {
				String fileName = fileMap.keySet().toArray(new String[0])[0];
				return new AttributeFileImage(fileName, fileMap.get(fileName));
			}

			return new AttributeFileImage(className + "GaeMstMntSample.zip", createZipImage(fileMap));

		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}

	}

	/**
	 * readMe.txtt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createReadMeTxt(String packageName, String className, String nameJp) throws IOException,
			InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			if(packageName.length()>0){
				setParameter("package1", "pbP[W " +packageName+" 쐬");
				setParameter("package2", "쐬pbP[W");
			}else{
				setParameter("package1", "");
				setParameter("package2", "");
			}

			setParameter("mntName", className);
			setParameter("package", packageName);
			setParameter("nameJp", nameJp);
			setParameter("ver", Define.PROGRAM_VERSION_NO);
			setParameter("date", (new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")).format(Calendar.getInstance().getTime()));
			out(baos, getText("readMe.txt"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * web.xmlt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createWebXml(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			if (packageName.length() <= 0) {
				setParameter("packageMntName", className);
			} else {
				setParameter("packageMntName", packageName + "." + className);
			}
			out(baos, getText("web.xml"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	// /**
	// * db.xmlt@CC[W쐬
	// *
	// * @param packageName
	// * @param className
	// * @param nameJp
	// * @return t@CC[W
	// * @throws IOException
	// * @throws InterfaceException
	// */
	// protected byte[] createDbXml(String packageName, String className, String
	// nameJp) throws IOException, InterfaceException {
	//
	// ByteArrayOutputStream baos = null;
	// try {
	// baos = new ByteArrayOutputStream();
	//
	// setParameter("mntName", className);
	// setParameter("package", packageName);
	// out(baos, getText("db.xml"));
	// baos.flush();
	//
	// } finally {
	// if (baos != null) {
	// baos.close();
	// }
	// }
	// return baos.toByteArray();
	// }

	/**
	 * startAppt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createStartApp(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("startApp"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}
}
