package jp.oarts.pirka.iop.tool.core.plugin.sample.mntmulti;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;

import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerPlugin;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerTextCreatorSimplePlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.ParameterChecker;
import jp.oarts.pirka.iop.tool.core.business.ParameterItem;
import jp.oarts.pirka.iop.tool.core.business.ParameterSimpleItem;
import jp.oarts.pirka.iop.tool.core.general.constants.Define;
import jp.oarts.pirka.iop.tool.core.general.constants.ParameterType;
import jp.oarts.pirka.iop.tool.core.general.constants.PluginType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeFileImage;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DaoFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.db.DataBaseFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml.MntHtmlFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.mnthtml.MntHtmlJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.plugin.file.vo.ValueObjectJavaFileCreator;
import jp.oarts.pirka.iop.tool.core.tools.InterfaceTools;

/**
 * }X^eiXTvf[(C^[tF[Xꊇo)
 *
 * @author ito,furukawa
 *
 */
@SuppressWarnings("serial")
public class MultiMstMntSample extends FileCreatorSampleModelerTextCreatorSimplePlugin {

	// vOCʖ
	public static final String PLUGIN_NAME = "jp.oarts.ifop.tool.core.plugin.sample#MultiMstMntSample";

	// vOC{ꖼ
	public static final String PLUGIN_NAME_JP = "}X^[eiXTvꊇo";

	static final HashSet<String> paramerteNameSet;

	static {
		paramerteNameSet = new HashSet<String>();
		paramerteNameSet.add("targetInterface");
		paramerteNameSet.add("package");
		paramerteNameSet.add("db");
	}

	// `
	// ///////////////////////////////////////////////////////////////////
	private static AttributeItem[] attributeItems = new AttributeItem[] { //

	};

	// /////////////////////////////////////////////////////////////////////////////////////

	// p[^`
	// ///////////////////////////////////////////////////////////////////
	private static ParameterItem[] parameterItems = new ParameterItem[] { //

	//
			new ParameterSimpleItem("targetInterface", "o͂sC^[tF[X", "o͑Ώۂ̃C^[tF[Xw肵܂", ParameterType.INTERFACE, 10,
					null, new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					}, true),
			//
			new ParameterSimpleItem("package", "pbP[W", "o͂NXpbP[W͂܂", ParameterType.TEXT, null, null),
			//
			new ParameterSimpleItem("db", "f[^x[X", "o͂\[Xt@Cgpf[^x[Xw肵܂", ParameterType.DB, 0, null,
					new ParameterChecker() {

						@Override
						public void check(String value) throws InterfaceException {
							if (value == null || value.length() <= 0) {
								throw new InterfaceException("͂ł");
							}
						}
					})
	//
	};

	// /////////////////////////////////////////////////////////////////////////////////////

	public MultiMstMntSample() throws InterfaceException {
		super(PLUGIN_NAME, PLUGIN_NAME_JP, PluginType.SAMPLE_MODELER, false, true, true);

	}

	@Override
	public ParameterItem[] getParameterItems() {
		return parameterItems;
	}

	@Override
	public AttributeItem[] getAttributeItems() {
		return attributeItems;
	}

	@Override
	public String getComment() {
		return "f[^x[Xe[uE}X^eiXɕKvHTMLt@CA\n" //
				+ "Tv\[Xt@CAf[^x[Xe[u`t@C\n" //
				+ "et@Co͂܂B\n\n" //
				+ "włC^[tF[X́A10܂łłB\n\n" //
				+ "o͂sC^[tF[Xɂ\n@w" //
				+ MntHtmlFileCreator.PLUGIN_NAME_JP + "xA\n@w" + DataBaseFileCreator.PLUGIN_NAME_JP + "x\n" //
				+ "A^b`ĂKv܂B";
	}

	@Override
	public String getAttributeComment() {
		return getComment();
	}

	@Override
	public String getParameterComment() {
		return getComment();
	}

	@Override
	public void checkParameter(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject,
			List<String> errrorKeyList) throws InterfaceException {

		List<String> errrorKeyTempList = new LinkedList<String>();

		// C^[tF[XIôŁAIlzɕϊ
		String line = dataMap.get("targetInterface").getValue();
		StringTokenizer st = new StringTokenizer(line);
		List<Integer> interfaceIds = new LinkedList<Integer>();
		while (st.hasMoreTokens()) {
			interfaceIds.add(Integer.parseInt(st.nextToken()));
		}
		if (interfaceIds.size() > 10) {
			throw new InterfaceException("włC^[tF[X́A10܂łł");
		}
		ParameterData targetInterfaceIdSelected = dataMap.get("targetInterface");
		ParameterData packageName = dataMap.get("package");
		ParameterData db = dataMap.get("db");

		for (int id : interfaceIds) {
			targetInterfaceIdSelected.setValue(Integer.toString(id));

			HashMap<String, ParameterData> paramMap = new HashMap<String, ParameterData>();

			try {
				FileCreatorSampleModelerPlugin plugin = null;
				// f[^x[X`
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceIdSelected);
				paramMap.put("db", db);
				plugin = new DataBaseFileCreator();
				plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

				// DAO
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceIdSelected);
				paramMap.put("package", packageName);
				paramMap.put("db", db);
				paramMap.put("common", new ParameterData(true));
				paramMap.put("logout", new ParameterData(true));
				plugin = new DaoFileCreator();
				plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

				// VO
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceIdSelected);
				paramMap.put("package", packageName);
				plugin = new ValueObjectJavaFileCreator();
				plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

				// HTML
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceIdSelected);
				paramMap.put("list", new ParameterData(true));
				paramMap.put("reference", new ParameterData(true));
				paramMap.put("insert", new ParameterData(true));
				paramMap.put("update", new ParameterData(true));
				paramMap.put("gaeFlag", new ParameterData(false));
				plugin = new MntHtmlFileCreator();
				plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

				// HTML java
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceIdSelected);
				paramMap.put("package", packageName);
				paramMap.put("list", new ParameterData(true));
				paramMap.put("reference", new ParameterData(true));
				paramMap.put("insert", new ParameterData(true));
				paramMap.put("update", new ParameterData(true));
				paramMap.put("logout", new ParameterData(true));
				plugin = new MntHtmlJavaFileCreator();
				plugin.checkParameter(paramMap, interfaceProject, errrorKeyTempList);

			} catch (InterfaceException e) {
				HashSet<String> set = new HashSet<String>();

				for (String keyName : errrorKeyTempList) {
					if (paramerteNameSet.contains(keyName) && !set.contains(keyName)) {
						set.add(keyName);
					}
				}
				for (String keyName : set) {
					errrorKeyList.add(keyName);
				}
				throw e;
			}
			// dataMap  ParameterData ɖ߂
			targetInterfaceIdSelected.setValue(line);
		}
	}

	@Override
	public AttributeFileImage create(HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject)
			throws InterfaceException {
		AttributeFileImage ret = null;

		try {
			HashMap<String, byte[]> fileMap = new HashMap<String, byte[]>();

			// C^[tF[XIôŁAIlzɕϊ
			String line = dataMap.get("targetInterface").getValue();
			StringTokenizer st = new StringTokenizer(line);
			List<Integer> interfaceIds = new LinkedList<Integer>();
			while (st.hasMoreTokens()) {
				interfaceIds.add(Integer.parseInt(st.nextToken()));
			}
			ParameterData targetInterfaceId = dataMap.get("targetInterface");
			ParameterData packageName = dataMap.get("package");
			ParameterData db = dataMap.get("db");

			// j[p̃C^[tF[XێList
			List<String[]> ifList = new LinkedList<String[]>();

			for (int id : interfaceIds) {
				targetInterfaceId.setValue(Integer.toString(id));

				InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(
						dataMap.get("targetInterface").getValueInt());
				String className = InterfaceTools.changeClassNmae(interfaceData.getName());
				String nameJp = interfaceData.getNameJp();

				String[] menuName = { className, nameJp };
				ifList.add(menuName);

				HashMap<String, ParameterData> paramMap = new HashMap<String, ParameterData>();

				FileCreatorSampleModelerPlugin plugin = null;

				// f[^x[X`
				paramMap.put("targetInterface", targetInterfaceId);
				paramMap.put("db", db);
				plugin = new DataBaseFileCreator();
				AttributeFileImage tempFile = plugin.create(paramMap, interfaceProject);
				fileMap.put(tempFile.getFileNmae(), tempFile.getFileImage());

				// DAO
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceId);
				paramMap.put("package", packageName);
				paramMap.put("db", db);
				paramMap.put("common", new ParameterData(true));
				paramMap.put("logout", new ParameterData(true));
				plugin = new DaoFileCreator();
				tempFile = plugin.create(paramMap, interfaceProject);
				InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

				// VO
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceId);
				paramMap.put("package", packageName);
				plugin = new ValueObjectJavaFileCreator();
				tempFile = plugin.create(paramMap, interfaceProject);
				fileMap.put(tempFile.getFileNmae(), tempFile.getFileImage());

				// HTML
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceId);
				paramMap.put("list", new ParameterData(true));
				paramMap.put("reference", new ParameterData(true));
				paramMap.put("insert", new ParameterData(true));
				paramMap.put("update", new ParameterData(true));
				paramMap.put("gaeFlag", new ParameterData(false));
				plugin = new MntHtmlFileCreator();
				tempFile = plugin.create(paramMap, interfaceProject);
				InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

				// HTML java
				paramMap.clear();
				paramMap.put("targetInterface", targetInterfaceId);
				paramMap.put("package", packageName);
				paramMap.put("list", new ParameterData(true));
				paramMap.put("reference", new ParameterData(true));
				paramMap.put("insert", new ParameterData(true));
				paramMap.put("update", new ParameterData(true));
				paramMap.put("logout", new ParameterData(true));
				plugin = new MntHtmlJavaFileCreator();
				tempFile = plugin.create(paramMap, interfaceProject);
				InterfaceTools.putMapFromZip(tempFile.getFileImage(), fileMap);

				if (fileMap.size() == 1) {
					String fileName = fileMap.keySet().toArray(new String[0])[0];
					return new AttributeFileImage(fileName, fileMap.get(fileName));
				}
			}
			// Menu.java
			fileMap.put("MaintenanceMenu.java", createMenuJava(packageName.getValue(), ifList));
			// Menu.html
			fileMap.put("MaintenanceMenu.html", createMenuHtml(packageName.getValue(), ifList));

			// readMe.txt
			fileMap.put("readMe.txt", createReadMeTxt(packageName.getValue(), "", nameJp));

			// web.xml
			fileMap.put("web.xml", createWebXml(packageName.getValue(), "", nameJp));

			// db.xml
			fileMap.put("db.xml", createDbXml(packageName.getValue(), "", nameJp));

			// Gg[|Cg
			fileMap.put("MenuStartApp.java", createStartApp(packageName.getValue(), "", nameJp));

			ret = new AttributeFileImage("MultiMstMntSample.zip", createZipImage(fileMap));
		} catch (IOException e) {
			throw new InterfaceException("쐬ɗ\ȂG[܂");
		}
		return ret;

	}

	/**
	 * readMe.txtt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createReadMeTxt(String packageName, String className, String nameJp) throws IOException,
			InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			if(packageName.length()>0){
				setParameter("package1", "pbP[W " +packageName+" 쐬");
				setParameter("package2", "쐬pbP[W");
			}else{
				setParameter("package1", "");
				setParameter("package2", "");
			}

			setParameter("mntName", className);
			setParameter("package", packageName);
			setParameter("nameJp", nameJp);
			setParameter("ver", Define.PROGRAM_VERSION_NO);
			setParameter("date", (new SimpleDateFormat("yyyy/MM/dd HH:mm:ss")).format(Calendar.getInstance().getTime()));
			out(baos, getText("readMe.txt"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * web.xmlt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createWebXml(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("web.xml"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * db.xmlt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createDbXml(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("db.xml"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * startAppt@CC[W쐬
	 *
	 * @param packageName
	 * @param className
	 * @param nameJp
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createStartApp(String packageName, String className, String nameJp) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("mntName", className);
			setParameter("package", packageName);
			out(baos, getText("startApp"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * Menu.htmlt@CC[W쐬
	 *
	 * @param packageName
	 * @param ifList
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createMenuHtml(String packageName, List<String[]> ifList) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();

			setParameter("package", packageName);
			setParameter("link0", "");
			setParameter("link1", "");
			setParameter("link2", "");
			setParameter("link3", "");
			setParameter("link4", "");
			setParameter("link5", "");
			setParameter("link6", "");
			setParameter("link7", "");
			setParameter("link8", "");
			setParameter("link9", "");
			for (int id = 0; id < ifList.size(); id++) {
				String data[] = ifList.get(id);
				switch (id) {
				case 0:
					setParameter("link0", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 1:
					setParameter("link1", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 2:
					setParameter("link2", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 3:
					setParameter("link3", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 4:
					setParameter("link4", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 5:
					setParameter("link5", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 6:
					setParameter("link6", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 7:
					setParameter("link7", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 8:
					setParameter("link8", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				case 9:
					setParameter("link9", "<a name=\"" + data[0] + "\" href=\"\">" + data[0] + ":" + data[1] + "_eiX</a>");
					break;
				}
			}
			out(baos, getText("MaintenanceMenu.html"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	/**
	 * Menu.htmlt@CC[W쐬
	 *
	 * @param packageName
	 * @return t@CC[W
	 * @throws IOException
	 * @throws InterfaceException
	 */
	protected byte[] createMenuJava(String packageName, List<String[]> ifList) throws IOException, InterfaceException {

		ByteArrayOutputStream baos = null;
		try {
			// A^ONp\bh쐬
			String link0String = "";
			String link1String = "";
			String link2String = "";
			String link3String = "";
			String link4String = "";
			String link5String = "";
			String link6String = "";
			String link7String = "";
			String link8String = "";
			String link9String = "";
			for (int id = 0; id < ifList.size(); id++) {
				String data[] = ifList.get(id);
				switch (id) {
				case 0:
					link0String = createLinkMethod(data);
					break;
				case 1:
					link1String = createLinkMethod(data);
					break;
				case 2:
					link2String = createLinkMethod(data);
					break;
				case 3:
					link3String = createLinkMethod(data);
					break;
				case 4:
					link4String = createLinkMethod(data);
					break;
				case 5:
					link5String = createLinkMethod(data);
					break;
				case 6:
					link6String = createLinkMethod(data);
					break;
				case 7:
					link7String = createLinkMethod(data);
					break;
				case 8:
					link8String = createLinkMethod(data);
					break;
				case 9:
					link9String = createLinkMethod(data);
					break;
				}
			}

			baos = new ByteArrayOutputStream();

			setParameter("package", packageName);
			setParameter("link0", link0String);
			setParameter("link1", link1String);
			setParameter("link2", link2String);
			setParameter("link3", link3String);
			setParameter("link4", link4String);
			setParameter("link5", link5String);
			setParameter("link6", link6String);
			setParameter("link7", link7String);
			setParameter("link8", link8String);
			setParameter("link9", link9String);
			out(baos, getText("MaintenanceMenu.java"));
			baos.flush();

		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return baos.toByteArray();
	}

	// menu.java ̃Np\bh쐬
	private String createLinkMethod(String data[]) throws IOException, InterfaceException {
		ByteArrayOutputStream baos = null;
		try {
			baos = new ByteArrayOutputStream();
			setParameter("interface", data[0]);
			setParameter("interfaceJp", data[1]);
			out(baos, getText("LinkMethod"));
			baos.flush();
		} finally {
			if (baos != null) {
				baos.close();
			}
		}
		return new String(baos.toByteArray());
	}

}
