package jp.oarts.pirka.iop.tool.core.tools.text;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import jp.oarts.pirka.iop.tool.core.business.InterfaceException;

import org.apache.log4j.Logger;

public class TextCreator {

	// eLXg͂̃NXhNX.txttApbP[WɊi[B
	// #%Ŏn܂s̓RgsƂ݂ȂAB
	// #!Ŏn܂s̓^CgsƂ#!ȍ~^CgƂĈA^Cgł̍sȍ~̍s
	// ǗrBǗs͎#!oĂ܂ł̊ԂƂB
	// #!݂̂Ń^CgLĂȂsyшȍ~#!LĂs܂ł̊Ԃ͂͊ǗȂBi^CgǗ̏IƂ݂Ȃj
	// eLXg###ƋLq邱ƁB
	// uL[#Ŏn܂镶ƂAŏIB

	/**
	 * x[XeLXg̃TtBbNX<BR>
	 * eLXg̃RXgN^̂Ƃ̓NX{̃TqbNƂȂ
	 */
	protected static final String suffix = ".txt";

	/**
	 * x[XeLXg̃LN^Zbg
	 */
	private static final String CHAR_SET = "UTF-8";

	/**
	 * }[J[LN^
	 */
	protected static final char MARK_CHAR = '#';

	/**
	 * }[J[LN^String
	 */
	protected static final String MARK_STRING = "" + MARK_CHAR;

	/**
	 * x[XeLXgł̃}[J[LN^
	 */
	protected static final String MARK2_STRING = "" + MARK_CHAR + MARK_CHAR;

	/**
	 * ^CgLN^
	 */
	protected static final char TITLE_CHAR = '!';

	/**
	 * RgLN^
	 */
	protected static final char COMMENT_CHAR = '%';

	protected static final String CHANGE_PRE_CHAR_STRING = "@";
	protected static final String CHANGE_AFTER_CHAR_STRING = "@1";
	protected static final String CHANGE_MARK_STRING = "@2";

	/**
	 * ͍ς݂̃}bṽLbVp}bviL[FeLXgAlF͂ꂽ}bvj
	 */
	protected static HashMap<String, HashMap<String, List<String>>> textCreatorMap = new HashMap<String, HashMap<String, List<String>>>();

	/**
	 * x[XeLXg
	 */
	protected String baseTextName;

	/**
	 * ͂ꂽeLXgi[}bviL[F^CgAlF^Cg̍sj
	 */
	protected  HashMap<String, List<String>> textMap = new HashMap<String, List<String>>();

	/**
	 * p[^}bv
	 */
	protected  HashMap<String, String> paramMap;

	/**
	 * ʃp[^}bv
	 */
	protected  HashMap<String, String> commonParamMap;

	/**
	 * K[
	 */
	protected Logger logger = Logger.getLogger(getClass());

	/**
	 * RXgN^
	 * @throws InterfaceException
	 */
	public TextCreator() throws InterfaceException {
		baseTextName = "/" + getClass().getName().replace('.', '/') + suffix;

		init(baseTextName);
	}

	/**
	 * RXgN^
	 *
	 * @param textName
	 * @throws InterfaceException
	 */
	public TextCreator(String textName) throws InterfaceException {
		init(textName);
	}

	/**
	 * ݒς݂̃p[^̃NA
	 */
	public void clearParameter() {
		paramMap.clear();
	}

	/**
	 * ݒς݂̋ʃp[^̃NA
	 */
	public void clearCommonParameter() {
		commonParamMap.clear();
	}

	/**
	 * p[^̒ǉ
	 *
	 * @param key
	 *            L[
	 * @param value
	 *            l
	 */
	public void setParameter(String key, String value) {
		setParameter(paramMap, key, value);
	}

	/**
	 * ʃp[^̒ǉ
	 *
	 * @param key
	 *            L[
	 * @param value
	 *            l
	 */
	public void setCommonParameter(String key, String value) {
		setParameter(commonParamMap, key, value);
	}

	/**
	 * p[^̒ǉ
	 *
	 * @param key
	 *            L[
	 * @param value
	 *            l
	 */
	public void setParameter(HashMap<String, String> map, String key, String value) {
		// u@@1A#@2ɒuiĕϊh߁j
		value = value.replaceAll(CHANGE_PRE_CHAR_STRING, CHANGE_AFTER_CHAR_STRING);
		value = value.replaceAll(MARK_STRING, CHANGE_MARK_STRING);
		map.put(key, value);
	}

	/**
	 * ϊꂽs̎o
	 *
	 * @param title
	 *            ^Cg
	 * @param keyAndValues
	 *            L[Al̑gݍ킹iL[ƒlŏɋwj
	 * @return s
	 * @throws InterfaceException
	 */
	public List<String> getText(String title, String... keyAndValues) throws InterfaceException {
		return getText(title, true, keyAndValues);
	}

	/**
	 * ϊꂽs̎o
	 *
	 * @param title
	 *            ^Cg
	 * @param afterParamClear
	 *            true=oɒǉĂp[^NA
	 * @param keyAndValues
	 *            L[Al̑gݍ킹iL[ƒlŏɋwj
	 * @return s
	 * @throws InterfaceException
	 */
	public List<String> getText(String title, boolean afterParamClear, String... keyAndValues) throws InterfaceException {

		if ((keyAndValues.length % 2) != 0) {
			throw new InterfaceException("L[l̃p[^Ɍ肪܂ L[ɑΉl܂");
		}

		for (int i = 0; i < keyAndValues.length; i += 2) {
			setParameter(keyAndValues[i], keyAndValues[i + 1]);
		}

		HashMap<String, String> pMap = new HashMap<String, String>();
		pMap.putAll(commonParamMap);
		pMap.putAll(paramMap);
		
		List<String> outputLineList = new LinkedList<String>();

		List<String> inputLines = textMap.get(title);

		if (inputLines != null) {
			for (String line : inputLines) {
				for (String key : pMap.keySet()) {
					line = line.replaceAll(MARK_CHAR + key + MARK_CHAR, pMap.get(key));
				}
				line = line.replaceAll(MARK2_STRING, MARK_STRING);

				// @2#A@1@ɖ߂
				line = line.replaceAll(CHANGE_MARK_STRING, MARK_STRING);
				line = line.replaceAll(CHANGE_AFTER_CHAR_STRING, CHANGE_PRE_CHAR_STRING);

				// ss
				String[] lines = line.split("\\n");
				for (String sLine : lines) {
					outputLineList.add(sLine);
				}
			}
		}

		if (afterParamClear) {
			clearParameter();
		}
		return outputLineList;
	}

	/**
	 * 
	 *
	 * @param textName
	 * @throws InterfaceException
	 */
	protected void init(String textName) throws InterfaceException {

		this.baseTextName = textName;
		paramMap = new HashMap<String, String>();
		commonParamMap = new HashMap<String, String>();
		textMap = getMap(textName);
		if (textMap == null) {
			textMap = analyze(textName);
			putMap(textName, textMap);
		}
	}

	/**
	 * \[Xt@C̉
	 *
	 * @param resourceName
	 *            \[Xt@C
	 * @return ͂ꂽ}bviL[F^CgAlF^Cg̍sj
	 * @throws InterfaceException
	 */
	protected HashMap<String, List<String>> analyze(String resourceName) throws InterfaceException {

		List<String> lineList = new LinkedList<String>();
		String title = "";

		InputStream is = null;
		BufferedReader br = null;

		HashMap<String, List<String>> map = new HashMap<String, List<String>>();
		try {
			try {
				try {
					is = getClass().getResourceAsStream(resourceName);
					if (is != null) {
						br = new BufferedReader(new InputStreamReader(is, CHAR_SET));

						while (true) {
							String line = br.readLine();
							if (line == null) {
								break;
							}

							// Rgs͓ǂݔ΂
							if (line.length() >= 2 && line.charAt(0) == MARK_CHAR && line.charAt(1) == COMMENT_CHAR) {
								continue;
							}

							// ^CgƔ
							if (line.length() >= 2 && line.charAt(0) == MARK_CHAR && line.charAt(1) == TITLE_CHAR) {
								if (title.length() > 0) {
									map.put(title, lineList);
								}
								lineList = new LinkedList<String>();
								if (line.length() <= 2) {
									title = "";
								} else {
									title = line.substring(2).trim();
								}
								continue;
							}

							if (title.length() > 0) {
								lineList.add(line.replaceAll(CHANGE_PRE_CHAR_STRING, CHANGE_AFTER_CHAR_STRING));
							}
						}
						if (title.length() > 0) {
							map.put(title, lineList);
						}
					}

					return map;
				} finally {
					if (br != null) {
						br.close();
					}
				}
			} finally {
				if (is != null) {
					is.close();
				}
			}

		} catch (IOException e) {
			logger.fatal("eLXgNG[^[ɂɗ\ʃG[܂", e);
			throw new InterfaceException(e);
		}
	}

	/**
	 * ͍ς݂̃}bvLbVp}bvo
	 *
	 * @param name
	 *            \[X
	 * @return ͍ς݃}bvi\[XɑΉ͍ς݃}bvnullԂj
	 */
	protected static synchronized HashMap<String, List<String>> getMap(String name) {
		return textCreatorMap.get(name);
	}

	/**
	 * ͍ς݂̃}bvLbVp}bv֊i[
	 *
	 * @param name
	 *            \[X
	 * @param map
	 *            ͍ς݃}bv
	 */
	protected static synchronized void putMap(String name, HashMap<String, List<String>> map) {
		// ɓo^ς݂ȂΓo^Ȃ
		if (textCreatorMap.containsKey(name)) {
			return;
		}

		textCreatorMap.put(name, map);
	}
}
