package jp.oarts.pirka.iop.tool.core.tools.xml;

import java.util.LinkedHashMap;

import jp.oarts.pirka.iop.tool.core.business.InterfaceException;

/**
 * XMLp[T[f[^
 *
 * @author ito
 *
 */
public class XmlParserData {

	/** f[^}bv */
	private LinkedHashMap<String, XmlParserItem> dataMap;

	/** ŏIANZXf[^ */
	private XmlParserItem lastAccessXmlParserItem;

	/** x[XL[ */
	private String baseKey;

	/**
	 * RXgN^
	 *
	 * @param dataMap
	 *            f[^}bv
	 */
	protected XmlParserData(LinkedHashMap<String, XmlParserItem> dataMap) {
		this.dataMap = dataMap;
		this.baseKey = ""; // [g
	}

	/**
	 * RXgN^
	 *
	 * @param dataMap
	 *            f[^}bv
	 * @param baseKey
	 *            x[XL[
	 */
	private XmlParserData(LinkedHashMap<String, XmlParserItem> dataMap, String baseKey) {
		this.dataMap = dataMap;
		this.baseKey = baseKey;
	}

	/**
	 * w肳ꂽx[XL[ɑΉXmlParserDataIuWFNg擾
	 *
	 * @param baseKey
	 *            x[XL[
	 * @return XmlParserDataIuWFNg
	 */
	public XmlParserData getXmlParserData(String baseKey) {
		return new XmlParserData(dataMap, getKey(baseKey));
	}

	/**
	 * ۂ̃L[߂
	 *
	 * @param itemKey
	 * @return
	 */
	private String getKey(String itemKey) {
		if (baseKey == null || baseKey.length() <= 0) {
			return itemKey;
		}

		return baseKey + XmlParser.XML_ELEMENT_KEY_SEPARATOR + itemKey;
	}

	/**
	 * f[^ɃANZX
	 *
	 * @param itemKey
	 *            ڃL[
	 * @throws InterfaceException
	 */
	private void accessXmlParserItem(String itemKey) throws InterfaceException {
		lastAccessXmlParserItem = null;
		String key = getKey(itemKey);

		if (!dataMap.containsKey(key)) {
			throw new InterfaceException("w肳ꂽL[̃f[^݂܂ " + key);
		}

		lastAccessXmlParserItem = dataMap.get(key);
	}

	/**
	 * f[^擾
	 *
	 * @param itemKey
	 * @return
	 * @throws InterfaceException
	 */
	private XmlParserItem getXmlParserItem(String itemKey) throws InterfaceException {
		accessXmlParserItem(itemKey);
		return lastAccessXmlParserItem;
	}

	private XmlParserItem getLastAccessXmlParserItem() throws InterfaceException {
		if (lastAccessXmlParserItem == null) {
			throw new InterfaceException("ŌɃANZXꂽf[^݂܂");
		}

		return lastAccessXmlParserItem;
	}

	/**
	 * w肳ꂽڃL[݂Ă邩`FbN
	 *
	 * @param itemKey
	 *            ڃL[
	 * @return true=݂Ă
	 */
	public boolean isExists(String itemKey) {
		try {
			accessXmlParserItem(itemKey);
		} catch (InterfaceException e) {
			return false;
		}

		return true;
	}

	/**
	 * w肳ꂽڃL[̑擾<br>
	 * ڃL[ɑΉf[^݂ȂƂInterfaceException<br>
	 * L[ɑΉ鑮݂ȂƂnullԂ<br>
	 *
	 * @param itemKey
	 *            ڃL[
	 * @param attributeKey
	 *            L[
	 * @return	
	 * @throws InterfaceException
	 */
	public String getAttribute(String itemKey, String attributeKey) throws InterfaceException {
		return getXmlParserItem(itemKey).getAttributeMap().get(attributeKey);
	}

	/**
	 * ŌɃANZXꂽf[^̑擾<br>
	 * ŌɃANZXꂽf[^݂ȂƂInterfaceException<br>
	 * L[ɑΉ鑮݂ȂƂnullԂ<br>
	 *
	 * @param attributeKey
	 * @return	
	 * @throws InterfaceException
	 */
	public String getAttribute(String attributeKey) throws InterfaceException {
		return getLastAccessXmlParserItem().getAttributeMap().get(attributeKey);
	}

	/**
	 * w肳ꂽL[̕f[^擾<br>
	 * ڃL[ɑΉf[^݂ȂƂInterfaceException<br>
	 *
	 * @param itemKey
	 *            ڃL[
	 * @return f[^
	 * @throws InterfaceException
	 */
	public String getString(String itemKey) throws InterfaceException {
		return getXmlParserItem(itemKey).getValue();
	}

	/**
	 * ŌɃANZXꂽf[^蕶f[^擾<br>
	 * ŌɃANZXꂽf[^݂ȂƂInterfaceException<br>
	 *
	 * @return f[^
	 * @throws InterfaceException
	 */
	public String getString() throws InterfaceException {
		return getLastAccessXmlParserItem().getValue();
	}

	/**
	 * w肳ꂽL[intl擾<br>
	 * ڃL[ɑΉf[^݂ȂƂInterfaceException<br>
	 *
	 * @param itemKey
	 *            ڃL[
	 * @return f[^
	 * @throws InterfaceException
	 * @throws NumberFormatException
	 */
	public int getInt(String itemKey) throws NumberFormatException, InterfaceException {
		return Integer.parseInt(getXmlParserItem(itemKey).getValue());
	}

	/**
	 * ŌɃANZXꂽf[^intl擾<br>
	 * ŌɃANZXꂽf[^݂ȂƂInterfaceException<br>
	 *
	 * @return f[^
	 * @throws InterfaceException
	 * @throws NumberFormatException
	 */
	public int getInt() throws NumberFormatException, InterfaceException {
		return Integer.parseInt(getLastAccessXmlParserItem().getValue());
	}

	/**
	 * w肳ꂽL[longl擾<br>
	 * ڃL[ɑΉf[^݂ȂƂInterfaceException<br>
	 *
	 * @param itemKey
	 *            ڃL[
	 * @return f[^
	 * @throws InterfaceException
	 * @throws NumberFormatException
	 */
	public long getLong(String itemKey) throws NumberFormatException, InterfaceException {
		return Long.parseLong(getXmlParserItem(itemKey).getValue());
	}

	/**
	 * ŌɃANZXꂽf[^longl擾<br>
	 * ŌɃANZXꂽf[^݂ȂƂInterfaceException<br>
	 *
	 * @return f[^
	 * @throws InterfaceException
	 * @throws NumberFormatException
	 */
	public long getLong() throws NumberFormatException, InterfaceException {
		return Long.parseLong(getLastAccessXmlParserItem().getValue());
	}

	/**
	 * w肳ꂽL[booleanl擾<br>
	 * ڃL[ɑΉf[^݂ȂƂInterfaceException<br>
	 *
	 * @param itemKey
	 *            ڃL[
	 * @return f[^
	 * @throws InterfaceException
	 */
	public boolean getBoolean(String itemKey) throws InterfaceException {
		return Boolean.parseBoolean(getXmlParserItem(itemKey).getValue());
	}

	/**
	 * ŌɃANZXꂽf[^booleanl擾<br>
	 * ŌɃANZXꂽf[^݂ȂƂInterfaceException<br>
	 *
	 * @return f[^
	 * @throws InterfaceException
	 */
	public boolean getBoolean() throws InterfaceException {
		return Boolean.parseBoolean(getLastAccessXmlParserItem().getValue());
	}
}
