package jp.oarts.pirka.iop.tool.core.tools.xml;

import java.util.HashMap;

/**
 * XML̃ACe
 *
 * @author ito
 *
 */
public class XmlParserItem {

	/** l */
	private String value;

	/** Agr[g}bv */
	private HashMap<String, String> attributeMap;

	/**
	 * RXgN^
	 */
	public XmlParserItem(String value) {
		this(value, new HashMap<String, String>());
	}

	/**
	 * RXgN^
	 *
	 * @param attributeMap
	 */
	public XmlParserItem(HashMap<String, String> attributeMap) {
		this("", attributeMap);
	}

	/**
	 * RXgN^
	 *
	 * @param value
	 * @param attributeMap
	 */
	public XmlParserItem(String value, HashMap<String, String> attributeMap) {
		this.value = value;
		this.attributeMap = attributeMap;
	}

	/**
	 *
	 */
	public String toString() {
		StringBuilder sb = new StringBuilder();

		sb.append(value);
		if (attributeMap.size() > 0) {
			for (String key : attributeMap.keySet()) {
				sb.append(", ");
				sb.append(key);
				sb.append("=");
				sb.append(attributeMap.get(key));
			}
		}
		return sb.toString();
	}

	/**
	 * Agr[g}bv擾
	 *
	 * @return	Agr[g}bv
	 */
	public HashMap<String, String> getAttributeMap() {
		return attributeMap;
	}

	/**
	 * Agr[g}bvi[
	 *
	 * @param attributeMap
	 *            Agr[g}bv
	 */
	public void setAttributeMap(HashMap<String, String> attributeMap) {
		this.attributeMap = attributeMap;
	}

	/**
	 * l̎擾
	 *
	 * @return l
	 */
	public String getValue() {
		return value;
	}

	/**
	 * l̐ݒ
	 *
	 * @param value
	 *            l
	 */
	public void setValue(String value) {
		this.value = value;
	}
}
