package jp.oarts.pirka.iop.tool.web.in;

import java.text.DecimalFormat;

import jp.oarts.pirka.core.ctrl.SelectList;
import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.util.check.PirkaChecker;
import jp.oarts.pirka.core.util.check.PirkaCheckerString;
import jp.oarts.pirka.core.util.check.PirkaCheckerStringChars;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataMyItem;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;

public class EditInterfaceItem extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = -4522943256446547395L;

	private InterfaceProject interfaceProject;

	private boolean newInsertMode;

	private Integer dataId;

	private InterfaceDataMyItem myDataItem;

	/**
	 * RXgN^
	 */
	public EditInterfaceItem(Integer dataId, Integer itemId) {
		super();
		init(dataId, itemId, ((InterfaceProject) getSession(Define.PROJECT_SESSION_NAME)));
	}

	/**
	 * RXgN^
	 */
	public EditInterfaceItem(Integer dataId, Integer itemId, InterfaceProject interfaceProject) {
		super();
		init(dataId, itemId, interfaceProject);

		FieldMap fm = getFieldMap();
		fm.setValue("regist", "ύX");
		fm.setValue("back", "");
	}

	/**
	 * RXgN^
	 */
	protected void init(Integer dataId, Integer itemId, InterfaceProject interfaceProject) {
		this.interfaceProject = interfaceProject;
		try {
			if (itemId == null) {
				newInsertMode = true;
			} else {
				newInsertMode = false;
			}

			FieldMap fm = getFieldMap();

			// `FbJ[ݒ
			addCheck("inName", PirkaChecker.required);
			// addCheck("inName", new
			// PirkaCheckerString(PirkaCheckerStringChars.NUM,
			// PirkaCheckerStringChars.LOW_ALPHABET,
			// PirkaCheckerStringChars.HIGHT_ALPHABET, new
			// PirkaCheckerStringChars("_")));
			addCheck("inName", new PirkaCheckerString(PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.LOW_ALPHABET,
					PirkaCheckerStringChars.HIGHT_ALPHABET, new PirkaCheckerStringChars("_")));
			addCheck("inNameJp", PirkaChecker.required);

			addCheck("inType", PirkaChecker.required);
			addCheck("inLength", PirkaChecker.numeric);
			addCheck("inSubLength", PirkaChecker.numeric);
			addErrorCheckReturner();

			fm.setOfficialFieldName("inName", "ږ");
			fm.setOfficialFieldName("inNameJp", "ږi{ꖼj");
			fm.setOfficialFieldName("inType", "^");
			fm.setOfficialFieldName("inLength", "ڒ");
			fm.setOfficialFieldName("inSubLength", "");
			fm.setOfficialFieldName("primaryKey", "L[");

			fm.setAutoCheck("back", false);

			SelectList selectList = new SelectList();
			for (FieldType type : FieldType.values()) {
				selectList.add(type.toString(), type.toString());
			}
			fm.setSelectList("inType", selectList);

			this.dataId = dataId;

			InterfaceData interfaceData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

			DecimalFormat fmt = new DecimalFormat("0000");
			fm.setValue("myInfo", interfaceData.getName() + " ( " + fmt.format(interfaceData.getDataId()) + " : "
					+ interfaceData.getNameJp() + " )");

			if (!newInsertMode) {
				myDataItem = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).getMyItem(itemId);
				fm.setValue("inName", myDataItem.getName());
				fm.setValue("inNameJp", myDataItem.getNameJp());
				fm.setValue("inType", myDataItem.getType().toString());
				fm.setValue("inLength", myDataItem.getLength());
				fm.setValue("inSubLength", myDataItem.getSubLength());
				fm.setValue("primaryKey", myDataItem.isPrimaryKey());
			}
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * ڒǉ{^NbNꂽ̏
	 *
	 * @return EBhE
	 */
	public PirkaWindow regist() {
		try {
			FieldMap fm = getFieldMap();

			String name = fm.getValueString("inName");
			String nameJp = fm.getValueString("inNameJp");
			FieldType type = FieldType.valueOf(fm.getValueString("inType"));
			long length = fm.getValueLong("inLength", 0);
			int subLength = fm.getValueInt("inSubLength", 0);
			boolean primaryKey = fm.getValueBoolean("primaryKey");

			interfaceProject.setChanged(true);
			if (newInsertMode) {
				InterfaceDataMyItem item = new InterfaceDataMyItem(name, nameJp, type, length, subLength, primaryKey);
				interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).addMyItem(item);
				fm.setValue("inName", "");
				fm.setValue("inNameJp", "");
				fm.setValue("inType", FieldType.STRING.toString());
				fm.setValue("inLength", "");
				fm.setValue("inSubLength", "");
				fm.setValue("primaryKey", false);
				return this;

			} else {
				myDataItem.setName(name);
				myDataItem.setNameJp(nameJp);
				myDataItem.setType(type);
				myDataItem.setLength(length);
				myDataItem.setSubLength(subLength);
				myDataItem.setPrimaryKey(primaryKey);
				interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).updateMyItem(myDataItem);
				myDataItem = null;
			}
			return null;

		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * I{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {
		return null;
	}

}
