package jp.oarts.pirka.iop.tool.web.in;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.util.check.PirkaChecker;
import jp.oarts.pirka.core.util.check.PirkaCheckerString;
import jp.oarts.pirka.core.util.check.PirkaCheckerStringChars;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDataManager;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;

public class EditInterfaceName extends IopBaseWindow {

	/** VKtO */
	private boolean newFlag;

	/** C^[tF[XID */
	private Integer dataId;

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * RXgN^
	 *
	 * @param dataId
	 *            f[^ID
	 */
	public EditInterfaceName(Integer dataId) {
		super();
		try {
			FieldMap fm = getFieldMap();

			// `FbJ[ݒ
			addCheck("interfaceName", PirkaChecker.required);
			addCheck("interfaceName", new PirkaCheckerString(PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.LOW_ALPHABET,
					PirkaCheckerStringChars.HIGHT_ALPHABET, new PirkaCheckerStringChars("_")));
			addCheck("interfaceNameJp", PirkaChecker.required);
			addErrorCheckReturner();

			fm.setOfficialFieldName("interfaceName", "C^[tF[X");
			fm.setOfficialFieldName("interfaceNameJp", "C^[tF[Xi{ꖼj");
			fm.setAutoCheck("back", false);

			// f[^i[
			InterfaceDataManager interfaceDataManager = ((InterfaceProject) getSession(Define.PROJECT_SESSION_NAME))
					.getInterfaceDataManager();
			this.dataId = dataId;
			if (dataId == null) {
				fm.setValue("title", "VKC^[tF[X쐬");
				fm.setValue("interfaceName", "");
				fm.setValue("interfaceNameJp", "");
				fm.setValue("comment", "");
				newFlag = true;
			} else {
				InterfaceData ifData = interfaceDataManager.getInterfaceData(dataId);
				fm.setValue("title", "C^[tF[XҏW");
				fm.setValue("interfaceName", ifData.getName());
				fm.setValue("interfaceNameJp", ifData.getNameJp());
				fm.setValue("comment", ifData.getComment());
				newFlag = false;
			}
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * o^{^NbNꂽ̏
	 */
	public PirkaWindow regist() {
		try {
			FieldMap fm = getFieldMap();

			String name = fm.getValueString("interfaceName").trim();
			String nameJp = fm.getValueString("interfaceNameJp");
			String comment = fm.getValueString("comment");

			InterfaceProject interfaceProject = ((InterfaceProject) getSession(Define.PROJECT_SESSION_NAME));
			InterfaceDataManager interfaceDataManager = interfaceProject.getInterfaceDataManager();

			InterfaceData ifData;
			if (newFlag) {
				ifData = interfaceDataManager.createInterfaceData();
			} else {
				ifData = interfaceDataManager.getInterfaceData(dataId);
			}
			ifData.setName(name);
			ifData.setNameJp(nameJp);
			ifData.setComment(comment);
			interfaceProject.setChanged(true);

			return new InterfaceView(ifData.getDataId());
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * I{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {
		return null;
	}

}
