package jp.oarts.pirka.iop.tool.web.in;

import java.text.DecimalFormat;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDataManager;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;

public class InterfaceList extends IopBaseWindow {

	private final int MAX_COL = 4;

	private Integer[] dataIds;

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * RXgN^
	 */
	public InterfaceList() {
		super();

		renew();
	}

	public void preDraw() {
		super.preDraw();
		renew();
	}

	/**
	 * ꗗXV
	 */
	public void renew() {
		try {
			FieldMap fm = getFieldMap();
			InterfaceProject interfaceProject = (InterfaceProject) getSession(Define.PROJECT_SESSION_NAME);
			InterfaceDataManager interfaceDataManager = interfaceProject.getInterfaceDataManager();

			fm.clearFieldMap("listRow");

			dataIds = interfaceDataManager.getInterfaceDataIdListOrderByName();

			int maxRow = (dataIds.length + MAX_COL - 1) / MAX_COL;

			DecimalFormat fmt = new DecimalFormat("0000");
			int index = 0;
			for (int rowIndex = 0; rowIndex < maxRow; rowIndex++) {

				if (index >= dataIds.length) {
					break;
				}

				FieldMap rowFieldMap = createLoopFieldMap("listRow");
				fm.addFieldMap("listRow", rowFieldMap);

				for (int colIndex = 0; colIndex < MAX_COL; colIndex++) {

					if (index >= dataIds.length) {
						break;
					}

					FieldMap colFieldMap = createLoopFieldMap("listCol");
					rowFieldMap.addFieldMap("listCol", colFieldMap);

					InterfaceData interfaceData = interfaceDataManager.getInterfaceData(dataIds[index]);
					colFieldMap.setValue("name", interfaceData.getName() + " (" + fmt.format(interfaceData.getDataId()) + ")");
					colFieldMap.setValue("nameJp", interfaceData.getNameJp());
					colFieldMap.setTagEffective("name", true);
					colFieldMap.setTagEffective("nameJp", true);
					colFieldMap.setOption("name", "title", interfaceData.getComment());
					colFieldMap.setOption("nameJp", "title", interfaceData.getComment());
					index++;
				}
			}

		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * C^[tF[XNbNꂽ̏
	 *
	 * @return	EBhE
	 */
	public PirkaWindow interfaceItem() {
		int[] indexs = getActionLoopIndex();
		int index = indexs[0] * MAX_COL + indexs[1];

		return new InterfaceView(dataIds[index]);
	}

	/**
	 * VK{^NbNꂽ̏
	 *
	 * @return	EBhE
	 */
	public PirkaWindow newInterface() {
		return new EditInterfaceName(null);
	}

	/**
	 * I{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {
		return null;
	}

}
