package jp.oarts.pirka.iop.tool.web.in;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import jp.oarts.pirka.core.ctrl.SelectList;
import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDataManager;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.general.vo.IncludeInfo;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;

public class SelectIncludeInterface extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private Integer dataId;

	private InterfaceProject interfaceProject;

	private List<Integer> includeIdList;

	/**
	 * RXgN^
	 *
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 */
	public SelectIncludeInterface(InterfaceProject interfaceProject, Integer dataId) {
		super();

		this.dataId = dataId;
		this.interfaceProject = interfaceProject;
		this.includeIdList = new ArrayList<Integer>();

		renew();
	}

	/**
	 * ꗗXV
	 */
	public void renew() {
		try {
			includeIdList.clear();

			FieldMap fm = getFieldMap();
			InterfaceDataManager interfaceDataManager = interfaceProject.getInterfaceDataManager();
			InterfaceData interfaceData = interfaceDataManager.getInterfaceData(dataId);

			fm.clearFieldMap("includeLoop");

			SelectList includeSelectList = new SelectList();
			DecimalFormat fmt = new DecimalFormat("0000");

			for (Integer wkDataId : interfaceDataManager.getInterfaceDataIdListOrderByName()) {
				InterfaceData includeInterfaceData = interfaceDataManager.getInterfaceData(wkDataId);
				// if
				// (interfaceData.canInclude(includeInterfaceData.getDataId()))
				// {
				if (includeInterfaceData.canInclude(this.dataId)) {
					String value = includeInterfaceData.getName() + " ( " + fmt.format(includeInterfaceData.getDataId())
							+ " : " + includeInterfaceData.getNameJp() + " )";
					includeSelectList.add(value, "" + includeInterfaceData.getDataId());
				}
			}
			fm.setSelectList("includeList", includeSelectList);
			fm.setValue("includeList", "");

			fm.setValue("myInfo", interfaceData.getName() + " ( " + fmt.format(interfaceData.getDataId()) + " : "
					+ interfaceData.getNameJp() + " )");

			if (interfaceData.getIncludeIfoList().length > 0) {
				for (IncludeInfo info : interfaceData.getIncludeIfoList()) {
					FieldMap includeColFieldMap = createLoopFieldMap("includeLoop");
					fm.addFieldMap("includeLoop", includeColFieldMap);

					InterfaceData idwk = interfaceDataManager.getInterfaceData(info.getIncludeDataId());

					includeColFieldMap.setValue("incNo", info.getIncludeId());
					includeColFieldMap.setValue("includeInterfaceName", idwk.getName() + " ("
							+ fmt.format(info.getIncludeDataId()) + " : " + idwk.getNameJp() + ")");
					includeColFieldMap.setOption("includeInterfaceName", "title", idwk.getComment());
					includeIdList.add(info.getIncludeId());
				}

			}
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * C^[tF[XNbNꂽ̏
	 */
	public void addInclude() {
		try {
			FieldMap fm = getFieldMap();
			String includeDataIdStr = fm.getValueString("includeList");
			if (includeDataIdStr == null || includeDataIdStr.length() <= 0) {
				addError("CN[hsC^[tF[XIĂ܂");
				fm.setError("includeList", true);
				return;
			}

			int includeDataId;
			try {
				includeDataId = Integer.valueOf(includeDataIdStr);
			} catch (NumberFormatException e) {
				addError("CN[hsC^[tF[XIĂ܂");
				fm.setError("includeList", true);
				return;
			}

			interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).includeInterfaceData(includeDataId);

			renew();
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * CN[h폜{^NbNꂽ̏
	 */
	public void deleteInclude() {
		try {
			int[] indexs = getActionLoopIndex();
			interfaceProject.getInterfaceDataManager().getInterfaceData(dataId).removeIncludeInterfaceData(
					includeIdList.get(indexs[0]));

			renew();
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * o^{^NbNꂽ̏
	 *
	 * @return	EBhE
	 */
	public PirkaWindow regist() {
		interfaceProject.setChanged(true);
		putSession(Define.PROJECT_SESSION_NAME, interfaceProject);

		return null;
	}

	/**
	 * I{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {
		return null;
	}

}
