package jp.oarts.pirka.iop.tool.web.plugin;

import java.util.HashMap;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.res.PirkaRespons;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDesignerPlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;

public class ExecuteInterfaceDesigner extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = -4522943256446547395L;

	private InterfaceDesignerPlugin plugin;

	private HashMap<String, ParameterData> dataMap;

	private InterfaceProject interfaceProject;

	/**
	 * RXgN^
	 *
	 * @param plugin
	 *            vOC
	 */
	public ExecuteInterfaceDesigner(InterfaceDesignerPlugin plugin, HashMap<String, ParameterData> dataMap, InterfaceProject interfaceProject) {
		super();
		this.plugin = plugin;
		this.dataMap = dataMap;
		this.interfaceProject = interfaceProject;

		FieldMap fm = getFieldMap();
		fm.setValue("title", plugin.getNameJp());
		fm.setValue("backSw", false);
		fm.setValue("runtimeErrorMessage", "");
	}

	public PirkaRespons onElse() {

		FieldMap fm = getFieldMap();
		try {
			String message = plugin.createInterfaceDesign(dataMap, interfaceProject);

			if (message == null || message.length() <= 0) {
				fm.setValue("message", "ɏI܂");
			} else {
				fm.setValue("message", message);
			}

		} catch (InterfaceException e) {
			fm.setValue("message", "");
			fm.setValue("message", e.getMessage());
		}
		fm.setValue("backSw", true);

		// Tu~bg֎~
		fm.setValue("initScript", "\n<!--\nfunction init(){}\n-->\n");

		return this;
	}

	/**
	 * ߂{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {

		return null;
	}

}
