package jp.oarts.pirka.iop.tool.web.plugin;

import jp.oarts.pirka.core.ctrl.SelectList;
import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.util.check.PirkaChecker;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;

public class ParameterLoad extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = -4522943256446547395L;

	private String pluginName;
	private ParameterInput parameterInput;

	/**
	 * RXgN^
	 *
	 * @param pluginName
	 *            vOC
	 * @param parameterInput
	 *            p[^Cvbg
	 */
	public ParameterLoad(String pluginName, ParameterInput parameterInput) {
		super();

		this.pluginName = pluginName;
		this.parameterInput = parameterInput;

		FieldMap fm = getFieldMap();

		// `FbJ[ݒ
		addCheck("parameterName", PirkaChecker.required);
		addErrorCheckReturner();

		fm.setOfficialFieldName("parameterName", "p[^");
		fm.setAutoCheck("back", false);

		fm.setSelectList("parameterName", setSelectList());
	}

	private SelectList setSelectList() {
		InterfaceProject interfaceProject = (InterfaceProject) getSession(Define.PROJECT_SESSION_NAME);
		String[] names = interfaceProject.getParameterDataManager().getParameterFileListString(pluginName);

		SelectList selectList = new SelectList();
		for (String name : names) {
			selectList.add(name);
		}

		return selectList;
	}

	/**
	 * Ǎ{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow load() {

		FieldMap fm = getFieldMap();
		String parameterName = fm.getValueString("parameterName");

		parameterInput.setParameterName(parameterName);
		return null;
	}

//	/**
//	 * 폜{^NbNꂽ̏
//	 *
//	 * @return thisiʁj
//	 */
//	public void delete() {
//
//		FieldMap fm = getFieldMap();
//		String parameterName = fm.getValueString("parameterName");
//
//		InterfaceProject interfaceProject = (InterfaceProject) getSession(Define.PROJECT_SESSION_NAME);
//		interfaceProject.getParameterDataManager().removeParameterDataMap(pluginName, parameterName);
//
//		fm.setSelectList("parameterName", setSelectList());
//		fm.setValue("parameterName", "");
//
//		interfaceProject.setChanged(true);
//	}

	/**
	 * ߂{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {

		return null;
	}

}
