package jp.oarts.pirka.iop.tool.web.plugin;

import java.util.HashMap;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.util.check.PirkaChecker;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.general.vo.ParameterData;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;

public class ParameterSave extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = -4522943256446547395L;

	private String pluginName;
	private HashMap<String, ParameterData> dataMap;
	private ParameterInput parameterInput;

	/**
	 * RXgN^
	 */
	public ParameterSave(String pluginName, String parameterName, HashMap<String, ParameterData> dataMap,
			ParameterInput parameterInput) {
		super();
		this.pluginName = pluginName;
		this.dataMap = dataMap;
		this.parameterInput = parameterInput;

		FieldMap fm = getFieldMap();

		// `FbJ[ݒ
		addCheck("parameterName", PirkaChecker.required);
		addErrorCheckReturner();

		fm.setOfficialFieldName("parameterName", "p[^");
		fm.setAutoCheck("back", false);

		fm.setValue("parameterName", parameterName);
	}

	/**
	 * ۑ^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow save() {

		FieldMap fm = getFieldMap();
		String parameterName = fm.getValueString("parameterName");

		InterfaceProject interfaceProject = (InterfaceProject) getSession(Define.PROJECT_SESSION_NAME);
		interfaceProject.getParameterDataManager().setParameterDataMap(pluginName, parameterName, dataMap);
		interfaceProject.setChanged(true);
		parameterInput.setParameterName(parameterName);

		return null;
	}

	/**
	 * ߂{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {

		return null;
	}

}
