package jp.oarts.pirka.iop.tool.web.project;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.util.check.PirkaChecker;
import jp.oarts.pirka.core.util.check.PirkaCheckerString;
import jp.oarts.pirka.core.util.check.PirkaCheckerStringChars;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

public class EditProject extends IopBaseWindow {

	/** VKtO */
	private boolean newFlag;

	/** C^[tF[XvWFNg */
	private InterfaceProject interfaceProject;

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * RXgN^
	 *
	 * @param interfaceProject
	 *            C^tF[XvWFNg
	 */
	public EditProject(InterfaceProject interfaceProject) {
		super();

		FieldMap fm = getFieldMap();

		// `FbJ[ݒ
		addCheck("projectName", PirkaChecker.required);
		addCheck("projectName", new PirkaCheckerString(PirkaCheckerStringChars.NUM, PirkaCheckerStringChars.LOW_ALPHABET,
				PirkaCheckerStringChars.HIGHT_ALPHABET, new PirkaCheckerStringChars("_-.")));
		addCheck("projectNameJp", PirkaChecker.required);
		addErrorCheckReturner();

		fm.setOfficialFieldName("projectName", "vWFNg");
		fm.setOfficialFieldName("projectNameJp", "vWFNgi{ꖼj");
		fm.setAutoCheck("back", false);

		// f[^i[
		this.interfaceProject = interfaceProject;
		if (interfaceProject == null) {
			fm.setValue("title", "VKvWFNg쐬");
			fm.setValue("projectName", "");
			fm.setValue("projectNameJp", "");
			fm.setValue("comment", "");
			newFlag = true;
		} else {
			fm.setValue("title", "vWFNgXV");
			fm.setValue("projectName", interfaceProject.getName());
			fm.setValue("projectNameJp", interfaceProject.getNameJp());
			fm.setValue("comment", interfaceProject.getComment());
			newFlag = false;
		}
	}

	/**
	 * o^{^NbNꂽ̏
	 *
	 * @return	EBhE
	 */
	public PirkaWindow regist() {

		FieldMap fm = getFieldMap();

		String name = fm.getValueString("projectName").trim();
		String nameJp = fm.getValueString("projectNameJp");
		String comment = fm.getValueString("comment");

		// gqxmloȂΕt
		name = IopUtil.remakeProjectFileName(name);

		if (newFlag) {
			interfaceProject = new InterfaceProject(name, nameJp, comment);
		} else {
			interfaceProject.setName(name);
			interfaceProject.setNameJp(nameJp);
			interfaceProject.setComment(comment);
		}
		interfaceProject.setChanged(true);
		putSession(Define.PROJECT_SESSION_NAME, interfaceProject);

		return null;
	}

	/**
	 * I{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {
		return null;
	}

}
