package jp.oarts.pirka.iop.tool.web.project;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import jp.oarts.pirka.core.kernel.FieldMap;
import jp.oarts.pirka.core.util.check.PirkaChecker;
import jp.oarts.pirka.core.win.PirkaWindow;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.web.common.Alert;
import jp.oarts.pirka.iop.tool.web.common.IopBaseWindow;
import jp.oarts.pirka.iop.tool.web.constants.Define;
import jp.oarts.pirka.iop.tool.web.start.StartMenu;
import jp.oarts.pirka.iop.tool.web.tools.IopUtil;

public class LoadProject extends IopBaseWindow {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private StartMenu startMenu;

	/**
	 * RXgN^
	 */
	public LoadProject(StartMenu startMenu) {
		super();

		this.startMenu = startMenu;

		FieldMap fm = getFieldMap();

		// `FbJ[ݒ
		addCheck("projectFileName", PirkaChecker.required);
		addErrorCheckReturner();

		fm.setOfficialFieldName("projectFileName", "vWFNgt@C");
		fm.setAutoCheck("back", false);
	}

	/**
	 * vWFNgǂݍ݃{^NbNꂽ̏
	 *
	 * @return	EBhE
	 */
	public PirkaWindow load() {

		FieldMap fm = getFieldMap();
		InputStream is = null;
		ByteArrayOutputStream baos = null;
		try {
			is = fm.getInputStream("projectFileName");

			try {
				byte[] buf = new byte[4096];

				baos = new ByteArrayOutputStream();
				while (true) {
					int length = is.read(buf);
					if (length <= 0) {
						break;
					}
					baos.write(buf, 0, length);
				}
			} finally {
				try {
					baos.close();
				} catch (Exception e) {
					// Ȃ
				}
			}
		} catch (IOException e) {
			return new Alert(startMenu, "vWFNgǍ", "vWFNgt@C̓ǂݍ݂Ɏs܂");
		} finally {
			try {
				is.close();
			} catch (Exception e) {
				// Ȃ
			}
		}

		InterfaceProject interfaceProject = null;

		try {
			interfaceProject = InterfaceProject.fromXml(baos.toByteArray());
		} catch (Exception e) {
			return new Alert(startMenu, "vWFNgǍ", "vWFNgt@C̓ǂݍ݂Ɏs܂");
		}

		String projectFileName = fm.getValueString("projectFileName");
		projectFileName = projectFileName.replace('\\', '/');	//	LinuxT[o[ɃtpXt@C肭؂oȂsC
		File file = new File(projectFileName);
		String loadFileName = IopUtil.remakeProjectFileName(file.getName());
		interfaceProject.setName(loadFileName);
		interfaceProject.setChanged(false);

		putSession(Define.PROJECT_SESSION_NAME, interfaceProject);

		return null;
	}

	/**
	 * I{^NbNꂽ̏
	 *
	 * @return nulliOʁj
	 */
	public PirkaWindow back() {
		return null;
	}

}
