package jp.oarts.pirka.iop.tool.web.tools;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.TreeMap;

import jp.oarts.pirka.core.ctrl.SelectList;
import jp.oarts.pirka.iop.tool.core.business.AttributeItem;
import jp.oarts.pirka.iop.tool.core.business.FileCreatorSampleModelerPlugin;
import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDataManager;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.business.PluginManager;
import jp.oarts.pirka.iop.tool.core.general.constants.DbType;
import jp.oarts.pirka.iop.tool.core.general.vo.AttributeData;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.Selecter;

public class IopUtil {

	/**
	 * t@CvWFNgpt@CɕύX
	 *
	 * @param fileName
	 *            t@C
	 * @return vWFNgpt@C
	 */
	public static String remakeProjectFileName(String fileName) {

		return addFileEx(fileName, ".xml");
	}

	/**
	 * t@CɎw肳ꂽgqΕt
	 *
	 * @param fileName
	 *            t@C
	 * @param ex
	 *            gq
	 * @return gqtt@C
	 */
	public static String addFileEx(String fileName, String ex) {

		int length = fileName.length();
		if (length < ex.length() || !fileName.substring(length - ex.length()).equalsIgnoreCase(ex)) {
			fileName = fileName + ex;
		}

		return fileName;
	}

	/**
	 * vWFNg̃C^[tF[X̃ZNgXg쐬
	 *
	 * @param interfaceProject
	 * @return ZNgXg
	 */
	public static SelectList getInterfaceDataSelecter(InterfaceProject interfaceProject) {
		return getInterfaceDataSelecter(interfaceProject, true);
	}

	/**
	 * vWFNg̃C^[tF[X̃ZNgXg쐬
	 *
	 * @param interfaceProject
	 * @param useSpaceRow
	 * @return ZNgXg
	 */
	public static SelectList getInterfaceDataSelecter(InterfaceProject interfaceProject, boolean useSpaceRow) {
		try {
			SelectList list = new SelectList();
			DecimalFormat fmt = new DecimalFormat("0000");

			if (useSpaceRow) {
				list.add("", "");
			}
			InterfaceDataManager interfaceDataManager = interfaceProject.getInterfaceDataManager();
			for (Integer dataId : interfaceDataManager.getInterfaceDataIdListOrderByName()) {
				InterfaceData interfaceData = interfaceDataManager.getInterfaceData(dataId);
				String value = interfaceData.getName() + " ( " + fmt.format(interfaceData.getDataId()) + " : "
						+ interfaceData.getNameJp() + " )";
				list.add(value, "" + interfaceData.getDataId());
			}

			return list;
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * DB̃ZNgXg쐬
	 *
	 * @return ZNgXg
	 */
	public static SelectList getDbSelecter() {
		return getDbSelecter(true);
	}

	/**
	 * DB̃ZNgXg쐬
	 *
	 * @param useSpaceRow
	 * @return ZNgXg
	 */
	public static SelectList getDbSelecter(boolean useSpaceRow) {

		SelectList list = new SelectList();

		if (useSpaceRow) {
			list.add("", "");
		}
		for (DbType type : DbType.values()) {
			list.add(type.getName(), type.toString());
		}

		return list;
	}

	/**
	 * ZN^[ZNgXgɕϊ
	 *
	 * @param selecters
	 * @return ZNgXg
	 */
	public static SelectList convartSelectList(Selecter[] selecters) {

		SelectList list = new SelectList();

		for (Selecter selecter : selecters) {
			list.add(selecter.getText(), selecter.getValue());
		}

		return list;
	}

	/**
	 * C^[tF[X^Cg擾
	 *
	 * @param interfaceProject
	 * @param interfaceDataId
	 * @return C^[tF[X^Cg
	 */
	public static String getInterfaceTitle(InterfaceProject interfaceProject, String interfaceDataId) {
		try {
			if (interfaceDataId == null) {
				return "";
			}

			int dataId;

			try {
				dataId = Integer.valueOf(interfaceDataId);
			} catch (NumberFormatException e) {
				return "";
			}

			DecimalFormat fmt = new DecimalFormat("0000");

			InterfaceDataManager interfaceDataManager = interfaceProject.getInterfaceDataManager();
			InterfaceData interfaceData = interfaceDataManager.getInterfaceData(dataId);
			String value = interfaceData.getName() + " ( " + fmt.format(interfaceData.getDataId()) + " : "
					+ interfaceData.getNameJp() + " )";

			return value;
		} catch (InterfaceException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * ZNgXgw肳ꂽL[ɑΉeLXg擾
	 *
	 * @param selecters
	 * @param key
	 * @return eLXg
	 */
	public static String searchTextFromSelectList(Selecter[] selecters, String key) {
		String value = null;

		for (Selecter selecter : selecters) {
			if (selecter.getValue().equals(key)) {
				value = selecter.getText();
			}
		}

		if (value == null) {
			return "";
		}

		return value;

	}

	/**
	 * 񂩂SQL폜
	 *
	 * @param str
	 * @return
	 */
	public static String cutSqlString(String str) {
		StringBuilder sb = new StringBuilder();

		char startChar = 0;
		boolean strFlag = false;

		for (char c : str.toCharArray()) {
			if (!strFlag) {
				if (c == '\'' || c == '\"') {
					strFlag = true;
					startChar = c;
				}
				sb.append(c);
			} else {
				if (c == startChar) {
					strFlag = false;
					sb.append(c);
				}
			}
		}

		return sb.toString();
	}

	/**
	 * 񂩂當Lŋ܂ꂽȊOɑ݂󔒂폜
	 *
	 * @param str
	 * @return
	 */
	public static String cutSqlSpace(String str) {
		StringBuilder sb = new StringBuilder();

		char startChar = 0;
		boolean strFlag = false;

		for (char c : str.toCharArray()) {
			if (!strFlag) {
				if (c == '\'' || c == '\"') {
					strFlag = true;
					startChar = c;
					sb.append(c);
				} else if (c != ' ' && c != '\t' && c != '\r' && c != '\f') {
					sb.append(c);
				}
			} else {
				if (c == startChar) {
					strFlag = false;
					sb.append(c);
				} else {
					sb.append(c);
				}
			}
		}

		return sb.toString();
	}

	/**
	 * SQLicreate tablej̃ftHgwnextvalݒ肳ĂV[PX ԂBAnullԂB
	 *
	 * @param defaultString
	 * @return V[PX
	 */
	public static String getSequenceNameFromNextval(String defaultString) {

		if (defaultString == null) {
			return null;
		}

		defaultString = cutSqlSpace(defaultString);

		String nextval = "nextval('";

		if (defaultString.length() <= nextval.length()) {
			return null;
		}

		if (!defaultString.substring(0, nextval.length()).equalsIgnoreCase(nextval)) {
			return null;
		}

		int index = defaultString.indexOf('\'', nextval.length());
		if (index < 1) {
			return null;
		}

		return defaultString.substring(nextval.length(), index);
	}

	/**
	 * C^[tF[XɃAb^`Ăf[^̐`FbNs
	 *
	 * @param dataId
	 *            `FbNΏۂ̃C^[tF[XID
	 * @param interfaceProject
	 *            vWFNg
	 * @param pluginName
	 *            `FbNΏۂ̃vOC
	 * @throws InterfaceException
	 */
	public static void checkAttach(int dataId, InterfaceProject interfaceProject) throws InterfaceException {

		try {

			HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>> dataMap = new HashMap<String, TreeMap<Integer, HashMap<String, AttributeData>>>();

			InterfaceData ifData = interfaceProject.getInterfaceDataManager().getInterfaceData(dataId);

			for (Integer itemId : ifData.getAllItemIdList()) {

				InterfaceDataItem item = ifData.getItem(itemId);

				for (String attachName : ifData.getAttachList()) {

					TreeMap<Integer, HashMap<String, AttributeData>> aDataMap = null;
					if (dataMap.containsKey(attachName)) {
						aDataMap = dataMap.get(attachName);
					} else {
						aDataMap = new TreeMap<Integer, HashMap<String, AttributeData>>();
						dataMap.put(attachName, aDataMap);
					}

					HashMap<String, AttributeData> itemDataMap = new HashMap<String, AttributeData>();
					aDataMap.put(itemId, itemDataMap);
					FileCreatorSampleModelerPlugin plugin = PluginManager.getInstance().getAttachPlugin(attachName);

					if (plugin.useDisableItemsAttribute() || item.isEnable()) {
						for (AttributeItem aItem : plugin.getAttributeItems()) {
							AttributeData attributeData = ifData.getAttribute(itemId, attachName, aItem.getName());
							if (attributeData == null) {
								itemDataMap.put(aItem.getName(), aItem.getDefaultValue());
							} else {
								itemDataMap.put(aItem.getName(), attributeData);
							}
							aItem.check(attributeData.getValue(), item);
						}

//						for (AttributeItem aItem : plugin.getAttributeItems()) {
//							AttributeData attributeData = ifData.getAttribute(itemId, attachName, aItem.getName());
//							aItem.check(attributeData.getValue(), item);
//						}
						plugin.checkAttribute(dataId, itemId, itemDataMap, interfaceProject);
					}
				}
			}

			for (String attachName : ifData.getAttachList()) {
				FileCreatorSampleModelerPlugin plugin = PluginManager.getInstance().getAttachPlugin(attachName);
				plugin.checkAttribute(dataId, dataMap, interfaceProject);
			}

		} catch (InterfaceException e) {
			throw new InterfaceException("Ab^`Ă鑮Ɍ肪܂ " + e.getMessage());
		}
	}

	public static void main(String[] args) {
		String s = "";

		s = "nextval('sssss')";
		System.out.println(s + " -> " + cutSqlString(s));

		s = "nextval(\"sssss\")";
		System.out.println(s + " -> " + cutSqlString(s));

		s = "\"nextval('sssss')\"";
		System.out.println(s + " -> " + cutSqlString(s));

		s = "'nextval(\"sssss\")'";
		System.out.println(s + " -> " + cutSqlString(s));
	}

}
