package test.jp.oarts.pirka.iop.tool.core.business;

import java.io.FileOutputStream;
import java.io.IOException;

import jp.oarts.pirka.iop.tool.core.business.InterfaceData;
import jp.oarts.pirka.iop.tool.core.business.InterfaceDataManager;
import jp.oarts.pirka.iop.tool.core.business.InterfaceException;
import jp.oarts.pirka.iop.tool.core.business.InterfaceProject;
import jp.oarts.pirka.iop.tool.core.general.constants.FieldType;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataItem;
import jp.oarts.pirka.iop.tool.core.general.vo.InterfaceDataMyItem;
import jp.oarts.pirka.iop.tool.core.tools.xml.XmlCreator;

/**
 * IopRAEeXgp
 *
 * @author ito
 *
 */
public class InterfaceDataManagerTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			main01(args);
		} catch (InterfaceException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @param args
	 * @throws InterfaceException
	 */
	public static void main02(String[] args) throws InterfaceException {

		InterfaceDataManager idm = new InterfaceDataManager();

		InterfaceData id01 = idm.createInterfaceData();

		id01.setName("syouhin");
		id01.setNameJp("i");

		InterfaceDataMyItem myItem = new InterfaceDataMyItem("no", "iԍ", FieldType.STRING, 5L, 0,false);
		id01.addMyItem(myItem);

		myItem = new InterfaceDataMyItem("name", "i", FieldType.STRING, 30L, 0,false);
		id01.addMyItem(myItem);

		myItem = new InterfaceDataMyItem("price", "P", FieldType.NUM, 8L, 0,false);
		id01.addMyItem(myItem);

		myItem = new InterfaceDataMyItem("insertDate", "o^t", FieldType.DATE_TIME, 0L, 0,false);
		id01.addMyItem(myItem);

		id01.sysout();
		System.out.println("------------------------------");

		System.out.println("1=" + id01.downInterfaceItem(1));
		id01.sysout();
		System.out.println("------------------------------");

		System.out.println("2=" + id01.downInterfaceItem(1));
		id01.sysout();
		System.out.println("------------------------------");

		System.out.println("3=" + id01.downInterfaceItem(1));
		id01.sysout();
		System.out.println("------------------------------");

		System.out.println("4=" + id01.downInterfaceItem(1));
		id01.sysout();
		System.out.println("------------------------------");

		Integer[] itemIds = id01.getEnableItemIdList();
		for (Integer itemId : itemIds) {
			InterfaceDataItem dItem = id01.getItem(itemId);
			System.out.println(dItem.toString());
		}
		System.out.println("------------------------------");

		XmlCreator xml = new XmlCreator();

		idm.toXml(xml);

		System.out.println(xml.toString());
	}

	/**
	 * @param args
	 * @throws InterfaceException
	 */
	public static void main01(String[] args) throws InterfaceException {

		InterfaceProject ip = new InterfaceProject("abc001.xml", "eXgvWFNg-001", "̓eXgp̃vWFNgłB\nC^[tF[X͓KłB");

		InterfaceDataManager idm = ip.getInterfaceDataManager();

		InterfaceData id01 = idm.createInterfaceData();

		id01.setName("syouhin");
		id01.setNameJp("i");

		InterfaceDataMyItem myItem = new InterfaceDataMyItem("no", "iԍ", FieldType.STRING, 5L, 0,false);
		id01.addMyItem(myItem);

		myItem = new InterfaceDataMyItem("name", "i", FieldType.STRING, 30L, 0,false);
		id01.addMyItem(myItem);

		myItem = new InterfaceDataMyItem("price", "P", FieldType.NUM, 8L, 0,false);
		id01.addMyItem(myItem);

		myItem = new InterfaceDataMyItem("insertDate", "o^t", FieldType.DATE_TIME, 0L, 0,false);
		id01.addMyItem(myItem);

		id01.sysout();

		InterfaceData id02 = idm.createInterfaceData();

		id02.setName("syouhinEx");
		id02.setNameJp("ig");

		id02.includeInterfaceData(id01.getDataId());

		InterfaceDataItem item = id02.getItem(2);
		item.setName("aaaa");
		item.setNameJp("iӂ");
		item.setUseNameJp(true);
		id02.updateItem(item);

		id02.includeInterfaceData(id01.getDataId());
		item = id02.getItem(5);
		item.setNameJp("iӂ");
		item.setEnable(false);
		id02.updateItem(item);

		System.out.println("------------------------------");
		id01.sysout();

		System.out.println("------------------------------");
		id02.sysout();

		// InterfaceData id03 = idm.createInterfaceData();
		//
		// id03.setName("syouhinEx2");
		// id03.setNameJp("ig2");
		//
		// id03.includeInterfaceData(id02.getDataId());
		//
		// System.out.println("------------------------------");
		// id03.sysout();
		//
		// myItem = id01.getMyItem(1);
		// myItem.setName("sNo");
		//
		// id01.updateMyItem(myItem);
		//
		// id03 = idm.getInterfaceData(3);
		// id03.upInterfaceItem(7);
		//
		// System.out.println("------------------------------");
		// id03.sysout();
		// System.out.println("------------------------------");
		//
		// InterfaceData id04 = id03.clone(true);
		//
		// System.out.println("------------------------------");
		// id04.sysout();
		// System.out.println("------------------------------");
		//
		// InterfaceData id05 = id03.expandcClone(true);
		// id05.setName("a001");
		// id05.setNameJp("ID05̃C^[tF[Xł");
		// id05.attach("jp.oarts.ifop.tool.core.business.InterfaceAttributeManager$TestAttribute_1");
		// id05.attach("jp.oarts.ifop.tool.core.business.InterfaceAttributeManager$TestAttribute_2");
		// System.out.println("------------------------------");
		// id05.sysout();
		// System.out.println("------------------------------");
		//
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);
		// id03.clone(true);

		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream("C:\\Documents and Settings\\ito\\fXNgbv\\abc003.xml");
			fos.write(ip.toXmlByteArray());
		} catch (Exception e) {
			e.printStackTrace();
		} finally {

			if (fos != null) {
				try {
					fos.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

		// XmlCreator xml = new XmlCreator();
		//
		// idm.toXml(xml);
		//
		// System.out.println(xml.toString());
		//
		// XmlParser xmlParser = new XmlParser();
		//
		// XmlParserData xmlData = xmlParser.parse(xml.toString());
		//
		// InterfaceDataManager idm2 = InterfaceDataManager.fromXml(xmlData);
		//
		// System.out.println("=================================================================================");
		// idm2.sysout();
	}

}
